/**
 * The current status of the test suite.
 *
 * See README.Mozilla for details on how to generate this.
 */
const TEST_RESULTS = {
  "S": {
    "Proposed": {
      "SELALL_TEXT-1_SI": {
        "dM": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "{`foo bar baz´}",
          "innerHTML": "{`foo bar baz´}",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">{`foo bar baz´}</body>",
          "bodyInnerHTML": "{`foo bar baz´}",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">{`foo bar baz´}</body>"
        },
        "body": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "{`foo bar baz´}",
          "innerHTML": "{`foo bar baz´}",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">{`foo bar baz´}</body>",
          "bodyInnerHTML": "{`foo bar baz´}",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">{`foo bar baz´}</body>"
        },
        "div": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "{`foo bar baz´}",
          "innerHTML": "{`foo bar baz´}",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\">{`foo bar baz´}</div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\">{`foo bar baz´}</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\">{`foo bar baz´}</div>CAN<br>ARY</body>"
        }
      },
      "SELALL_I-1_SI": {
        "dM": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "{<i>`foo bar baz´</i>}",
          "innerHTML": "{<i>`foo bar baz´</i>}",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">{<i>`foo bar baz´</i>}</body>",
          "bodyInnerHTML": "{<i>`foo bar baz´</i>}",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">{<i>`foo bar baz´</i>}</body>"
        },
        "body": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "{<i>`foo bar baz´</i>}",
          "innerHTML": "{<i>`foo bar baz´</i>}",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">{<i>`foo bar baz´</i>}</body>",
          "bodyInnerHTML": "{<i>`foo bar baz´</i>}",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">{<i>`foo bar baz´</i>}</body>"
        },
        "div": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "{<i>`foo bar baz´</i>}",
          "innerHTML": "{<i>`foo bar baz´</i>}",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\">{<i>`foo bar baz´</i>}</div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\">{<i>`foo bar baz´</i>}</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\">{<i>`foo bar baz´</i>}</div>CAN<br>ARY</body>"
        }
      },
      "UNSEL_TEXT-1_SI": {
        "dM": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 2,
          "output": "`foo [bar] baz´",
          "innerHTML": "`foo [bar] baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo [bar] baz´</body>",
          "bodyInnerHTML": "`foo [bar] baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo [bar] baz´</body>"
        },
        "body": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 2,
          "output": "`foo [bar] baz´",
          "innerHTML": "`foo [bar] baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo [bar] baz´</body>",
          "bodyInnerHTML": "`foo [bar] baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo [bar] baz´</body>"
        },
        "div": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 2,
          "output": "`foo [bar] baz´",
          "innerHTML": "`foo [bar] baz´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\">`foo [bar] baz´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\">`foo [bar] baz´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\">`foo [bar] baz´</div>CAN<br>ARY</body>"
        }
      },
      "SM:m.f.c_TEXT-1_SC-1": {
        "dM": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`foo ba^r baz´",
          "innerHTML": "`foo ba^r baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo ba^r baz´</body>",
          "bodyInnerHTML": "`foo ba^r baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo ba^r baz´</body>"
        },
        "body": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`foo ba^r baz´",
          "innerHTML": "`foo ba^r baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo ba^r baz´</body>",
          "bodyInnerHTML": "`foo ba^r baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo ba^r baz´</body>"
        },
        "div": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`foo ba^r baz´",
          "innerHTML": "`foo ba^r baz´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\">`foo ba^r baz´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\">`foo ba^r baz´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\">`foo ba^r baz´</div>CAN<br>ARY</body>"
        }
      },
      "SM:m.b.c_TEXT-1_SC-1": {
        "dM": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`foo ^bar baz´",
          "innerHTML": "`foo ^bar baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo ^bar baz´</body>",
          "bodyInnerHTML": "`foo ^bar baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo ^bar baz´</body>"
        },
        "body": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`foo ^bar baz´",
          "innerHTML": "`foo ^bar baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo ^bar baz´</body>",
          "bodyInnerHTML": "`foo ^bar baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo ^bar baz´</body>"
        },
        "div": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`foo ^bar baz´",
          "innerHTML": "`foo ^bar baz´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\">`foo ^bar baz´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\">`foo ^bar baz´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\">`foo ^bar baz´</div>CAN<br>ARY</body>"
        }
      },
      "SM:m.f.c_TEXT-1_SI-1": {
        "dM": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 2,
          "output": "`foo bar ^baz´",
          "innerHTML": "`foo bar ^baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo bar ^baz´</body>",
          "bodyInnerHTML": "`foo bar ^baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo bar ^baz´</body>"
        },
        "body": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 2,
          "output": "`foo bar ^baz´",
          "innerHTML": "`foo bar ^baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo bar ^baz´</body>",
          "bodyInnerHTML": "`foo bar ^baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo bar ^baz´</body>"
        },
        "div": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 2,
          "output": "`foo bar ^baz´",
          "innerHTML": "`foo bar ^baz´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\">`foo bar ^baz´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\">`foo bar ^baz´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\">`foo bar ^baz´</div>CAN<br>ARY</body>"
        }
      },
      "SM:m.b.c_TEXT-1_SI-1": {
        "dM": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 2,
          "output": "`foo ba^r baz´",
          "innerHTML": "`foo ba^r baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo ba^r baz´</body>",
          "bodyInnerHTML": "`foo ba^r baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo ba^r baz´</body>"
        },
        "body": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 2,
          "output": "`foo ba^r baz´",
          "innerHTML": "`foo ba^r baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo ba^r baz´</body>",
          "bodyInnerHTML": "`foo ba^r baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo ba^r baz´</body>"
        },
        "div": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 2,
          "output": "`foo ba^r baz´",
          "innerHTML": "`foo ba^r baz´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\">`foo ba^r baz´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\">`foo ba^r baz´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\">`foo ba^r baz´</div>CAN<br>ARY</body>"
        }
      },
      "SM:m.f.w_TEXT-1_SC-1": {
        "dM": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`foo bar^ baz´",
          "innerHTML": "`foo bar^ baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo bar^ baz´</body>",
          "bodyInnerHTML": "`foo bar^ baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo bar^ baz´</body>"
        },
        "body": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`foo bar^ baz´",
          "innerHTML": "`foo bar^ baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo bar^ baz´</body>",
          "bodyInnerHTML": "`foo bar^ baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo bar^ baz´</body>"
        },
        "div": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`foo bar^ baz´",
          "innerHTML": "`foo bar^ baz´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\">`foo bar^ baz´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\">`foo bar^ baz´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\">`foo bar^ baz´</div>CAN<br>ARY</body>"
        }
      },
      "SM:m.f.w_TEXT-1_SC-2": {
        "dM": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`foo bar^ baz´",
          "innerHTML": "`foo bar^ baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo bar^ baz´</body>",
          "bodyInnerHTML": "`foo bar^ baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo bar^ baz´</body>"
        },
        "body": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`foo bar^ baz´",
          "innerHTML": "`foo bar^ baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo bar^ baz´</body>",
          "bodyInnerHTML": "`foo bar^ baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo bar^ baz´</body>"
        },
        "div": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`foo bar^ baz´",
          "innerHTML": "`foo bar^ baz´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\">`foo bar^ baz´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\">`foo bar^ baz´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\">`foo bar^ baz´</div>CAN<br>ARY</body>"
        }
      },
      "SM:m.f.w_TEXT-1_SI-1": {
        "dM": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`foo bar baz^´",
          "innerHTML": "`foo bar baz^´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo bar baz^´</body>",
          "bodyInnerHTML": "`foo bar baz^´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo bar baz^´</body>"
        },
        "body": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`foo bar baz^´",
          "innerHTML": "`foo bar baz^´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo bar baz^´</body>",
          "bodyInnerHTML": "`foo bar baz^´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo bar baz^´</body>"
        },
        "div": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`foo bar baz^´",
          "innerHTML": "`foo bar baz^´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\">`foo bar baz^´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\">`foo bar baz^´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\">`foo bar baz^´</div>CAN<br>ARY</body>"
        }
      },
      "SM:m.b.w_TEXT-1_SC-1": {
        "dM": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`foo ^bar baz´",
          "innerHTML": "`foo ^bar baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo ^bar baz´</body>",
          "bodyInnerHTML": "`foo ^bar baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo ^bar baz´</body>"
        },
        "body": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`foo ^bar baz´",
          "innerHTML": "`foo ^bar baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo ^bar baz´</body>",
          "bodyInnerHTML": "`foo ^bar baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo ^bar baz´</body>"
        },
        "div": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`foo ^bar baz´",
          "innerHTML": "`foo ^bar baz´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\">`foo ^bar baz´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\">`foo ^bar baz´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\">`foo ^bar baz´</div>CAN<br>ARY</body>"
        }
      },
      "SM:m.b.w_TEXT-1_SC-3": {
        "dM": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`foo ^bar baz´",
          "innerHTML": "`foo ^bar baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo ^bar baz´</body>",
          "bodyInnerHTML": "`foo ^bar baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo ^bar baz´</body>"
        },
        "body": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`foo ^bar baz´",
          "innerHTML": "`foo ^bar baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo ^bar baz´</body>",
          "bodyInnerHTML": "`foo ^bar baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo ^bar baz´</body>"
        },
        "div": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`foo ^bar baz´",
          "innerHTML": "`foo ^bar baz´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\">`foo ^bar baz´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\">`foo ^bar baz´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\">`foo ^bar baz´</div>CAN<br>ARY</body>"
        }
      },
      "SM:m.b.w_TEXT-1_SI-1": {
        "dM": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 2,
          "output": "`foo ^bar baz´",
          "innerHTML": "`foo ^bar baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo ^bar baz´</body>",
          "bodyInnerHTML": "`foo ^bar baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo ^bar baz´</body>"
        },
        "body": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 2,
          "output": "`foo ^bar baz´",
          "innerHTML": "`foo ^bar baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo ^bar baz´</body>",
          "bodyInnerHTML": "`foo ^bar baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo ^bar baz´</body>"
        },
        "div": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 2,
          "output": "`foo ^bar baz´",
          "innerHTML": "`foo ^bar baz´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\">`foo ^bar baz´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\">`foo ^bar baz´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\">`foo ^bar baz´</div>CAN<br>ARY</body>"
        }
      },
      "SM:m.f.c_CHAR-2_SC-1": {
        "dM": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`foö^barbaz´",
          "innerHTML": "`foö^barbaz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foö^barbaz´</body>",
          "bodyInnerHTML": "`foö^barbaz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foö^barbaz´</body>"
        },
        "body": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`foö^barbaz´",
          "innerHTML": "`foö^barbaz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foö^barbaz´</body>",
          "bodyInnerHTML": "`foö^barbaz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foö^barbaz´</body>"
        },
        "div": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`foö^barbaz´",
          "innerHTML": "`foö^barbaz´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\">`foö^barbaz´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\">`foö^barbaz´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\">`foö^barbaz´</div>CAN<br>ARY</body>"
        }
      },
      "SM:m.f.c_CHAR-3_SC-1": {
        "dM": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`foö^barbaz´",
          "innerHTML": "`foö^barbaz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foö^barbaz´</body>",
          "bodyInnerHTML": "`foö^barbaz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foö^barbaz´</body>"
        },
        "body": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`foö^barbaz´",
          "innerHTML": "`foö^barbaz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foö^barbaz´</body>",
          "bodyInnerHTML": "`foö^barbaz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foö^barbaz´</body>"
        },
        "div": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`foö^barbaz´",
          "innerHTML": "`foö^barbaz´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\">`foö^barbaz´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\">`foö^barbaz´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\">`foö^barbaz´</div>CAN<br>ARY</body>"
        }
      },
      "SM:m.f.c_CHAR-4_SC-1": {
        "dM": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`foo̤^barbaz´",
          "innerHTML": "`foo̤^barbaz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo̤^barbaz´</body>",
          "bodyInnerHTML": "`foo̤^barbaz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo̤^barbaz´</body>"
        },
        "body": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`foo̤^barbaz´",
          "innerHTML": "`foo̤^barbaz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo̤^barbaz´</body>",
          "bodyInnerHTML": "`foo̤^barbaz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo̤^barbaz´</body>"
        },
        "div": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`foo̤^barbaz´",
          "innerHTML": "`foo̤^barbaz´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\">`foo̤^barbaz´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\">`foo̤^barbaz´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\">`foo̤^barbaz´</div>CAN<br>ARY</body>"
        }
      },
      "SM:m.f.c_CHAR-5_SC-1": {
        "dM": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`foö̤^barbaz´",
          "innerHTML": "`foö̤^barbaz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foö̤^barbaz´</body>",
          "bodyInnerHTML": "`foö̤^barbaz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foö̤^barbaz´</body>"
        },
        "body": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`foö̤^barbaz´",
          "innerHTML": "`foö̤^barbaz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foö̤^barbaz´</body>",
          "bodyInnerHTML": "`foö̤^barbaz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foö̤^barbaz´</body>"
        },
        "div": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`foö̤^barbaz´",
          "innerHTML": "`foö̤^barbaz´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\">`foö̤^barbaz´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\">`foö̤^barbaz´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\">`foö̤^barbaz´</div>CAN<br>ARY</body>"
        }
      },
      "SM:m.f.c_CHAR-5_SI-1": {
        "dM": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`foö̤^barbaz´",
          "innerHTML": "`foö̤^barbaz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foö̤^barbaz´</body>",
          "bodyInnerHTML": "`foö̤^barbaz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foö̤^barbaz´</body>"
        },
        "body": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`foö̤^barbaz´",
          "innerHTML": "`foö̤^barbaz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foö̤^barbaz´</body>",
          "bodyInnerHTML": "`foö̤^barbaz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foö̤^barbaz´</body>"
        },
        "div": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`foö̤^barbaz´",
          "innerHTML": "`foö̤^barbaz´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\">`foö̤^barbaz´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\">`foö̤^barbaz´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\">`foö̤^barbaz´</div>CAN<br>ARY</body>"
        }
      },
      "SM:m.f.c_CHAR-5_SI-2": {
        "dM": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 2,
          "output": "`foö̤b^arbaz´",
          "innerHTML": "`foö̤b^arbaz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foö̤b^arbaz´</body>",
          "bodyInnerHTML": "`foö̤b^arbaz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foö̤b^arbaz´</body>"
        },
        "body": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 2,
          "output": "`foö̤b^arbaz´",
          "innerHTML": "`foö̤b^arbaz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foö̤b^arbaz´</body>",
          "bodyInnerHTML": "`foö̤b^arbaz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foö̤b^arbaz´</body>"
        },
        "div": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 2,
          "output": "`foö̤b^arbaz´",
          "innerHTML": "`foö̤b^arbaz´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\">`foö̤b^arbaz´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\">`foö̤b^arbaz´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\">`foö̤b^arbaz´</div>CAN<br>ARY</body>"
        }
      },
      "SM:m.f.c_CHAR-5_SL": {
        "dM": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`foö̤^barbaz´",
          "innerHTML": "`foö̤^barbaz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foö̤^barbaz´</body>",
          "bodyInnerHTML": "`foö̤^barbaz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foö̤^barbaz´</body>"
        },
        "body": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`foö̤^barbaz´",
          "innerHTML": "`foö̤^barbaz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foö̤^barbaz´</body>",
          "bodyInnerHTML": "`foö̤^barbaz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foö̤^barbaz´</body>"
        },
        "div": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`foö̤^barbaz´",
          "innerHTML": "`foö̤^barbaz´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\">`foö̤^barbaz´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\">`foö̤^barbaz´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\">`foö̤^barbaz´</div>CAN<br>ARY</body>"
        }
      },
      "SM:m.f.c_CHAR-5_SR": {
        "dM": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 2,
          "output": "`foö̤barb^az´",
          "innerHTML": "`foö̤barb^az´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foö̤barb^az´</body>",
          "bodyInnerHTML": "`foö̤barb^az´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foö̤barb^az´</body>"
        },
        "body": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 2,
          "output": "`foö̤barb^az´",
          "innerHTML": "`foö̤barb^az´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foö̤barb^az´</body>",
          "bodyInnerHTML": "`foö̤barb^az´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foö̤barb^az´</body>"
        },
        "div": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 2,
          "output": "`foö̤barb^az´",
          "innerHTML": "`foö̤barb^az´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\">`foö̤barb^az´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\">`foö̤barb^az´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\">`foö̤barb^az´</div>CAN<br>ARY</body>"
        }
      },
      "SM:m.f.c_CHAR-6_SC-1": {
        "dM": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`foo⃞^barbaz´",
          "innerHTML": "`foo⃞^barbaz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo⃞^barbaz´</body>",
          "bodyInnerHTML": "`foo⃞^barbaz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo⃞^barbaz´</body>"
        },
        "body": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`foo⃞^barbaz´",
          "innerHTML": "`foo⃞^barbaz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo⃞^barbaz´</body>",
          "bodyInnerHTML": "`foo⃞^barbaz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo⃞^barbaz´</body>"
        },
        "div": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`foo⃞^barbaz´",
          "innerHTML": "`foo⃞^barbaz´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\">`foo⃞^barbaz´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\">`foo⃞^barbaz´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\">`foo⃞^barbaz´</div>CAN<br>ARY</body>"
        }
      },
      "SM:m.f.c_CHAR-7_SC-1": {
        "dM": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`foo̸^barbaz´",
          "innerHTML": "`foo̸^barbaz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo̸^barbaz´</body>",
          "bodyInnerHTML": "`foo̸^barbaz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo̸^barbaz´</body>"
        },
        "body": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`foo̸^barbaz´",
          "innerHTML": "`foo̸^barbaz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo̸^barbaz´</body>",
          "bodyInnerHTML": "`foo̸^barbaz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo̸^barbaz´</body>"
        },
        "div": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`foo̸^barbaz´",
          "innerHTML": "`foo̸^barbaz´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\">`foo̸^barbaz´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\">`foo̸^barbaz´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\">`foo̸^barbaz´</div>CAN<br>ARY</body>"
        }
      },
      "SM:m.b.c_CHAR-2_SC-1": {
        "dM": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`fo^öbarbaz´",
          "innerHTML": "`fo^öbarbaz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`fo^öbarbaz´</body>",
          "bodyInnerHTML": "`fo^öbarbaz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`fo^öbarbaz´</body>"
        },
        "body": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`fo^öbarbaz´",
          "innerHTML": "`fo^öbarbaz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`fo^öbarbaz´</body>",
          "bodyInnerHTML": "`fo^öbarbaz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`fo^öbarbaz´</body>"
        },
        "div": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`fo^öbarbaz´",
          "innerHTML": "`fo^öbarbaz´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\">`fo^öbarbaz´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\">`fo^öbarbaz´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\">`fo^öbarbaz´</div>CAN<br>ARY</body>"
        }
      },
      "SM:m.b.c_CHAR-3_SC-1": {
        "dM": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`fo^öbarbaz´",
          "innerHTML": "`fo^öbarbaz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`fo^öbarbaz´</body>",
          "bodyInnerHTML": "`fo^öbarbaz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`fo^öbarbaz´</body>"
        },
        "body": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`fo^öbarbaz´",
          "innerHTML": "`fo^öbarbaz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`fo^öbarbaz´</body>",
          "bodyInnerHTML": "`fo^öbarbaz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`fo^öbarbaz´</body>"
        },
        "div": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`fo^öbarbaz´",
          "innerHTML": "`fo^öbarbaz´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\">`fo^öbarbaz´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\">`fo^öbarbaz´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\">`fo^öbarbaz´</div>CAN<br>ARY</body>"
        }
      },
      "SM:m.b.c_CHAR-4_SC-1": {
        "dM": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`fo^o̤barbaz´",
          "innerHTML": "`fo^o̤barbaz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`fo^o̤barbaz´</body>",
          "bodyInnerHTML": "`fo^o̤barbaz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`fo^o̤barbaz´</body>"
        },
        "body": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`fo^o̤barbaz´",
          "innerHTML": "`fo^o̤barbaz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`fo^o̤barbaz´</body>",
          "bodyInnerHTML": "`fo^o̤barbaz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`fo^o̤barbaz´</body>"
        },
        "div": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`fo^o̤barbaz´",
          "innerHTML": "`fo^o̤barbaz´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\">`fo^o̤barbaz´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\">`fo^o̤barbaz´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\">`fo^o̤barbaz´</div>CAN<br>ARY</body>"
        }
      },
      "SM:m.b.c_CHAR-5_SC-1": {
        "dM": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`fo^ö̤barbaz´",
          "innerHTML": "`fo^ö̤barbaz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`fo^ö̤barbaz´</body>",
          "bodyInnerHTML": "`fo^ö̤barbaz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`fo^ö̤barbaz´</body>"
        },
        "body": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`fo^ö̤barbaz´",
          "innerHTML": "`fo^ö̤barbaz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`fo^ö̤barbaz´</body>",
          "bodyInnerHTML": "`fo^ö̤barbaz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`fo^ö̤barbaz´</body>"
        },
        "div": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`fo^ö̤barbaz´",
          "innerHTML": "`fo^ö̤barbaz´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\">`fo^ö̤barbaz´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\">`fo^ö̤barbaz´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\">`fo^ö̤barbaz´</div>CAN<br>ARY</body>"
        }
      },
      "SM:m.b.c_CHAR-5_SI-1": {
        "dM": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`fo^ö̤barbaz´",
          "innerHTML": "`fo^ö̤barbaz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`fo^ö̤barbaz´</body>",
          "bodyInnerHTML": "`fo^ö̤barbaz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`fo^ö̤barbaz´</body>"
        },
        "body": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`fo^ö̤barbaz´",
          "innerHTML": "`fo^ö̤barbaz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`fo^ö̤barbaz´</body>",
          "bodyInnerHTML": "`fo^ö̤barbaz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`fo^ö̤barbaz´</body>"
        },
        "div": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`fo^ö̤barbaz´",
          "innerHTML": "`fo^ö̤barbaz´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\">`fo^ö̤barbaz´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\">`fo^ö̤barbaz´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\">`fo^ö̤barbaz´</div>CAN<br>ARY</body>"
        }
      },
      "SM:m.b.c_CHAR-5_SI-2": {
        "dM": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`fo^ö̤barbaz´",
          "innerHTML": "`fo^ö̤barbaz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`fo^ö̤barbaz´</body>",
          "bodyInnerHTML": "`fo^ö̤barbaz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`fo^ö̤barbaz´</body>"
        },
        "body": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`fo^ö̤barbaz´",
          "innerHTML": "`fo^ö̤barbaz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`fo^ö̤barbaz´</body>",
          "bodyInnerHTML": "`fo^ö̤barbaz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`fo^ö̤barbaz´</body>"
        },
        "div": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`fo^ö̤barbaz´",
          "innerHTML": "`fo^ö̤barbaz´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\">`fo^ö̤barbaz´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\">`fo^ö̤barbaz´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\">`fo^ö̤barbaz´</div>CAN<br>ARY</body>"
        }
      },
      "SM:m.b.c_CHAR-5_SL": {
        "dM": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`fo^ö̤barbaz´",
          "innerHTML": "`fo^ö̤barbaz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`fo^ö̤barbaz´</body>",
          "bodyInnerHTML": "`fo^ö̤barbaz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`fo^ö̤barbaz´</body>"
        },
        "body": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`fo^ö̤barbaz´",
          "innerHTML": "`fo^ö̤barbaz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`fo^ö̤barbaz´</body>",
          "bodyInnerHTML": "`fo^ö̤barbaz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`fo^ö̤barbaz´</body>"
        },
        "div": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`fo^ö̤barbaz´",
          "innerHTML": "`fo^ö̤barbaz´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\">`fo^ö̤barbaz´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\">`fo^ö̤barbaz´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\">`fo^ö̤barbaz´</div>CAN<br>ARY</body>"
        }
      },
      "SM:m.b.c_CHAR-5_SR": {
        "dM": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 2,
          "output": "`foö̤ba^rbaz´",
          "innerHTML": "`foö̤ba^rbaz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foö̤ba^rbaz´</body>",
          "bodyInnerHTML": "`foö̤ba^rbaz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foö̤ba^rbaz´</body>"
        },
        "body": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 2,
          "output": "`foö̤ba^rbaz´",
          "innerHTML": "`foö̤ba^rbaz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foö̤ba^rbaz´</body>",
          "bodyInnerHTML": "`foö̤ba^rbaz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foö̤ba^rbaz´</body>"
        },
        "div": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 2,
          "output": "`foö̤ba^rbaz´",
          "innerHTML": "`foö̤ba^rbaz´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\">`foö̤ba^rbaz´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\">`foö̤ba^rbaz´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\">`foö̤ba^rbaz´</div>CAN<br>ARY</body>"
        }
      },
      "SM:m.b.c_CHAR-6_SC-1": {
        "dM": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`fo^o⃞barbaz´",
          "innerHTML": "`fo^o⃞barbaz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`fo^o⃞barbaz´</body>",
          "bodyInnerHTML": "`fo^o⃞barbaz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`fo^o⃞barbaz´</body>"
        },
        "body": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`fo^o⃞barbaz´",
          "innerHTML": "`fo^o⃞barbaz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`fo^o⃞barbaz´</body>",
          "bodyInnerHTML": "`fo^o⃞barbaz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`fo^o⃞barbaz´</body>"
        },
        "div": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`fo^o⃞barbaz´",
          "innerHTML": "`fo^o⃞barbaz´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\">`fo^o⃞barbaz´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\">`fo^o⃞barbaz´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\">`fo^o⃞barbaz´</div>CAN<br>ARY</body>"
        }
      },
      "SM:m.b.c_CHAR-7_SC-1": {
        "dM": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`fo^o̸barbaz´",
          "innerHTML": "`fo^o̸barbaz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`fo^o̸barbaz´</body>",
          "bodyInnerHTML": "`fo^o̸barbaz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`fo^o̸barbaz´</body>"
        },
        "body": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`fo^o̸barbaz´",
          "innerHTML": "`fo^o̸barbaz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`fo^o̸barbaz´</body>",
          "bodyInnerHTML": "`fo^o̸barbaz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`fo^o̸barbaz´</body>"
        },
        "div": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`fo^o̸barbaz´",
          "innerHTML": "`fo^o̸barbaz´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\">`fo^o̸barbaz´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\">`fo^o̸barbaz´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\">`fo^o̸barbaz´</div>CAN<br>ARY</body>"
        }
      },
      "SM:m.f.c_Pdir:rtl-1_SC-1": {
        "dM": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 2,
          "output": "<p dir=\"rtl\">`foo ^bar baz´</p>",
          "innerHTML": "<p dir=\"rtl\">`foo ^bar baz´</p>",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\"><p dir=\"rtl\">`foo ^bar baz´</p></body>",
          "bodyInnerHTML": "<p dir=\"rtl\">`foo ^bar baz´</p>",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\"><p dir=\"rtl\">`foo ^bar baz´</p></body>"
        },
        "body": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 2,
          "output": "<p dir=\"rtl\">`foo ^bar baz´</p>",
          "innerHTML": "<p dir=\"rtl\">`foo ^bar baz´</p>",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\"><p dir=\"rtl\">`foo ^bar baz´</p></body>",
          "bodyInnerHTML": "<p dir=\"rtl\">`foo ^bar baz´</p>",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\"><p dir=\"rtl\">`foo ^bar baz´</p></body>"
        },
        "div": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 2,
          "output": "<p dir=\"rtl\">`foo ^bar baz´</p>",
          "innerHTML": "<p dir=\"rtl\">`foo ^bar baz´</p>",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\"><p dir=\"rtl\">`foo ^bar baz´</p></div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\"><p dir=\"rtl\">`foo ^bar baz´</p></div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\"><p dir=\"rtl\">`foo ^bar baz´</p></div>CAN<br>ARY</body>"
        }
      },
      "SM:m.b.c_Pdir:rtl-1_SC-1": {
        "dM": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 2,
          "output": "<p dir=\"rtl\">`foo bar^ baz´</p>",
          "innerHTML": "<p dir=\"rtl\">`foo bar^ baz´</p>",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\"><p dir=\"rtl\">`foo bar^ baz´</p></body>",
          "bodyInnerHTML": "<p dir=\"rtl\">`foo bar^ baz´</p>",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\"><p dir=\"rtl\">`foo bar^ baz´</p></body>"
        },
        "body": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 2,
          "output": "<p dir=\"rtl\">`foo bar^ baz´</p>",
          "innerHTML": "<p dir=\"rtl\">`foo bar^ baz´</p>",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\"><p dir=\"rtl\">`foo bar^ baz´</p></body>",
          "bodyInnerHTML": "<p dir=\"rtl\">`foo bar^ baz´</p>",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\"><p dir=\"rtl\">`foo bar^ baz´</p></body>"
        },
        "div": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 2,
          "output": "<p dir=\"rtl\">`foo bar^ baz´</p>",
          "innerHTML": "<p dir=\"rtl\">`foo bar^ baz´</p>",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\"><p dir=\"rtl\">`foo bar^ baz´</p></div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\"><p dir=\"rtl\">`foo bar^ baz´</p></div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\"><p dir=\"rtl\">`foo bar^ baz´</p></div>CAN<br>ARY</body>"
        }
      },
      "SM:m.r.c_Pdir:rtl-1_SC-1": {
        "dM": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "<p dir=\"rtl\">`foo ba^r baz´</p>",
          "innerHTML": "<p dir=\"rtl\">`foo ba^r baz´</p>",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\"><p dir=\"rtl\">`foo ba^r baz´</p></body>",
          "bodyInnerHTML": "<p dir=\"rtl\">`foo ba^r baz´</p>",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\"><p dir=\"rtl\">`foo ba^r baz´</p></body>"
        },
        "body": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "<p dir=\"rtl\">`foo ba^r baz´</p>",
          "innerHTML": "<p dir=\"rtl\">`foo ba^r baz´</p>",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\"><p dir=\"rtl\">`foo ba^r baz´</p></body>",
          "bodyInnerHTML": "<p dir=\"rtl\">`foo ba^r baz´</p>",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\"><p dir=\"rtl\">`foo ba^r baz´</p></body>"
        },
        "div": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "<p dir=\"rtl\">`foo ba^r baz´</p>",
          "innerHTML": "<p dir=\"rtl\">`foo ba^r baz´</p>",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\"><p dir=\"rtl\">`foo ba^r baz´</p></div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\"><p dir=\"rtl\">`foo ba^r baz´</p></div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\"><p dir=\"rtl\">`foo ba^r baz´</p></div>CAN<br>ARY</body>"
        }
      },
      "SM:m.l.c_Pdir:rtl-1_SC-1": {
        "dM": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "<p dir=\"rtl\">`foo b^ar baz´</p>",
          "innerHTML": "<p dir=\"rtl\">`foo b^ar baz´</p>",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\"><p dir=\"rtl\">`foo b^ar baz´</p></body>",
          "bodyInnerHTML": "<p dir=\"rtl\">`foo b^ar baz´</p>",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\"><p dir=\"rtl\">`foo b^ar baz´</p></body>"
        },
        "body": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "<p dir=\"rtl\">`foo b^ar baz´</p>",
          "innerHTML": "<p dir=\"rtl\">`foo b^ar baz´</p>",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\"><p dir=\"rtl\">`foo b^ar baz´</p></body>",
          "bodyInnerHTML": "<p dir=\"rtl\">`foo b^ar baz´</p>",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\"><p dir=\"rtl\">`foo b^ar baz´</p></body>"
        },
        "div": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "<p dir=\"rtl\">`foo b^ar baz´</p>",
          "innerHTML": "<p dir=\"rtl\">`foo b^ar baz´</p>",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\"><p dir=\"rtl\">`foo b^ar baz´</p></div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\"><p dir=\"rtl\">`foo b^ar baz´</p></div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\"><p dir=\"rtl\">`foo b^ar baz´</p></div>CAN<br>ARY</body>"
        }
      },
      "SM:m.f.c_TEXT:ar-1_SC-1": {
        "dM": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`مرحب^ا العالم´",
          "innerHTML": "`مرحب^ا العالم´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`مرحب^ا العالم´</body>",
          "bodyInnerHTML": "`مرحب^ا العالم´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`مرحب^ا العالم´</body>"
        },
        "body": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`مرحب^ا العالم´",
          "innerHTML": "`مرحب^ا العالم´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`مرحب^ا العالم´</body>",
          "bodyInnerHTML": "`مرحب^ا العالم´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`مرحب^ا العالم´</body>"
        },
        "div": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`مرحب^ا العالم´",
          "innerHTML": "`مرحب^ا العالم´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\">`مرحب^ا العالم´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\">`مرحب^ا العالم´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\">`مرحب^ا العالم´</div>CAN<br>ARY</body>"
        }
      },
      "SM:m.b.c_TEXT:ar-1_SC-1": {
        "dM": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`مر^حبا العالم´",
          "innerHTML": "`مر^حبا العالم´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`مر^حبا العالم´</body>",
          "bodyInnerHTML": "`مر^حبا العالم´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`مر^حبا العالم´</body>"
        },
        "body": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`مر^حبا العالم´",
          "innerHTML": "`مر^حبا العالم´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`مر^حبا العالم´</body>",
          "bodyInnerHTML": "`مر^حبا العالم´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`مر^حبا العالم´</body>"
        },
        "div": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`مر^حبا العالم´",
          "innerHTML": "`مر^حبا العالم´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\">`مر^حبا العالم´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\">`مر^حبا العالم´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\">`مر^حبا العالم´</div>CAN<br>ARY</body>"
        }
      },
      "SM:m.f.c_TEXT:he-1_SC-1": {
        "dM": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`שלו^ם עולם´",
          "innerHTML": "`שלו^ם עולם´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`שלו^ם עולם´</body>",
          "bodyInnerHTML": "`שלו^ם עולם´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`שלו^ם עולם´</body>"
        },
        "body": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`שלו^ם עולם´",
          "innerHTML": "`שלו^ם עולם´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`שלו^ם עולם´</body>",
          "bodyInnerHTML": "`שלו^ם עולם´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`שלו^ם עולם´</body>"
        },
        "div": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`שלו^ם עולם´",
          "innerHTML": "`שלו^ם עולם´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\">`שלו^ם עולם´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\">`שלו^ם עולם´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\">`שלו^ם עולם´</div>CAN<br>ARY</body>"
        }
      },
      "SM:m.b.c_TEXT:he-1_SC-1": {
        "dM": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`ש^לום עולם´",
          "innerHTML": "`ש^לום עולם´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`ש^לום עולם´</body>",
          "bodyInnerHTML": "`ש^לום עולם´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`ש^לום עולם´</body>"
        },
        "body": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`ש^לום עולם´",
          "innerHTML": "`ש^לום עולם´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`ש^לום עולם´</body>",
          "bodyInnerHTML": "`ש^לום עולם´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`ש^לום עולם´</body>"
        },
        "div": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`ש^לום עולם´",
          "innerHTML": "`ש^לום עולם´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\">`ש^לום עולם´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\">`ש^לום עולם´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\">`ש^לום עולם´</div>CAN<br>ARY</body>"
        }
      },
      "SM:m.f.c_BDOdir:rtl-1_SC-1": {
        "dM": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`foo ´<bdo dir=\"rtl\">`ba^r´</bdo>` baz´",
          "innerHTML": "`foo ´<bdo dir=\"rtl\">`ba^r´</bdo>` baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo ´<bdo dir=\"rtl\">`ba^r´</bdo>` baz´</body>",
          "bodyInnerHTML": "`foo ´<bdo dir=\"rtl\">`ba^r´</bdo>` baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo ´<bdo dir=\"rtl\">`ba^r´</bdo>` baz´</body>"
        },
        "body": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`foo ´<bdo dir=\"rtl\">`ba^r´</bdo>` baz´",
          "innerHTML": "`foo ´<bdo dir=\"rtl\">`ba^r´</bdo>` baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo ´<bdo dir=\"rtl\">`ba^r´</bdo>` baz´</body>",
          "bodyInnerHTML": "`foo ´<bdo dir=\"rtl\">`ba^r´</bdo>` baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo ´<bdo dir=\"rtl\">`ba^r´</bdo>` baz´</body>"
        },
        "div": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`foo ´<bdo dir=\"rtl\">`ba^r´</bdo>` baz´",
          "innerHTML": "`foo ´<bdo dir=\"rtl\">`ba^r´</bdo>` baz´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\">`foo ´<bdo dir=\"rtl\">`ba^r´</bdo>` baz´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\">`foo ´<bdo dir=\"rtl\">`ba^r´</bdo>` baz´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\">`foo ´<bdo dir=\"rtl\">`ba^r´</bdo>` baz´</div>CAN<br>ARY</body>"
        }
      },
      "SM:m.b.c_BDOdir:rtl-1_SC-1": {
        "dM": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`foo ´<bdo dir=\"rtl\">`b^ar´</bdo>` baz´",
          "innerHTML": "`foo ´<bdo dir=\"rtl\">`b^ar´</bdo>` baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo ´<bdo dir=\"rtl\">`b^ar´</bdo>` baz´</body>",
          "bodyInnerHTML": "`foo ´<bdo dir=\"rtl\">`b^ar´</bdo>` baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo ´<bdo dir=\"rtl\">`b^ar´</bdo>` baz´</body>"
        },
        "body": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`foo ´<bdo dir=\"rtl\">`b^ar´</bdo>` baz´",
          "innerHTML": "`foo ´<bdo dir=\"rtl\">`b^ar´</bdo>` baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo ´<bdo dir=\"rtl\">`b^ar´</bdo>` baz´</body>",
          "bodyInnerHTML": "`foo ´<bdo dir=\"rtl\">`b^ar´</bdo>` baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo ´<bdo dir=\"rtl\">`b^ar´</bdo>` baz´</body>"
        },
        "div": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`foo ´<bdo dir=\"rtl\">`b^ar´</bdo>` baz´",
          "innerHTML": "`foo ´<bdo dir=\"rtl\">`b^ar´</bdo>` baz´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\">`foo ´<bdo dir=\"rtl\">`b^ar´</bdo>` baz´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\">`foo ´<bdo dir=\"rtl\">`b^ar´</bdo>` baz´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\">`foo ´<bdo dir=\"rtl\">`b^ar´</bdo>` baz´</div>CAN<br>ARY</body>"
        }
      },
      "SM:m.r.c_BDOdir:rtl-1_SC-1": {
        "dM": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`foo ´<bdo dir=\"rtl\">`b^ar´</bdo>` baz´",
          "innerHTML": "`foo ´<bdo dir=\"rtl\">`b^ar´</bdo>` baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo ´<bdo dir=\"rtl\">`b^ar´</bdo>` baz´</body>",
          "bodyInnerHTML": "`foo ´<bdo dir=\"rtl\">`b^ar´</bdo>` baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo ´<bdo dir=\"rtl\">`b^ar´</bdo>` baz´</body>"
        },
        "body": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`foo ´<bdo dir=\"rtl\">`b^ar´</bdo>` baz´",
          "innerHTML": "`foo ´<bdo dir=\"rtl\">`b^ar´</bdo>` baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo ´<bdo dir=\"rtl\">`b^ar´</bdo>` baz´</body>",
          "bodyInnerHTML": "`foo ´<bdo dir=\"rtl\">`b^ar´</bdo>` baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo ´<bdo dir=\"rtl\">`b^ar´</bdo>` baz´</body>"
        },
        "div": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`foo ´<bdo dir=\"rtl\">`b^ar´</bdo>` baz´",
          "innerHTML": "`foo ´<bdo dir=\"rtl\">`b^ar´</bdo>` baz´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\">`foo ´<bdo dir=\"rtl\">`b^ar´</bdo>` baz´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\">`foo ´<bdo dir=\"rtl\">`b^ar´</bdo>` baz´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\">`foo ´<bdo dir=\"rtl\">`b^ar´</bdo>` baz´</div>CAN<br>ARY</body>"
        }
      },
      "SM:m.l.c_BDOdir:rtl-1_SC-1": {
        "dM": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`foo ´<bdo dir=\"rtl\">`ba^r´</bdo>` baz´",
          "innerHTML": "`foo ´<bdo dir=\"rtl\">`ba^r´</bdo>` baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo ´<bdo dir=\"rtl\">`ba^r´</bdo>` baz´</body>",
          "bodyInnerHTML": "`foo ´<bdo dir=\"rtl\">`ba^r´</bdo>` baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo ´<bdo dir=\"rtl\">`ba^r´</bdo>` baz´</body>"
        },
        "body": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`foo ´<bdo dir=\"rtl\">`ba^r´</bdo>` baz´",
          "innerHTML": "`foo ´<bdo dir=\"rtl\">`ba^r´</bdo>` baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo ´<bdo dir=\"rtl\">`ba^r´</bdo>` baz´</body>",
          "bodyInnerHTML": "`foo ´<bdo dir=\"rtl\">`ba^r´</bdo>` baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo ´<bdo dir=\"rtl\">`ba^r´</bdo>` baz´</body>"
        },
        "div": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`foo ´<bdo dir=\"rtl\">`ba^r´</bdo>` baz´",
          "innerHTML": "`foo ´<bdo dir=\"rtl\">`ba^r´</bdo>` baz´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\">`foo ´<bdo dir=\"rtl\">`ba^r´</bdo>` baz´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\">`foo ´<bdo dir=\"rtl\">`ba^r´</bdo>` baz´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\">`foo ´<bdo dir=\"rtl\">`ba^r´</bdo>` baz´</div>CAN<br>ARY</body>"
        }
      },
      "SM:m.f.c_TEXTrle-1_SC-rtl-1": {
        "dM": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`I said, \"(RLE)‫car يعني سيا^رة‬(PDF)\".´",
          "innerHTML": "`I said, \"(RLE)‫car يعني سيا^رة‬(PDF)\".´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`I said, \"(RLE)‫car يعني سيا^رة‬(PDF)\".´</body>",
          "bodyInnerHTML": "`I said, \"(RLE)‫car يعني سيا^رة‬(PDF)\".´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`I said, \"(RLE)‫car يعني سيا^رة‬(PDF)\".´</body>"
        },
        "body": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`I said, \"(RLE)‫car يعني سيا^رة‬(PDF)\".´",
          "innerHTML": "`I said, \"(RLE)‫car يعني سيا^رة‬(PDF)\".´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`I said, \"(RLE)‫car يعني سيا^رة‬(PDF)\".´</body>",
          "bodyInnerHTML": "`I said, \"(RLE)‫car يعني سيا^رة‬(PDF)\".´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`I said, \"(RLE)‫car يعني سيا^رة‬(PDF)\".´</body>"
        },
        "div": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`I said, \"(RLE)‫car يعني سيا^رة‬(PDF)\".´",
          "innerHTML": "`I said, \"(RLE)‫car يعني سيا^رة‬(PDF)\".´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\">`I said, \"(RLE)‫car يعني سيا^رة‬(PDF)\".´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\">`I said, \"(RLE)‫car يعني سيا^رة‬(PDF)\".´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\">`I said, \"(RLE)‫car يعني سيا^رة‬(PDF)\".´</div>CAN<br>ARY</body>"
        }
      },
      "SM:m.b.c_TEXTrle-1_SC-rtl-1": {
        "dM": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`I said, \"(RLE)‫car يعني س^يارة‬(PDF)\".´",
          "innerHTML": "`I said, \"(RLE)‫car يعني س^يارة‬(PDF)\".´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`I said, \"(RLE)‫car يعني س^يارة‬(PDF)\".´</body>",
          "bodyInnerHTML": "`I said, \"(RLE)‫car يعني س^يارة‬(PDF)\".´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`I said, \"(RLE)‫car يعني س^يارة‬(PDF)\".´</body>"
        },
        "body": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`I said, \"(RLE)‫car يعني س^يارة‬(PDF)\".´",
          "innerHTML": "`I said, \"(RLE)‫car يعني س^يارة‬(PDF)\".´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`I said, \"(RLE)‫car يعني س^يارة‬(PDF)\".´</body>",
          "bodyInnerHTML": "`I said, \"(RLE)‫car يعني س^يارة‬(PDF)\".´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`I said, \"(RLE)‫car يعني س^يارة‬(PDF)\".´</body>"
        },
        "div": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`I said, \"(RLE)‫car يعني س^يارة‬(PDF)\".´",
          "innerHTML": "`I said, \"(RLE)‫car يعني س^يارة‬(PDF)\".´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\">`I said, \"(RLE)‫car يعني س^يارة‬(PDF)\".´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\">`I said, \"(RLE)‫car يعني س^يارة‬(PDF)\".´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\">`I said, \"(RLE)‫car يعني س^يارة‬(PDF)\".´</div>CAN<br>ARY</body>"
        }
      },
      "SM:m.r.c_TEXTrle-1_SC-rtl-1": {
        "dM": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`I said, \"(RLE)‫car يعني س^يارة‬(PDF)\".´",
          "innerHTML": "`I said, \"(RLE)‫car يعني س^يارة‬(PDF)\".´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`I said, \"(RLE)‫car يعني س^يارة‬(PDF)\".´</body>",
          "bodyInnerHTML": "`I said, \"(RLE)‫car يعني س^يارة‬(PDF)\".´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`I said, \"(RLE)‫car يعني س^يارة‬(PDF)\".´</body>"
        },
        "body": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`I said, \"(RLE)‫car يعني س^يارة‬(PDF)\".´",
          "innerHTML": "`I said, \"(RLE)‫car يعني س^يارة‬(PDF)\".´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`I said, \"(RLE)‫car يعني س^يارة‬(PDF)\".´</body>",
          "bodyInnerHTML": "`I said, \"(RLE)‫car يعني س^يارة‬(PDF)\".´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`I said, \"(RLE)‫car يعني س^يارة‬(PDF)\".´</body>"
        },
        "div": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`I said, \"(RLE)‫car يعني س^يارة‬(PDF)\".´",
          "innerHTML": "`I said, \"(RLE)‫car يعني س^يارة‬(PDF)\".´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\">`I said, \"(RLE)‫car يعني س^يارة‬(PDF)\".´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\">`I said, \"(RLE)‫car يعني س^يارة‬(PDF)\".´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\">`I said, \"(RLE)‫car يعني س^يارة‬(PDF)\".´</div>CAN<br>ARY</body>"
        }
      },
      "SM:m.l.c_TEXTrle-1_SC-rtl-1": {
        "dM": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`I said, \"(RLE)‫car يعني سيا^رة‬(PDF)\".´",
          "innerHTML": "`I said, \"(RLE)‫car يعني سيا^رة‬(PDF)\".´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`I said, \"(RLE)‫car يعني سيا^رة‬(PDF)\".´</body>",
          "bodyInnerHTML": "`I said, \"(RLE)‫car يعني سيا^رة‬(PDF)\".´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`I said, \"(RLE)‫car يعني سيا^رة‬(PDF)\".´</body>"
        },
        "body": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`I said, \"(RLE)‫car يعني سيا^رة‬(PDF)\".´",
          "innerHTML": "`I said, \"(RLE)‫car يعني سيا^رة‬(PDF)\".´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`I said, \"(RLE)‫car يعني سيا^رة‬(PDF)\".´</body>",
          "bodyInnerHTML": "`I said, \"(RLE)‫car يعني سيا^رة‬(PDF)\".´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`I said, \"(RLE)‫car يعني سيا^رة‬(PDF)\".´</body>"
        },
        "div": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`I said, \"(RLE)‫car يعني سيا^رة‬(PDF)\".´",
          "innerHTML": "`I said, \"(RLE)‫car يعني سيا^رة‬(PDF)\".´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\">`I said, \"(RLE)‫car يعني سيا^رة‬(PDF)\".´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\">`I said, \"(RLE)‫car يعني سيا^رة‬(PDF)\".´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\">`I said, \"(RLE)‫car يعني سيا^رة‬(PDF)\".´</div>CAN<br>ARY</body>"
        }
      },
      "SM:m.f.c_TEXTrle-1_SC-ltr-1": {
        "dM": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`I said, \"(RLE)‫ca^r يعني سيارة‬(PDF)\".´",
          "innerHTML": "`I said, \"(RLE)‫ca^r يعني سيارة‬(PDF)\".´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`I said, \"(RLE)‫ca^r يعني سيارة‬(PDF)\".´</body>",
          "bodyInnerHTML": "`I said, \"(RLE)‫ca^r يعني سيارة‬(PDF)\".´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`I said, \"(RLE)‫ca^r يعني سيارة‬(PDF)\".´</body>"
        },
        "body": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`I said, \"(RLE)‫ca^r يعني سيارة‬(PDF)\".´",
          "innerHTML": "`I said, \"(RLE)‫ca^r يعني سيارة‬(PDF)\".´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`I said, \"(RLE)‫ca^r يعني سيارة‬(PDF)\".´</body>",
          "bodyInnerHTML": "`I said, \"(RLE)‫ca^r يعني سيارة‬(PDF)\".´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`I said, \"(RLE)‫ca^r يعني سيارة‬(PDF)\".´</body>"
        },
        "div": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`I said, \"(RLE)‫ca^r يعني سيارة‬(PDF)\".´",
          "innerHTML": "`I said, \"(RLE)‫ca^r يعني سيارة‬(PDF)\".´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\">`I said, \"(RLE)‫ca^r يعني سيارة‬(PDF)\".´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\">`I said, \"(RLE)‫ca^r يعني سيارة‬(PDF)\".´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\">`I said, \"(RLE)‫ca^r يعني سيارة‬(PDF)\".´</div>CAN<br>ARY</body>"
        }
      },
      "SM:m.b.c_TEXTrle-1_SC-ltr-1": {
        "dM": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`I said, \"(RLE)‫c^ar يعني سيارة‬(PDF)\".´",
          "innerHTML": "`I said, \"(RLE)‫c^ar يعني سيارة‬(PDF)\".´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`I said, \"(RLE)‫c^ar يعني سيارة‬(PDF)\".´</body>",
          "bodyInnerHTML": "`I said, \"(RLE)‫c^ar يعني سيارة‬(PDF)\".´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`I said, \"(RLE)‫c^ar يعني سيارة‬(PDF)\".´</body>"
        },
        "body": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`I said, \"(RLE)‫c^ar يعني سيارة‬(PDF)\".´",
          "innerHTML": "`I said, \"(RLE)‫c^ar يعني سيارة‬(PDF)\".´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`I said, \"(RLE)‫c^ar يعني سيارة‬(PDF)\".´</body>",
          "bodyInnerHTML": "`I said, \"(RLE)‫c^ar يعني سيارة‬(PDF)\".´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`I said, \"(RLE)‫c^ar يعني سيارة‬(PDF)\".´</body>"
        },
        "div": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`I said, \"(RLE)‫c^ar يعني سيارة‬(PDF)\".´",
          "innerHTML": "`I said, \"(RLE)‫c^ar يعني سيارة‬(PDF)\".´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\">`I said, \"(RLE)‫c^ar يعني سيارة‬(PDF)\".´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\">`I said, \"(RLE)‫c^ar يعني سيارة‬(PDF)\".´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\">`I said, \"(RLE)‫c^ar يعني سيارة‬(PDF)\".´</div>CAN<br>ARY</body>"
        }
      },
      "SM:m.r.c_TEXTrle-1_SC-ltr-1": {
        "dM": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`I said, \"(RLE)‫ca^r يعني سيارة‬(PDF)\".´",
          "innerHTML": "`I said, \"(RLE)‫ca^r يعني سيارة‬(PDF)\".´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`I said, \"(RLE)‫ca^r يعني سيارة‬(PDF)\".´</body>",
          "bodyInnerHTML": "`I said, \"(RLE)‫ca^r يعني سيارة‬(PDF)\".´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`I said, \"(RLE)‫ca^r يعني سيارة‬(PDF)\".´</body>"
        },
        "body": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`I said, \"(RLE)‫ca^r يعني سيارة‬(PDF)\".´",
          "innerHTML": "`I said, \"(RLE)‫ca^r يعني سيارة‬(PDF)\".´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`I said, \"(RLE)‫ca^r يعني سيارة‬(PDF)\".´</body>",
          "bodyInnerHTML": "`I said, \"(RLE)‫ca^r يعني سيارة‬(PDF)\".´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`I said, \"(RLE)‫ca^r يعني سيارة‬(PDF)\".´</body>"
        },
        "div": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`I said, \"(RLE)‫ca^r يعني سيارة‬(PDF)\".´",
          "innerHTML": "`I said, \"(RLE)‫ca^r يعني سيارة‬(PDF)\".´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\">`I said, \"(RLE)‫ca^r يعني سيارة‬(PDF)\".´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\">`I said, \"(RLE)‫ca^r يعني سيارة‬(PDF)\".´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\">`I said, \"(RLE)‫ca^r يعني سيارة‬(PDF)\".´</div>CAN<br>ARY</body>"
        }
      },
      "SM:m.l.c_TEXTrle-1_SC-ltr-1": {
        "dM": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`I said, \"(RLE)‫c^ar يعني سيارة‬(PDF)\".´",
          "innerHTML": "`I said, \"(RLE)‫c^ar يعني سيارة‬(PDF)\".´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`I said, \"(RLE)‫c^ar يعني سيارة‬(PDF)\".´</body>",
          "bodyInnerHTML": "`I said, \"(RLE)‫c^ar يعني سيارة‬(PDF)\".´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`I said, \"(RLE)‫c^ar يعني سيارة‬(PDF)\".´</body>"
        },
        "body": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`I said, \"(RLE)‫c^ar يعني سيارة‬(PDF)\".´",
          "innerHTML": "`I said, \"(RLE)‫c^ar يعني سيارة‬(PDF)\".´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`I said, \"(RLE)‫c^ar يعني سيارة‬(PDF)\".´</body>",
          "bodyInnerHTML": "`I said, \"(RLE)‫c^ar يعني سيارة‬(PDF)\".´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`I said, \"(RLE)‫c^ar يعني سيارة‬(PDF)\".´</body>"
        },
        "div": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`I said, \"(RLE)‫c^ar يعني سيارة‬(PDF)\".´",
          "innerHTML": "`I said, \"(RLE)‫c^ar يعني سيارة‬(PDF)\".´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\">`I said, \"(RLE)‫c^ar يعني سيارة‬(PDF)\".´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\">`I said, \"(RLE)‫c^ar يعني سيارة‬(PDF)\".´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\">`I said, \"(RLE)‫c^ar يعني سيارة‬(PDF)\".´</div>CAN<br>ARY</body>"
        }
      },
      "SM:m.f.c_TEXTrlo-1_SC-rtl-1": {
        "dM": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`I said, \"(RLO)‮car يعني سيا^رة‬(PDF)\".´",
          "innerHTML": "`I said, \"(RLO)‮car يعني سيا^رة‬(PDF)\".´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`I said, \"(RLO)‮car يعني سيا^رة‬(PDF)\".´</body>",
          "bodyInnerHTML": "`I said, \"(RLO)‮car يعني سيا^رة‬(PDF)\".´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`I said, \"(RLO)‮car يعني سيا^رة‬(PDF)\".´</body>"
        },
        "body": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`I said, \"(RLO)‮car يعني سيا^رة‬(PDF)\".´",
          "innerHTML": "`I said, \"(RLO)‮car يعني سيا^رة‬(PDF)\".´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`I said, \"(RLO)‮car يعني سيا^رة‬(PDF)\".´</body>",
          "bodyInnerHTML": "`I said, \"(RLO)‮car يعني سيا^رة‬(PDF)\".´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`I said, \"(RLO)‮car يعني سيا^رة‬(PDF)\".´</body>"
        },
        "div": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`I said, \"(RLO)‮car يعني سيا^رة‬(PDF)\".´",
          "innerHTML": "`I said, \"(RLO)‮car يعني سيا^رة‬(PDF)\".´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\">`I said, \"(RLO)‮car يعني سيا^رة‬(PDF)\".´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\">`I said, \"(RLO)‮car يعني سيا^رة‬(PDF)\".´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\">`I said, \"(RLO)‮car يعني سيا^رة‬(PDF)\".´</div>CAN<br>ARY</body>"
        }
      },
      "SM:m.b.c_TEXTrlo-1_SC-rtl-1": {
        "dM": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`I said, \"(RLO)‮car يعني س^يارة‬(PDF)\".´",
          "innerHTML": "`I said, \"(RLO)‮car يعني س^يارة‬(PDF)\".´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`I said, \"(RLO)‮car يعني س^يارة‬(PDF)\".´</body>",
          "bodyInnerHTML": "`I said, \"(RLO)‮car يعني س^يارة‬(PDF)\".´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`I said, \"(RLO)‮car يعني س^يارة‬(PDF)\".´</body>"
        },
        "body": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`I said, \"(RLO)‮car يعني س^يارة‬(PDF)\".´",
          "innerHTML": "`I said, \"(RLO)‮car يعني س^يارة‬(PDF)\".´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`I said, \"(RLO)‮car يعني س^يارة‬(PDF)\".´</body>",
          "bodyInnerHTML": "`I said, \"(RLO)‮car يعني س^يارة‬(PDF)\".´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`I said, \"(RLO)‮car يعني س^يارة‬(PDF)\".´</body>"
        },
        "div": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`I said, \"(RLO)‮car يعني س^يارة‬(PDF)\".´",
          "innerHTML": "`I said, \"(RLO)‮car يعني س^يارة‬(PDF)\".´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\">`I said, \"(RLO)‮car يعني س^يارة‬(PDF)\".´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\">`I said, \"(RLO)‮car يعني س^يارة‬(PDF)\".´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\">`I said, \"(RLO)‮car يعني س^يارة‬(PDF)\".´</div>CAN<br>ARY</body>"
        }
      },
      "SM:m.r.c_TEXTrlo-1_SC-rtl-1": {
        "dM": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`I said, \"(RLO)‮car يعني س^يارة‬(PDF)\".´",
          "innerHTML": "`I said, \"(RLO)‮car يعني س^يارة‬(PDF)\".´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`I said, \"(RLO)‮car يعني س^يارة‬(PDF)\".´</body>",
          "bodyInnerHTML": "`I said, \"(RLO)‮car يعني س^يارة‬(PDF)\".´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`I said, \"(RLO)‮car يعني س^يارة‬(PDF)\".´</body>"
        },
        "body": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`I said, \"(RLO)‮car يعني س^يارة‬(PDF)\".´",
          "innerHTML": "`I said, \"(RLO)‮car يعني س^يارة‬(PDF)\".´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`I said, \"(RLO)‮car يعني س^يارة‬(PDF)\".´</body>",
          "bodyInnerHTML": "`I said, \"(RLO)‮car يعني س^يارة‬(PDF)\".´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`I said, \"(RLO)‮car يعني س^يارة‬(PDF)\".´</body>"
        },
        "div": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`I said, \"(RLO)‮car يعني س^يارة‬(PDF)\".´",
          "innerHTML": "`I said, \"(RLO)‮car يعني س^يارة‬(PDF)\".´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\">`I said, \"(RLO)‮car يعني س^يارة‬(PDF)\".´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\">`I said, \"(RLO)‮car يعني س^يارة‬(PDF)\".´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\">`I said, \"(RLO)‮car يعني س^يارة‬(PDF)\".´</div>CAN<br>ARY</body>"
        }
      },
      "SM:m.l.c_TEXTrlo-1_SC-rtl-1": {
        "dM": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`I said, \"(RLO)‮car يعني سيا^رة‬(PDF)\".´",
          "innerHTML": "`I said, \"(RLO)‮car يعني سيا^رة‬(PDF)\".´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`I said, \"(RLO)‮car يعني سيا^رة‬(PDF)\".´</body>",
          "bodyInnerHTML": "`I said, \"(RLO)‮car يعني سيا^رة‬(PDF)\".´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`I said, \"(RLO)‮car يعني سيا^رة‬(PDF)\".´</body>"
        },
        "body": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`I said, \"(RLO)‮car يعني سيا^رة‬(PDF)\".´",
          "innerHTML": "`I said, \"(RLO)‮car يعني سيا^رة‬(PDF)\".´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`I said, \"(RLO)‮car يعني سيا^رة‬(PDF)\".´</body>",
          "bodyInnerHTML": "`I said, \"(RLO)‮car يعني سيا^رة‬(PDF)\".´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`I said, \"(RLO)‮car يعني سيا^رة‬(PDF)\".´</body>"
        },
        "div": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`I said, \"(RLO)‮car يعني سيا^رة‬(PDF)\".´",
          "innerHTML": "`I said, \"(RLO)‮car يعني سيا^رة‬(PDF)\".´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\">`I said, \"(RLO)‮car يعني سيا^رة‬(PDF)\".´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\">`I said, \"(RLO)‮car يعني سيا^رة‬(PDF)\".´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\">`I said, \"(RLO)‮car يعني سيا^رة‬(PDF)\".´</div>CAN<br>ARY</body>"
        }
      },
      "SM:m.f.c_TEXTrlo-1_SC-ltr-1": {
        "dM": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`I said, \"(RLO)‮ca^r يعني سيارة‬(PDF)\".´",
          "innerHTML": "`I said, \"(RLO)‮ca^r يعني سيارة‬(PDF)\".´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`I said, \"(RLO)‮ca^r يعني سيارة‬(PDF)\".´</body>",
          "bodyInnerHTML": "`I said, \"(RLO)‮ca^r يعني سيارة‬(PDF)\".´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`I said, \"(RLO)‮ca^r يعني سيارة‬(PDF)\".´</body>"
        },
        "body": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`I said, \"(RLO)‮ca^r يعني سيارة‬(PDF)\".´",
          "innerHTML": "`I said, \"(RLO)‮ca^r يعني سيارة‬(PDF)\".´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`I said, \"(RLO)‮ca^r يعني سيارة‬(PDF)\".´</body>",
          "bodyInnerHTML": "`I said, \"(RLO)‮ca^r يعني سيارة‬(PDF)\".´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`I said, \"(RLO)‮ca^r يعني سيارة‬(PDF)\".´</body>"
        },
        "div": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`I said, \"(RLO)‮ca^r يعني سيارة‬(PDF)\".´",
          "innerHTML": "`I said, \"(RLO)‮ca^r يعني سيارة‬(PDF)\".´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\">`I said, \"(RLO)‮ca^r يعني سيارة‬(PDF)\".´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\">`I said, \"(RLO)‮ca^r يعني سيارة‬(PDF)\".´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\">`I said, \"(RLO)‮ca^r يعني سيارة‬(PDF)\".´</div>CAN<br>ARY</body>"
        }
      },
      "SM:m.b.c_TEXTrlo-1_SC-ltr-1": {
        "dM": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`I said, \"(RLO)‮c^ar يعني سيارة‬(PDF)\".´",
          "innerHTML": "`I said, \"(RLO)‮c^ar يعني سيارة‬(PDF)\".´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`I said, \"(RLO)‮c^ar يعني سيارة‬(PDF)\".´</body>",
          "bodyInnerHTML": "`I said, \"(RLO)‮c^ar يعني سيارة‬(PDF)\".´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`I said, \"(RLO)‮c^ar يعني سيارة‬(PDF)\".´</body>"
        },
        "body": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`I said, \"(RLO)‮c^ar يعني سيارة‬(PDF)\".´",
          "innerHTML": "`I said, \"(RLO)‮c^ar يعني سيارة‬(PDF)\".´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`I said, \"(RLO)‮c^ar يعني سيارة‬(PDF)\".´</body>",
          "bodyInnerHTML": "`I said, \"(RLO)‮c^ar يعني سيارة‬(PDF)\".´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`I said, \"(RLO)‮c^ar يعني سيارة‬(PDF)\".´</body>"
        },
        "div": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`I said, \"(RLO)‮c^ar يعني سيارة‬(PDF)\".´",
          "innerHTML": "`I said, \"(RLO)‮c^ar يعني سيارة‬(PDF)\".´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\">`I said, \"(RLO)‮c^ar يعني سيارة‬(PDF)\".´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\">`I said, \"(RLO)‮c^ar يعني سيارة‬(PDF)\".´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\">`I said, \"(RLO)‮c^ar يعني سيارة‬(PDF)\".´</div>CAN<br>ARY</body>"
        }
      },
      "SM:m.r.c_TEXTrlo-1_SC-ltr-1": {
        "dM": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`I said, \"(RLO)‮c^ar يعني سيارة‬(PDF)\".´",
          "innerHTML": "`I said, \"(RLO)‮c^ar يعني سيارة‬(PDF)\".´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`I said, \"(RLO)‮c^ar يعني سيارة‬(PDF)\".´</body>",
          "bodyInnerHTML": "`I said, \"(RLO)‮c^ar يعني سيارة‬(PDF)\".´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`I said, \"(RLO)‮c^ar يعني سيارة‬(PDF)\".´</body>"
        },
        "body": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`I said, \"(RLO)‮c^ar يعني سيارة‬(PDF)\".´",
          "innerHTML": "`I said, \"(RLO)‮c^ar يعني سيارة‬(PDF)\".´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`I said, \"(RLO)‮c^ar يعني سيارة‬(PDF)\".´</body>",
          "bodyInnerHTML": "`I said, \"(RLO)‮c^ar يعني سيارة‬(PDF)\".´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`I said, \"(RLO)‮c^ar يعني سيارة‬(PDF)\".´</body>"
        },
        "div": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`I said, \"(RLO)‮c^ar يعني سيارة‬(PDF)\".´",
          "innerHTML": "`I said, \"(RLO)‮c^ar يعني سيارة‬(PDF)\".´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\">`I said, \"(RLO)‮c^ar يعني سيارة‬(PDF)\".´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\">`I said, \"(RLO)‮c^ar يعني سيارة‬(PDF)\".´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\">`I said, \"(RLO)‮c^ar يعني سيارة‬(PDF)\".´</div>CAN<br>ARY</body>"
        }
      },
      "SM:m.l.c_TEXTrlo-1_SC-ltr-1": {
        "dM": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`I said, \"(RLO)‮ca^r يعني سيارة‬(PDF)\".´",
          "innerHTML": "`I said, \"(RLO)‮ca^r يعني سيارة‬(PDF)\".´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`I said, \"(RLO)‮ca^r يعني سيارة‬(PDF)\".´</body>",
          "bodyInnerHTML": "`I said, \"(RLO)‮ca^r يعني سيارة‬(PDF)\".´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`I said, \"(RLO)‮ca^r يعني سيارة‬(PDF)\".´</body>"
        },
        "body": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`I said, \"(RLO)‮ca^r يعني سيارة‬(PDF)\".´",
          "innerHTML": "`I said, \"(RLO)‮ca^r يعني سيارة‬(PDF)\".´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`I said, \"(RLO)‮ca^r يعني سيارة‬(PDF)\".´</body>",
          "bodyInnerHTML": "`I said, \"(RLO)‮ca^r يعني سيارة‬(PDF)\".´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`I said, \"(RLO)‮ca^r يعني سيارة‬(PDF)\".´</body>"
        },
        "div": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`I said, \"(RLO)‮ca^r يعني سيارة‬(PDF)\".´",
          "innerHTML": "`I said, \"(RLO)‮ca^r يعني سيارة‬(PDF)\".´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\">`I said, \"(RLO)‮ca^r يعني سيارة‬(PDF)\".´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\">`I said, \"(RLO)‮ca^r يعني سيارة‬(PDF)\".´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\">`I said, \"(RLO)‮ca^r يعني سيارة‬(PDF)\".´</div>CAN<br>ARY</body>"
        }
      },
      "SM:m.f.c_TEXTrlm-1_SC-1": {
        "dM": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`I said, \"يعني سيارة!?^!‏(RLM)\".´",
          "innerHTML": "`I said, \"يعني سيارة!?^!‏(RLM)\".´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`I said, \"يعني سيارة!?^!‏(RLM)\".´</body>",
          "bodyInnerHTML": "`I said, \"يعني سيارة!?^!‏(RLM)\".´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`I said, \"يعني سيارة!?^!‏(RLM)\".´</body>"
        },
        "body": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`I said, \"يعني سيارة!?^!‏(RLM)\".´",
          "innerHTML": "`I said, \"يعني سيارة!?^!‏(RLM)\".´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`I said, \"يعني سيارة!?^!‏(RLM)\".´</body>",
          "bodyInnerHTML": "`I said, \"يعني سيارة!?^!‏(RLM)\".´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`I said, \"يعني سيارة!?^!‏(RLM)\".´</body>"
        },
        "div": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`I said, \"يعني سيارة!?^!‏(RLM)\".´",
          "innerHTML": "`I said, \"يعني سيارة!?^!‏(RLM)\".´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\">`I said, \"يعني سيارة!?^!‏(RLM)\".´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\">`I said, \"يعني سيارة!?^!‏(RLM)\".´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\">`I said, \"يعني سيارة!?^!‏(RLM)\".´</div>CAN<br>ARY</body>"
        }
      },
      "SM:m.b.c_TEXTrlm-1_SC-1": {
        "dM": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`I said, \"يعني سيارة!^?!‏(RLM)\".´",
          "innerHTML": "`I said, \"يعني سيارة!^?!‏(RLM)\".´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`I said, \"يعني سيارة!^?!‏(RLM)\".´</body>",
          "bodyInnerHTML": "`I said, \"يعني سيارة!^?!‏(RLM)\".´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`I said, \"يعني سيارة!^?!‏(RLM)\".´</body>"
        },
        "body": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`I said, \"يعني سيارة!^?!‏(RLM)\".´",
          "innerHTML": "`I said, \"يعني سيارة!^?!‏(RLM)\".´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`I said, \"يعني سيارة!^?!‏(RLM)\".´</body>",
          "bodyInnerHTML": "`I said, \"يعني سيارة!^?!‏(RLM)\".´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`I said, \"يعني سيارة!^?!‏(RLM)\".´</body>"
        },
        "div": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`I said, \"يعني سيارة!^?!‏(RLM)\".´",
          "innerHTML": "`I said, \"يعني سيارة!^?!‏(RLM)\".´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\">`I said, \"يعني سيارة!^?!‏(RLM)\".´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\">`I said, \"يعني سيارة!^?!‏(RLM)\".´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\">`I said, \"يعني سيارة!^?!‏(RLM)\".´</div>CAN<br>ARY</body>"
        }
      },
      "SM:m.r.c_TEXTrlm-1_SC-1": {
        "dM": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`I said, \"يعني سيارة!^?!‏(RLM)\".´",
          "innerHTML": "`I said, \"يعني سيارة!^?!‏(RLM)\".´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`I said, \"يعني سيارة!^?!‏(RLM)\".´</body>",
          "bodyInnerHTML": "`I said, \"يعني سيارة!^?!‏(RLM)\".´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`I said, \"يعني سيارة!^?!‏(RLM)\".´</body>"
        },
        "body": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`I said, \"يعني سيارة!^?!‏(RLM)\".´",
          "innerHTML": "`I said, \"يعني سيارة!^?!‏(RLM)\".´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`I said, \"يعني سيارة!^?!‏(RLM)\".´</body>",
          "bodyInnerHTML": "`I said, \"يعني سيارة!^?!‏(RLM)\".´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`I said, \"يعني سيارة!^?!‏(RLM)\".´</body>"
        },
        "div": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`I said, \"يعني سيارة!^?!‏(RLM)\".´",
          "innerHTML": "`I said, \"يعني سيارة!^?!‏(RLM)\".´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\">`I said, \"يعني سيارة!^?!‏(RLM)\".´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\">`I said, \"يعني سيارة!^?!‏(RLM)\".´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\">`I said, \"يعني سيارة!^?!‏(RLM)\".´</div>CAN<br>ARY</body>"
        }
      },
      "SM:m.l.c_TEXTrlm-1_SC-1": {
        "dM": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`I said, \"يعني سيارة!?^!‏(RLM)\".´",
          "innerHTML": "`I said, \"يعني سيارة!?^!‏(RLM)\".´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`I said, \"يعني سيارة!?^!‏(RLM)\".´</body>",
          "bodyInnerHTML": "`I said, \"يعني سيارة!?^!‏(RLM)\".´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`I said, \"يعني سيارة!?^!‏(RLM)\".´</body>"
        },
        "body": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`I said, \"يعني سيارة!?^!‏(RLM)\".´",
          "innerHTML": "`I said, \"يعني سيارة!?^!‏(RLM)\".´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`I said, \"يعني سيارة!?^!‏(RLM)\".´</body>",
          "bodyInnerHTML": "`I said, \"يعني سيارة!?^!‏(RLM)\".´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`I said, \"يعني سيارة!?^!‏(RLM)\".´</body>"
        },
        "div": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`I said, \"يعني سيارة!?^!‏(RLM)\".´",
          "innerHTML": "`I said, \"يعني سيارة!?^!‏(RLM)\".´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\">`I said, \"يعني سيارة!?^!‏(RLM)\".´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\">`I said, \"يعني سيارة!?^!‏(RLM)\".´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\">`I said, \"يعني سيارة!?^!‏(RLM)\".´</div>CAN<br>ARY</body>"
        }
      },
      "SM:m.f.w_TEXT-jp_SC-1": {
        "dM": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 2,
          "output": "`面白^い例文をテストしましょう。´",
          "innerHTML": "`面白^い例文をテストしましょう。´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`面白^い例文をテストしましょう。´</body>",
          "bodyInnerHTML": "`面白^い例文をテストしましょう。´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`面白^い例文をテストしましょう。´</body>"
        },
        "body": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 2,
          "output": "`面白^い例文をテストしましょう。´",
          "innerHTML": "`面白^い例文をテストしましょう。´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`面白^い例文をテストしましょう。´</body>",
          "bodyInnerHTML": "`面白^い例文をテストしましょう。´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`面白^い例文をテストしましょう。´</body>"
        },
        "div": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 2,
          "output": "`面白^い例文をテストしましょう。´",
          "innerHTML": "`面白^い例文をテストしましょう。´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\">`面白^い例文をテストしましょう。´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\">`面白^い例文をテストしましょう。´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\">`面白^い例文をテストしましょう。´</div>CAN<br>ARY</body>"
        }
      },
      "SM:m.f.w_TEXT-jp_SC-2": {
        "dM": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 2,
          "output": "`面白^い例文をテストしましょう。´",
          "innerHTML": "`面白^い例文をテストしましょう。´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`面白^い例文をテストしましょう。´</body>",
          "bodyInnerHTML": "`面白^い例文をテストしましょう。´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`面白^い例文をテストしましょう。´</body>"
        },
        "body": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 2,
          "output": "`面白^い例文をテストしましょう。´",
          "innerHTML": "`面白^い例文をテストしましょう。´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`面白^い例文をテストしましょう。´</body>",
          "bodyInnerHTML": "`面白^い例文をテストしましょう。´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`面白^い例文をテストしましょう。´</body>"
        },
        "div": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 2,
          "output": "`面白^い例文をテストしましょう。´",
          "innerHTML": "`面白^い例文をテストしましょう。´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\">`面白^い例文をテストしましょう。´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\">`面白^い例文をテストしましょう。´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\">`面白^い例文をテストしましょう。´</div>CAN<br>ARY</body>"
        }
      },
      "SM:m.f.w_TEXT-jp_SC-3": {
        "dM": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`面白い例文^をテストしましょう。´",
          "innerHTML": "`面白い例文^をテストしましょう。´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`面白い例文^をテストしましょう。´</body>",
          "bodyInnerHTML": "`面白い例文^をテストしましょう。´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`面白い例文^をテストしましょう。´</body>"
        },
        "body": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`面白い例文^をテストしましょう。´",
          "innerHTML": "`面白い例文^をテストしましょう。´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`面白い例文^をテストしましょう。´</body>",
          "bodyInnerHTML": "`面白い例文^をテストしましょう。´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`面白い例文^をテストしましょう。´</body>"
        },
        "div": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`面白い例文^をテストしましょう。´",
          "innerHTML": "`面白い例文^をテストしましょう。´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\">`面白い例文^をテストしましょう。´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\">`面白い例文^をテストしましょう。´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\">`面白い例文^をテストしましょう。´</div>CAN<br>ARY</body>"
        }
      },
      "SM:m.f.w_TEXT-jp_SC-4": {
        "dM": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`面白い例文をテスト^しましょう。´",
          "innerHTML": "`面白い例文をテスト^しましょう。´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`面白い例文をテスト^しましょう。´</body>",
          "bodyInnerHTML": "`面白い例文をテスト^しましょう。´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`面白い例文をテスト^しましょう。´</body>"
        },
        "body": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`面白い例文をテスト^しましょう。´",
          "innerHTML": "`面白い例文をテスト^しましょう。´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`面白い例文をテスト^しましょう。´</body>",
          "bodyInnerHTML": "`面白い例文をテスト^しましょう。´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`面白い例文をテスト^しましょう。´</body>"
        },
        "div": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`面白い例文をテスト^しましょう。´",
          "innerHTML": "`面白い例文をテスト^しましょう。´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\">`面白い例文をテスト^しましょう。´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\">`面白い例文をテスト^しましょう。´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\">`面白い例文をテスト^しましょう。´</div>CAN<br>ARY</body>"
        }
      },
      "SM:m.f.w_TEXT-jp_SC-5": {
        "dM": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 2,
          "output": "`面白い例文をテストしましょう。^´",
          "innerHTML": "`面白い例文をテストしましょう。^´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`面白い例文をテストしましょう。^´</body>",
          "bodyInnerHTML": "`面白い例文をテストしましょう。^´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`面白い例文をテストしましょう。^´</body>"
        },
        "body": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 2,
          "output": "`面白い例文をテストしましょう。^´",
          "innerHTML": "`面白い例文をテストしましょう。^´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`面白い例文をテストしましょう。^´</body>",
          "bodyInnerHTML": "`面白い例文をテストしましょう。^´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`面白い例文をテストしましょう。^´</body>"
        },
        "div": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 2,
          "output": "`面白い例文をテストしましょう。^´",
          "innerHTML": "`面白い例文をテストしましょう。^´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\">`面白い例文をテストしましょう。^´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\">`面白い例文をテストしましょう。^´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\">`面白い例文をテストしましょう。^´</div>CAN<br>ARY</body>"
        }
      },
      "SM:e.f.c_TEXT-1_SC-1": {
        "dM": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`foo [b]ar baz´",
          "innerHTML": "`foo [b]ar baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo [b]ar baz´</body>",
          "bodyInnerHTML": "`foo [b]ar baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo [b]ar baz´</body>"
        },
        "body": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`foo [b]ar baz´",
          "innerHTML": "`foo [b]ar baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo [b]ar baz´</body>",
          "bodyInnerHTML": "`foo [b]ar baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo [b]ar baz´</body>"
        },
        "div": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`foo [b]ar baz´",
          "innerHTML": "`foo [b]ar baz´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\">`foo [b]ar baz´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\">`foo [b]ar baz´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\">`foo [b]ar baz´</div>CAN<br>ARY</body>"
        }
      },
      "SM:e.f.c_TEXT-1_SI-1": {
        "dM": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`foo [ba]r baz´",
          "innerHTML": "`foo [ba]r baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo [ba]r baz´</body>",
          "bodyInnerHTML": "`foo [ba]r baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo [ba]r baz´</body>"
        },
        "body": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`foo [ba]r baz´",
          "innerHTML": "`foo [ba]r baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo [ba]r baz´</body>",
          "bodyInnerHTML": "`foo [ba]r baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo [ba]r baz´</body>"
        },
        "div": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`foo [ba]r baz´",
          "innerHTML": "`foo [ba]r baz´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\">`foo [ba]r baz´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\">`foo [ba]r baz´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\">`foo [ba]r baz´</div>CAN<br>ARY</body>"
        }
      },
      "SM:e.f.w_TEXT-1_SC-1": {
        "dM": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`foo [bar] baz´",
          "innerHTML": "`foo [bar] baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo [bar] baz´</body>",
          "bodyInnerHTML": "`foo [bar] baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo [bar] baz´</body>"
        },
        "body": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`foo [bar] baz´",
          "innerHTML": "`foo [bar] baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo [bar] baz´</body>",
          "bodyInnerHTML": "`foo [bar] baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo [bar] baz´</body>"
        },
        "div": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`foo [bar] baz´",
          "innerHTML": "`foo [bar] baz´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\">`foo [bar] baz´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\">`foo [bar] baz´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\">`foo [bar] baz´</div>CAN<br>ARY</body>"
        }
      },
      "SM:e.f.w_TEXT-1_SI-1": {
        "dM": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`foo [bar] baz´",
          "innerHTML": "`foo [bar] baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo [bar] baz´</body>",
          "bodyInnerHTML": "`foo [bar] baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo [bar] baz´</body>"
        },
        "body": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`foo [bar] baz´",
          "innerHTML": "`foo [bar] baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo [bar] baz´</body>",
          "bodyInnerHTML": "`foo [bar] baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo [bar] baz´</body>"
        },
        "div": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`foo [bar] baz´",
          "innerHTML": "`foo [bar] baz´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\">`foo [bar] baz´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\">`foo [bar] baz´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\">`foo [bar] baz´</div>CAN<br>ARY</body>"
        }
      },
      "SM:e.f.w_TEXT-1_SI-2": {
        "dM": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`foo [bar baz]´",
          "innerHTML": "`foo [bar baz]´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo [bar baz]´</body>",
          "bodyInnerHTML": "`foo [bar baz]´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo [bar baz]´</body>"
        },
        "body": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`foo [bar baz]´",
          "innerHTML": "`foo [bar baz]´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo [bar baz]´</body>",
          "bodyInnerHTML": "`foo [bar baz]´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo [bar baz]´</body>"
        },
        "div": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`foo [bar baz]´",
          "innerHTML": "`foo [bar baz]´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\">`foo [bar baz]´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\">`foo [bar baz]´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\">`foo [bar baz]´</div>CAN<br>ARY</body>"
        }
      },
      "SM:e.b.c_TEXT-1_SI-2": {
        "dM": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`foo [ba]r baz´",
          "innerHTML": "`foo [ba]r baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo [ba]r baz´</body>",
          "bodyInnerHTML": "`foo [ba]r baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo [ba]r baz´</body>"
        },
        "body": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`foo [ba]r baz´",
          "innerHTML": "`foo [ba]r baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo [ba]r baz´</body>",
          "bodyInnerHTML": "`foo [ba]r baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo [ba]r baz´</body>"
        },
        "div": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`foo [ba]r baz´",
          "innerHTML": "`foo [ba]r baz´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\">`foo [ba]r baz´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\">`foo [ba]r baz´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\">`foo [ba]r baz´</div>CAN<br>ARY</body>"
        }
      },
      "SM:e.b.c_TEXT-1_SI-1": {
        "dM": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`foo ^bar baz´",
          "innerHTML": "`foo ^bar baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo ^bar baz´</body>",
          "bodyInnerHTML": "`foo ^bar baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo ^bar baz´</body>"
        },
        "body": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`foo ^bar baz´",
          "innerHTML": "`foo ^bar baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo ^bar baz´</body>",
          "bodyInnerHTML": "`foo ^bar baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo ^bar baz´</body>"
        },
        "div": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`foo ^bar baz´",
          "innerHTML": "`foo ^bar baz´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\">`foo ^bar baz´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\">`foo ^bar baz´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\">`foo ^bar baz´</div>CAN<br>ARY</body>"
        }
      },
      "SM:e.b.w_TEXT-1_SI-3": {
        "dM": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 2,
          "output": "`foo [bar ]baz´",
          "innerHTML": "`foo [bar ]baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo [bar ]baz´</body>",
          "bodyInnerHTML": "`foo [bar ]baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo [bar ]baz´</body>"
        },
        "body": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 2,
          "output": "`foo [bar ]baz´",
          "innerHTML": "`foo [bar ]baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo [bar ]baz´</body>",
          "bodyInnerHTML": "`foo [bar ]baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo [bar ]baz´</body>"
        },
        "div": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 2,
          "output": "`foo [bar ]baz´",
          "innerHTML": "`foo [bar ]baz´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\">`foo [bar ]baz´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\">`foo [bar ]baz´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\">`foo [bar ]baz´</div>CAN<br>ARY</body>"
        }
      },
      "SM:e.b.w_TEXT-1_SI-2": {
        "dM": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`foo ^bar baz´",
          "innerHTML": "`foo ^bar baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo ^bar baz´</body>",
          "bodyInnerHTML": "`foo ^bar baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo ^bar baz´</body>"
        },
        "body": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`foo ^bar baz´",
          "innerHTML": "`foo ^bar baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo ^bar baz´</body>",
          "bodyInnerHTML": "`foo ^bar baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo ^bar baz´</body>"
        },
        "div": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`foo ^bar baz´",
          "innerHTML": "`foo ^bar baz´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\">`foo ^bar baz´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\">`foo ^bar baz´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\">`foo ^bar baz´</div>CAN<br>ARY</body>"
        }
      },
      "SM:e.b.w_TEXT-1_SI-4": {
        "dM": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 2,
          "output": "`foo b[ar ]baz´",
          "innerHTML": "`foo b[ar ]baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo b[ar ]baz´</body>",
          "bodyInnerHTML": "`foo b[ar ]baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo b[ar ]baz´</body>"
        },
        "body": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 2,
          "output": "`foo b[ar ]baz´",
          "innerHTML": "`foo b[ar ]baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo b[ar ]baz´</body>",
          "bodyInnerHTML": "`foo b[ar ]baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo b[ar ]baz´</body>"
        },
        "div": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 2,
          "output": "`foo b[ar ]baz´",
          "innerHTML": "`foo b[ar ]baz´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\">`foo b[ar ]baz´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\">`foo b[ar ]baz´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\">`foo b[ar ]baz´</div>CAN<br>ARY</body>"
        }
      },
      "SM:e.b.w_TEXT-1_SI-5": {
        "dM": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 2,
          "output": "`foo ]b[ar baz´",
          "innerHTML": "`foo ]b[ar baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo ]b[ar baz´</body>",
          "bodyInnerHTML": "`foo ]b[ar baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo ]b[ar baz´</body>"
        },
        "body": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 2,
          "output": "`foo ]b[ar baz´",
          "innerHTML": "`foo ]b[ar baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo ]b[ar baz´</body>",
          "bodyInnerHTML": "`foo ]b[ar baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo ]b[ar baz´</body>"
        },
        "div": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 2,
          "output": "`foo ]b[ar baz´",
          "innerHTML": "`foo ]b[ar baz´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\">`foo ]b[ar baz´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\">`foo ]b[ar baz´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\">`foo ]b[ar baz´</div>CAN<br>ARY</body>"
        }
      },
      "SM:e.b.c_TEXT-1_SC-1": {
        "dM": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`foo ]b[ar baz´",
          "innerHTML": "`foo ]b[ar baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo ]b[ar baz´</body>",
          "bodyInnerHTML": "`foo ]b[ar baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo ]b[ar baz´</body>"
        },
        "body": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`foo ]b[ar baz´",
          "innerHTML": "`foo ]b[ar baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo ]b[ar baz´</body>",
          "bodyInnerHTML": "`foo ]b[ar baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo ]b[ar baz´</body>"
        },
        "div": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`foo ]b[ar baz´",
          "innerHTML": "`foo ]b[ar baz´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\">`foo ]b[ar baz´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\">`foo ]b[ar baz´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\">`foo ]b[ar baz´</div>CAN<br>ARY</body>"
        }
      },
      "SM:e.b.c_TEXT-1_SIR-1": {
        "dM": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`foo ]ba[r baz´",
          "innerHTML": "`foo ]ba[r baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo ]ba[r baz´</body>",
          "bodyInnerHTML": "`foo ]ba[r baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo ]ba[r baz´</body>"
        },
        "body": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`foo ]ba[r baz´",
          "innerHTML": "`foo ]ba[r baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo ]ba[r baz´</body>",
          "bodyInnerHTML": "`foo ]ba[r baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo ]ba[r baz´</body>"
        },
        "div": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`foo ]ba[r baz´",
          "innerHTML": "`foo ]ba[r baz´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\">`foo ]ba[r baz´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\">`foo ]ba[r baz´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\">`foo ]ba[r baz´</div>CAN<br>ARY</body>"
        }
      },
      "SM:e.b.w_TEXT-1_SIR-1": {
        "dM": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`foo ]ba[r baz´",
          "innerHTML": "`foo ]ba[r baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo ]ba[r baz´</body>",
          "bodyInnerHTML": "`foo ]ba[r baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo ]ba[r baz´</body>"
        },
        "body": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`foo ]ba[r baz´",
          "innerHTML": "`foo ]ba[r baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo ]ba[r baz´</body>",
          "bodyInnerHTML": "`foo ]ba[r baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo ]ba[r baz´</body>"
        },
        "div": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`foo ]ba[r baz´",
          "innerHTML": "`foo ]ba[r baz´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\">`foo ]ba[r baz´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\">`foo ]ba[r baz´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\">`foo ]ba[r baz´</div>CAN<br>ARY</body>"
        }
      },
      "SM:e.b.w_TEXT-1_SIR-2": {
        "dM": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`]foo ba[r baz´",
          "innerHTML": "`]foo ba[r baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`]foo ba[r baz´</body>",
          "bodyInnerHTML": "`]foo ba[r baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`]foo ba[r baz´</body>"
        },
        "body": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`]foo ba[r baz´",
          "innerHTML": "`]foo ba[r baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`]foo ba[r baz´</body>",
          "bodyInnerHTML": "`]foo ba[r baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`]foo ba[r baz´</body>"
        },
        "div": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`]foo ba[r baz´",
          "innerHTML": "`]foo ba[r baz´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\">`]foo ba[r baz´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\">`]foo ba[r baz´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\">`]foo ba[r baz´</div>CAN<br>ARY</body>"
        }
      },
      "SM:e.f.c_TEXT-1_SIR-1": {
        "dM": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`foo ba^r baz´",
          "innerHTML": "`foo ba^r baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo ba^r baz´</body>",
          "bodyInnerHTML": "`foo ba^r baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo ba^r baz´</body>"
        },
        "body": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`foo ba^r baz´",
          "innerHTML": "`foo ba^r baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo ba^r baz´</body>",
          "bodyInnerHTML": "`foo ba^r baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo ba^r baz´</body>"
        },
        "div": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`foo ba^r baz´",
          "innerHTML": "`foo ba^r baz´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\">`foo ba^r baz´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\">`foo ba^r baz´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\">`foo ba^r baz´</div>CAN<br>ARY</body>"
        }
      },
      "SM:e.f.c_TEXT-1_SIR-2": {
        "dM": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`foo b]a[r baz´",
          "innerHTML": "`foo b]a[r baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo b]a[r baz´</body>",
          "bodyInnerHTML": "`foo b]a[r baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo b]a[r baz´</body>"
        },
        "body": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`foo b]a[r baz´",
          "innerHTML": "`foo b]a[r baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo b]a[r baz´</body>",
          "bodyInnerHTML": "`foo b]a[r baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo b]a[r baz´</body>"
        },
        "div": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`foo b]a[r baz´",
          "innerHTML": "`foo b]a[r baz´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\">`foo b]a[r baz´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\">`foo b]a[r baz´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\">`foo b]a[r baz´</div>CAN<br>ARY</body>"
        }
      },
      "SM:e.f.w_TEXT-1_SIR-1": {
        "dM": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 2,
          "output": "`foo ba[r] baz´",
          "innerHTML": "`foo ba[r] baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo ba[r] baz´</body>",
          "bodyInnerHTML": "`foo ba[r] baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo ba[r] baz´</body>"
        },
        "body": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 2,
          "output": "`foo ba[r] baz´",
          "innerHTML": "`foo ba[r] baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo ba[r] baz´</body>",
          "bodyInnerHTML": "`foo ba[r] baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo ba[r] baz´</body>"
        },
        "div": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 2,
          "output": "`foo ba[r] baz´",
          "innerHTML": "`foo ba[r] baz´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\">`foo ba[r] baz´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\">`foo ba[r] baz´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\">`foo ba[r] baz´</div>CAN<br>ARY</body>"
        }
      },
      "SM:e.f.w_TEXT-1_SIR-3": {
        "dM": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 2,
          "output": "`foo] ba[r baz´",
          "innerHTML": "`foo] ba[r baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo] ba[r baz´</body>",
          "bodyInnerHTML": "`foo] ba[r baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo] ba[r baz´</body>"
        },
        "body": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 2,
          "output": "`foo] ba[r baz´",
          "innerHTML": "`foo] ba[r baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo] ba[r baz´</body>",
          "bodyInnerHTML": "`foo] ba[r baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo] ba[r baz´</body>"
        },
        "div": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 2,
          "output": "`foo] ba[r baz´",
          "innerHTML": "`foo] ba[r baz´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\">`foo] ba[r baz´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\">`foo] ba[r baz´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\">`foo] ba[r baz´</div>CAN<br>ARY</body>"
        }
      },
      "SM:e.f.lb_BR.BR-1_SC-1": {
        "dM": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 2,
          "output": "`fo[o´}<br>`bar´<br>`baz´",
          "innerHTML": "`fo[o´}<br>`bar´<br>`baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`fo[o´}<br>`bar´<br>`baz´</body>",
          "bodyInnerHTML": "`fo[o´}<br>`bar´<br>`baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`fo[o´}<br>`bar´<br>`baz´</body>"
        },
        "body": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 2,
          "output": "`fo[o´}<br>`bar´<br>`baz´",
          "innerHTML": "`fo[o´}<br>`bar´<br>`baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`fo[o´}<br>`bar´<br>`baz´</body>",
          "bodyInnerHTML": "`fo[o´}<br>`bar´<br>`baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`fo[o´}<br>`bar´<br>`baz´</body>"
        },
        "div": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 2,
          "output": "`fo[o´}<br>`bar´<br>`baz´",
          "innerHTML": "`fo[o´}<br>`bar´<br>`baz´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\">`fo[o´}<br>`bar´<br>`baz´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\">`fo[o´}<br>`bar´<br>`baz´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\">`fo[o´}<br>`bar´<br>`baz´</div>CAN<br>ARY</body>"
        }
      },
      "SM:e.f.lb_BR.BR-1_SI-1": {
        "dM": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 2,
          "output": "`fo[o´}<br>`bar´<br>`baz´",
          "innerHTML": "`fo[o´}<br>`bar´<br>`baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`fo[o´}<br>`bar´<br>`baz´</body>",
          "bodyInnerHTML": "`fo[o´}<br>`bar´<br>`baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`fo[o´}<br>`bar´<br>`baz´</body>"
        },
        "body": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 2,
          "output": "`fo[o´}<br>`bar´<br>`baz´",
          "innerHTML": "`fo[o´}<br>`bar´<br>`baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`fo[o´}<br>`bar´<br>`baz´</body>",
          "bodyInnerHTML": "`fo[o´}<br>`bar´<br>`baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`fo[o´}<br>`bar´<br>`baz´</body>"
        },
        "div": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 2,
          "output": "`fo[o´}<br>`bar´<br>`baz´",
          "innerHTML": "`fo[o´}<br>`bar´<br>`baz´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\">`fo[o´}<br>`bar´<br>`baz´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\">`fo[o´}<br>`bar´<br>`baz´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\">`fo[o´}<br>`bar´<br>`baz´</div>CAN<br>ARY</body>"
        }
      },
      "SM:e.f.lb_BR.BR-1_SM-1": {
        "dM": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 2,
          "output": "`fo[o´<br>`bar´}<br>`baz´",
          "innerHTML": "`fo[o´<br>`bar´}<br>`baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`fo[o´<br>`bar´}<br>`baz´</body>",
          "bodyInnerHTML": "`fo[o´<br>`bar´}<br>`baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`fo[o´<br>`bar´}<br>`baz´</body>"
        },
        "body": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 2,
          "output": "`fo[o´<br>`bar´}<br>`baz´",
          "innerHTML": "`fo[o´<br>`bar´}<br>`baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`fo[o´<br>`bar´}<br>`baz´</body>",
          "bodyInnerHTML": "`fo[o´<br>`bar´}<br>`baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`fo[o´<br>`bar´}<br>`baz´</body>"
        },
        "div": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 2,
          "output": "`fo[o´<br>`bar´}<br>`baz´",
          "innerHTML": "`fo[o´<br>`bar´}<br>`baz´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\">`fo[o´<br>`bar´}<br>`baz´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\">`fo[o´<br>`bar´}<br>`baz´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\">`fo[o´<br>`bar´}<br>`baz´</div>CAN<br>ARY</body>"
        }
      },
      "SM:e.f.lb_P.P.P-1_SC-1": {
        "dM": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "<p>`fo[o]´</p><p>`bar´</p><p>`baz´</p>",
          "innerHTML": "<p>`fo[o]´</p><p>`bar´</p><p>`baz´</p>",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\"><p>`fo[o]´</p><p>`bar´</p><p>`baz´</p></body>",
          "bodyInnerHTML": "<p>`fo[o]´</p><p>`bar´</p><p>`baz´</p>",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\"><p>`fo[o]´</p><p>`bar´</p><p>`baz´</p></body>"
        },
        "body": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "<p>`fo[o]´</p><p>`bar´</p><p>`baz´</p>",
          "innerHTML": "<p>`fo[o]´</p><p>`bar´</p><p>`baz´</p>",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\"><p>`fo[o]´</p><p>`bar´</p><p>`baz´</p></body>",
          "bodyInnerHTML": "<p>`fo[o]´</p><p>`bar´</p><p>`baz´</p>",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\"><p>`fo[o]´</p><p>`bar´</p><p>`baz´</p></body>"
        },
        "div": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "<p>`fo[o]´</p><p>`bar´</p><p>`baz´</p>",
          "innerHTML": "<p>`fo[o]´</p><p>`bar´</p><p>`baz´</p>",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\"><p>`fo[o]´</p><p>`bar´</p><p>`baz´</p></div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\"><p>`fo[o]´</p><p>`bar´</p><p>`baz´</p></div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\"><p>`fo[o]´</p><p>`bar´</p><p>`baz´</p></div>CAN<br>ARY</body>"
        }
      },
      "SM:e.f.lb_P.P.P-1_SI-1": {
        "dM": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 2,
          "output": "<p>`fo[o]´</p><p>`bar´</p><p>`baz´</p>",
          "innerHTML": "<p>`fo[o]´</p><p>`bar´</p><p>`baz´</p>",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\"><p>`fo[o]´</p><p>`bar´</p><p>`baz´</p></body>",
          "bodyInnerHTML": "<p>`fo[o]´</p><p>`bar´</p><p>`baz´</p>",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\"><p>`fo[o]´</p><p>`bar´</p><p>`baz´</p></body>"
        },
        "body": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 2,
          "output": "<p>`fo[o]´</p><p>`bar´</p><p>`baz´</p>",
          "innerHTML": "<p>`fo[o]´</p><p>`bar´</p><p>`baz´</p>",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\"><p>`fo[o]´</p><p>`bar´</p><p>`baz´</p></body>",
          "bodyInnerHTML": "<p>`fo[o]´</p><p>`bar´</p><p>`baz´</p>",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\"><p>`fo[o]´</p><p>`bar´</p><p>`baz´</p></body>"
        },
        "div": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 2,
          "output": "<p>`fo[o]´</p><p>`bar´</p><p>`baz´</p>",
          "innerHTML": "<p>`fo[o]´</p><p>`bar´</p><p>`baz´</p>",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\"><p>`fo[o]´</p><p>`bar´</p><p>`baz´</p></div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\"><p>`fo[o]´</p><p>`bar´</p><p>`baz´</p></div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\"><p>`fo[o]´</p><p>`bar´</p><p>`baz´</p></div>CAN<br>ARY</body>"
        }
      },
      "SM:e.f.lb_P.P.P-1_SM-1": {
        "dM": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "<p>`fo[o´</p><p>`bar]´</p><p>`baz´</p>",
          "innerHTML": "<p>`fo[o´</p><p>`bar]´</p><p>`baz´</p>",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\"><p>`fo[o´</p><p>`bar]´</p><p>`baz´</p></body>",
          "bodyInnerHTML": "<p>`fo[o´</p><p>`bar]´</p><p>`baz´</p>",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\"><p>`fo[o´</p><p>`bar]´</p><p>`baz´</p></body>"
        },
        "body": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "<p>`fo[o´</p><p>`bar]´</p><p>`baz´</p>",
          "innerHTML": "<p>`fo[o´</p><p>`bar]´</p><p>`baz´</p>",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\"><p>`fo[o´</p><p>`bar]´</p><p>`baz´</p></body>",
          "bodyInnerHTML": "<p>`fo[o´</p><p>`bar]´</p><p>`baz´</p>",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\"><p>`fo[o´</p><p>`bar]´</p><p>`baz´</p></body>"
        },
        "div": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "<p>`fo[o´</p><p>`bar]´</p><p>`baz´</p>",
          "innerHTML": "<p>`fo[o´</p><p>`bar]´</p><p>`baz´</p>",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\"><p>`fo[o´</p><p>`bar]´</p><p>`baz´</p></div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\"><p>`fo[o´</p><p>`bar]´</p><p>`baz´</p></div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\"><p>`fo[o´</p><p>`bar]´</p><p>`baz´</p></div>CAN<br>ARY</body>"
        }
      },
      "SM:e.f.lb_P.P.P-1_SMR-1": {
        "dM": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "<p>`foo´</p><p>`ba[r]´</p><p>`baz´</p>",
          "innerHTML": "<p>`foo´</p><p>`ba[r]´</p><p>`baz´</p>",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\"><p>`foo´</p><p>`ba[r]´</p><p>`baz´</p></body>",
          "bodyInnerHTML": "<p>`foo´</p><p>`ba[r]´</p><p>`baz´</p>",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\"><p>`foo´</p><p>`ba[r]´</p><p>`baz´</p></body>"
        },
        "body": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "<p>`foo´</p><p>`ba[r]´</p><p>`baz´</p>",
          "innerHTML": "<p>`foo´</p><p>`ba[r]´</p><p>`baz´</p>",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\"><p>`foo´</p><p>`ba[r]´</p><p>`baz´</p></body>",
          "bodyInnerHTML": "<p>`foo´</p><p>`ba[r]´</p><p>`baz´</p>",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\"><p>`foo´</p><p>`ba[r]´</p><p>`baz´</p></body>"
        },
        "div": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "<p>`foo´</p><p>`ba[r]´</p><p>`baz´</p>",
          "innerHTML": "<p>`foo´</p><p>`ba[r]´</p><p>`baz´</p>",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\"><p>`foo´</p><p>`ba[r]´</p><p>`baz´</p></div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\"><p>`foo´</p><p>`ba[r]´</p><p>`baz´</p></div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\"><p>`foo´</p><p>`ba[r]´</p><p>`baz´</p></div>CAN<br>ARY</body>"
        }
      },
      "SM:e.b.lb_BR.BR-1_SC-2": {
        "dM": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`foo´<br>`bar´<br>`]b[az´",
          "innerHTML": "`foo´<br>`bar´<br>`]b[az´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo´<br>`bar´<br>`]b[az´</body>",
          "bodyInnerHTML": "`foo´<br>`bar´<br>`]b[az´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo´<br>`bar´<br>`]b[az´</body>"
        },
        "body": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`foo´<br>`bar´<br>`]b[az´",
          "innerHTML": "`foo´<br>`bar´<br>`]b[az´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo´<br>`bar´<br>`]b[az´</body>",
          "bodyInnerHTML": "`foo´<br>`bar´<br>`]b[az´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo´<br>`bar´<br>`]b[az´</body>"
        },
        "div": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`foo´<br>`bar´<br>`]b[az´",
          "innerHTML": "`foo´<br>`bar´<br>`]b[az´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\">`foo´<br>`bar´<br>`]b[az´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\">`foo´<br>`bar´<br>`]b[az´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\">`foo´<br>`bar´<br>`]b[az´</div>CAN<br>ARY</body>"
        }
      },
      "SM:e.b.lb_BR.BR-1_SIR-2": {
        "dM": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 2,
          "output": "`foo´<br>`bar´<br>`]b[az´",
          "innerHTML": "`foo´<br>`bar´<br>`]b[az´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo´<br>`bar´<br>`]b[az´</body>",
          "bodyInnerHTML": "`foo´<br>`bar´<br>`]b[az´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo´<br>`bar´<br>`]b[az´</body>"
        },
        "body": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 2,
          "output": "`foo´<br>`bar´<br>`]b[az´",
          "innerHTML": "`foo´<br>`bar´<br>`]b[az´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo´<br>`bar´<br>`]b[az´</body>",
          "bodyInnerHTML": "`foo´<br>`bar´<br>`]b[az´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo´<br>`bar´<br>`]b[az´</body>"
        },
        "div": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 2,
          "output": "`foo´<br>`bar´<br>`]b[az´",
          "innerHTML": "`foo´<br>`bar´<br>`]b[az´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\">`foo´<br>`bar´<br>`]b[az´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\">`foo´<br>`bar´<br>`]b[az´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\">`foo´<br>`bar´<br>`]b[az´</div>CAN<br>ARY</body>"
        }
      },
      "SM:e.b.lb_BR.BR-1_SMR-2": {
        "dM": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`foo´<br>`]bar´<br>`b[az´",
          "innerHTML": "`foo´<br>`]bar´<br>`b[az´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo´<br>`]bar´<br>`b[az´</body>",
          "bodyInnerHTML": "`foo´<br>`]bar´<br>`b[az´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo´<br>`]bar´<br>`b[az´</body>"
        },
        "body": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`foo´<br>`]bar´<br>`b[az´",
          "innerHTML": "`foo´<br>`]bar´<br>`b[az´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo´<br>`]bar´<br>`b[az´</body>",
          "bodyInnerHTML": "`foo´<br>`]bar´<br>`b[az´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo´<br>`]bar´<br>`b[az´</body>"
        },
        "div": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`foo´<br>`]bar´<br>`b[az´",
          "innerHTML": "`foo´<br>`]bar´<br>`b[az´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\">`foo´<br>`]bar´<br>`b[az´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\">`foo´<br>`]bar´<br>`b[az´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\">`foo´<br>`]bar´<br>`b[az´</div>CAN<br>ARY</body>"
        }
      },
      "SM:e.b.lb_P.P.P-1_SC-2": {
        "dM": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "<p>`foo´</p><p>`bar´</p><p>`]b[az´</p>",
          "innerHTML": "<p>`foo´</p><p>`bar´</p><p>`]b[az´</p>",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\"><p>`foo´</p><p>`bar´</p><p>`]b[az´</p></body>",
          "bodyInnerHTML": "<p>`foo´</p><p>`bar´</p><p>`]b[az´</p>",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\"><p>`foo´</p><p>`bar´</p><p>`]b[az´</p></body>"
        },
        "body": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "<p>`foo´</p><p>`bar´</p><p>`]b[az´</p>",
          "innerHTML": "<p>`foo´</p><p>`bar´</p><p>`]b[az´</p>",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\"><p>`foo´</p><p>`bar´</p><p>`]b[az´</p></body>",
          "bodyInnerHTML": "<p>`foo´</p><p>`bar´</p><p>`]b[az´</p>",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\"><p>`foo´</p><p>`bar´</p><p>`]b[az´</p></body>"
        },
        "div": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "<p>`foo´</p><p>`bar´</p><p>`]b[az´</p>",
          "innerHTML": "<p>`foo´</p><p>`bar´</p><p>`]b[az´</p>",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\"><p>`foo´</p><p>`bar´</p><p>`]b[az´</p></div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\"><p>`foo´</p><p>`bar´</p><p>`]b[az´</p></div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\"><p>`foo´</p><p>`bar´</p><p>`]b[az´</p></div>CAN<br>ARY</body>"
        }
      },
      "SM:e.b.lb_P.P.P-1_SIR-2": {
        "dM": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 2,
          "output": "<p>`foo´</p><p>`bar´</p><p>`]b[az´</p>",
          "innerHTML": "<p>`foo´</p><p>`bar´</p><p>`]b[az´</p>",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\"><p>`foo´</p><p>`bar´</p><p>`]b[az´</p></body>",
          "bodyInnerHTML": "<p>`foo´</p><p>`bar´</p><p>`]b[az´</p>",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\"><p>`foo´</p><p>`bar´</p><p>`]b[az´</p></body>"
        },
        "body": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 2,
          "output": "<p>`foo´</p><p>`bar´</p><p>`]b[az´</p>",
          "innerHTML": "<p>`foo´</p><p>`bar´</p><p>`]b[az´</p>",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\"><p>`foo´</p><p>`bar´</p><p>`]b[az´</p></body>",
          "bodyInnerHTML": "<p>`foo´</p><p>`bar´</p><p>`]b[az´</p>",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\"><p>`foo´</p><p>`bar´</p><p>`]b[az´</p></body>"
        },
        "div": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 2,
          "output": "<p>`foo´</p><p>`bar´</p><p>`]b[az´</p>",
          "innerHTML": "<p>`foo´</p><p>`bar´</p><p>`]b[az´</p>",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\"><p>`foo´</p><p>`bar´</p><p>`]b[az´</p></div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\"><p>`foo´</p><p>`bar´</p><p>`]b[az´</p></div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\"><p>`foo´</p><p>`bar´</p><p>`]b[az´</p></div>CAN<br>ARY</body>"
        }
      },
      "SM:e.b.lb_P.P.P-1_SMR-2": {
        "dM": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "<p>`foo´</p><p>`]bar´</p><p>`b[az´</p>",
          "innerHTML": "<p>`foo´</p><p>`]bar´</p><p>`b[az´</p>",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\"><p>`foo´</p><p>`]bar´</p><p>`b[az´</p></body>",
          "bodyInnerHTML": "<p>`foo´</p><p>`]bar´</p><p>`b[az´</p>",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\"><p>`foo´</p><p>`]bar´</p><p>`b[az´</p></body>"
        },
        "body": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "<p>`foo´</p><p>`]bar´</p><p>`b[az´</p>",
          "innerHTML": "<p>`foo´</p><p>`]bar´</p><p>`b[az´</p>",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\"><p>`foo´</p><p>`]bar´</p><p>`b[az´</p></body>",
          "bodyInnerHTML": "<p>`foo´</p><p>`]bar´</p><p>`b[az´</p>",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\"><p>`foo´</p><p>`]bar´</p><p>`b[az´</p></body>"
        },
        "div": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "<p>`foo´</p><p>`]bar´</p><p>`b[az´</p>",
          "innerHTML": "<p>`foo´</p><p>`]bar´</p><p>`b[az´</p>",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\"><p>`foo´</p><p>`]bar´</p><p>`b[az´</p></div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\"><p>`foo´</p><p>`]bar´</p><p>`b[az´</p></div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\"><p>`foo´</p><p>`]bar´</p><p>`b[az´</p></div>CAN<br>ARY</body>"
        }
      },
      "SM:e.b.lb_P.P.P-1_SM-2": {
        "dM": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "<p>`foo´</p><p>`]b[ar´</p><p>`baz´</p>",
          "innerHTML": "<p>`foo´</p><p>`]b[ar´</p><p>`baz´</p>",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\"><p>`foo´</p><p>`]b[ar´</p><p>`baz´</p></body>",
          "bodyInnerHTML": "<p>`foo´</p><p>`]b[ar´</p><p>`baz´</p>",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\"><p>`foo´</p><p>`]b[ar´</p><p>`baz´</p></body>"
        },
        "body": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "<p>`foo´</p><p>`]b[ar´</p><p>`baz´</p>",
          "innerHTML": "<p>`foo´</p><p>`]b[ar´</p><p>`baz´</p>",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\"><p>`foo´</p><p>`]b[ar´</p><p>`baz´</p></body>",
          "bodyInnerHTML": "<p>`foo´</p><p>`]b[ar´</p><p>`baz´</p>",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\"><p>`foo´</p><p>`]b[ar´</p><p>`baz´</p></body>"
        },
        "div": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "<p>`foo´</p><p>`]b[ar´</p><p>`baz´</p>",
          "innerHTML": "<p>`foo´</p><p>`]b[ar´</p><p>`baz´</p>",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\"><p>`foo´</p><p>`]b[ar´</p><p>`baz´</p></div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\"><p>`foo´</p><p>`]b[ar´</p><p>`baz´</p></div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\"><p>`foo´</p><p>`]b[ar´</p><p>`baz´</p></div>CAN<br>ARY</body>"
        }
      },
      "SM:e.f.l_BR.BR-2_SC-1": {
        "dM": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`fo[o´<br>`fo]o´<br>`foo´",
          "innerHTML": "`fo[o´<br>`fo]o´<br>`foo´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`fo[o´<br>`fo]o´<br>`foo´</body>",
          "bodyInnerHTML": "`fo[o´<br>`fo]o´<br>`foo´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`fo[o´<br>`fo]o´<br>`foo´</body>"
        },
        "body": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`fo[o´<br>`fo]o´<br>`foo´",
          "innerHTML": "`fo[o´<br>`fo]o´<br>`foo´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`fo[o´<br>`fo]o´<br>`foo´</body>",
          "bodyInnerHTML": "`fo[o´<br>`fo]o´<br>`foo´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`fo[o´<br>`fo]o´<br>`foo´</body>"
        },
        "div": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`fo[o´<br>`fo]o´<br>`foo´",
          "innerHTML": "`fo[o´<br>`fo]o´<br>`foo´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\">`fo[o´<br>`fo]o´<br>`foo´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\">`fo[o´<br>`fo]o´<br>`foo´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\">`fo[o´<br>`fo]o´<br>`foo´</div>CAN<br>ARY</body>"
        }
      },
      "SM:e.f.l_BR.BR-2_SI-1": {
        "dM": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 2,
          "output": "`fo[o´<br>`foo´}<br>`foo´",
          "innerHTML": "`fo[o´<br>`foo´}<br>`foo´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`fo[o´<br>`foo´}<br>`foo´</body>",
          "bodyInnerHTML": "`fo[o´<br>`foo´}<br>`foo´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`fo[o´<br>`foo´}<br>`foo´</body>"
        },
        "body": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 2,
          "output": "`fo[o´<br>`foo´}<br>`foo´",
          "innerHTML": "`fo[o´<br>`foo´}<br>`foo´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`fo[o´<br>`foo´}<br>`foo´</body>",
          "bodyInnerHTML": "`fo[o´<br>`foo´}<br>`foo´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`fo[o´<br>`foo´}<br>`foo´</body>"
        },
        "div": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 2,
          "output": "`fo[o´<br>`foo´}<br>`foo´",
          "innerHTML": "`fo[o´<br>`foo´}<br>`foo´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\">`fo[o´<br>`foo´}<br>`foo´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\">`fo[o´<br>`foo´}<br>`foo´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\">`fo[o´<br>`foo´}<br>`foo´</div>CAN<br>ARY</body>"
        }
      },
      "SM:e.f.l_BR.BR-2_SM-1": {
        "dM": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`fo[o´<br>`foo´<br>`f]oo´",
          "innerHTML": "`fo[o´<br>`foo´<br>`f]oo´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`fo[o´<br>`foo´<br>`f]oo´</body>",
          "bodyInnerHTML": "`fo[o´<br>`foo´<br>`f]oo´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`fo[o´<br>`foo´<br>`f]oo´</body>"
        },
        "body": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`fo[o´<br>`foo´<br>`f]oo´",
          "innerHTML": "`fo[o´<br>`foo´<br>`f]oo´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`fo[o´<br>`foo´<br>`f]oo´</body>",
          "bodyInnerHTML": "`fo[o´<br>`foo´<br>`f]oo´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`fo[o´<br>`foo´<br>`f]oo´</body>"
        },
        "div": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`fo[o´<br>`foo´<br>`f]oo´",
          "innerHTML": "`fo[o´<br>`foo´<br>`f]oo´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\">`fo[o´<br>`foo´<br>`f]oo´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\">`fo[o´<br>`foo´<br>`f]oo´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\">`fo[o´<br>`foo´<br>`f]oo´</div>CAN<br>ARY</body>"
        }
      },
      "SM:e.f.l_P.P-1_SC-1": {
        "dM": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "<p>`foo[bar´</p><p>`foo]bar´</p>",
          "innerHTML": "<p>`foo[bar´</p><p>`foo]bar´</p>",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\"><p>`foo[bar´</p><p>`foo]bar´</p></body>",
          "bodyInnerHTML": "<p>`foo[bar´</p><p>`foo]bar´</p>",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\"><p>`foo[bar´</p><p>`foo]bar´</p></body>"
        },
        "body": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "<p>`foo[bar´</p><p>`foo]bar´</p>",
          "innerHTML": "<p>`foo[bar´</p><p>`foo]bar´</p>",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\"><p>`foo[bar´</p><p>`foo]bar´</p></body>",
          "bodyInnerHTML": "<p>`foo[bar´</p><p>`foo]bar´</p>",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\"><p>`foo[bar´</p><p>`foo]bar´</p></body>"
        },
        "div": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "<p>`foo[bar´</p><p>`foo]bar´</p>",
          "innerHTML": "<p>`foo[bar´</p><p>`foo]bar´</p>",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\"><p>`foo[bar´</p><p>`foo]bar´</p></div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\"><p>`foo[bar´</p><p>`foo]bar´</p></div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\"><p>`foo[bar´</p><p>`foo]bar´</p></div>CAN<br>ARY</body>"
        }
      },
      "SM:e.f.l_P.P-1_SMR-1": {
        "dM": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "<p>`foobar´</p><p>`fo]ob[ar´</p>",
          "innerHTML": "<p>`foobar´</p><p>`fo]ob[ar´</p>",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\"><p>`foobar´</p><p>`fo]ob[ar´</p></body>",
          "bodyInnerHTML": "<p>`foobar´</p><p>`fo]ob[ar´</p>",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\"><p>`foobar´</p><p>`fo]ob[ar´</p></body>"
        },
        "body": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "<p>`foobar´</p><p>`fo]ob[ar´</p>",
          "innerHTML": "<p>`foobar´</p><p>`fo]ob[ar´</p>",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\"><p>`foobar´</p><p>`fo]ob[ar´</p></body>",
          "bodyInnerHTML": "<p>`foobar´</p><p>`fo]ob[ar´</p>",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\"><p>`foobar´</p><p>`fo]ob[ar´</p></body>"
        },
        "div": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "<p>`foobar´</p><p>`fo]ob[ar´</p>",
          "innerHTML": "<p>`foobar´</p><p>`fo]ob[ar´</p>",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\"><p>`foobar´</p><p>`fo]ob[ar´</p></div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\"><p>`foobar´</p><p>`fo]ob[ar´</p></div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\"><p>`foobar´</p><p>`fo]ob[ar´</p></div>CAN<br>ARY</body>"
        }
      },
      "SM:e.b.l_BR.BR-2_SC-2": {
        "dM": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`foo´<br>`f]oo´<br>`f[oo´",
          "innerHTML": "`foo´<br>`f]oo´<br>`f[oo´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo´<br>`f]oo´<br>`f[oo´</body>",
          "bodyInnerHTML": "`foo´<br>`f]oo´<br>`f[oo´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo´<br>`f]oo´<br>`f[oo´</body>"
        },
        "body": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`foo´<br>`f]oo´<br>`f[oo´",
          "innerHTML": "`foo´<br>`f]oo´<br>`f[oo´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo´<br>`f]oo´<br>`f[oo´</body>",
          "bodyInnerHTML": "`foo´<br>`f]oo´<br>`f[oo´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo´<br>`f]oo´<br>`f[oo´</body>"
        },
        "div": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`foo´<br>`f]oo´<br>`f[oo´",
          "innerHTML": "`foo´<br>`f]oo´<br>`f[oo´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\">`foo´<br>`f]oo´<br>`f[oo´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\">`foo´<br>`f]oo´<br>`f[oo´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\">`foo´<br>`f]oo´<br>`f[oo´</div>CAN<br>ARY</body>"
        }
      },
      "SM:e.b.l_BR.BR-2_SIR-2": {
        "dM": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`foo´<br>`]foo´<br>`f[oo´",
          "innerHTML": "`foo´<br>`]foo´<br>`f[oo´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo´<br>`]foo´<br>`f[oo´</body>",
          "bodyInnerHTML": "`foo´<br>`]foo´<br>`f[oo´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo´<br>`]foo´<br>`f[oo´</body>"
        },
        "body": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`foo´<br>`]foo´<br>`f[oo´",
          "innerHTML": "`foo´<br>`]foo´<br>`f[oo´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo´<br>`]foo´<br>`f[oo´</body>",
          "bodyInnerHTML": "`foo´<br>`]foo´<br>`f[oo´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo´<br>`]foo´<br>`f[oo´</body>"
        },
        "div": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`foo´<br>`]foo´<br>`f[oo´",
          "innerHTML": "`foo´<br>`]foo´<br>`f[oo´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\">`foo´<br>`]foo´<br>`f[oo´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\">`foo´<br>`]foo´<br>`f[oo´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\">`foo´<br>`]foo´<br>`f[oo´</div>CAN<br>ARY</body>"
        }
      },
      "SM:e.b.l_BR.BR-2_SMR-2": {
        "dM": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`fo]o´<br>`foo´<br>`f[oo´",
          "innerHTML": "`fo]o´<br>`foo´<br>`f[oo´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`fo]o´<br>`foo´<br>`f[oo´</body>",
          "bodyInnerHTML": "`fo]o´<br>`foo´<br>`f[oo´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`fo]o´<br>`foo´<br>`f[oo´</body>"
        },
        "body": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`fo]o´<br>`foo´<br>`f[oo´",
          "innerHTML": "`fo]o´<br>`foo´<br>`f[oo´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`fo]o´<br>`foo´<br>`f[oo´</body>",
          "bodyInnerHTML": "`fo]o´<br>`foo´<br>`f[oo´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`fo]o´<br>`foo´<br>`f[oo´</body>"
        },
        "div": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`fo]o´<br>`foo´<br>`f[oo´",
          "innerHTML": "`fo]o´<br>`foo´<br>`f[oo´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\">`fo]o´<br>`foo´<br>`f[oo´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\">`fo]o´<br>`foo´<br>`f[oo´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\">`fo]o´<br>`foo´<br>`f[oo´</div>CAN<br>ARY</body>"
        }
      },
      "SM:e.b.l_P.P-1_SC-2": {
        "dM": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "<p>`foo]bar´</p><p>`foo[bar´</p>",
          "innerHTML": "<p>`foo]bar´</p><p>`foo[bar´</p>",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\"><p>`foo]bar´</p><p>`foo[bar´</p></body>",
          "bodyInnerHTML": "<p>`foo]bar´</p><p>`foo[bar´</p>",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\"><p>`foo]bar´</p><p>`foo[bar´</p></body>"
        },
        "body": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "<p>`foo]bar´</p><p>`foo[bar´</p>",
          "innerHTML": "<p>`foo]bar´</p><p>`foo[bar´</p>",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\"><p>`foo]bar´</p><p>`foo[bar´</p></body>",
          "bodyInnerHTML": "<p>`foo]bar´</p><p>`foo[bar´</p>",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\"><p>`foo]bar´</p><p>`foo[bar´</p></body>"
        },
        "div": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "<p>`foo]bar´</p><p>`foo[bar´</p>",
          "innerHTML": "<p>`foo]bar´</p><p>`foo[bar´</p>",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\"><p>`foo]bar´</p><p>`foo[bar´</p></div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\"><p>`foo]bar´</p><p>`foo[bar´</p></div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\"><p>`foo]bar´</p><p>`foo[bar´</p></div>CAN<br>ARY</body>"
        }
      },
      "SM:e.b.l_P.P-1_SM-1": {
        "dM": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "<p>`fo[ob]ar´</p><p>`foobar´</p>",
          "innerHTML": "<p>`fo[ob]ar´</p><p>`foobar´</p>",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\"><p>`fo[ob]ar´</p><p>`foobar´</p></body>",
          "bodyInnerHTML": "<p>`fo[ob]ar´</p><p>`foobar´</p>",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\"><p>`fo[ob]ar´</p><p>`foobar´</p></body>"
        },
        "body": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "<p>`fo[ob]ar´</p><p>`foobar´</p>",
          "innerHTML": "<p>`fo[ob]ar´</p><p>`foobar´</p>",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\"><p>`fo[ob]ar´</p><p>`foobar´</p></body>",
          "bodyInnerHTML": "<p>`fo[ob]ar´</p><p>`foobar´</p>",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\"><p>`fo[ob]ar´</p><p>`foobar´</p></body>"
        },
        "div": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "<p>`fo[ob]ar´</p><p>`foobar´</p>",
          "innerHTML": "<p>`fo[ob]ar´</p><p>`foobar´</p>",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\"><p>`fo[ob]ar´</p><p>`foobar´</p></div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\"><p>`fo[ob]ar´</p><p>`foobar´</p></div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\"><p>`fo[ob]ar´</p><p>`foobar´</p></div>CAN<br>ARY</body>"
        }
      },
      "SAC:div_DIV-1_SC-1": {
        "dM": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`foo´<div id=\"div\">{`bar ´<span>`baz´</span>}</div>`qoz´",
          "innerHTML": "`foo´<div id=\"div\">{`bar ´<span>`baz´</span>}</div>`qoz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo´<div id=\"div\">{`bar ´<span>`baz´</span>}</div>`qoz´</body>",
          "bodyInnerHTML": "`foo´<div id=\"div\">{`bar ´<span>`baz´</span>}</div>`qoz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo´<div id=\"div\">{`bar ´<span>`baz´</span>}</div>`qoz´</body>"
        },
        "body": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`foo´<div id=\"div\">{`bar ´<span>`baz´</span>}</div>`qoz´",
          "innerHTML": "`foo´<div id=\"div\">{`bar ´<span>`baz´</span>}</div>`qoz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo´<div id=\"div\">{`bar ´<span>`baz´</span>}</div>`qoz´</body>",
          "bodyInnerHTML": "`foo´<div id=\"div\">{`bar ´<span>`baz´</span>}</div>`qoz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo´<div id=\"div\">{`bar ´<span>`baz´</span>}</div>`qoz´</body>"
        },
        "div": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`foo´<div id=\"div\">{`bar ´<span>`baz´</span>}</div>`qoz´",
          "innerHTML": "`foo´<div id=\"div\">{`bar ´<span>`baz´</span>}</div>`qoz´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\">`foo´<div id=\"div\">{`bar ´<span>`baz´</span>}</div>`qoz´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\">`foo´<div id=\"div\">{`bar ´<span>`baz´</span>}</div>`qoz´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\">`foo´<div id=\"div\">{`bar ´<span>`baz´</span>}</div>`qoz´</div>CAN<br>ARY</body>"
        }
      }
    }
  },
  "A": {
    "Proposed": {
      "B_TEXT-1_SI": {
        "dM": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 2,
          "output": "`foo[´<b>`bar]´</b>`baz´",
          "innerHTML": "`foo[´<b>`bar]´</b>`baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo[´<b>`bar]´</b>`baz´</body>",
          "bodyInnerHTML": "`foo[´<b>`bar]´</b>`baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo[´<b>`bar]´</b>`baz´</body>"
        },
        "body": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 2,
          "output": "`foo[´<b>`bar]´</b>`baz´",
          "innerHTML": "`foo[´<b>`bar]´</b>`baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo[´<b>`bar]´</b>`baz´</body>",
          "bodyInnerHTML": "`foo[´<b>`bar]´</b>`baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo[´<b>`bar]´</b>`baz´</body>"
        },
        "div": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 2,
          "output": "`foo[´<b>`bar]´</b>`baz´",
          "innerHTML": "`foo[´<b>`bar]´</b>`baz´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\">`foo[´<b>`bar]´</b>`baz´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\">`foo[´<b>`bar]´</b>`baz´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\">`foo[´<b>`bar]´</b>`baz´</div>CAN<br>ARY</body>"
        }
      },
      "B_TEXT-1_SIR": {
        "dM": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 2,
          "output": "`foo[´<b>`bar]´</b>`baz´",
          "innerHTML": "`foo[´<b>`bar]´</b>`baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo[´<b>`bar]´</b>`baz´</body>",
          "bodyInnerHTML": "`foo[´<b>`bar]´</b>`baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo[´<b>`bar]´</b>`baz´</body>"
        },
        "body": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 2,
          "output": "`foo[´<b>`bar]´</b>`baz´",
          "innerHTML": "`foo[´<b>`bar]´</b>`baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo[´<b>`bar]´</b>`baz´</body>",
          "bodyInnerHTML": "`foo[´<b>`bar]´</b>`baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo[´<b>`bar]´</b>`baz´</body>"
        },
        "div": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 2,
          "output": "`foo[´<b>`bar]´</b>`baz´",
          "innerHTML": "`foo[´<b>`bar]´</b>`baz´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\">`foo[´<b>`bar]´</b>`baz´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\">`foo[´<b>`bar]´</b>`baz´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\">`foo[´<b>`bar]´</b>`baz´</div>CAN<br>ARY</body>"
        }
      },
      "B_I-1_SL": {
        "dM": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 2,
          "output": "`foo[´<b>`bar´</b><i><b>`baz]´</b>`qoz´</i>`quz´",
          "innerHTML": "`foo[´<b>`bar´</b><i><b>`baz]´</b>`qoz´</i>`quz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo[´<b>`bar´</b><i><b>`baz]´</b>`qoz´</i>`quz´</body>",
          "bodyInnerHTML": "`foo[´<b>`bar´</b><i><b>`baz]´</b>`qoz´</i>`quz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo[´<b>`bar´</b><i><b>`baz]´</b>`qoz´</i>`quz´</body>"
        },
        "body": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 2,
          "output": "`foo[´<b>`bar´</b><i><b>`baz]´</b>`qoz´</i>`quz´",
          "innerHTML": "`foo[´<b>`bar´</b><i><b>`baz]´</b>`qoz´</i>`quz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo[´<b>`bar´</b><i><b>`baz]´</b>`qoz´</i>`quz´</body>",
          "bodyInnerHTML": "`foo[´<b>`bar´</b><i><b>`baz]´</b>`qoz´</i>`quz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo[´<b>`bar´</b><i><b>`baz]´</b>`qoz´</i>`quz´</body>"
        },
        "div": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 2,
          "output": "`foo[´<b>`bar´</b><i><b>`baz]´</b>`qoz´</i>`quz´",
          "innerHTML": "`foo[´<b>`bar´</b><i><b>`baz]´</b>`qoz´</i>`quz´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\">`foo[´<b>`bar´</b><i><b>`baz]´</b>`qoz´</i>`quz´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\">`foo[´<b>`bar´</b><i><b>`baz]´</b>`qoz´</i>`quz´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\">`foo[´<b>`bar´</b><i><b>`baz]´</b>`qoz´</i>`quz´</div>CAN<br>ARY</body>"
        }
      },
      "I_TEXT-1_SI": {
        "dM": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 2,
          "output": "`foo[´<i>`bar]´</i>`baz´",
          "innerHTML": "`foo[´<i>`bar]´</i>`baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo[´<i>`bar]´</i>`baz´</body>",
          "bodyInnerHTML": "`foo[´<i>`bar]´</i>`baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo[´<i>`bar]´</i>`baz´</body>"
        },
        "body": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 2,
          "output": "`foo[´<i>`bar]´</i>`baz´",
          "innerHTML": "`foo[´<i>`bar]´</i>`baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo[´<i>`bar]´</i>`baz´</body>",
          "bodyInnerHTML": "`foo[´<i>`bar]´</i>`baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo[´<i>`bar]´</i>`baz´</body>"
        },
        "div": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 2,
          "output": "`foo[´<i>`bar]´</i>`baz´",
          "innerHTML": "`foo[´<i>`bar]´</i>`baz´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\">`foo[´<i>`bar]´</i>`baz´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\">`foo[´<i>`bar]´</i>`baz´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\">`foo[´<i>`bar]´</i>`baz´</div>CAN<br>ARY</body>"
        }
      },
      "U_TEXT-1_SI": {
        "dM": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 2,
          "output": "`foo[´<u>`bar]´</u>`baz´",
          "innerHTML": "`foo[´<u>`bar]´</u>`baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo[´<u>`bar]´</u>`baz´</body>",
          "bodyInnerHTML": "`foo[´<u>`bar]´</u>`baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo[´<u>`bar]´</u>`baz´</body>"
        },
        "body": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 2,
          "output": "`foo[´<u>`bar]´</u>`baz´",
          "innerHTML": "`foo[´<u>`bar]´</u>`baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo[´<u>`bar]´</u>`baz´</body>",
          "bodyInnerHTML": "`foo[´<u>`bar]´</u>`baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo[´<u>`bar]´</u>`baz´</body>"
        },
        "div": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 2,
          "output": "`foo[´<u>`bar]´</u>`baz´",
          "innerHTML": "`foo[´<u>`bar]´</u>`baz´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\">`foo[´<u>`bar]´</u>`baz´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\">`foo[´<u>`bar]´</u>`baz´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\">`foo[´<u>`bar]´</u>`baz´</div>CAN<br>ARY</body>"
        }
      },
      "S_TEXT-1_SI": {
        "dM": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 2,
          "output": "`foo[´<strike>`bar]´</strike>`baz´",
          "innerHTML": "`foo[´<strike>`bar]´</strike>`baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo[´<strike>`bar]´</strike>`baz´</body>",
          "bodyInnerHTML": "`foo[´<strike>`bar]´</strike>`baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo[´<strike>`bar]´</strike>`baz´</body>"
        },
        "body": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 2,
          "output": "`foo[´<strike>`bar]´</strike>`baz´",
          "innerHTML": "`foo[´<strike>`bar]´</strike>`baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo[´<strike>`bar]´</strike>`baz´</body>",
          "bodyInnerHTML": "`foo[´<strike>`bar]´</strike>`baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo[´<strike>`bar]´</strike>`baz´</body>"
        },
        "div": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 2,
          "output": "`foo[´<strike>`bar]´</strike>`baz´",
          "innerHTML": "`foo[´<strike>`bar]´</strike>`baz´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\">`foo[´<strike>`bar]´</strike>`baz´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\">`foo[´<strike>`bar]´</strike>`baz´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\">`foo[´<strike>`bar]´</strike>`baz´</div>CAN<br>ARY</body>"
        }
      },
      "SUB_TEXT-1_SI": {
        "dM": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 2,
          "output": "`foo[´<sub>`bar]´</sub>`baz´",
          "innerHTML": "`foo[´<sub>`bar]´</sub>`baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo[´<sub>`bar]´</sub>`baz´</body>",
          "bodyInnerHTML": "`foo[´<sub>`bar]´</sub>`baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo[´<sub>`bar]´</sub>`baz´</body>"
        },
        "body": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 2,
          "output": "`foo[´<sub>`bar]´</sub>`baz´",
          "innerHTML": "`foo[´<sub>`bar]´</sub>`baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo[´<sub>`bar]´</sub>`baz´</body>",
          "bodyInnerHTML": "`foo[´<sub>`bar]´</sub>`baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo[´<sub>`bar]´</sub>`baz´</body>"
        },
        "div": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 2,
          "output": "`foo[´<sub>`bar]´</sub>`baz´",
          "innerHTML": "`foo[´<sub>`bar]´</sub>`baz´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\">`foo[´<sub>`bar]´</sub>`baz´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\">`foo[´<sub>`bar]´</sub>`baz´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\">`foo[´<sub>`bar]´</sub>`baz´</div>CAN<br>ARY</body>"
        }
      },
      "SUP_TEXT-1_SI": {
        "dM": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 2,
          "output": "`foo[´<sup>`bar]´</sup>`baz´",
          "innerHTML": "`foo[´<sup>`bar]´</sup>`baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo[´<sup>`bar]´</sup>`baz´</body>",
          "bodyInnerHTML": "`foo[´<sup>`bar]´</sup>`baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo[´<sup>`bar]´</sup>`baz´</body>"
        },
        "body": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 2,
          "output": "`foo[´<sup>`bar]´</sup>`baz´",
          "innerHTML": "`foo[´<sup>`bar]´</sup>`baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo[´<sup>`bar]´</sup>`baz´</body>",
          "bodyInnerHTML": "`foo[´<sup>`bar]´</sup>`baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo[´<sup>`bar]´</sup>`baz´</body>"
        },
        "div": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 2,
          "output": "`foo[´<sup>`bar]´</sup>`baz´",
          "innerHTML": "`foo[´<sup>`bar]´</sup>`baz´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\">`foo[´<sup>`bar]´</sup>`baz´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\">`foo[´<sup>`bar]´</sup>`baz´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\">`foo[´<sup>`bar]´</sup>`baz´</div>CAN<br>ARY</body>"
        }
      },
      "CL:url_TEXT-1_SI": {
        "dM": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 2,
          "output": "`foo[´<a href=\"#foo\">`bar]´</a>`baz´",
          "innerHTML": "`foo[´<a href=\"#foo\">`bar]´</a>`baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo[´<a href=\"#foo\">`bar]´</a>`baz´</body>",
          "bodyInnerHTML": "`foo[´<a href=\"#foo\">`bar]´</a>`baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo[´<a href=\"#foo\">`bar]´</a>`baz´</body>"
        },
        "body": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 2,
          "output": "`foo[´<a href=\"#foo\">`bar]´</a>`baz´",
          "innerHTML": "`foo[´<a href=\"#foo\">`bar]´</a>`baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo[´<a href=\"#foo\">`bar]´</a>`baz´</body>",
          "bodyInnerHTML": "`foo[´<a href=\"#foo\">`bar]´</a>`baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo[´<a href=\"#foo\">`bar]´</a>`baz´</body>"
        },
        "div": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 2,
          "output": "`foo[´<a href=\"#foo\">`bar]´</a>`baz´",
          "innerHTML": "`foo[´<a href=\"#foo\">`bar]´</a>`baz´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\">`foo[´<a href=\"#foo\">`bar]´</a>`baz´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\">`foo[´<a href=\"#foo\">`bar]´</a>`baz´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\">`foo[´<a href=\"#foo\">`bar]´</a>`baz´</div>CAN<br>ARY</body>"
        }
      },
      "FB:H1_TEXT-1_SI": {
        "dM": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "<h1>`foo[bar]baz´</h1>",
          "innerHTML": "<h1>`foo[bar]baz´</h1>",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\"><h1>`foo[bar]baz´</h1></body>",
          "bodyInnerHTML": "<h1>`foo[bar]baz´</h1>",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\"><h1>`foo[bar]baz´</h1></body>"
        },
        "body": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "<h1>`foo[bar]baz´</h1>",
          "innerHTML": "<h1>`foo[bar]baz´</h1>",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\"><h1>`foo[bar]baz´</h1></body>",
          "bodyInnerHTML": "<h1>`foo[bar]baz´</h1>",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\"><h1>`foo[bar]baz´</h1></body>"
        },
        "div": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "<h1>`foo[bar]baz´</h1>",
          "innerHTML": "<h1>`foo[bar]baz´</h1>",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\"><h1>`foo[bar]baz´</h1></div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\"><h1>`foo[bar]baz´</h1></div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\"><h1>`foo[bar]baz´</h1></div>CAN<br>ARY</body>"
        }
      },
      "FB:P_TEXT-1_SI": {
        "dM": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "<p>`foo[bar]baz´</p>",
          "innerHTML": "<p>`foo[bar]baz´</p>",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\"><p>`foo[bar]baz´</p></body>",
          "bodyInnerHTML": "<p>`foo[bar]baz´</p>",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\"><p>`foo[bar]baz´</p></body>"
        },
        "body": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "<p>`foo[bar]baz´</p>",
          "innerHTML": "<p>`foo[bar]baz´</p>",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\"><p>`foo[bar]baz´</p></body>",
          "bodyInnerHTML": "<p>`foo[bar]baz´</p>",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\"><p>`foo[bar]baz´</p></body>"
        },
        "div": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "<p>`foo[bar]baz´</p>",
          "innerHTML": "<p>`foo[bar]baz´</p>",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\"><p>`foo[bar]baz´</p></div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\"><p>`foo[bar]baz´</p></div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\"><p>`foo[bar]baz´</p></div>CAN<br>ARY</body>"
        }
      },
      "FB:PRE_TEXT-1_SI": {
        "dM": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "<pre>`foo[bar]baz´</pre>",
          "innerHTML": "<pre>`foo[bar]baz´</pre>",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\"><pre>`foo[bar]baz´</pre></body>",
          "bodyInnerHTML": "<pre>`foo[bar]baz´</pre>",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\"><pre>`foo[bar]baz´</pre></body>"
        },
        "body": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "<pre>`foo[bar]baz´</pre>",
          "innerHTML": "<pre>`foo[bar]baz´</pre>",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\"><pre>`foo[bar]baz´</pre></body>",
          "bodyInnerHTML": "<pre>`foo[bar]baz´</pre>",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\"><pre>`foo[bar]baz´</pre></body>"
        },
        "div": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "<pre>`foo[bar]baz´</pre>",
          "innerHTML": "<pre>`foo[bar]baz´</pre>",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\"><pre>`foo[bar]baz´</pre></div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\"><pre>`foo[bar]baz´</pre></div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\"><pre>`foo[bar]baz´</pre></div>CAN<br>ARY</body>"
        }
      },
      "FB:ADDRESS_TEXT-1_SI": {
        "dM": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "<address>`foo[bar]baz´</address>",
          "innerHTML": "<address>`foo[bar]baz´</address>",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\"><address>`foo[bar]baz´</address></body>",
          "bodyInnerHTML": "<address>`foo[bar]baz´</address>",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\"><address>`foo[bar]baz´</address></body>"
        },
        "body": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "<address>`foo[bar]baz´</address>",
          "innerHTML": "<address>`foo[bar]baz´</address>",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\"><address>`foo[bar]baz´</address></body>",
          "bodyInnerHTML": "<address>`foo[bar]baz´</address>",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\"><address>`foo[bar]baz´</address></body>"
        },
        "div": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "<address>`foo[bar]baz´</address>",
          "innerHTML": "<address>`foo[bar]baz´</address>",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\"><address>`foo[bar]baz´</address></div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\"><address>`foo[bar]baz´</address></div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\"><address>`foo[bar]baz´</address></div>CAN<br>ARY</body>"
        }
      },
      "FB:BQ_TEXT-1_SI": {
        "dM": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "<blockquote>`foo[bar]baz´</blockquote>",
          "innerHTML": "<blockquote>`foo[bar]baz´</blockquote>",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\"><blockquote>`foo[bar]baz´</blockquote></body>",
          "bodyInnerHTML": "<blockquote>`foo[bar]baz´</blockquote>",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\"><blockquote>`foo[bar]baz´</blockquote></body>"
        },
        "body": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "<blockquote>`foo[bar]baz´</blockquote>",
          "innerHTML": "<blockquote>`foo[bar]baz´</blockquote>",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\"><blockquote>`foo[bar]baz´</blockquote></body>",
          "bodyInnerHTML": "<blockquote>`foo[bar]baz´</blockquote>",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\"><blockquote>`foo[bar]baz´</blockquote></body>"
        },
        "div": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "<blockquote>`foo[bar]baz´</blockquote>",
          "innerHTML": "<blockquote>`foo[bar]baz´</blockquote>",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\"><blockquote>`foo[bar]baz´</blockquote></div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\"><blockquote>`foo[bar]baz´</blockquote></div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\"><blockquote>`foo[bar]baz´</blockquote></div>CAN<br>ARY</body>"
        }
      },
      "FB:BQ_BR.BR-1_SM": {
        "dM": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "<blockquote>`fo[o´<br>`bar´<br>`b]az´</blockquote>",
          "innerHTML": "<blockquote>`fo[o´<br>`bar´<br>`b]az´</blockquote>",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\"><blockquote>`fo[o´<br>`bar´<br>`b]az´</blockquote></body>",
          "bodyInnerHTML": "<blockquote>`fo[o´<br>`bar´<br>`b]az´</blockquote>",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\"><blockquote>`fo[o´<br>`bar´<br>`b]az´</blockquote></body>"
        },
        "body": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "<blockquote>`fo[o´<br>`bar´<br>`b]az´</blockquote>",
          "innerHTML": "<blockquote>`fo[o´<br>`bar´<br>`b]az´</blockquote>",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\"><blockquote>`fo[o´<br>`bar´<br>`b]az´</blockquote></body>",
          "bodyInnerHTML": "<blockquote>`fo[o´<br>`bar´<br>`b]az´</blockquote>",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\"><blockquote>`fo[o´<br>`bar´<br>`b]az´</blockquote></body>"
        },
        "div": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "<blockquote>`fo[o´<br>`bar´<br>`b]az´</blockquote>",
          "innerHTML": "<blockquote>`fo[o´<br>`bar´<br>`b]az´</blockquote>",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\"><blockquote>`fo[o´<br>`bar´<br>`b]az´</blockquote></div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\"><blockquote>`fo[o´<br>`bar´<br>`b]az´</blockquote></div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\"><blockquote>`fo[o´<br>`bar´<br>`b]az´</blockquote></div>CAN<br>ARY</body>"
        }
      },
      "BC:blue_TEXT-1_SI": {
        "dM": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "<body xmlns=\"http://www.w3.org/1999/xhtml\" bgcolor=\"blue\" onload=\"setDesignMode()\">`foo[bar]baz´</body>",
          "innerHTML": "`foo[bar]baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" bgcolor=\"blue\" onload=\"setDesignMode()\">`foo[bar]baz´</body>",
          "bodyInnerHTML": "`foo[bar]baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" bgcolor=\"blue\" onload=\"setDesignMode()\">`foo[bar]baz´</body>"
        },
        "body": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "<body xmlns=\"http://www.w3.org/1999/xhtml\" bgcolor=\"blue\" contenteditable=\"true\">`foo[bar]baz´</body>",
          "innerHTML": "`foo[bar]baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" bgcolor=\"blue\" contenteditable=\"true\">`foo[bar]baz´</body>",
          "bodyInnerHTML": "`foo[bar]baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" bgcolor=\"blue\" contenteditable=\"true\">`foo[bar]baz´</body>"
        },
        "div": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`foo[bar]baz´",
          "innerHTML": "`foo[bar]baz´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\">`foo[bar]baz´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\">`foo[bar]baz´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" bgcolor=\"blue\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\">`foo[bar]baz´</div>CAN<br>ARY</body>"
        }
      },
      "FC:blue_TEXT-1_SI": {
        "dM": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 2,
          "output": "`foo[´<font color=\"blue\">`bar]´</font>`baz´",
          "innerHTML": "`foo[´<font color=\"blue\">`bar]´</font>`baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo[´<font color=\"blue\">`bar]´</font>`baz´</body>",
          "bodyInnerHTML": "`foo[´<font color=\"blue\">`bar]´</font>`baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo[´<font color=\"blue\">`bar]´</font>`baz´</body>"
        },
        "body": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 2,
          "output": "`foo[´<font color=\"blue\">`bar]´</font>`baz´",
          "innerHTML": "`foo[´<font color=\"blue\">`bar]´</font>`baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo[´<font color=\"blue\">`bar]´</font>`baz´</body>",
          "bodyInnerHTML": "`foo[´<font color=\"blue\">`bar]´</font>`baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo[´<font color=\"blue\">`bar]´</font>`baz´</body>"
        },
        "div": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 2,
          "output": "`foo[´<font color=\"blue\">`bar]´</font>`baz´",
          "innerHTML": "`foo[´<font color=\"blue\">`bar]´</font>`baz´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\">`foo[´<font color=\"blue\">`bar]´</font>`baz´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\">`foo[´<font color=\"blue\">`bar]´</font>`baz´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\">`foo[´<font color=\"blue\">`bar]´</font>`baz´</div>CAN<br>ARY</body>"
        }
      },
      "HC:blue_TEXT-1_SI": {
        "dM": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`foo[bar]baz´",
          "innerHTML": "`foo[bar]baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo[bar]baz´</body>",
          "bodyInnerHTML": "`foo[bar]baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo[bar]baz´</body>"
        },
        "body": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`foo[bar]baz´",
          "innerHTML": "`foo[bar]baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo[bar]baz´</body>",
          "bodyInnerHTML": "`foo[bar]baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo[bar]baz´</body>"
        },
        "div": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`foo[bar]baz´",
          "innerHTML": "`foo[bar]baz´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\">`foo[bar]baz´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\">`foo[bar]baz´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\">`foo[bar]baz´</div>CAN<br>ARY</body>"
        }
      },
      "FN:a_TEXT-1_SI": {
        "dM": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 2,
          "output": "`foo[´<font face=\"arial\">`bar]´</font>`baz´",
          "innerHTML": "`foo[´<font face=\"arial\">`bar]´</font>`baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo[´<font face=\"arial\">`bar]´</font>`baz´</body>",
          "bodyInnerHTML": "`foo[´<font face=\"arial\">`bar]´</font>`baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo[´<font face=\"arial\">`bar]´</font>`baz´</body>"
        },
        "body": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 2,
          "output": "`foo[´<font face=\"arial\">`bar]´</font>`baz´",
          "innerHTML": "`foo[´<font face=\"arial\">`bar]´</font>`baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo[´<font face=\"arial\">`bar]´</font>`baz´</body>",
          "bodyInnerHTML": "`foo[´<font face=\"arial\">`bar]´</font>`baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo[´<font face=\"arial\">`bar]´</font>`baz´</body>"
        },
        "div": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 2,
          "output": "`foo[´<font face=\"arial\">`bar]´</font>`baz´",
          "innerHTML": "`foo[´<font face=\"arial\">`bar]´</font>`baz´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\">`foo[´<font face=\"arial\">`bar]´</font>`baz´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\">`foo[´<font face=\"arial\">`bar]´</font>`baz´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\">`foo[´<font face=\"arial\">`bar]´</font>`baz´</div>CAN<br>ARY</body>"
        }
      },
      "FS:2_TEXT-1_SI": {
        "dM": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 2,
          "output": "`foo[´<font size=\"2\">`bar]´</font>`baz´",
          "innerHTML": "`foo[´<font size=\"2\">`bar]´</font>`baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo[´<font size=\"2\">`bar]´</font>`baz´</body>",
          "bodyInnerHTML": "`foo[´<font size=\"2\">`bar]´</font>`baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo[´<font size=\"2\">`bar]´</font>`baz´</body>"
        },
        "body": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 2,
          "output": "`foo[´<font size=\"2\">`bar]´</font>`baz´",
          "innerHTML": "`foo[´<font size=\"2\">`bar]´</font>`baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo[´<font size=\"2\">`bar]´</font>`baz´</body>",
          "bodyInnerHTML": "`foo[´<font size=\"2\">`bar]´</font>`baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo[´<font size=\"2\">`bar]´</font>`baz´</body>"
        },
        "div": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 2,
          "output": "`foo[´<font size=\"2\">`bar]´</font>`baz´",
          "innerHTML": "`foo[´<font size=\"2\">`bar]´</font>`baz´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\">`foo[´<font size=\"2\">`bar]´</font>`baz´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\">`foo[´<font size=\"2\">`bar]´</font>`baz´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\">`foo[´<font size=\"2\">`bar]´</font>`baz´</div>CAN<br>ARY</body>"
        }
      },
      "FS:18px_TEXT-1_SI": {
        "dM": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 2,
          "output": "`foo[´<font size=\"18px\">`bar]´</font>`baz´",
          "innerHTML": "`foo[´<font size=\"18px\">`bar]´</font>`baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo[´<font size=\"18px\">`bar]´</font>`baz´</body>",
          "bodyInnerHTML": "`foo[´<font size=\"18px\">`bar]´</font>`baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo[´<font size=\"18px\">`bar]´</font>`baz´</body>"
        },
        "body": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 2,
          "output": "`foo[´<font size=\"18px\">`bar]´</font>`baz´",
          "innerHTML": "`foo[´<font size=\"18px\">`bar]´</font>`baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo[´<font size=\"18px\">`bar]´</font>`baz´</body>",
          "bodyInnerHTML": "`foo[´<font size=\"18px\">`bar]´</font>`baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo[´<font size=\"18px\">`bar]´</font>`baz´</body>"
        },
        "div": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 2,
          "output": "`foo[´<font size=\"18px\">`bar]´</font>`baz´",
          "innerHTML": "`foo[´<font size=\"18px\">`bar]´</font>`baz´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\">`foo[´<font size=\"18px\">`bar]´</font>`baz´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\">`foo[´<font size=\"18px\">`bar]´</font>`baz´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\">`foo[´<font size=\"18px\">`bar]´</font>`baz´</div>CAN<br>ARY</body>"
        }
      },
      "FS:large_TEXT-1_SI": {
        "dM": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 2,
          "output": "`foo[´<font size=\"large\">`bar]´</font>`baz´",
          "innerHTML": "`foo[´<font size=\"large\">`bar]´</font>`baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo[´<font size=\"large\">`bar]´</font>`baz´</body>",
          "bodyInnerHTML": "`foo[´<font size=\"large\">`bar]´</font>`baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo[´<font size=\"large\">`bar]´</font>`baz´</body>"
        },
        "body": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 2,
          "output": "`foo[´<font size=\"large\">`bar]´</font>`baz´",
          "innerHTML": "`foo[´<font size=\"large\">`bar]´</font>`baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo[´<font size=\"large\">`bar]´</font>`baz´</body>",
          "bodyInnerHTML": "`foo[´<font size=\"large\">`bar]´</font>`baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo[´<font size=\"large\">`bar]´</font>`baz´</body>"
        },
        "div": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 2,
          "output": "`foo[´<font size=\"large\">`bar]´</font>`baz´",
          "innerHTML": "`foo[´<font size=\"large\">`bar]´</font>`baz´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\">`foo[´<font size=\"large\">`bar]´</font>`baz´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\">`foo[´<font size=\"large\">`bar]´</font>`baz´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\">`foo[´<font size=\"large\">`bar]´</font>`baz´</div>CAN<br>ARY</body>"
        }
      },
      "INCFS:2_TEXT-1_SI": {
        "dM": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 2,
          "output": "`foo[´<big>`bar]´</big>`baz´",
          "innerHTML": "`foo[´<big>`bar]´</big>`baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo[´<big>`bar]´</big>`baz´</body>",
          "bodyInnerHTML": "`foo[´<big>`bar]´</big>`baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo[´<big>`bar]´</big>`baz´</body>"
        },
        "body": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 2,
          "output": "`foo[´<big>`bar]´</big>`baz´",
          "innerHTML": "`foo[´<big>`bar]´</big>`baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo[´<big>`bar]´</big>`baz´</body>",
          "bodyInnerHTML": "`foo[´<big>`bar]´</big>`baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo[´<big>`bar]´</big>`baz´</body>"
        },
        "div": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 2,
          "output": "`foo[´<big>`bar]´</big>`baz´",
          "innerHTML": "`foo[´<big>`bar]´</big>`baz´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\">`foo[´<big>`bar]´</big>`baz´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\">`foo[´<big>`bar]´</big>`baz´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\">`foo[´<big>`bar]´</big>`baz´</div>CAN<br>ARY</body>"
        }
      },
      "DECFS:2_TEXT-1_SI": {
        "dM": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 2,
          "output": "`foo[´<small>`bar]´</small>`baz´",
          "innerHTML": "`foo[´<small>`bar]´</small>`baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo[´<small>`bar]´</small>`baz´</body>",
          "bodyInnerHTML": "`foo[´<small>`bar]´</small>`baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo[´<small>`bar]´</small>`baz´</body>"
        },
        "body": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 2,
          "output": "`foo[´<small>`bar]´</small>`baz´",
          "innerHTML": "`foo[´<small>`bar]´</small>`baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo[´<small>`bar]´</small>`baz´</body>",
          "bodyInnerHTML": "`foo[´<small>`bar]´</small>`baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo[´<small>`bar]´</small>`baz´</body>"
        },
        "div": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 2,
          "output": "`foo[´<small>`bar]´</small>`baz´",
          "innerHTML": "`foo[´<small>`bar]´</small>`baz´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\">`foo[´<small>`bar]´</small>`baz´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\">`foo[´<small>`bar]´</small>`baz´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\">`foo[´<small>`bar]´</small>`baz´</div>CAN<br>ARY</body>"
        }
      },
      "IND_TEXT-1_SI": {
        "dM": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "<blockquote>`foo[bar]baz´</blockquote>",
          "innerHTML": "<blockquote>`foo[bar]baz´</blockquote>",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\"><blockquote>`foo[bar]baz´</blockquote></body>",
          "bodyInnerHTML": "<blockquote>`foo[bar]baz´</blockquote>",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\"><blockquote>`foo[bar]baz´</blockquote></body>"
        },
        "body": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "<blockquote>`foo[bar]baz´</blockquote>",
          "innerHTML": "<blockquote>`foo[bar]baz´</blockquote>",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\"><blockquote>`foo[bar]baz´</blockquote></body>",
          "bodyInnerHTML": "<blockquote>`foo[bar]baz´</blockquote>",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\"><blockquote>`foo[bar]baz´</blockquote></body>"
        },
        "div": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "<blockquote>`foo[bar]baz´</blockquote>",
          "innerHTML": "<blockquote>`foo[bar]baz´</blockquote>",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\"><blockquote>`foo[bar]baz´</blockquote></div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\"><blockquote>`foo[bar]baz´</blockquote></div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\"><blockquote>`foo[bar]baz´</blockquote></div>CAN<br>ARY</body>"
        }
      },
      "JC_TEXT-1_SC": {
        "dM": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "<div align=\"center\">`foo^bar´</div>",
          "innerHTML": "<div align=\"center\">`foo^bar´</div>",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\"><div align=\"center\">`foo^bar´</div></body>",
          "bodyInnerHTML": "<div align=\"center\">`foo^bar´</div>",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\"><div align=\"center\">`foo^bar´</div></body>"
        },
        "body": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "<div align=\"center\">`foo^bar´</div>",
          "innerHTML": "<div align=\"center\">`foo^bar´</div>",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\"><div align=\"center\">`foo^bar´</div></body>",
          "bodyInnerHTML": "<div align=\"center\">`foo^bar´</div>",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\"><div align=\"center\">`foo^bar´</div></body>"
        },
        "div": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "<div align=\"center\">`foo^bar´</div>",
          "innerHTML": "<div align=\"center\">`foo^bar´</div>",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\"><div align=\"center\">`foo^bar´</div></div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\"><div align=\"center\">`foo^bar´</div></div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\"><div align=\"center\">`foo^bar´</div></div>CAN<br>ARY</body>"
        }
      },
      "JF_TEXT-1_SC": {
        "dM": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "<div align=\"justify\">`foo^bar´</div>",
          "innerHTML": "<div align=\"justify\">`foo^bar´</div>",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\"><div align=\"justify\">`foo^bar´</div></body>",
          "bodyInnerHTML": "<div align=\"justify\">`foo^bar´</div>",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\"><div align=\"justify\">`foo^bar´</div></body>"
        },
        "body": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "<div align=\"justify\">`foo^bar´</div>",
          "innerHTML": "<div align=\"justify\">`foo^bar´</div>",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\"><div align=\"justify\">`foo^bar´</div></body>",
          "bodyInnerHTML": "<div align=\"justify\">`foo^bar´</div>",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\"><div align=\"justify\">`foo^bar´</div></body>"
        },
        "div": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "<div align=\"justify\">`foo^bar´</div>",
          "innerHTML": "<div align=\"justify\">`foo^bar´</div>",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\"><div align=\"justify\">`foo^bar´</div></div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\"><div align=\"justify\">`foo^bar´</div></div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\"><div align=\"justify\">`foo^bar´</div></div>CAN<br>ARY</body>"
        }
      },
      "JL_TEXT-1_SC": {
        "dM": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "<div align=\"left\">`foo^bar´</div>",
          "innerHTML": "<div align=\"left\">`foo^bar´</div>",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\"><div align=\"left\">`foo^bar´</div></body>",
          "bodyInnerHTML": "<div align=\"left\">`foo^bar´</div>",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\"><div align=\"left\">`foo^bar´</div></body>"
        },
        "body": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "<div align=\"left\">`foo^bar´</div>",
          "innerHTML": "<div align=\"left\">`foo^bar´</div>",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\"><div align=\"left\">`foo^bar´</div></body>",
          "bodyInnerHTML": "<div align=\"left\">`foo^bar´</div>",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\"><div align=\"left\">`foo^bar´</div></body>"
        },
        "div": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "<div align=\"left\">`foo^bar´</div>",
          "innerHTML": "<div align=\"left\">`foo^bar´</div>",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\"><div align=\"left\">`foo^bar´</div></div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\"><div align=\"left\">`foo^bar´</div></div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\"><div align=\"left\">`foo^bar´</div></div>CAN<br>ARY</body>"
        }
      },
      "JR_TEXT-1_SC": {
        "dM": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "<div align=\"right\">`foo^bar´</div>",
          "innerHTML": "<div align=\"right\">`foo^bar´</div>",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\"><div align=\"right\">`foo^bar´</div></body>",
          "bodyInnerHTML": "<div align=\"right\">`foo^bar´</div>",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\"><div align=\"right\">`foo^bar´</div></body>"
        },
        "body": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "<div align=\"right\">`foo^bar´</div>",
          "innerHTML": "<div align=\"right\">`foo^bar´</div>",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\"><div align=\"right\">`foo^bar´</div></body>",
          "bodyInnerHTML": "<div align=\"right\">`foo^bar´</div>",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\"><div align=\"right\">`foo^bar´</div></body>"
        },
        "div": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "<div align=\"right\">`foo^bar´</div>",
          "innerHTML": "<div align=\"right\">`foo^bar´</div>",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\"><div align=\"right\">`foo^bar´</div></div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\"><div align=\"right\">`foo^bar´</div></div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\"><div align=\"right\">`foo^bar´</div></div>CAN<br>ARY</body>"
        }
      },
      "H:H1_TEXT-1_SC": {
        "dM": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "<h1>`foo[bar]baz´</h1>",
          "innerHTML": "<h1>`foo[bar]baz´</h1>",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\"><h1>`foo[bar]baz´</h1></body>",
          "bodyInnerHTML": "<h1>`foo[bar]baz´</h1>",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\"><h1>`foo[bar]baz´</h1></body>"
        },
        "body": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "<h1>`foo[bar]baz´</h1>",
          "innerHTML": "<h1>`foo[bar]baz´</h1>",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\"><h1>`foo[bar]baz´</h1></body>",
          "bodyInnerHTML": "<h1>`foo[bar]baz´</h1>",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\"><h1>`foo[bar]baz´</h1></body>"
        },
        "div": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "<h1>`foo[bar]baz´</h1>",
          "innerHTML": "<h1>`foo[bar]baz´</h1>",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\"><h1>`foo[bar]baz´</h1></div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\"><h1>`foo[bar]baz´</h1></div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\"><h1>`foo[bar]baz´</h1></div>CAN<br>ARY</body>"
        }
      },
      "CB:name_TEXT-1_SI": {
        "dM": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`foo[bar]baz´",
          "innerHTML": "`foo[bar]baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo[bar]baz´</body>",
          "bodyInnerHTML": "`foo[bar]baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo[bar]baz´</body>"
        },
        "body": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`foo[bar]baz´",
          "innerHTML": "`foo[bar]baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo[bar]baz´</body>",
          "bodyInnerHTML": "`foo[bar]baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo[bar]baz´</body>"
        },
        "div": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`foo[bar]baz´",
          "innerHTML": "`foo[bar]baz´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\">`foo[bar]baz´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\">`foo[bar]baz´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\">`foo[bar]baz´</div>CAN<br>ARY</body>"
        }
      }
    }
  },
  "AC": {
    "Proposed": {
      "B_TEXT-1_SI": {
        "dM": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 2,
          "output": "`foo[´<span style=\"font-weight: bold;\">`bar]´</span>`baz´",
          "innerHTML": "`foo[´<span style=\"font-weight: bold;\">`bar]´</span>`baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo[´<span style=\"font-weight: bold;\">`bar]´</span>`baz´</body>",
          "bodyInnerHTML": "`foo[´<span style=\"font-weight: bold;\">`bar]´</span>`baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo[´<span style=\"font-weight: bold;\">`bar]´</span>`baz´</body>"
        },
        "body": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 2,
          "output": "`foo[´<span style=\"font-weight: bold;\">`bar]´</span>`baz´",
          "innerHTML": "`foo[´<span style=\"font-weight: bold;\">`bar]´</span>`baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo[´<span style=\"font-weight: bold;\">`bar]´</span>`baz´</body>",
          "bodyInnerHTML": "`foo[´<span style=\"font-weight: bold;\">`bar]´</span>`baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo[´<span style=\"font-weight: bold;\">`bar]´</span>`baz´</body>"
        },
        "div": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 2,
          "output": "`foo[´<span style=\"font-weight: bold;\">`bar]´</span>`baz´",
          "innerHTML": "`foo[´<span style=\"font-weight: bold;\">`bar]´</span>`baz´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\">`foo[´<span style=\"font-weight: bold;\">`bar]´</span>`baz´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\">`foo[´<span style=\"font-weight: bold;\">`bar]´</span>`baz´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\">`foo[´<span style=\"font-weight: bold;\">`bar]´</span>`baz´</div>CAN<br>ARY</body>"
        }
      },
      "I_TEXT-1_SI": {
        "dM": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 2,
          "output": "`foo[´<span style=\"font-style: italic;\">`bar]´</span>`baz´",
          "innerHTML": "`foo[´<span style=\"font-style: italic;\">`bar]´</span>`baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo[´<span style=\"font-style: italic;\">`bar]´</span>`baz´</body>",
          "bodyInnerHTML": "`foo[´<span style=\"font-style: italic;\">`bar]´</span>`baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo[´<span style=\"font-style: italic;\">`bar]´</span>`baz´</body>"
        },
        "body": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 2,
          "output": "`foo[´<span style=\"font-style: italic;\">`bar]´</span>`baz´",
          "innerHTML": "`foo[´<span style=\"font-style: italic;\">`bar]´</span>`baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo[´<span style=\"font-style: italic;\">`bar]´</span>`baz´</body>",
          "bodyInnerHTML": "`foo[´<span style=\"font-style: italic;\">`bar]´</span>`baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo[´<span style=\"font-style: italic;\">`bar]´</span>`baz´</body>"
        },
        "div": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 2,
          "output": "`foo[´<span style=\"font-style: italic;\">`bar]´</span>`baz´",
          "innerHTML": "`foo[´<span style=\"font-style: italic;\">`bar]´</span>`baz´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\">`foo[´<span style=\"font-style: italic;\">`bar]´</span>`baz´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\">`foo[´<span style=\"font-style: italic;\">`bar]´</span>`baz´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\">`foo[´<span style=\"font-style: italic;\">`bar]´</span>`baz´</div>CAN<br>ARY</body>"
        }
      },
      "U_TEXT-1_SI": {
        "dM": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 2,
          "output": "`foo[´<span style=\"text-decoration: underline;\">`bar]´</span>`baz´",
          "innerHTML": "`foo[´<span style=\"text-decoration: underline;\">`bar]´</span>`baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo[´<span style=\"text-decoration: underline;\">`bar]´</span>`baz´</body>",
          "bodyInnerHTML": "`foo[´<span style=\"text-decoration: underline;\">`bar]´</span>`baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo[´<span style=\"text-decoration: underline;\">`bar]´</span>`baz´</body>"
        },
        "body": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 2,
          "output": "`foo[´<span style=\"text-decoration: underline;\">`bar]´</span>`baz´",
          "innerHTML": "`foo[´<span style=\"text-decoration: underline;\">`bar]´</span>`baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo[´<span style=\"text-decoration: underline;\">`bar]´</span>`baz´</body>",
          "bodyInnerHTML": "`foo[´<span style=\"text-decoration: underline;\">`bar]´</span>`baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo[´<span style=\"text-decoration: underline;\">`bar]´</span>`baz´</body>"
        },
        "div": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 2,
          "output": "`foo[´<span style=\"text-decoration: underline;\">`bar]´</span>`baz´",
          "innerHTML": "`foo[´<span style=\"text-decoration: underline;\">`bar]´</span>`baz´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\">`foo[´<span style=\"text-decoration: underline;\">`bar]´</span>`baz´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\">`foo[´<span style=\"text-decoration: underline;\">`bar]´</span>`baz´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\">`foo[´<span style=\"text-decoration: underline;\">`bar]´</span>`baz´</div>CAN<br>ARY</body>"
        }
      },
      "S_TEXT-1_SI": {
        "dM": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 2,
          "output": "`foo[´<span style=\"text-decoration: line-through;\">`bar]´</span>`baz´",
          "innerHTML": "`foo[´<span style=\"text-decoration: line-through;\">`bar]´</span>`baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo[´<span style=\"text-decoration: line-through;\">`bar]´</span>`baz´</body>",
          "bodyInnerHTML": "`foo[´<span style=\"text-decoration: line-through;\">`bar]´</span>`baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo[´<span style=\"text-decoration: line-through;\">`bar]´</span>`baz´</body>"
        },
        "body": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 2,
          "output": "`foo[´<span style=\"text-decoration: line-through;\">`bar]´</span>`baz´",
          "innerHTML": "`foo[´<span style=\"text-decoration: line-through;\">`bar]´</span>`baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo[´<span style=\"text-decoration: line-through;\">`bar]´</span>`baz´</body>",
          "bodyInnerHTML": "`foo[´<span style=\"text-decoration: line-through;\">`bar]´</span>`baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo[´<span style=\"text-decoration: line-through;\">`bar]´</span>`baz´</body>"
        },
        "div": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 2,
          "output": "`foo[´<span style=\"text-decoration: line-through;\">`bar]´</span>`baz´",
          "innerHTML": "`foo[´<span style=\"text-decoration: line-through;\">`bar]´</span>`baz´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\">`foo[´<span style=\"text-decoration: line-through;\">`bar]´</span>`baz´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\">`foo[´<span style=\"text-decoration: line-through;\">`bar]´</span>`baz´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\">`foo[´<span style=\"text-decoration: line-through;\">`bar]´</span>`baz´</div>CAN<br>ARY</body>"
        }
      },
      "SUB_TEXT-1_SI": {
        "dM": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`foo[´<sub>`bar]´</sub>`baz´",
          "innerHTML": "`foo[´<sub>`bar]´</sub>`baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo[´<sub>`bar]´</sub>`baz´</body>",
          "bodyInnerHTML": "`foo[´<sub>`bar]´</sub>`baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo[´<sub>`bar]´</sub>`baz´</body>"
        },
        "body": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`foo[´<sub>`bar]´</sub>`baz´",
          "innerHTML": "`foo[´<sub>`bar]´</sub>`baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo[´<sub>`bar]´</sub>`baz´</body>",
          "bodyInnerHTML": "`foo[´<sub>`bar]´</sub>`baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo[´<sub>`bar]´</sub>`baz´</body>"
        },
        "div": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`foo[´<sub>`bar]´</sub>`baz´",
          "innerHTML": "`foo[´<sub>`bar]´</sub>`baz´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\">`foo[´<sub>`bar]´</sub>`baz´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\">`foo[´<sub>`bar]´</sub>`baz´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\">`foo[´<sub>`bar]´</sub>`baz´</div>CAN<br>ARY</body>"
        }
      },
      "SUP_TEXT-1_SI": {
        "dM": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`foo[´<sup>`bar]´</sup>`baz´",
          "innerHTML": "`foo[´<sup>`bar]´</sup>`baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo[´<sup>`bar]´</sup>`baz´</body>",
          "bodyInnerHTML": "`foo[´<sup>`bar]´</sup>`baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo[´<sup>`bar]´</sup>`baz´</body>"
        },
        "body": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`foo[´<sup>`bar]´</sup>`baz´",
          "innerHTML": "`foo[´<sup>`bar]´</sup>`baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo[´<sup>`bar]´</sup>`baz´</body>",
          "bodyInnerHTML": "`foo[´<sup>`bar]´</sup>`baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo[´<sup>`bar]´</sup>`baz´</body>"
        },
        "div": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`foo[´<sup>`bar]´</sup>`baz´",
          "innerHTML": "`foo[´<sup>`bar]´</sup>`baz´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\">`foo[´<sup>`bar]´</sup>`baz´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\">`foo[´<sup>`bar]´</sup>`baz´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\">`foo[´<sup>`bar]´</sup>`baz´</div>CAN<br>ARY</body>"
        }
      },
      "BC:blue_TEXT-1_SI": {
        "dM": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\" style=\"background-color: blue;\">`foo[bar]baz´</body>",
          "innerHTML": "`foo[bar]baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\" style=\"background-color: blue;\">`foo[bar]baz´</body>",
          "bodyInnerHTML": "`foo[bar]baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\" style=\"background-color: blue;\">`foo[bar]baz´</body>"
        },
        "body": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" style=\"background-color: blue;\">`foo[bar]baz´</body>",
          "innerHTML": "`foo[bar]baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" style=\"background-color: blue;\">`foo[bar]baz´</body>",
          "bodyInnerHTML": "`foo[bar]baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" style=\"background-color: blue;\">`foo[bar]baz´</body>"
        },
        "div": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\" style=\"background-color: blue;\">`foo[bar]baz´</div>",
          "innerHTML": "`foo[bar]baz´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\" style=\"background-color: blue;\">`foo[bar]baz´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div style=\"background-color: blue;\" id=\"editor-div\" contenteditable=\"true\">`foo[bar]baz´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\" style=\"background-color: blue;\">`foo[bar]baz´</div>CAN<br>ARY</body>"
        }
      },
      "FC:blue_TEXT-1_SI": {
        "dM": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 2,
          "output": "`foo[´<span style=\"color: blue;\">`bar]´</span>`baz´",
          "innerHTML": "`foo[´<span style=\"color: blue;\">`bar]´</span>`baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo[´<span style=\"color: blue;\">`bar]´</span>`baz´</body>",
          "bodyInnerHTML": "`foo[´<span style=\"color: blue;\">`bar]´</span>`baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo[´<span style=\"color: blue;\">`bar]´</span>`baz´</body>"
        },
        "body": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 2,
          "output": "`foo[´<span style=\"color: blue;\">`bar]´</span>`baz´",
          "innerHTML": "`foo[´<span style=\"color: blue;\">`bar]´</span>`baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo[´<span style=\"color: blue;\">`bar]´</span>`baz´</body>",
          "bodyInnerHTML": "`foo[´<span style=\"color: blue;\">`bar]´</span>`baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo[´<span style=\"color: blue;\">`bar]´</span>`baz´</body>"
        },
        "div": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 2,
          "output": "`foo[´<span style=\"color: blue;\">`bar]´</span>`baz´",
          "innerHTML": "`foo[´<span style=\"color: blue;\">`bar]´</span>`baz´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\">`foo[´<span style=\"color: blue;\">`bar]´</span>`baz´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\">`foo[´<span style=\"color: blue;\">`bar]´</span>`baz´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\">`foo[´<span style=\"color: blue;\">`bar]´</span>`baz´</div>CAN<br>ARY</body>"
        }
      },
      "HC:blue_TEXT-1_SI": {
        "dM": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 2,
          "output": "`foo[´<span style=\"background-color: blue;\">`bar]´</span>`baz´",
          "innerHTML": "`foo[´<span style=\"background-color: blue;\">`bar]´</span>`baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo[´<span style=\"background-color: blue;\">`bar]´</span>`baz´</body>",
          "bodyInnerHTML": "`foo[´<span style=\"background-color: blue;\">`bar]´</span>`baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo[´<span style=\"background-color: blue;\">`bar]´</span>`baz´</body>"
        },
        "body": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 2,
          "output": "`foo[´<span style=\"background-color: blue;\">`bar]´</span>`baz´",
          "innerHTML": "`foo[´<span style=\"background-color: blue;\">`bar]´</span>`baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo[´<span style=\"background-color: blue;\">`bar]´</span>`baz´</body>",
          "bodyInnerHTML": "`foo[´<span style=\"background-color: blue;\">`bar]´</span>`baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo[´<span style=\"background-color: blue;\">`bar]´</span>`baz´</body>"
        },
        "div": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 2,
          "output": "`foo[´<span style=\"background-color: blue;\">`bar]´</span>`baz´",
          "innerHTML": "`foo[´<span style=\"background-color: blue;\">`bar]´</span>`baz´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\">`foo[´<span style=\"background-color: blue;\">`bar]´</span>`baz´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\">`foo[´<span style=\"background-color: blue;\">`bar]´</span>`baz´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\">`foo[´<span style=\"background-color: blue;\">`bar]´</span>`baz´</div>CAN<br>ARY</body>"
        }
      },
      "FN:a_TEXT-1_SI": {
        "dM": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 2,
          "output": "`foo[´<span style=\"font-family: arial;\">`bar]´</span>`baz´",
          "innerHTML": "`foo[´<span style=\"font-family: arial;\">`bar]´</span>`baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo[´<span style=\"font-family: arial;\">`bar]´</span>`baz´</body>",
          "bodyInnerHTML": "`foo[´<span style=\"font-family: arial;\">`bar]´</span>`baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo[´<span style=\"font-family: arial;\">`bar]´</span>`baz´</body>"
        },
        "body": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 2,
          "output": "`foo[´<span style=\"font-family: arial;\">`bar]´</span>`baz´",
          "innerHTML": "`foo[´<span style=\"font-family: arial;\">`bar]´</span>`baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo[´<span style=\"font-family: arial;\">`bar]´</span>`baz´</body>",
          "bodyInnerHTML": "`foo[´<span style=\"font-family: arial;\">`bar]´</span>`baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo[´<span style=\"font-family: arial;\">`bar]´</span>`baz´</body>"
        },
        "div": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 2,
          "output": "`foo[´<span style=\"font-family: arial;\">`bar]´</span>`baz´",
          "innerHTML": "`foo[´<span style=\"font-family: arial;\">`bar]´</span>`baz´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\">`foo[´<span style=\"font-family: arial;\">`bar]´</span>`baz´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\">`foo[´<span style=\"font-family: arial;\">`bar]´</span>`baz´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\">`foo[´<span style=\"font-family: arial;\">`bar]´</span>`baz´</div>CAN<br>ARY</body>"
        }
      },
      "FS:2_TEXT-1_SI": {
        "dM": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`foo[´<font size=\"2\">`bar]´</font>`baz´",
          "innerHTML": "`foo[´<font size=\"2\">`bar]´</font>`baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo[´<font size=\"2\">`bar]´</font>`baz´</body>",
          "bodyInnerHTML": "`foo[´<font size=\"2\">`bar]´</font>`baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo[´<font size=\"2\">`bar]´</font>`baz´</body>"
        },
        "body": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`foo[´<font size=\"2\">`bar]´</font>`baz´",
          "innerHTML": "`foo[´<font size=\"2\">`bar]´</font>`baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo[´<font size=\"2\">`bar]´</font>`baz´</body>",
          "bodyInnerHTML": "`foo[´<font size=\"2\">`bar]´</font>`baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo[´<font size=\"2\">`bar]´</font>`baz´</body>"
        },
        "div": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`foo[´<font size=\"2\">`bar]´</font>`baz´",
          "innerHTML": "`foo[´<font size=\"2\">`bar]´</font>`baz´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\">`foo[´<font size=\"2\">`bar]´</font>`baz´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\">`foo[´<font size=\"2\">`bar]´</font>`baz´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\">`foo[´<font size=\"2\">`bar]´</font>`baz´</div>CAN<br>ARY</body>"
        }
      },
      "FS:18px_TEXT-1_SI": {
        "dM": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`foo[´<font size=\"18px\">`bar]´</font>`baz´",
          "innerHTML": "`foo[´<font size=\"18px\">`bar]´</font>`baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo[´<font size=\"18px\">`bar]´</font>`baz´</body>",
          "bodyInnerHTML": "`foo[´<font size=\"18px\">`bar]´</font>`baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo[´<font size=\"18px\">`bar]´</font>`baz´</body>"
        },
        "body": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`foo[´<font size=\"18px\">`bar]´</font>`baz´",
          "innerHTML": "`foo[´<font size=\"18px\">`bar]´</font>`baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo[´<font size=\"18px\">`bar]´</font>`baz´</body>",
          "bodyInnerHTML": "`foo[´<font size=\"18px\">`bar]´</font>`baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo[´<font size=\"18px\">`bar]´</font>`baz´</body>"
        },
        "div": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`foo[´<font size=\"18px\">`bar]´</font>`baz´",
          "innerHTML": "`foo[´<font size=\"18px\">`bar]´</font>`baz´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\">`foo[´<font size=\"18px\">`bar]´</font>`baz´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\">`foo[´<font size=\"18px\">`bar]´</font>`baz´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\">`foo[´<font size=\"18px\">`bar]´</font>`baz´</div>CAN<br>ARY</body>"
        }
      },
      "FS:large_TEXT-1_SI": {
        "dM": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`foo[´<font size=\"large\">`bar]´</font>`baz´",
          "innerHTML": "`foo[´<font size=\"large\">`bar]´</font>`baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo[´<font size=\"large\">`bar]´</font>`baz´</body>",
          "bodyInnerHTML": "`foo[´<font size=\"large\">`bar]´</font>`baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo[´<font size=\"large\">`bar]´</font>`baz´</body>"
        },
        "body": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`foo[´<font size=\"large\">`bar]´</font>`baz´",
          "innerHTML": "`foo[´<font size=\"large\">`bar]´</font>`baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo[´<font size=\"large\">`bar]´</font>`baz´</body>",
          "bodyInnerHTML": "`foo[´<font size=\"large\">`bar]´</font>`baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo[´<font size=\"large\">`bar]´</font>`baz´</body>"
        },
        "div": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`foo[´<font size=\"large\">`bar]´</font>`baz´",
          "innerHTML": "`foo[´<font size=\"large\">`bar]´</font>`baz´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\">`foo[´<font size=\"large\">`bar]´</font>`baz´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\">`foo[´<font size=\"large\">`bar]´</font>`baz´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\">`foo[´<font size=\"large\">`bar]´</font>`baz´</div>CAN<br>ARY</body>"
        }
      },
      "IND_TEXT-1_SI": {
        "dM": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "<div style=\"margin-left: 40px;\">`foo[bar]baz´</div>",
          "innerHTML": "<div style=\"margin-left: 40px;\">`foo[bar]baz´</div>",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\"><div style=\"margin-left: 40px;\">`foo[bar]baz´</div></body>",
          "bodyInnerHTML": "<div style=\"margin-left: 40px;\">`foo[bar]baz´</div>",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\"><div style=\"margin-left: 40px;\">`foo[bar]baz´</div></body>"
        },
        "body": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "<div style=\"margin-left: 40px;\">`foo[bar]baz´</div>",
          "innerHTML": "<div style=\"margin-left: 40px;\">`foo[bar]baz´</div>",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\"><div style=\"margin-left: 40px;\">`foo[bar]baz´</div></body>",
          "bodyInnerHTML": "<div style=\"margin-left: 40px;\">`foo[bar]baz´</div>",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\"><div style=\"margin-left: 40px;\">`foo[bar]baz´</div></body>"
        },
        "div": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "<div style=\"margin-left: 40px;\">`foo[bar]baz´</div>",
          "innerHTML": "<div style=\"margin-left: 40px;\">`foo[bar]baz´</div>",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\"><div style=\"margin-left: 40px;\">`foo[bar]baz´</div></div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\"><div style=\"margin-left: 40px;\">`foo[bar]baz´</div></div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\"><div style=\"margin-left: 40px;\">`foo[bar]baz´</div></div>CAN<br>ARY</body>"
        }
      },
      "JC_TEXT-1_SC": {
        "dM": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "<div style=\"text-align: center;\">`foo^bar´</div>",
          "innerHTML": "<div style=\"text-align: center;\">`foo^bar´</div>",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\"><div style=\"text-align: center;\">`foo^bar´</div></body>",
          "bodyInnerHTML": "<div style=\"text-align: center;\">`foo^bar´</div>",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\"><div style=\"text-align: center;\">`foo^bar´</div></body>"
        },
        "body": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "<div style=\"text-align: center;\">`foo^bar´</div>",
          "innerHTML": "<div style=\"text-align: center;\">`foo^bar´</div>",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\"><div style=\"text-align: center;\">`foo^bar´</div></body>",
          "bodyInnerHTML": "<div style=\"text-align: center;\">`foo^bar´</div>",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\"><div style=\"text-align: center;\">`foo^bar´</div></body>"
        },
        "div": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "<div style=\"text-align: center;\">`foo^bar´</div>",
          "innerHTML": "<div style=\"text-align: center;\">`foo^bar´</div>",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\"><div style=\"text-align: center;\">`foo^bar´</div></div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\"><div style=\"text-align: center;\">`foo^bar´</div></div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\"><div style=\"text-align: center;\">`foo^bar´</div></div>CAN<br>ARY</body>"
        }
      },
      "JF_TEXT-1_SC": {
        "dM": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "<div style=\"text-align: justify;\">`foo^bar´</div>",
          "innerHTML": "<div style=\"text-align: justify;\">`foo^bar´</div>",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\"><div style=\"text-align: justify;\">`foo^bar´</div></body>",
          "bodyInnerHTML": "<div style=\"text-align: justify;\">`foo^bar´</div>",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\"><div style=\"text-align: justify;\">`foo^bar´</div></body>"
        },
        "body": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "<div style=\"text-align: justify;\">`foo^bar´</div>",
          "innerHTML": "<div style=\"text-align: justify;\">`foo^bar´</div>",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\"><div style=\"text-align: justify;\">`foo^bar´</div></body>",
          "bodyInnerHTML": "<div style=\"text-align: justify;\">`foo^bar´</div>",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\"><div style=\"text-align: justify;\">`foo^bar´</div></body>"
        },
        "div": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "<div style=\"text-align: justify;\">`foo^bar´</div>",
          "innerHTML": "<div style=\"text-align: justify;\">`foo^bar´</div>",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\"><div style=\"text-align: justify;\">`foo^bar´</div></div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\"><div style=\"text-align: justify;\">`foo^bar´</div></div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\"><div style=\"text-align: justify;\">`foo^bar´</div></div>CAN<br>ARY</body>"
        }
      },
      "JL_TEXT-1_SC": {
        "dM": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "<div style=\"text-align: left;\">`foo^bar´</div>",
          "innerHTML": "<div style=\"text-align: left;\">`foo^bar´</div>",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\"><div style=\"text-align: left;\">`foo^bar´</div></body>",
          "bodyInnerHTML": "<div style=\"text-align: left;\">`foo^bar´</div>",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\"><div style=\"text-align: left;\">`foo^bar´</div></body>"
        },
        "body": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "<div style=\"text-align: left;\">`foo^bar´</div>",
          "innerHTML": "<div style=\"text-align: left;\">`foo^bar´</div>",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\"><div style=\"text-align: left;\">`foo^bar´</div></body>",
          "bodyInnerHTML": "<div style=\"text-align: left;\">`foo^bar´</div>",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\"><div style=\"text-align: left;\">`foo^bar´</div></body>"
        },
        "div": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "<div style=\"text-align: left;\">`foo^bar´</div>",
          "innerHTML": "<div style=\"text-align: left;\">`foo^bar´</div>",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\"><div style=\"text-align: left;\">`foo^bar´</div></div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\"><div style=\"text-align: left;\">`foo^bar´</div></div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\"><div style=\"text-align: left;\">`foo^bar´</div></div>CAN<br>ARY</body>"
        }
      },
      "JR_TEXT-1_SC": {
        "dM": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "<div style=\"text-align: right;\">`foo^bar´</div>",
          "innerHTML": "<div style=\"text-align: right;\">`foo^bar´</div>",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\"><div style=\"text-align: right;\">`foo^bar´</div></body>",
          "bodyInnerHTML": "<div style=\"text-align: right;\">`foo^bar´</div>",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\"><div style=\"text-align: right;\">`foo^bar´</div></body>"
        },
        "body": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "<div style=\"text-align: right;\">`foo^bar´</div>",
          "innerHTML": "<div style=\"text-align: right;\">`foo^bar´</div>",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\"><div style=\"text-align: right;\">`foo^bar´</div></body>",
          "bodyInnerHTML": "<div style=\"text-align: right;\">`foo^bar´</div>",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\"><div style=\"text-align: right;\">`foo^bar´</div></body>"
        },
        "div": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "<div style=\"text-align: right;\">`foo^bar´</div>",
          "innerHTML": "<div style=\"text-align: right;\">`foo^bar´</div>",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\"><div style=\"text-align: right;\">`foo^bar´</div></div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\"><div style=\"text-align: right;\">`foo^bar´</div></div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\"><div style=\"text-align: right;\">`foo^bar´</div></div>CAN<br>ARY</body>"
        }
      }
    }
  },
  "C": {
    "Proposed": {
      "I_I-1_SL": {
        "dM": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 2,
          "output": "`foo[´<i>`bar´`baz]´</i>`qoz´",
          "innerHTML": "`foo[´<i>`bar´`baz]´</i>`qoz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo[´<i>`bar´`baz]´</i>`qoz´</body>",
          "bodyInnerHTML": "`foo[´<i>`bar´`baz]´</i>`qoz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo[´<i>`bar´`baz]´</i>`qoz´</body>"
        },
        "body": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 2,
          "output": "`foo[´<i>`bar´`baz]´</i>`qoz´",
          "innerHTML": "`foo[´<i>`bar´`baz]´</i>`qoz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo[´<i>`bar´`baz]´</i>`qoz´</body>",
          "bodyInnerHTML": "`foo[´<i>`bar´`baz]´</i>`qoz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo[´<i>`bar´`baz]´</i>`qoz´</body>"
        },
        "div": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 2,
          "output": "`foo[´<i>`bar´`baz]´</i>`qoz´",
          "innerHTML": "`foo[´<i>`bar´`baz]´</i>`qoz´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\">`foo[´<i>`bar´`baz]´</i>`qoz´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\">`foo[´<i>`bar´`baz]´</i>`qoz´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\">`foo[´<i>`bar´`baz]´</i>`qoz´</div>CAN<br>ARY</body>"
        }
      },
      "I_B-I-1_SO": {
        "dM": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 2,
          "output": "<b>`foo[´<i>`bar´`baz´</i>}</b>",
          "innerHTML": "<b>`foo[´<i>`bar´`baz´</i>}</b>",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\"><b>`foo[´<i>`bar´`baz´</i>}</b></body>",
          "bodyInnerHTML": "<b>`foo[´<i>`bar´`baz´</i>}</b>",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\"><b>`foo[´<i>`bar´`baz´</i>}</b></body>"
        },
        "body": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 2,
          "output": "<b>`foo[´<i>`bar´`baz´</i>}</b>",
          "innerHTML": "<b>`foo[´<i>`bar´`baz´</i>}</b>",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\"><b>`foo[´<i>`bar´`baz´</i>}</b></body>",
          "bodyInnerHTML": "<b>`foo[´<i>`bar´`baz´</i>}</b>",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\"><b>`foo[´<i>`bar´`baz´</i>}</b></body>"
        },
        "div": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 2,
          "output": "<b>`foo[´<i>`bar´`baz´</i>}</b>",
          "innerHTML": "<b>`foo[´<i>`bar´`baz´</i>}</b>",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\"><b>`foo[´<i>`bar´`baz´</i>}</b></div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\"><b>`foo[´<i>`bar´`baz´</i>}</b></div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\"><b>`foo[´<i>`bar´`baz´</i>}</b></div>CAN<br>ARY</body>"
        }
      },
      "U_U-1_SO": {
        "dM": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 2,
          "output": "`foo[´<u>`bar´`baz´`qoz]´</u>`quz´",
          "innerHTML": "`foo[´<u>`bar´`baz´`qoz]´</u>`quz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo[´<u>`bar´`baz´`qoz]´</u>`quz´</body>",
          "bodyInnerHTML": "`foo[´<u>`bar´`baz´`qoz]´</u>`quz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo[´<u>`bar´`baz´`qoz]´</u>`quz´</body>"
        },
        "body": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 2,
          "output": "`foo[´<u>`bar´`baz´`qoz]´</u>`quz´",
          "innerHTML": "`foo[´<u>`bar´`baz´`qoz]´</u>`quz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo[´<u>`bar´`baz´`qoz]´</u>`quz´</body>",
          "bodyInnerHTML": "`foo[´<u>`bar´`baz´`qoz]´</u>`quz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo[´<u>`bar´`baz´`qoz]´</u>`quz´</body>"
        },
        "div": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 2,
          "output": "`foo[´<u>`bar´`baz´`qoz]´</u>`quz´",
          "innerHTML": "`foo[´<u>`bar´`baz´`qoz]´</u>`quz´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\">`foo[´<u>`bar´`baz´`qoz]´</u>`quz´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\">`foo[´<u>`bar´`baz´`qoz]´</u>`quz´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\">`foo[´<u>`bar´`baz´`qoz]´</u>`quz´</div>CAN<br>ARY</body>"
        }
      },
      "U_U-1_SL": {
        "dM": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 2,
          "output": "`foo[´<u>`bar´`baz]qoz´</u>`quz´",
          "innerHTML": "`foo[´<u>`bar´`baz]qoz´</u>`quz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo[´<u>`bar´`baz]qoz´</u>`quz´</body>",
          "bodyInnerHTML": "`foo[´<u>`bar´`baz]qoz´</u>`quz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo[´<u>`bar´`baz]qoz´</u>`quz´</body>"
        },
        "body": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 2,
          "output": "`foo[´<u>`bar´`baz]qoz´</u>`quz´",
          "innerHTML": "`foo[´<u>`bar´`baz]qoz´</u>`quz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo[´<u>`bar´`baz]qoz´</u>`quz´</body>",
          "bodyInnerHTML": "`foo[´<u>`bar´`baz]qoz´</u>`quz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo[´<u>`bar´`baz]qoz´</u>`quz´</body>"
        },
        "div": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 2,
          "output": "`foo[´<u>`bar´`baz]qoz´</u>`quz´",
          "innerHTML": "`foo[´<u>`bar´`baz]qoz´</u>`quz´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\">`foo[´<u>`bar´`baz]qoz´</u>`quz´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\">`foo[´<u>`bar´`baz]qoz´</u>`quz´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\">`foo[´<u>`bar´`baz]qoz´</u>`quz´</div>CAN<br>ARY</body>"
        }
      },
      "U_S-U-1_SO": {
        "dM": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 2,
          "output": "<s>`foo[´<u>`bar´`baz´</u>}</s>",
          "innerHTML": "<s>`foo[´<u>`bar´`baz´</u>}</s>",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\"><s>`foo[´<u>`bar´`baz´</u>}</s></body>",
          "bodyInnerHTML": "<s>`foo[´<u>`bar´`baz´</u>}</s>",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\"><s>`foo[´<u>`bar´`baz´</u>}</s></body>"
        },
        "body": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 2,
          "output": "<s>`foo[´<u>`bar´`baz´</u>}</s>",
          "innerHTML": "<s>`foo[´<u>`bar´`baz´</u>}</s>",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\"><s>`foo[´<u>`bar´`baz´</u>}</s></body>",
          "bodyInnerHTML": "<s>`foo[´<u>`bar´`baz´</u>}</s>",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\"><s>`foo[´<u>`bar´`baz´</u>}</s></body>"
        },
        "div": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 2,
          "output": "<s>`foo[´<u>`bar´`baz´</u>}</s>",
          "innerHTML": "<s>`foo[´<u>`bar´`baz´</u>}</s>",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\"><s>`foo[´<u>`bar´`baz´</u>}</s></div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\"><s>`foo[´<u>`bar´`baz´</u>}</s></div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\"><s>`foo[´<u>`bar´`baz´</u>}</s></div>CAN<br>ARY</body>"
        }
      },
      "BC:842_FONTs:bc:fca-1_SW": {
        "dM": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "<body xmlns=\"http://www.w3.org/1999/xhtml\" bgcolor=\"#884422\" onload=\"setDesignMode()\"><font style=\"background-color: #ffccaa\">`[foobarbaz]´</font></body>",
          "innerHTML": "<font style=\"background-color: #ffccaa\">`[foobarbaz]´</font>",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" bgcolor=\"#884422\" onload=\"setDesignMode()\"><font style=\"background-color: #ffccaa\">`[foobarbaz]´</font></body>",
          "bodyInnerHTML": "<font style=\"background-color: #ffccaa\">`[foobarbaz]´</font>",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" bgcolor=\"#884422\" onload=\"setDesignMode()\"><font style=\"background-color: #ffccaa\">`[foobarbaz]´</font></body>"
        },
        "body": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "<body xmlns=\"http://www.w3.org/1999/xhtml\" bgcolor=\"#884422\" contenteditable=\"true\"><font style=\"background-color: #ffccaa\">`[foobarbaz]´</font></body>",
          "innerHTML": "<font style=\"background-color: #ffccaa\">`[foobarbaz]´</font>",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" bgcolor=\"#884422\" contenteditable=\"true\"><font style=\"background-color: #ffccaa\">`[foobarbaz]´</font></body>",
          "bodyInnerHTML": "<font style=\"background-color: #ffccaa\">`[foobarbaz]´</font>",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" bgcolor=\"#884422\" contenteditable=\"true\"><font style=\"background-color: #ffccaa\">`[foobarbaz]´</font></body>"
        },
        "div": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "<font style=\"background-color: #ffccaa\">`[foobarbaz]´</font>",
          "innerHTML": "<font style=\"background-color: #ffccaa\">`[foobarbaz]´</font>",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\"><font style=\"background-color: #ffccaa\">`[foobarbaz]´</font></div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\"><font style=\"background-color: #ffccaa\">`[foobarbaz]´</font></div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" bgcolor=\"#884422\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\"><font style=\"background-color: #ffccaa\">`[foobarbaz]´</font></div>CAN<br>ARY</body>"
        }
      },
      "BC:00f_SPANs:bc:f00-1_SW": {
        "dM": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "<body xmlns=\"http://www.w3.org/1999/xhtml\" bgcolor=\"#0000ff\" onload=\"setDesignMode()\"><span style=\"background-color: #ff0000\">`[foobarbaz]´</span></body>",
          "innerHTML": "<span style=\"background-color: #ff0000\">`[foobarbaz]´</span>",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" bgcolor=\"#0000ff\" onload=\"setDesignMode()\"><span style=\"background-color: #ff0000\">`[foobarbaz]´</span></body>",
          "bodyInnerHTML": "<span style=\"background-color: #ff0000\">`[foobarbaz]´</span>",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" bgcolor=\"#0000ff\" onload=\"setDesignMode()\"><span style=\"background-color: #ff0000\">`[foobarbaz]´</span></body>"
        },
        "body": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "<body xmlns=\"http://www.w3.org/1999/xhtml\" bgcolor=\"#0000ff\" contenteditable=\"true\"><span style=\"background-color: #ff0000\">`[foobarbaz]´</span></body>",
          "innerHTML": "<span style=\"background-color: #ff0000\">`[foobarbaz]´</span>",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" bgcolor=\"#0000ff\" contenteditable=\"true\"><span style=\"background-color: #ff0000\">`[foobarbaz]´</span></body>",
          "bodyInnerHTML": "<span style=\"background-color: #ff0000\">`[foobarbaz]´</span>",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" bgcolor=\"#0000ff\" contenteditable=\"true\"><span style=\"background-color: #ff0000\">`[foobarbaz]´</span></body>"
        },
        "div": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "<span style=\"background-color: #ff0000\">`[foobarbaz]´</span>",
          "innerHTML": "<span style=\"background-color: #ff0000\">`[foobarbaz]´</span>",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\"><span style=\"background-color: #ff0000\">`[foobarbaz]´</span></div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\"><span style=\"background-color: #ff0000\">`[foobarbaz]´</span></div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" bgcolor=\"#0000ff\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\"><span style=\"background-color: #ff0000\">`[foobarbaz]´</span></div>CAN<br>ARY</body>"
        }
      },
      "BC:ace_FONT.ass.s:bc:rgb-1_SW": {
        "dM": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "<body xmlns=\"http://www.w3.org/1999/xhtml\" bgcolor=\"#aaccee\" onload=\"setDesignMode()\"><span style=\"background-color: rgb(255, 0, 0)\" class=\"Apple-style-span\">`[foobarbaz]´</span></body>",
          "innerHTML": "<span class=\"Apple-style-span\" style=\"background-color: rgb(255, 0, 0)\">`[foobarbaz]´</span>",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" bgcolor=\"#aaccee\" onload=\"setDesignMode()\"><span style=\"background-color: rgb(255, 0, 0)\" class=\"Apple-style-span\">`[foobarbaz]´</span></body>",
          "bodyInnerHTML": "<span class=\"Apple-style-span\" style=\"background-color: rgb(255, 0, 0)\">`[foobarbaz]´</span>",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" bgcolor=\"#aaccee\" onload=\"setDesignMode()\"><span style=\"background-color: rgb(255, 0, 0)\" class=\"Apple-style-span\">`[foobarbaz]´</span></body>"
        },
        "body": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "<body xmlns=\"http://www.w3.org/1999/xhtml\" bgcolor=\"#aaccee\" contenteditable=\"true\"><span style=\"background-color: rgb(255, 0, 0)\" class=\"Apple-style-span\">`[foobarbaz]´</span></body>",
          "innerHTML": "<span class=\"Apple-style-span\" style=\"background-color: rgb(255, 0, 0)\">`[foobarbaz]´</span>",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" bgcolor=\"#aaccee\" contenteditable=\"true\"><span style=\"background-color: rgb(255, 0, 0)\" class=\"Apple-style-span\">`[foobarbaz]´</span></body>",
          "bodyInnerHTML": "<span class=\"Apple-style-span\" style=\"background-color: rgb(255, 0, 0)\">`[foobarbaz]´</span>",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" bgcolor=\"#aaccee\" contenteditable=\"true\"><span style=\"background-color: rgb(255, 0, 0)\" class=\"Apple-style-span\">`[foobarbaz]´</span></body>"
        },
        "div": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "<span class=\"Apple-style-span\" style=\"background-color: rgb(255, 0, 0)\">`[foobarbaz]´</span>",
          "innerHTML": "<span class=\"Apple-style-span\" style=\"background-color: rgb(255, 0, 0)\">`[foobarbaz]´</span>",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\"><span style=\"background-color: rgb(255, 0, 0)\" class=\"Apple-style-span\">`[foobarbaz]´</span></div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\"><span class=\"Apple-style-span\" style=\"background-color: rgb(255, 0, 0)\">`[foobarbaz]´</span></div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" bgcolor=\"#aaccee\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\"><span style=\"background-color: rgb(255, 0, 0)\" class=\"Apple-style-span\">`[foobarbaz]´</span></div>CAN<br>ARY</body>"
        }
      },
      "FC:g_FONTc:b-1_SW": {
        "dM": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "<font color=\"green\">`[foobarbaz]´</font>",
          "innerHTML": "<font color=\"green\">`[foobarbaz]´</font>",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\"><font color=\"green\">`[foobarbaz]´</font></body>",
          "bodyInnerHTML": "<font color=\"green\">`[foobarbaz]´</font>",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\"><font color=\"green\">`[foobarbaz]´</font></body>"
        },
        "body": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "<font color=\"green\">`[foobarbaz]´</font>",
          "innerHTML": "<font color=\"green\">`[foobarbaz]´</font>",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\"><font color=\"green\">`[foobarbaz]´</font></body>",
          "bodyInnerHTML": "<font color=\"green\">`[foobarbaz]´</font>",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\"><font color=\"green\">`[foobarbaz]´</font></body>"
        },
        "div": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "<font color=\"green\">`[foobarbaz]´</font>",
          "innerHTML": "<font color=\"green\">`[foobarbaz]´</font>",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\"><font color=\"green\">`[foobarbaz]´</font></div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\"><font color=\"green\">`[foobarbaz]´</font></div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\"><font color=\"green\">`[foobarbaz]´</font></div>CAN<br>ARY</body>"
        }
      },
      "FC:g_SPANs:c:g-1_SW": {
        "dM": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "<font color=\"green\"><span style=\"color: blue\">`[foobarbaz]´</span></font>",
          "innerHTML": "<font color=\"green\"><span style=\"color: blue\">`[foobarbaz]´</span></font>",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\"><font color=\"green\"><span style=\"color: blue\">`[foobarbaz]´</span></font></body>",
          "bodyInnerHTML": "<font color=\"green\"><span style=\"color: blue\">`[foobarbaz]´</span></font>",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\"><font color=\"green\"><span style=\"color: blue\">`[foobarbaz]´</span></font></body>"
        },
        "body": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "<font color=\"green\"><span style=\"color: blue\">`[foobarbaz]´</span></font>",
          "innerHTML": "<font color=\"green\"><span style=\"color: blue\">`[foobarbaz]´</span></font>",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\"><font color=\"green\"><span style=\"color: blue\">`[foobarbaz]´</span></font></body>",
          "bodyInnerHTML": "<font color=\"green\"><span style=\"color: blue\">`[foobarbaz]´</span></font>",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\"><font color=\"green\"><span style=\"color: blue\">`[foobarbaz]´</span></font></body>"
        },
        "div": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "<font color=\"green\"><span style=\"color: blue\">`[foobarbaz]´</span></font>",
          "innerHTML": "<font color=\"green\"><span style=\"color: blue\">`[foobarbaz]´</span></font>",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\"><font color=\"green\"><span style=\"color: blue\">`[foobarbaz]´</span></font></div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\"><font color=\"green\"><span style=\"color: blue\">`[foobarbaz]´</span></font></div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\"><font color=\"green\"><span style=\"color: blue\">`[foobarbaz]´</span></font></div>CAN<br>ARY</body>"
        }
      },
      "FC:g_FONTc:b.s:c:r-1_SW": {
        "dM": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "<font style=\"color: red\" color=\"green\">`[foobarbaz]´</font>",
          "innerHTML": "<font style=\"color: red\" color=\"green\">`[foobarbaz]´</font>",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\"><font color=\"green\" style=\"color: red\">`[foobarbaz]´</font></body>",
          "bodyInnerHTML": "<font style=\"color: red\" color=\"green\">`[foobarbaz]´</font>",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\"><font color=\"green\" style=\"color: red\">`[foobarbaz]´</font></body>"
        },
        "body": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "<font style=\"color: red\" color=\"green\">`[foobarbaz]´</font>",
          "innerHTML": "<font style=\"color: red\" color=\"green\">`[foobarbaz]´</font>",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\"><font color=\"green\" style=\"color: red\">`[foobarbaz]´</font></body>",
          "bodyInnerHTML": "<font style=\"color: red\" color=\"green\">`[foobarbaz]´</font>",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\"><font color=\"green\" style=\"color: red\">`[foobarbaz]´</font></body>"
        },
        "div": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "<font style=\"color: red\" color=\"green\">`[foobarbaz]´</font>",
          "innerHTML": "<font style=\"color: red\" color=\"green\">`[foobarbaz]´</font>",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\"><font color=\"green\" style=\"color: red\">`[foobarbaz]´</font></div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\"><font style=\"color: red\" color=\"green\">`[foobarbaz]´</font></div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\"><font color=\"green\" style=\"color: red\">`[foobarbaz]´</font></div>CAN<br>ARY</body>"
        }
      },
      "FC:g_FONTc:b.sz:6-1_SI": {
        "dM": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 2,
          "output": "<font color=\"blue\" size=\"6\">`foo[´<font color=\"green\">`bar]´</font>`baz´</font>",
          "innerHTML": "<font color=\"blue\" size=\"6\">`foo[´<font color=\"green\">`bar]´</font>`baz´</font>",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\"><font size=\"6\" color=\"blue\">`foo[´<font color=\"green\">`bar]´</font>`baz´</font></body>",
          "bodyInnerHTML": "<font color=\"blue\" size=\"6\">`foo[´<font color=\"green\">`bar]´</font>`baz´</font>",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\"><font size=\"6\" color=\"blue\">`foo[´<font color=\"green\">`bar]´</font>`baz´</font></body>"
        },
        "body": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 2,
          "output": "<font color=\"blue\" size=\"6\">`foo[´<font color=\"green\">`bar]´</font>`baz´</font>",
          "innerHTML": "<font color=\"blue\" size=\"6\">`foo[´<font color=\"green\">`bar]´</font>`baz´</font>",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\"><font size=\"6\" color=\"blue\">`foo[´<font color=\"green\">`bar]´</font>`baz´</font></body>",
          "bodyInnerHTML": "<font color=\"blue\" size=\"6\">`foo[´<font color=\"green\">`bar]´</font>`baz´</font>",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\"><font size=\"6\" color=\"blue\">`foo[´<font color=\"green\">`bar]´</font>`baz´</font></body>"
        },
        "div": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 2,
          "output": "<font color=\"blue\" size=\"6\">`foo[´<font color=\"green\">`bar]´</font>`baz´</font>",
          "innerHTML": "<font color=\"blue\" size=\"6\">`foo[´<font color=\"green\">`bar]´</font>`baz´</font>",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\"><font size=\"6\" color=\"blue\">`foo[´<font color=\"green\">`bar]´</font>`baz´</font></div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\"><font color=\"blue\" size=\"6\">`foo[´<font color=\"green\">`bar]´</font>`baz´</font></div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\"><font size=\"6\" color=\"blue\">`foo[´<font color=\"green\">`bar]´</font>`baz´</font></div>CAN<br>ARY</body>"
        }
      },
      "HC:g_FONTs:c:b-1_SW": {
        "dM": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "<font style=\"background-color: blue\">`[foobarbaz]´</font>",
          "innerHTML": "<font style=\"background-color: blue\">`[foobarbaz]´</font>",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\"><font style=\"background-color: blue\">`[foobarbaz]´</font></body>",
          "bodyInnerHTML": "<font style=\"background-color: blue\">`[foobarbaz]´</font>",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\"><font style=\"background-color: blue\">`[foobarbaz]´</font></body>"
        },
        "body": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "<font style=\"background-color: blue\">`[foobarbaz]´</font>",
          "innerHTML": "<font style=\"background-color: blue\">`[foobarbaz]´</font>",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\"><font style=\"background-color: blue\">`[foobarbaz]´</font></body>",
          "bodyInnerHTML": "<font style=\"background-color: blue\">`[foobarbaz]´</font>",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\"><font style=\"background-color: blue\">`[foobarbaz]´</font></body>"
        },
        "div": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "<font style=\"background-color: blue\">`[foobarbaz]´</font>",
          "innerHTML": "<font style=\"background-color: blue\">`[foobarbaz]´</font>",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\"><font style=\"background-color: blue\">`[foobarbaz]´</font></div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\"><font style=\"background-color: blue\">`[foobarbaz]´</font></div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\"><font style=\"background-color: blue\">`[foobarbaz]´</font></div>CAN<br>ARY</body>"
        }
      },
      "HC:g_SPANs:c:g-1_SW": {
        "dM": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "<span style=\"background-color: blue\">`[foobarbaz]´</span>",
          "innerHTML": "<span style=\"background-color: blue\">`[foobarbaz]´</span>",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\"><span style=\"background-color: blue\">`[foobarbaz]´</span></body>",
          "bodyInnerHTML": "<span style=\"background-color: blue\">`[foobarbaz]´</span>",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\"><span style=\"background-color: blue\">`[foobarbaz]´</span></body>"
        },
        "body": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "<span style=\"background-color: blue\">`[foobarbaz]´</span>",
          "innerHTML": "<span style=\"background-color: blue\">`[foobarbaz]´</span>",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\"><span style=\"background-color: blue\">`[foobarbaz]´</span></body>",
          "bodyInnerHTML": "<span style=\"background-color: blue\">`[foobarbaz]´</span>",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\"><span style=\"background-color: blue\">`[foobarbaz]´</span></body>"
        },
        "div": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "<span style=\"background-color: blue\">`[foobarbaz]´</span>",
          "innerHTML": "<span style=\"background-color: blue\">`[foobarbaz]´</span>",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\"><span style=\"background-color: blue\">`[foobarbaz]´</span></div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\"><span style=\"background-color: blue\">`[foobarbaz]´</span></div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\"><span style=\"background-color: blue\">`[foobarbaz]´</span></div>CAN<br>ARY</body>"
        }
      },
      "HC:g_SPAN.ass.s:c:rgb-1_SW": {
        "dM": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "<span class=\"Apple-style-span\" style=\"background-color: rgb(255, 0, 0);\">`[foobarbaz]´</span>",
          "innerHTML": "<span class=\"Apple-style-span\" style=\"background-color: rgb(255, 0, 0);\">`[foobarbaz]´</span>",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\"><span style=\"background-color: rgb(255, 0, 0);\" class=\"Apple-style-span\">`[foobarbaz]´</span></body>",
          "bodyInnerHTML": "<span class=\"Apple-style-span\" style=\"background-color: rgb(255, 0, 0);\">`[foobarbaz]´</span>",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\"><span style=\"background-color: rgb(255, 0, 0);\" class=\"Apple-style-span\">`[foobarbaz]´</span></body>"
        },
        "body": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "<span class=\"Apple-style-span\" style=\"background-color: rgb(255, 0, 0);\">`[foobarbaz]´</span>",
          "innerHTML": "<span class=\"Apple-style-span\" style=\"background-color: rgb(255, 0, 0);\">`[foobarbaz]´</span>",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\"><span style=\"background-color: rgb(255, 0, 0);\" class=\"Apple-style-span\">`[foobarbaz]´</span></body>",
          "bodyInnerHTML": "<span class=\"Apple-style-span\" style=\"background-color: rgb(255, 0, 0);\">`[foobarbaz]´</span>",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\"><span style=\"background-color: rgb(255, 0, 0);\" class=\"Apple-style-span\">`[foobarbaz]´</span></body>"
        },
        "div": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "<span class=\"Apple-style-span\" style=\"background-color: rgb(255, 0, 0);\">`[foobarbaz]´</span>",
          "innerHTML": "<span class=\"Apple-style-span\" style=\"background-color: rgb(255, 0, 0);\">`[foobarbaz]´</span>",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\"><span style=\"background-color: rgb(255, 0, 0);\" class=\"Apple-style-span\">`[foobarbaz]´</span></div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\"><span class=\"Apple-style-span\" style=\"background-color: rgb(255, 0, 0);\">`[foobarbaz]´</span></div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\"><span style=\"background-color: rgb(255, 0, 0);\" class=\"Apple-style-span\">`[foobarbaz]´</span></div>CAN<br>ARY</body>"
        }
      },
      "FN:c_FONTf:a-1_SW": {
        "dM": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "<font face=\"courier\">`[foobarbaz]´</font>",
          "innerHTML": "<font face=\"courier\">`[foobarbaz]´</font>",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\"><font face=\"courier\">`[foobarbaz]´</font></body>",
          "bodyInnerHTML": "<font face=\"courier\">`[foobarbaz]´</font>",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\"><font face=\"courier\">`[foobarbaz]´</font></body>"
        },
        "body": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "<font face=\"courier\">`[foobarbaz]´</font>",
          "innerHTML": "<font face=\"courier\">`[foobarbaz]´</font>",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\"><font face=\"courier\">`[foobarbaz]´</font></body>",
          "bodyInnerHTML": "<font face=\"courier\">`[foobarbaz]´</font>",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\"><font face=\"courier\">`[foobarbaz]´</font></body>"
        },
        "div": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "<font face=\"courier\">`[foobarbaz]´</font>",
          "innerHTML": "<font face=\"courier\">`[foobarbaz]´</font>",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\"><font face=\"courier\">`[foobarbaz]´</font></div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\"><font face=\"courier\">`[foobarbaz]´</font></div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\"><font face=\"courier\">`[foobarbaz]´</font></div>CAN<br>ARY</body>"
        }
      },
      "FN:c_SPANs:ff:a-1_SW": {
        "dM": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "<font face=\"courier\"><span style=\"font-family: arial\">`[foobarbaz]´</span></font>",
          "innerHTML": "<font face=\"courier\"><span style=\"font-family: arial\">`[foobarbaz]´</span></font>",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\"><font face=\"courier\"><span style=\"font-family: arial\">`[foobarbaz]´</span></font></body>",
          "bodyInnerHTML": "<font face=\"courier\"><span style=\"font-family: arial\">`[foobarbaz]´</span></font>",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\"><font face=\"courier\"><span style=\"font-family: arial\">`[foobarbaz]´</span></font></body>"
        },
        "body": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "<font face=\"courier\"><span style=\"font-family: arial\">`[foobarbaz]´</span></font>",
          "innerHTML": "<font face=\"courier\"><span style=\"font-family: arial\">`[foobarbaz]´</span></font>",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\"><font face=\"courier\"><span style=\"font-family: arial\">`[foobarbaz]´</span></font></body>",
          "bodyInnerHTML": "<font face=\"courier\"><span style=\"font-family: arial\">`[foobarbaz]´</span></font>",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\"><font face=\"courier\"><span style=\"font-family: arial\">`[foobarbaz]´</span></font></body>"
        },
        "div": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "<font face=\"courier\"><span style=\"font-family: arial\">`[foobarbaz]´</span></font>",
          "innerHTML": "<font face=\"courier\"><span style=\"font-family: arial\">`[foobarbaz]´</span></font>",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\"><font face=\"courier\"><span style=\"font-family: arial\">`[foobarbaz]´</span></font></div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\"><font face=\"courier\"><span style=\"font-family: arial\">`[foobarbaz]´</span></font></div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\"><font face=\"courier\"><span style=\"font-family: arial\">`[foobarbaz]´</span></font></div>CAN<br>ARY</body>"
        }
      },
      "FN:c_FONTf:a.s:ff:v-1_SW": {
        "dM": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "<font style=\"font-family: verdana\" face=\"courier\">`[foobarbaz]´</font>",
          "innerHTML": "<font style=\"font-family: verdana\" face=\"courier\">`[foobarbaz]´</font>",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\"><font face=\"courier\" style=\"font-family: verdana\">`[foobarbaz]´</font></body>",
          "bodyInnerHTML": "<font style=\"font-family: verdana\" face=\"courier\">`[foobarbaz]´</font>",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\"><font face=\"courier\" style=\"font-family: verdana\">`[foobarbaz]´</font></body>"
        },
        "body": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "<font style=\"font-family: verdana\" face=\"courier\">`[foobarbaz]´</font>",
          "innerHTML": "<font style=\"font-family: verdana\" face=\"courier\">`[foobarbaz]´</font>",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\"><font face=\"courier\" style=\"font-family: verdana\">`[foobarbaz]´</font></body>",
          "bodyInnerHTML": "<font style=\"font-family: verdana\" face=\"courier\">`[foobarbaz]´</font>",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\"><font face=\"courier\" style=\"font-family: verdana\">`[foobarbaz]´</font></body>"
        },
        "div": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "<font style=\"font-family: verdana\" face=\"courier\">`[foobarbaz]´</font>",
          "innerHTML": "<font style=\"font-family: verdana\" face=\"courier\">`[foobarbaz]´</font>",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\"><font face=\"courier\" style=\"font-family: verdana\">`[foobarbaz]´</font></div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\"><font style=\"font-family: verdana\" face=\"courier\">`[foobarbaz]´</font></div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\"><font face=\"courier\" style=\"font-family: verdana\">`[foobarbaz]´</font></div>CAN<br>ARY</body>"
        }
      },
      "FN:c_FONTf:a-1_SI": {
        "dM": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 7,
          "selresult": 2,
          "output": "<font face=\"arial\">`foo[´<font face=\"courier\">`bar]´</font>`baz´</font>",
          "innerHTML": "<font face=\"arial\">`foo[´<font face=\"courier\">`bar]´</font>`baz´</font>",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\"><font face=\"arial\">`foo[´<font face=\"courier\">`bar]´</font>`baz´</font></body>",
          "bodyInnerHTML": "<font face=\"arial\">`foo[´<font face=\"courier\">`bar]´</font>`baz´</font>",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\"><font face=\"arial\">`foo[´<font face=\"courier\">`bar]´</font>`baz´</font></body>"
        },
        "body": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 7,
          "selresult": 2,
          "output": "<font face=\"arial\">`foo[´<font face=\"courier\">`bar]´</font>`baz´</font>",
          "innerHTML": "<font face=\"arial\">`foo[´<font face=\"courier\">`bar]´</font>`baz´</font>",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\"><font face=\"arial\">`foo[´<font face=\"courier\">`bar]´</font>`baz´</font></body>",
          "bodyInnerHTML": "<font face=\"arial\">`foo[´<font face=\"courier\">`bar]´</font>`baz´</font>",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\"><font face=\"arial\">`foo[´<font face=\"courier\">`bar]´</font>`baz´</font></body>"
        },
        "div": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 7,
          "selresult": 2,
          "output": "<font face=\"arial\">`foo[´<font face=\"courier\">`bar]´</font>`baz´</font>",
          "innerHTML": "<font face=\"arial\">`foo[´<font face=\"courier\">`bar]´</font>`baz´</font>",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\"><font face=\"arial\">`foo[´<font face=\"courier\">`bar]´</font>`baz´</font></div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\"><font face=\"arial\">`foo[´<font face=\"courier\">`bar]´</font>`baz´</font></div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\"><font face=\"arial\">`foo[´<font face=\"courier\">`bar]´</font>`baz´</font></div>CAN<br>ARY</body>"
        }
      },
      "FN:c_FONTf:a-2_SL": {
        "dM": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`foo[´<font face=\"courier\">`bar´</font><font face=\"arial\"><font face=\"courier\">`baz]´</font>`qoz´</font>",
          "innerHTML": "`foo[´<font face=\"courier\">`bar´</font><font face=\"arial\"><font face=\"courier\">`baz]´</font>`qoz´</font>",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo[´<font face=\"courier\">`bar´</font><font face=\"arial\"><font face=\"courier\">`baz]´</font>`qoz´</font></body>",
          "bodyInnerHTML": "`foo[´<font face=\"courier\">`bar´</font><font face=\"arial\"><font face=\"courier\">`baz]´</font>`qoz´</font>",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo[´<font face=\"courier\">`bar´</font><font face=\"arial\"><font face=\"courier\">`baz]´</font>`qoz´</font></body>"
        },
        "body": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`foo[´<font face=\"courier\">`bar´</font><font face=\"arial\"><font face=\"courier\">`baz]´</font>`qoz´</font>",
          "innerHTML": "`foo[´<font face=\"courier\">`bar´</font><font face=\"arial\"><font face=\"courier\">`baz]´</font>`qoz´</font>",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo[´<font face=\"courier\">`bar´</font><font face=\"arial\"><font face=\"courier\">`baz]´</font>`qoz´</font></body>",
          "bodyInnerHTML": "`foo[´<font face=\"courier\">`bar´</font><font face=\"arial\"><font face=\"courier\">`baz]´</font>`qoz´</font>",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo[´<font face=\"courier\">`bar´</font><font face=\"arial\"><font face=\"courier\">`baz]´</font>`qoz´</font></body>"
        },
        "div": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`foo[´<font face=\"courier\">`bar´</font><font face=\"arial\"><font face=\"courier\">`baz]´</font>`qoz´</font>",
          "innerHTML": "`foo[´<font face=\"courier\">`bar´</font><font face=\"arial\"><font face=\"courier\">`baz]´</font>`qoz´</font>",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\">`foo[´<font face=\"courier\">`bar´</font><font face=\"arial\"><font face=\"courier\">`baz]´</font>`qoz´</font></div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\">`foo[´<font face=\"courier\">`bar´</font><font face=\"arial\"><font face=\"courier\">`baz]´</font>`qoz´</font></div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\">`foo[´<font face=\"courier\">`bar´</font><font face=\"arial\"><font face=\"courier\">`baz]´</font>`qoz´</font></div>CAN<br>ARY</body>"
        }
      },
      "FN:c_FONTf:v-FONTf:a-1_SW": {
        "dM": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "<font face=\"courier\">`[foobarbaz]´</font>",
          "innerHTML": "<font face=\"courier\">`[foobarbaz]´</font>",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\"><font face=\"courier\">`[foobarbaz]´</font></body>",
          "bodyInnerHTML": "<font face=\"courier\">`[foobarbaz]´</font>",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\"><font face=\"courier\">`[foobarbaz]´</font></body>"
        },
        "body": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "<font face=\"courier\">`[foobarbaz]´</font>",
          "innerHTML": "<font face=\"courier\">`[foobarbaz]´</font>",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\"><font face=\"courier\">`[foobarbaz]´</font></body>",
          "bodyInnerHTML": "<font face=\"courier\">`[foobarbaz]´</font>",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\"><font face=\"courier\">`[foobarbaz]´</font></body>"
        },
        "div": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "<font face=\"courier\">`[foobarbaz]´</font>",
          "innerHTML": "<font face=\"courier\">`[foobarbaz]´</font>",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\"><font face=\"courier\">`[foobarbaz]´</font></div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\"><font face=\"courier\">`[foobarbaz]´</font></div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\"><font face=\"courier\">`[foobarbaz]´</font></div>CAN<br>ARY</body>"
        }
      },
      "FN:c_SPANs:ff:v-FONTf:a-1_SW": {
        "dM": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "<font face=\"courier\"><span style=\"font-family: verdana\">`[foobarbaz]´</span></font>",
          "innerHTML": "<font face=\"courier\"><span style=\"font-family: verdana\">`[foobarbaz]´</span></font>",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\"><font face=\"courier\"><span style=\"font-family: verdana\">`[foobarbaz]´</span></font></body>",
          "bodyInnerHTML": "<font face=\"courier\"><span style=\"font-family: verdana\">`[foobarbaz]´</span></font>",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\"><font face=\"courier\"><span style=\"font-family: verdana\">`[foobarbaz]´</span></font></body>"
        },
        "body": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "<font face=\"courier\"><span style=\"font-family: verdana\">`[foobarbaz]´</span></font>",
          "innerHTML": "<font face=\"courier\"><span style=\"font-family: verdana\">`[foobarbaz]´</span></font>",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\"><font face=\"courier\"><span style=\"font-family: verdana\">`[foobarbaz]´</span></font></body>",
          "bodyInnerHTML": "<font face=\"courier\"><span style=\"font-family: verdana\">`[foobarbaz]´</span></font>",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\"><font face=\"courier\"><span style=\"font-family: verdana\">`[foobarbaz]´</span></font></body>"
        },
        "div": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "<font face=\"courier\"><span style=\"font-family: verdana\">`[foobarbaz]´</span></font>",
          "innerHTML": "<font face=\"courier\"><span style=\"font-family: verdana\">`[foobarbaz]´</span></font>",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\"><font face=\"courier\"><span style=\"font-family: verdana\">`[foobarbaz]´</span></font></div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\"><font face=\"courier\"><span style=\"font-family: verdana\">`[foobarbaz]´</span></font></div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\"><font face=\"courier\"><span style=\"font-family: verdana\">`[foobarbaz]´</span></font></div>CAN<br>ARY</body>"
        }
      },
      "FS:1_FONTsz:4-1_SW": {
        "dM": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "<font size=\"1\">`[foobarbaz]´</font>",
          "innerHTML": "<font size=\"1\">`[foobarbaz]´</font>",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\"><font size=\"1\">`[foobarbaz]´</font></body>",
          "bodyInnerHTML": "<font size=\"1\">`[foobarbaz]´</font>",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\"><font size=\"1\">`[foobarbaz]´</font></body>"
        },
        "body": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "<font size=\"1\">`[foobarbaz]´</font>",
          "innerHTML": "<font size=\"1\">`[foobarbaz]´</font>",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\"><font size=\"1\">`[foobarbaz]´</font></body>",
          "bodyInnerHTML": "<font size=\"1\">`[foobarbaz]´</font>",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\"><font size=\"1\">`[foobarbaz]´</font></body>"
        },
        "div": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "<font size=\"1\">`[foobarbaz]´</font>",
          "innerHTML": "<font size=\"1\">`[foobarbaz]´</font>",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\"><font size=\"1\">`[foobarbaz]´</font></div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\"><font size=\"1\">`[foobarbaz]´</font></div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\"><font size=\"1\">`[foobarbaz]´</font></div>CAN<br>ARY</body>"
        }
      },
      "FS:1_SPAN.ass.s:fs:large-1_SW": {
        "dM": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "<font size=\"1\"><span class=\"Apple-style-span\" style=\"font-size: large\">`[foobarbaz]´</span></font>",
          "innerHTML": "<font size=\"1\"><span class=\"Apple-style-span\" style=\"font-size: large\">`[foobarbaz]´</span></font>",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\"><font size=\"1\"><span style=\"font-size: large\" class=\"Apple-style-span\">`[foobarbaz]´</span></font></body>",
          "bodyInnerHTML": "<font size=\"1\"><span class=\"Apple-style-span\" style=\"font-size: large\">`[foobarbaz]´</span></font>",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\"><font size=\"1\"><span style=\"font-size: large\" class=\"Apple-style-span\">`[foobarbaz]´</span></font></body>"
        },
        "body": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "<font size=\"1\"><span class=\"Apple-style-span\" style=\"font-size: large\">`[foobarbaz]´</span></font>",
          "innerHTML": "<font size=\"1\"><span class=\"Apple-style-span\" style=\"font-size: large\">`[foobarbaz]´</span></font>",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\"><font size=\"1\"><span style=\"font-size: large\" class=\"Apple-style-span\">`[foobarbaz]´</span></font></body>",
          "bodyInnerHTML": "<font size=\"1\"><span class=\"Apple-style-span\" style=\"font-size: large\">`[foobarbaz]´</span></font>",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\"><font size=\"1\"><span style=\"font-size: large\" class=\"Apple-style-span\">`[foobarbaz]´</span></font></body>"
        },
        "div": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "<font size=\"1\"><span class=\"Apple-style-span\" style=\"font-size: large\">`[foobarbaz]´</span></font>",
          "innerHTML": "<font size=\"1\"><span class=\"Apple-style-span\" style=\"font-size: large\">`[foobarbaz]´</span></font>",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\"><font size=\"1\"><span style=\"font-size: large\" class=\"Apple-style-span\">`[foobarbaz]´</span></font></div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\"><font size=\"1\"><span class=\"Apple-style-span\" style=\"font-size: large\">`[foobarbaz]´</span></font></div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\"><font size=\"1\"><span style=\"font-size: large\" class=\"Apple-style-span\">`[foobarbaz]´</span></font></div>CAN<br>ARY</body>"
        }
      },
      "FS:5_FONTsz:1.s:fs:xs-1_SW": {
        "dM": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "<font style=\"font-size:x-small\" size=\"5\">`[foobarbaz]´</font>",
          "innerHTML": "<font style=\"font-size:x-small\" size=\"5\">`[foobarbaz]´</font>",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\"><font size=\"5\" style=\"font-size:x-small\">`[foobarbaz]´</font></body>",
          "bodyInnerHTML": "<font style=\"font-size:x-small\" size=\"5\">`[foobarbaz]´</font>",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\"><font size=\"5\" style=\"font-size:x-small\">`[foobarbaz]´</font></body>"
        },
        "body": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "<font style=\"font-size:x-small\" size=\"5\">`[foobarbaz]´</font>",
          "innerHTML": "<font style=\"font-size:x-small\" size=\"5\">`[foobarbaz]´</font>",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\"><font size=\"5\" style=\"font-size:x-small\">`[foobarbaz]´</font></body>",
          "bodyInnerHTML": "<font style=\"font-size:x-small\" size=\"5\">`[foobarbaz]´</font>",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\"><font size=\"5\" style=\"font-size:x-small\">`[foobarbaz]´</font></body>"
        },
        "div": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "<font style=\"font-size:x-small\" size=\"5\">`[foobarbaz]´</font>",
          "innerHTML": "<font style=\"font-size:x-small\" size=\"5\">`[foobarbaz]´</font>",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\"><font size=\"5\" style=\"font-size:x-small\">`[foobarbaz]´</font></div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\"><font style=\"font-size:x-small\" size=\"5\">`[foobarbaz]´</font></div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\"><font size=\"5\" style=\"font-size:x-small\">`[foobarbaz]´</font></div>CAN<br>ARY</body>"
        }
      },
      "FS:2_FONTc:b.sz:6-1_SI": {
        "dM": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 2,
          "output": "<font color=\"blue\" size=\"6\">`foo[´<font size=\"2\">`bar]´</font>`baz´</font>",
          "innerHTML": "<font color=\"blue\" size=\"6\">`foo[´<font size=\"2\">`bar]´</font>`baz´</font>",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\"><font size=\"6\" color=\"blue\">`foo[´<font size=\"2\">`bar]´</font>`baz´</font></body>",
          "bodyInnerHTML": "<font color=\"blue\" size=\"6\">`foo[´<font size=\"2\">`bar]´</font>`baz´</font>",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\"><font size=\"6\" color=\"blue\">`foo[´<font size=\"2\">`bar]´</font>`baz´</font></body>"
        },
        "body": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 2,
          "output": "<font color=\"blue\" size=\"6\">`foo[´<font size=\"2\">`bar]´</font>`baz´</font>",
          "innerHTML": "<font color=\"blue\" size=\"6\">`foo[´<font size=\"2\">`bar]´</font>`baz´</font>",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\"><font size=\"6\" color=\"blue\">`foo[´<font size=\"2\">`bar]´</font>`baz´</font></body>",
          "bodyInnerHTML": "<font color=\"blue\" size=\"6\">`foo[´<font size=\"2\">`bar]´</font>`baz´</font>",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\"><font size=\"6\" color=\"blue\">`foo[´<font size=\"2\">`bar]´</font>`baz´</font></body>"
        },
        "div": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 2,
          "output": "<font color=\"blue\" size=\"6\">`foo[´<font size=\"2\">`bar]´</font>`baz´</font>",
          "innerHTML": "<font color=\"blue\" size=\"6\">`foo[´<font size=\"2\">`bar]´</font>`baz´</font>",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\"><font size=\"6\" color=\"blue\">`foo[´<font size=\"2\">`bar]´</font>`baz´</font></div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\"><font color=\"blue\" size=\"6\">`foo[´<font size=\"2\">`bar]´</font>`baz´</font></div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\"><font size=\"6\" color=\"blue\">`foo[´<font size=\"2\">`bar]´</font>`baz´</font></div>CAN<br>ARY</body>"
        }
      },
      "FS:larger_FONTsz:4": {
        "dM": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 2,
          "output": "<font size=\"4\">`foo[´<font size=\"larger\">`bar]´</font>`baz´</font>",
          "innerHTML": "<font size=\"4\">`foo[´<font size=\"larger\">`bar]´</font>`baz´</font>",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\"><font size=\"4\">`foo[´<font size=\"larger\">`bar]´</font>`baz´</font></body>",
          "bodyInnerHTML": "<font size=\"4\">`foo[´<font size=\"larger\">`bar]´</font>`baz´</font>",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\"><font size=\"4\">`foo[´<font size=\"larger\">`bar]´</font>`baz´</font></body>"
        },
        "body": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 2,
          "output": "<font size=\"4\">`foo[´<font size=\"larger\">`bar]´</font>`baz´</font>",
          "innerHTML": "<font size=\"4\">`foo[´<font size=\"larger\">`bar]´</font>`baz´</font>",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\"><font size=\"4\">`foo[´<font size=\"larger\">`bar]´</font>`baz´</font></body>",
          "bodyInnerHTML": "<font size=\"4\">`foo[´<font size=\"larger\">`bar]´</font>`baz´</font>",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\"><font size=\"4\">`foo[´<font size=\"larger\">`bar]´</font>`baz´</font></body>"
        },
        "div": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 2,
          "output": "<font size=\"4\">`foo[´<font size=\"larger\">`bar]´</font>`baz´</font>",
          "innerHTML": "<font size=\"4\">`foo[´<font size=\"larger\">`bar]´</font>`baz´</font>",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\"><font size=\"4\">`foo[´<font size=\"larger\">`bar]´</font>`baz´</font></div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\"><font size=\"4\">`foo[´<font size=\"larger\">`bar]´</font>`baz´</font></div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\"><font size=\"4\">`foo[´<font size=\"larger\">`bar]´</font>`baz´</font></div>CAN<br>ARY</body>"
        }
      },
      "FS:smaller_FONTsz:4": {
        "dM": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 2,
          "output": "<font size=\"4\">`foo[´<font size=\"smaller\">`bar]´</font>`baz´</font>",
          "innerHTML": "<font size=\"4\">`foo[´<font size=\"smaller\">`bar]´</font>`baz´</font>",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\"><font size=\"4\">`foo[´<font size=\"smaller\">`bar]´</font>`baz´</font></body>",
          "bodyInnerHTML": "<font size=\"4\">`foo[´<font size=\"smaller\">`bar]´</font>`baz´</font>",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\"><font size=\"4\">`foo[´<font size=\"smaller\">`bar]´</font>`baz´</font></body>"
        },
        "body": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 2,
          "output": "<font size=\"4\">`foo[´<font size=\"smaller\">`bar]´</font>`baz´</font>",
          "innerHTML": "<font size=\"4\">`foo[´<font size=\"smaller\">`bar]´</font>`baz´</font>",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\"><font size=\"4\">`foo[´<font size=\"smaller\">`bar]´</font>`baz´</font></body>",
          "bodyInnerHTML": "<font size=\"4\">`foo[´<font size=\"smaller\">`bar]´</font>`baz´</font>",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\"><font size=\"4\">`foo[´<font size=\"smaller\">`bar]´</font>`baz´</font></body>"
        },
        "div": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 2,
          "output": "<font size=\"4\">`foo[´<font size=\"smaller\">`bar]´</font>`baz´</font>",
          "innerHTML": "<font size=\"4\">`foo[´<font size=\"smaller\">`bar]´</font>`baz´</font>",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\"><font size=\"4\">`foo[´<font size=\"smaller\">`bar]´</font>`baz´</font></div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\"><font size=\"4\">`foo[´<font size=\"smaller\">`bar]´</font>`baz´</font></div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\"><font size=\"4\">`foo[´<font size=\"smaller\">`bar]´</font>`baz´</font></div>CAN<br>ARY</body>"
        }
      },
      "FB:h1_ADDRESS-1_SW": {
        "dM": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "<h1>`foo [bar] baz´</h1>",
          "innerHTML": "<h1>`foo [bar] baz´</h1>",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\"><h1>`foo [bar] baz´</h1></body>",
          "bodyInnerHTML": "<h1>`foo [bar] baz´</h1>",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\"><h1>`foo [bar] baz´</h1></body>"
        },
        "body": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "<h1>`foo [bar] baz´</h1>",
          "innerHTML": "<h1>`foo [bar] baz´</h1>",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\"><h1>`foo [bar] baz´</h1></body>",
          "bodyInnerHTML": "<h1>`foo [bar] baz´</h1>",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\"><h1>`foo [bar] baz´</h1></body>"
        },
        "div": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "<h1>`foo [bar] baz´</h1>",
          "innerHTML": "<h1>`foo [bar] baz´</h1>",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\"><h1>`foo [bar] baz´</h1></div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\"><h1>`foo [bar] baz´</h1></div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\"><h1>`foo [bar] baz´</h1></div>CAN<br>ARY</body>"
        }
      },
      "FB:h1_ADDRESS-FONTsz:4-1_SO": {
        "dM": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "<h1>`foo [´<font size=\"4\">`bar´</font>`] baz´</h1>",
          "innerHTML": "<h1>`foo [´<font size=\"4\">`bar´</font>`] baz´</h1>",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\"><h1>`foo [´<font size=\"4\">`bar´</font>`] baz´</h1></body>",
          "bodyInnerHTML": "<h1>`foo [´<font size=\"4\">`bar´</font>`] baz´</h1>",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\"><h1>`foo [´<font size=\"4\">`bar´</font>`] baz´</h1></body>"
        },
        "body": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "<h1>`foo [´<font size=\"4\">`bar´</font>`] baz´</h1>",
          "innerHTML": "<h1>`foo [´<font size=\"4\">`bar´</font>`] baz´</h1>",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\"><h1>`foo [´<font size=\"4\">`bar´</font>`] baz´</h1></body>",
          "bodyInnerHTML": "<h1>`foo [´<font size=\"4\">`bar´</font>`] baz´</h1>",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\"><h1>`foo [´<font size=\"4\">`bar´</font>`] baz´</h1></body>"
        },
        "div": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "<h1>`foo [´<font size=\"4\">`bar´</font>`] baz´</h1>",
          "innerHTML": "<h1>`foo [´<font size=\"4\">`bar´</font>`] baz´</h1>",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\"><h1>`foo [´<font size=\"4\">`bar´</font>`] baz´</h1></div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\"><h1>`foo [´<font size=\"4\">`bar´</font>`] baz´</h1></div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\"><h1>`foo [´<font size=\"4\">`bar´</font>`] baz´</h1></div>CAN<br>ARY</body>"
        }
      },
      "FB:h1_ADDRESS-FONTsz:4-1_SW": {
        "dM": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "<h1>`foo ´<font size=\"4\">`[bar]´</font>` baz´</h1>",
          "innerHTML": "<h1>`foo ´<font size=\"4\">`[bar]´</font>` baz´</h1>",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\"><h1>`foo ´<font size=\"4\">`[bar]´</font>` baz´</h1></body>",
          "bodyInnerHTML": "<h1>`foo ´<font size=\"4\">`[bar]´</font>` baz´</h1>",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\"><h1>`foo ´<font size=\"4\">`[bar]´</font>` baz´</h1></body>"
        },
        "body": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "<h1>`foo ´<font size=\"4\">`[bar]´</font>` baz´</h1>",
          "innerHTML": "<h1>`foo ´<font size=\"4\">`[bar]´</font>` baz´</h1>",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\"><h1>`foo ´<font size=\"4\">`[bar]´</font>` baz´</h1></body>",
          "bodyInnerHTML": "<h1>`foo ´<font size=\"4\">`[bar]´</font>` baz´</h1>",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\"><h1>`foo ´<font size=\"4\">`[bar]´</font>` baz´</h1></body>"
        },
        "div": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "<h1>`foo ´<font size=\"4\">`[bar]´</font>` baz´</h1>",
          "innerHTML": "<h1>`foo ´<font size=\"4\">`[bar]´</font>` baz´</h1>",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\"><h1>`foo ´<font size=\"4\">`[bar]´</font>` baz´</h1></div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\"><h1>`foo ´<font size=\"4\">`[bar]´</font>` baz´</h1></div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\"><h1>`foo ´<font size=\"4\">`[bar]´</font>` baz´</h1></div>CAN<br>ARY</body>"
        }
      },
      "FB:h1_ADDRESS-FONT.ass.sz:4-1_SW": {
        "dM": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "<h1>`foo ´<font class=\"Apple-style-span\" size=\"4\">`[bar]´</font>` baz´</h1>",
          "innerHTML": "<h1>`foo ´<font class=\"Apple-style-span\" size=\"4\">`[bar]´</font>` baz´</h1>",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\"><h1>`foo ´<font size=\"4\" class=\"Apple-style-span\">`[bar]´</font>` baz´</h1></body>",
          "bodyInnerHTML": "<h1>`foo ´<font class=\"Apple-style-span\" size=\"4\">`[bar]´</font>` baz´</h1>",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\"><h1>`foo ´<font size=\"4\" class=\"Apple-style-span\">`[bar]´</font>` baz´</h1></body>"
        },
        "body": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "<h1>`foo ´<font class=\"Apple-style-span\" size=\"4\">`[bar]´</font>` baz´</h1>",
          "innerHTML": "<h1>`foo ´<font class=\"Apple-style-span\" size=\"4\">`[bar]´</font>` baz´</h1>",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\"><h1>`foo ´<font size=\"4\" class=\"Apple-style-span\">`[bar]´</font>` baz´</h1></body>",
          "bodyInnerHTML": "<h1>`foo ´<font class=\"Apple-style-span\" size=\"4\">`[bar]´</font>` baz´</h1>",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\"><h1>`foo ´<font size=\"4\" class=\"Apple-style-span\">`[bar]´</font>` baz´</h1></body>"
        },
        "div": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "<h1>`foo ´<font class=\"Apple-style-span\" size=\"4\">`[bar]´</font>` baz´</h1>",
          "innerHTML": "<h1>`foo ´<font class=\"Apple-style-span\" size=\"4\">`[bar]´</font>` baz´</h1>",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\"><h1>`foo ´<font size=\"4\" class=\"Apple-style-span\">`[bar]´</font>` baz´</h1></div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\"><h1>`foo ´<font class=\"Apple-style-span\" size=\"4\">`[bar]´</font>` baz´</h1></div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\"><h1>`foo ´<font size=\"4\" class=\"Apple-style-span\">`[bar]´</font>` baz´</h1></div>CAN<br>ARY</body>"
        }
      }
    }
  },
  "CC": {
    "Proposed": {
      "I_I-1_SL": {
        "dM": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`foo[´<i style=\"font-style: italic;\">`bar´`baz]´</i>`qoz´",
          "innerHTML": "`foo[´<i style=\"font-style: italic;\">`bar´`baz]´</i>`qoz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo[´<i style=\"font-style: italic;\">`bar´`baz]´</i>`qoz´</body>",
          "bodyInnerHTML": "`foo[´<i style=\"font-style: italic;\">`bar´`baz]´</i>`qoz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo[´<i style=\"font-style: italic;\">`bar´`baz]´</i>`qoz´</body>"
        },
        "body": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`foo[´<i style=\"font-style: italic;\">`bar´`baz]´</i>`qoz´",
          "innerHTML": "`foo[´<i style=\"font-style: italic;\">`bar´`baz]´</i>`qoz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo[´<i style=\"font-style: italic;\">`bar´`baz]´</i>`qoz´</body>",
          "bodyInnerHTML": "`foo[´<i style=\"font-style: italic;\">`bar´`baz]´</i>`qoz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo[´<i style=\"font-style: italic;\">`bar´`baz]´</i>`qoz´</body>"
        },
        "div": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`foo[´<i style=\"font-style: italic;\">`bar´`baz]´</i>`qoz´",
          "innerHTML": "`foo[´<i style=\"font-style: italic;\">`bar´`baz]´</i>`qoz´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\">`foo[´<i style=\"font-style: italic;\">`bar´`baz]´</i>`qoz´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\">`foo[´<i style=\"font-style: italic;\">`bar´`baz]´</i>`qoz´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\">`foo[´<i style=\"font-style: italic;\">`bar´`baz]´</i>`qoz´</div>CAN<br>ARY</body>"
        }
      },
      "I_B-1_SL": {
        "dM": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`foo[´<span style=\"font-style: italic;\">`bar´</span><b style=\"font-style: italic;\">`baz]´</b>`qoz´",
          "innerHTML": "`foo[´<span style=\"font-style: italic;\">`bar´</span><b style=\"font-style: italic;\">`baz]´</b>`qoz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo[´<span style=\"font-style: italic;\">`bar´</span><b style=\"font-style: italic;\">`baz]´</b>`qoz´</body>",
          "bodyInnerHTML": "`foo[´<span style=\"font-style: italic;\">`bar´</span><b style=\"font-style: italic;\">`baz]´</b>`qoz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo[´<span style=\"font-style: italic;\">`bar´</span><b style=\"font-style: italic;\">`baz]´</b>`qoz´</body>"
        },
        "body": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`foo[´<span style=\"font-style: italic;\">`bar´</span><b style=\"font-style: italic;\">`baz]´</b>`qoz´",
          "innerHTML": "`foo[´<span style=\"font-style: italic;\">`bar´</span><b style=\"font-style: italic;\">`baz]´</b>`qoz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo[´<span style=\"font-style: italic;\">`bar´</span><b style=\"font-style: italic;\">`baz]´</b>`qoz´</body>",
          "bodyInnerHTML": "`foo[´<span style=\"font-style: italic;\">`bar´</span><b style=\"font-style: italic;\">`baz]´</b>`qoz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo[´<span style=\"font-style: italic;\">`bar´</span><b style=\"font-style: italic;\">`baz]´</b>`qoz´</body>"
        },
        "div": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`foo[´<span style=\"font-style: italic;\">`bar´</span><b style=\"font-style: italic;\">`baz]´</b>`qoz´",
          "innerHTML": "`foo[´<span style=\"font-style: italic;\">`bar´</span><b style=\"font-style: italic;\">`baz]´</b>`qoz´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\">`foo[´<span style=\"font-style: italic;\">`bar´</span><b style=\"font-style: italic;\">`baz]´</b>`qoz´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\">`foo[´<span style=\"font-style: italic;\">`bar´</span><b style=\"font-style: italic;\">`baz]´</b>`qoz´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\">`foo[´<span style=\"font-style: italic;\">`bar´</span><b style=\"font-style: italic;\">`baz]´</b>`qoz´</div>CAN<br>ARY</body>"
        }
      },
      "I_B-1_SW": {
        "dM": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`foobar´<b style=\"font-style: italic;\">`[baz]´</b>`qoz´",
          "innerHTML": "`foobar´<b style=\"font-style: italic;\">`[baz]´</b>`qoz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foobar´<b style=\"font-style: italic;\">`[baz]´</b>`qoz´</body>",
          "bodyInnerHTML": "`foobar´<b style=\"font-style: italic;\">`[baz]´</b>`qoz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foobar´<b style=\"font-style: italic;\">`[baz]´</b>`qoz´</body>"
        },
        "body": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`foobar´<b style=\"font-style: italic;\">`[baz]´</b>`qoz´",
          "innerHTML": "`foobar´<b style=\"font-style: italic;\">`[baz]´</b>`qoz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foobar´<b style=\"font-style: italic;\">`[baz]´</b>`qoz´</body>",
          "bodyInnerHTML": "`foobar´<b style=\"font-style: italic;\">`[baz]´</b>`qoz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foobar´<b style=\"font-style: italic;\">`[baz]´</b>`qoz´</body>"
        },
        "div": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`foobar´<b style=\"font-style: italic;\">`[baz]´</b>`qoz´",
          "innerHTML": "`foobar´<b style=\"font-style: italic;\">`[baz]´</b>`qoz´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\">`foobar´<b style=\"font-style: italic;\">`[baz]´</b>`qoz´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\">`foobar´<b style=\"font-style: italic;\">`[baz]´</b>`qoz´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\">`foobar´<b style=\"font-style: italic;\">`[baz]´</b>`qoz´</div>CAN<br>ARY</body>"
        }
      },
      "BC:gray_SPANs:bc:b-1_SW": {
        "dM": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\" style=\"background-color: gray;\"><span style=\"background-color: blue\">`[foobarbaz]´</span></body>",
          "innerHTML": "<span style=\"background-color: blue\">`[foobarbaz]´</span>",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\" style=\"background-color: gray;\"><span style=\"background-color: blue\">`[foobarbaz]´</span></body>",
          "bodyInnerHTML": "<span style=\"background-color: blue\">`[foobarbaz]´</span>",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\" style=\"background-color: gray;\"><span style=\"background-color: blue\">`[foobarbaz]´</span></body>"
        },
        "body": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" style=\"background-color: gray;\"><span style=\"background-color: blue\">`[foobarbaz]´</span></body>",
          "innerHTML": "<span style=\"background-color: blue\">`[foobarbaz]´</span>",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" style=\"background-color: gray;\"><span style=\"background-color: blue\">`[foobarbaz]´</span></body>",
          "bodyInnerHTML": "<span style=\"background-color: blue\">`[foobarbaz]´</span>",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" style=\"background-color: gray;\"><span style=\"background-color: blue\">`[foobarbaz]´</span></body>"
        },
        "div": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\" style=\"background-color: gray;\"><span style=\"background-color: blue\">`[foobarbaz]´</span></div>",
          "innerHTML": "<span style=\"background-color: blue\">`[foobarbaz]´</span>",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\" style=\"background-color: gray;\"><span style=\"background-color: blue\">`[foobarbaz]´</span></div>",
          "bodyInnerHTML": "CAN<br>ARY<div style=\"background-color: gray;\" id=\"editor-div\" contenteditable=\"true\"><span style=\"background-color: blue\">`[foobarbaz]´</span></div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\" style=\"background-color: gray;\"><span style=\"background-color: blue\">`[foobarbaz]´</span></div>CAN<br>ARY</body>"
        }
      },
      "BC:gray_SPANs:bc:b-1_SO": {
        "dM": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\" style=\"background-color: gray;\">{<span style=\"background-color: blue\">`foobarbaz´</span>}</body>",
          "innerHTML": "{<span style=\"background-color: blue\">`foobarbaz´</span>}",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\" style=\"background-color: gray;\">{<span style=\"background-color: blue\">`foobarbaz´</span>}</body>",
          "bodyInnerHTML": "{<span style=\"background-color: blue\">`foobarbaz´</span>}",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\" style=\"background-color: gray;\">{<span style=\"background-color: blue\">`foobarbaz´</span>}</body>"
        },
        "body": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" style=\"background-color: gray;\">{<span style=\"background-color: blue\">`foobarbaz´</span>}</body>",
          "innerHTML": "{<span style=\"background-color: blue\">`foobarbaz´</span>}",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" style=\"background-color: gray;\">{<span style=\"background-color: blue\">`foobarbaz´</span>}</body>",
          "bodyInnerHTML": "{<span style=\"background-color: blue\">`foobarbaz´</span>}",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" style=\"background-color: gray;\">{<span style=\"background-color: blue\">`foobarbaz´</span>}</body>"
        },
        "div": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\" style=\"background-color: gray;\">{<span style=\"background-color: blue\">`foobarbaz´</span>}</div>",
          "innerHTML": "{<span style=\"background-color: blue\">`foobarbaz´</span>}",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\" style=\"background-color: gray;\">{<span style=\"background-color: blue\">`foobarbaz´</span>}</div>",
          "bodyInnerHTML": "CAN<br>ARY<div style=\"background-color: gray;\" id=\"editor-div\" contenteditable=\"true\">{<span style=\"background-color: blue\">`foobarbaz´</span>}</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\" style=\"background-color: gray;\">{<span style=\"background-color: blue\">`foobarbaz´</span>}</div>CAN<br>ARY</body>"
        }
      },
      "BC:gray_SPANs:bc:b-1_SI": {
        "dM": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\" style=\"background-color: gray;\"><span style=\"background-color: blue\">`foo[bar]baz´</span></body>",
          "innerHTML": "<span style=\"background-color: blue\">`foo[bar]baz´</span>",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\" style=\"background-color: gray;\"><span style=\"background-color: blue\">`foo[bar]baz´</span></body>",
          "bodyInnerHTML": "<span style=\"background-color: blue\">`foo[bar]baz´</span>",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\" style=\"background-color: gray;\"><span style=\"background-color: blue\">`foo[bar]baz´</span></body>"
        },
        "body": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" style=\"background-color: gray;\"><span style=\"background-color: blue\">`foo[bar]baz´</span></body>",
          "innerHTML": "<span style=\"background-color: blue\">`foo[bar]baz´</span>",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" style=\"background-color: gray;\"><span style=\"background-color: blue\">`foo[bar]baz´</span></body>",
          "bodyInnerHTML": "<span style=\"background-color: blue\">`foo[bar]baz´</span>",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" style=\"background-color: gray;\"><span style=\"background-color: blue\">`foo[bar]baz´</span></body>"
        },
        "div": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\" style=\"background-color: gray;\"><span style=\"background-color: blue\">`foo[bar]baz´</span></div>",
          "innerHTML": "<span style=\"background-color: blue\">`foo[bar]baz´</span>",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\" style=\"background-color: gray;\"><span style=\"background-color: blue\">`foo[bar]baz´</span></div>",
          "bodyInnerHTML": "CAN<br>ARY<div style=\"background-color: gray;\" id=\"editor-div\" contenteditable=\"true\"><span style=\"background-color: blue\">`foo[bar]baz´</span></div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\" style=\"background-color: gray;\"><span style=\"background-color: blue\">`foo[bar]baz´</span></div>CAN<br>ARY</body>"
        }
      },
      "BC:gray_P-SPANs:bc:b-1_SW": {
        "dM": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "<p style=\"background-color: gray;\"><span style=\"background-color: blue\">`[foobarbaz]´</span></p>",
          "innerHTML": "<p style=\"background-color: gray;\"><span style=\"background-color: blue\">`[foobarbaz]´</span></p>",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\"><p style=\"background-color: gray;\"><span style=\"background-color: blue\">`[foobarbaz]´</span></p></body>",
          "bodyInnerHTML": "<p style=\"background-color: gray;\"><span style=\"background-color: blue\">`[foobarbaz]´</span></p>",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\"><p style=\"background-color: gray;\"><span style=\"background-color: blue\">`[foobarbaz]´</span></p></body>"
        },
        "body": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "<p style=\"background-color: gray;\"><span style=\"background-color: blue\">`[foobarbaz]´</span></p>",
          "innerHTML": "<p style=\"background-color: gray;\"><span style=\"background-color: blue\">`[foobarbaz]´</span></p>",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\"><p style=\"background-color: gray;\"><span style=\"background-color: blue\">`[foobarbaz]´</span></p></body>",
          "bodyInnerHTML": "<p style=\"background-color: gray;\"><span style=\"background-color: blue\">`[foobarbaz]´</span></p>",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\"><p style=\"background-color: gray;\"><span style=\"background-color: blue\">`[foobarbaz]´</span></p></body>"
        },
        "div": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "<p style=\"background-color: gray;\"><span style=\"background-color: blue\">`[foobarbaz]´</span></p>",
          "innerHTML": "<p style=\"background-color: gray;\"><span style=\"background-color: blue\">`[foobarbaz]´</span></p>",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\"><p style=\"background-color: gray;\"><span style=\"background-color: blue\">`[foobarbaz]´</span></p></div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\"><p style=\"background-color: gray;\"><span style=\"background-color: blue\">`[foobarbaz]´</span></p></div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\"><p style=\"background-color: gray;\"><span style=\"background-color: blue\">`[foobarbaz]´</span></p></div>CAN<br>ARY</body>"
        }
      },
      "BC:gray_P-SPANs:bc:b-2_SW": {
        "dM": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "<p style=\"background-color: gray;\">`foo´<span style=\"background-color: blue\">`[bar]´</span>`baz´</p>",
          "innerHTML": "<p style=\"background-color: gray;\">`foo´<span style=\"background-color: blue\">`[bar]´</span>`baz´</p>",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\"><p style=\"background-color: gray;\">`foo´<span style=\"background-color: blue\">`[bar]´</span>`baz´</p></body>",
          "bodyInnerHTML": "<p style=\"background-color: gray;\">`foo´<span style=\"background-color: blue\">`[bar]´</span>`baz´</p>",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\"><p style=\"background-color: gray;\">`foo´<span style=\"background-color: blue\">`[bar]´</span>`baz´</p></body>"
        },
        "body": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "<p style=\"background-color: gray;\">`foo´<span style=\"background-color: blue\">`[bar]´</span>`baz´</p>",
          "innerHTML": "<p style=\"background-color: gray;\">`foo´<span style=\"background-color: blue\">`[bar]´</span>`baz´</p>",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\"><p style=\"background-color: gray;\">`foo´<span style=\"background-color: blue\">`[bar]´</span>`baz´</p></body>",
          "bodyInnerHTML": "<p style=\"background-color: gray;\">`foo´<span style=\"background-color: blue\">`[bar]´</span>`baz´</p>",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\"><p style=\"background-color: gray;\">`foo´<span style=\"background-color: blue\">`[bar]´</span>`baz´</p></body>"
        },
        "div": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "<p style=\"background-color: gray;\">`foo´<span style=\"background-color: blue\">`[bar]´</span>`baz´</p>",
          "innerHTML": "<p style=\"background-color: gray;\">`foo´<span style=\"background-color: blue\">`[bar]´</span>`baz´</p>",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\"><p style=\"background-color: gray;\">`foo´<span style=\"background-color: blue\">`[bar]´</span>`baz´</p></div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\"><p style=\"background-color: gray;\">`foo´<span style=\"background-color: blue\">`[bar]´</span>`baz´</p></div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\"><p style=\"background-color: gray;\">`foo´<span style=\"background-color: blue\">`[bar]´</span>`baz´</p></div>CAN<br>ARY</body>"
        }
      },
      "BC:gray_P-SPANs:bc:b-3_SO": {
        "dM": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "<p style=\"background-color: gray;\">`[foo´<span style=\"background-color: blue\">`barbaz´</span>`qoz]quz´</p>",
          "innerHTML": "<p style=\"background-color: gray;\">`[foo´<span style=\"background-color: blue\">`barbaz´</span>`qoz]quz´</p>",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\"><p style=\"background-color: gray;\">`[foo´<span style=\"background-color: blue\">`barbaz´</span>`qoz]quz´</p></body>",
          "bodyInnerHTML": "<p style=\"background-color: gray;\">`[foo´<span style=\"background-color: blue\">`barbaz´</span>`qoz]quz´</p>",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\"><p style=\"background-color: gray;\">`[foo´<span style=\"background-color: blue\">`barbaz´</span>`qoz]quz´</p></body>"
        },
        "body": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "<p style=\"background-color: gray;\">`[foo´<span style=\"background-color: blue\">`barbaz´</span>`qoz]quz´</p>",
          "innerHTML": "<p style=\"background-color: gray;\">`[foo´<span style=\"background-color: blue\">`barbaz´</span>`qoz]quz´</p>",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\"><p style=\"background-color: gray;\">`[foo´<span style=\"background-color: blue\">`barbaz´</span>`qoz]quz´</p></body>",
          "bodyInnerHTML": "<p style=\"background-color: gray;\">`[foo´<span style=\"background-color: blue\">`barbaz´</span>`qoz]quz´</p>",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\"><p style=\"background-color: gray;\">`[foo´<span style=\"background-color: blue\">`barbaz´</span>`qoz]quz´</p></body>"
        },
        "div": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "<p style=\"background-color: gray;\">`[foo´<span style=\"background-color: blue\">`barbaz´</span>`qoz]quz´</p>",
          "innerHTML": "<p style=\"background-color: gray;\">`[foo´<span style=\"background-color: blue\">`barbaz´</span>`qoz]quz´</p>",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\"><p style=\"background-color: gray;\">`[foo´<span style=\"background-color: blue\">`barbaz´</span>`qoz]quz´</p></div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\"><p style=\"background-color: gray;\">`[foo´<span style=\"background-color: blue\">`barbaz´</span>`qoz]quz´</p></div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\"><p style=\"background-color: gray;\">`[foo´<span style=\"background-color: blue\">`barbaz´</span>`qoz]quz´</p></div>CAN<br>ARY</body>"
        }
      },
      "BC:gray_P-SPANs:bc:b-3_SL": {
        "dM": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "<p style=\"background-color: gray;\">`[foo´<span style=\"background-color: blue\">`bar]baz´</span>`qozquz´</p>",
          "innerHTML": "<p style=\"background-color: gray;\">`[foo´<span style=\"background-color: blue\">`bar]baz´</span>`qozquz´</p>",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\"><p style=\"background-color: gray;\">`[foo´<span style=\"background-color: blue\">`bar]baz´</span>`qozquz´</p></body>",
          "bodyInnerHTML": "<p style=\"background-color: gray;\">`[foo´<span style=\"background-color: blue\">`bar]baz´</span>`qozquz´</p>",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\"><p style=\"background-color: gray;\">`[foo´<span style=\"background-color: blue\">`bar]baz´</span>`qozquz´</p></body>"
        },
        "body": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "<p style=\"background-color: gray;\">`[foo´<span style=\"background-color: blue\">`bar]baz´</span>`qozquz´</p>",
          "innerHTML": "<p style=\"background-color: gray;\">`[foo´<span style=\"background-color: blue\">`bar]baz´</span>`qozquz´</p>",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\"><p style=\"background-color: gray;\">`[foo´<span style=\"background-color: blue\">`bar]baz´</span>`qozquz´</p></body>",
          "bodyInnerHTML": "<p style=\"background-color: gray;\">`[foo´<span style=\"background-color: blue\">`bar]baz´</span>`qozquz´</p>",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\"><p style=\"background-color: gray;\">`[foo´<span style=\"background-color: blue\">`bar]baz´</span>`qozquz´</p></body>"
        },
        "div": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "<p style=\"background-color: gray;\">`[foo´<span style=\"background-color: blue\">`bar]baz´</span>`qozquz´</p>",
          "innerHTML": "<p style=\"background-color: gray;\">`[foo´<span style=\"background-color: blue\">`bar]baz´</span>`qozquz´</p>",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\"><p style=\"background-color: gray;\">`[foo´<span style=\"background-color: blue\">`bar]baz´</span>`qozquz´</p></div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\"><p style=\"background-color: gray;\">`[foo´<span style=\"background-color: blue\">`bar]baz´</span>`qozquz´</p></div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\"><p style=\"background-color: gray;\">`[foo´<span style=\"background-color: blue\">`bar]baz´</span>`qozquz´</p></div>CAN<br>ARY</body>"
        }
      },
      "BC:gray_SPANs:bc:b-2_SL": {
        "dM": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\" style=\"background-color: gray;\">`foo [bar ´<span style=\"background-color: blue\">`baz] qoz´</span>` quz sic´</body>",
          "innerHTML": "`foo [bar ´<span style=\"background-color: blue\">`baz] qoz´</span>` quz sic´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\" style=\"background-color: gray;\">`foo [bar ´<span style=\"background-color: blue\">`baz] qoz´</span>` quz sic´</body>",
          "bodyInnerHTML": "`foo [bar ´<span style=\"background-color: blue\">`baz] qoz´</span>` quz sic´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\" style=\"background-color: gray;\">`foo [bar ´<span style=\"background-color: blue\">`baz] qoz´</span>` quz sic´</body>"
        },
        "body": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" style=\"background-color: gray;\">`foo [bar ´<span style=\"background-color: blue\">`baz] qoz´</span>` quz sic´</body>",
          "innerHTML": "`foo [bar ´<span style=\"background-color: blue\">`baz] qoz´</span>` quz sic´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" style=\"background-color: gray;\">`foo [bar ´<span style=\"background-color: blue\">`baz] qoz´</span>` quz sic´</body>",
          "bodyInnerHTML": "`foo [bar ´<span style=\"background-color: blue\">`baz] qoz´</span>` quz sic´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" style=\"background-color: gray;\">`foo [bar ´<span style=\"background-color: blue\">`baz] qoz´</span>` quz sic´</body>"
        },
        "div": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\" style=\"background-color: gray;\">`foo [bar ´<span style=\"background-color: blue\">`baz] qoz´</span>` quz sic´</div>",
          "innerHTML": "`foo [bar ´<span style=\"background-color: blue\">`baz] qoz´</span>` quz sic´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\" style=\"background-color: gray;\">`foo [bar ´<span style=\"background-color: blue\">`baz] qoz´</span>` quz sic´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div style=\"background-color: gray;\" id=\"editor-div\" contenteditable=\"true\">`foo [bar ´<span style=\"background-color: blue\">`baz] qoz´</span>` quz sic´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\" style=\"background-color: gray;\">`foo [bar ´<span style=\"background-color: blue\">`baz] qoz´</span>` quz sic´</div>CAN<br>ARY</body>"
        }
      },
      "BC:gray_SPANs:bc:b-2_SR": {
        "dM": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\" style=\"background-color: gray;\">`foo bar ´<span style=\"background-color: blue\">`baz [qoz´</span>` quz] sic´</body>",
          "innerHTML": "`foo bar ´<span style=\"background-color: blue\">`baz [qoz´</span>` quz] sic´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\" style=\"background-color: gray;\">`foo bar ´<span style=\"background-color: blue\">`baz [qoz´</span>` quz] sic´</body>",
          "bodyInnerHTML": "`foo bar ´<span style=\"background-color: blue\">`baz [qoz´</span>` quz] sic´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\" style=\"background-color: gray;\">`foo bar ´<span style=\"background-color: blue\">`baz [qoz´</span>` quz] sic´</body>"
        },
        "body": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" style=\"background-color: gray;\">`foo bar ´<span style=\"background-color: blue\">`baz [qoz´</span>` quz] sic´</body>",
          "innerHTML": "`foo bar ´<span style=\"background-color: blue\">`baz [qoz´</span>` quz] sic´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" style=\"background-color: gray;\">`foo bar ´<span style=\"background-color: blue\">`baz [qoz´</span>` quz] sic´</body>",
          "bodyInnerHTML": "`foo bar ´<span style=\"background-color: blue\">`baz [qoz´</span>` quz] sic´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" style=\"background-color: gray;\">`foo bar ´<span style=\"background-color: blue\">`baz [qoz´</span>` quz] sic´</body>"
        },
        "div": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\" style=\"background-color: gray;\">`foo bar ´<span style=\"background-color: blue\">`baz [qoz´</span>` quz] sic´</div>",
          "innerHTML": "`foo bar ´<span style=\"background-color: blue\">`baz [qoz´</span>` quz] sic´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\" style=\"background-color: gray;\">`foo bar ´<span style=\"background-color: blue\">`baz [qoz´</span>` quz] sic´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div style=\"background-color: gray;\" id=\"editor-div\" contenteditable=\"true\">`foo bar ´<span style=\"background-color: blue\">`baz [qoz´</span>` quz] sic´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\" style=\"background-color: gray;\">`foo bar ´<span style=\"background-color: blue\">`baz [qoz´</span>` quz] sic´</div>CAN<br>ARY</body>"
        }
      },
      "FN:c_SPANs:ff:a-1_SW": {
        "dM": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "<span style=\"font-family: courier;\">`[foobarbaz]´</span>",
          "innerHTML": "<span style=\"font-family: courier;\">`[foobarbaz]´</span>",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\"><span style=\"font-family: courier;\">`[foobarbaz]´</span></body>",
          "bodyInnerHTML": "<span style=\"font-family: courier;\">`[foobarbaz]´</span>",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\"><span style=\"font-family: courier;\">`[foobarbaz]´</span></body>"
        },
        "body": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "<span style=\"font-family: courier;\">`[foobarbaz]´</span>",
          "innerHTML": "<span style=\"font-family: courier;\">`[foobarbaz]´</span>",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\"><span style=\"font-family: courier;\">`[foobarbaz]´</span></body>",
          "bodyInnerHTML": "<span style=\"font-family: courier;\">`[foobarbaz]´</span>",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\"><span style=\"font-family: courier;\">`[foobarbaz]´</span></body>"
        },
        "div": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\" style=\"font-family: courier;\">`[foobarbaz]´</div>",
          "innerHTML": "`[foobarbaz]´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\" style=\"font-family: courier;\">`[foobarbaz]´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div style=\"font-family: courier;\" id=\"editor-div\" contenteditable=\"true\">`[foobarbaz]´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\" style=\"font-family: courier;\">`[foobarbaz]´</div>CAN<br>ARY</body>"
        }
      },
      "FN:c_FONTf:a-1_SW": {
        "dM": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "<font style=\"font-family: courier;\" face=\"arial\">`[foobarbaz]´</font>",
          "innerHTML": "<font style=\"font-family: courier;\" face=\"arial\">`[foobarbaz]´</font>",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\"><font face=\"arial\" style=\"font-family: courier;\">`[foobarbaz]´</font></body>",
          "bodyInnerHTML": "<font style=\"font-family: courier;\" face=\"arial\">`[foobarbaz]´</font>",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\"><font face=\"arial\" style=\"font-family: courier;\">`[foobarbaz]´</font></body>"
        },
        "body": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "<font style=\"font-family: courier;\" face=\"arial\">`[foobarbaz]´</font>",
          "innerHTML": "<font style=\"font-family: courier;\" face=\"arial\">`[foobarbaz]´</font>",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\"><font face=\"arial\" style=\"font-family: courier;\">`[foobarbaz]´</font></body>",
          "bodyInnerHTML": "<font style=\"font-family: courier;\" face=\"arial\">`[foobarbaz]´</font>",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\"><font face=\"arial\" style=\"font-family: courier;\">`[foobarbaz]´</font></body>"
        },
        "div": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\" style=\"font-family: courier;\">`[foobarbaz]´</div>",
          "innerHTML": "`[foobarbaz]´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\" style=\"font-family: courier;\">`[foobarbaz]´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div style=\"font-family: courier;\" id=\"editor-div\" contenteditable=\"true\">`[foobarbaz]´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\" style=\"font-family: courier;\">`[foobarbaz]´</div>CAN<br>ARY</body>"
        }
      },
      "FN:c_FONTf:a-1_SI": {
        "dM": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "<font face=\"arial\">`foo[´<span style=\"font-family: courier;\">`bar]´</span>`baz´</font>",
          "innerHTML": "<font face=\"arial\">`foo[´<span style=\"font-family: courier;\">`bar]´</span>`baz´</font>",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\"><font face=\"arial\">`foo[´<span style=\"font-family: courier;\">`bar]´</span>`baz´</font></body>",
          "bodyInnerHTML": "<font face=\"arial\">`foo[´<span style=\"font-family: courier;\">`bar]´</span>`baz´</font>",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\"><font face=\"arial\">`foo[´<span style=\"font-family: courier;\">`bar]´</span>`baz´</font></body>"
        },
        "body": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "<font face=\"arial\">`foo[´<span style=\"font-family: courier;\">`bar]´</span>`baz´</font>",
          "innerHTML": "<font face=\"arial\">`foo[´<span style=\"font-family: courier;\">`bar]´</span>`baz´</font>",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\"><font face=\"arial\">`foo[´<span style=\"font-family: courier;\">`bar]´</span>`baz´</font></body>",
          "bodyInnerHTML": "<font face=\"arial\">`foo[´<span style=\"font-family: courier;\">`bar]´</span>`baz´</font>",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\"><font face=\"arial\">`foo[´<span style=\"font-family: courier;\">`bar]´</span>`baz´</font></body>"
        },
        "div": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "<font face=\"arial\">`foo[´<span style=\"font-family: courier;\">`bar]´</span>`baz´</font>",
          "innerHTML": "<font face=\"arial\">`foo[´<span style=\"font-family: courier;\">`bar]´</span>`baz´</font>",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\"><font face=\"arial\">`foo[´<span style=\"font-family: courier;\">`bar]´</span>`baz´</font></div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\"><font face=\"arial\">`foo[´<span style=\"font-family: courier;\">`bar]´</span>`baz´</font></div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\"><font face=\"arial\">`foo[´<span style=\"font-family: courier;\">`bar]´</span>`baz´</font></div>CAN<br>ARY</body>"
        }
      },
      "FN:a_FONTf:a-1_SI": {
        "dM": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "<font face=\"arial\">`foo[bar]baz´</font>",
          "innerHTML": "<font face=\"arial\">`foo[bar]baz´</font>",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\"><font face=\"arial\">`foo[bar]baz´</font></body>",
          "bodyInnerHTML": "<font face=\"arial\">`foo[bar]baz´</font>",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\"><font face=\"arial\">`foo[bar]baz´</font></body>"
        },
        "body": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "<font face=\"arial\">`foo[bar]baz´</font>",
          "innerHTML": "<font face=\"arial\">`foo[bar]baz´</font>",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\"><font face=\"arial\">`foo[bar]baz´</font></body>",
          "bodyInnerHTML": "<font face=\"arial\">`foo[bar]baz´</font>",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\"><font face=\"arial\">`foo[bar]baz´</font></body>"
        },
        "div": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "<font face=\"arial\">`foo[bar]baz´</font>",
          "innerHTML": "<font face=\"arial\">`foo[bar]baz´</font>",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\"><font face=\"arial\">`foo[bar]baz´</font></div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\"><font face=\"arial\">`foo[bar]baz´</font></div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\"><font face=\"arial\">`foo[bar]baz´</font></div>CAN<br>ARY</body>"
        }
      },
      "FN:a_FONTf:a-1_SW": {
        "dM": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "<font style=\"font-family: arial;\" face=\"arial\">`[foobarbaz]´</font>",
          "innerHTML": "<font style=\"font-family: arial;\" face=\"arial\">`[foobarbaz]´</font>",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\"><font face=\"arial\" style=\"font-family: arial;\">`[foobarbaz]´</font></body>",
          "bodyInnerHTML": "<font style=\"font-family: arial;\" face=\"arial\">`[foobarbaz]´</font>",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\"><font face=\"arial\" style=\"font-family: arial;\">`[foobarbaz]´</font></body>"
        },
        "body": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "<font style=\"font-family: arial;\" face=\"arial\">`[foobarbaz]´</font>",
          "innerHTML": "<font style=\"font-family: arial;\" face=\"arial\">`[foobarbaz]´</font>",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\"><font face=\"arial\" style=\"font-family: arial;\">`[foobarbaz]´</font></body>",
          "bodyInnerHTML": "<font style=\"font-family: arial;\" face=\"arial\">`[foobarbaz]´</font>",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\"><font face=\"arial\" style=\"font-family: arial;\">`[foobarbaz]´</font></body>"
        },
        "div": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\" style=\"font-family: arial;\">`[foobarbaz]´</div>",
          "innerHTML": "`[foobarbaz]´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\" style=\"font-family: arial;\">`[foobarbaz]´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div style=\"font-family: arial;\" id=\"editor-div\" contenteditable=\"true\">`[foobarbaz]´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\" style=\"font-family: arial;\">`[foobarbaz]´</div>CAN<br>ARY</body>"
        }
      },
      "FN:a_FONTf:a-1_SO": {
        "dM": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "{<font style=\"font-family: arial;\" face=\"arial\">`foobarbaz´</font>}",
          "innerHTML": "{<font style=\"font-family: arial;\" face=\"arial\">`foobarbaz´</font>}",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">{<font face=\"arial\" style=\"font-family: arial;\">`foobarbaz´</font>}</body>",
          "bodyInnerHTML": "{<font style=\"font-family: arial;\" face=\"arial\">`foobarbaz´</font>}",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">{<font face=\"arial\" style=\"font-family: arial;\">`foobarbaz´</font>}</body>"
        },
        "body": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "{<font style=\"font-family: arial;\" face=\"arial\">`foobarbaz´</font>}",
          "innerHTML": "{<font style=\"font-family: arial;\" face=\"arial\">`foobarbaz´</font>}",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">{<font face=\"arial\" style=\"font-family: arial;\">`foobarbaz´</font>}</body>",
          "bodyInnerHTML": "{<font style=\"font-family: arial;\" face=\"arial\">`foobarbaz´</font>}",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">{<font face=\"arial\" style=\"font-family: arial;\">`foobarbaz´</font>}</body>"
        },
        "div": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\" style=\"font-family: arial;\">{`foobarbaz´}</div>",
          "innerHTML": "{`foobarbaz´}",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\" style=\"font-family: arial;\">{`foobarbaz´}</div>",
          "bodyInnerHTML": "CAN<br>ARY<div style=\"font-family: arial;\" id=\"editor-div\" contenteditable=\"true\">{`foobarbaz´}</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\" style=\"font-family: arial;\">{`foobarbaz´}</div>CAN<br>ARY</body>"
        }
      },
      "FN:a_SPANs:ff:a-1_SI": {
        "dM": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "<span style=\"font-family: arial\">`[foobarbaz]´</span>",
          "innerHTML": "<span style=\"font-family: arial\">`[foobarbaz]´</span>",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\"><span style=\"font-family: arial\">`[foobarbaz]´</span></body>",
          "bodyInnerHTML": "<span style=\"font-family: arial\">`[foobarbaz]´</span>",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\"><span style=\"font-family: arial\">`[foobarbaz]´</span></body>"
        },
        "body": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "<span style=\"font-family: arial\">`[foobarbaz]´</span>",
          "innerHTML": "<span style=\"font-family: arial\">`[foobarbaz]´</span>",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\"><span style=\"font-family: arial\">`[foobarbaz]´</span></body>",
          "bodyInnerHTML": "<span style=\"font-family: arial\">`[foobarbaz]´</span>",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\"><span style=\"font-family: arial\">`[foobarbaz]´</span></body>"
        },
        "div": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\" style=\"font-family: arial;\">`[foobarbaz]´</div>",
          "innerHTML": "`[foobarbaz]´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\" style=\"font-family: arial;\">`[foobarbaz]´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div style=\"font-family: arial;\" id=\"editor-div\" contenteditable=\"true\">`[foobarbaz]´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\" style=\"font-family: arial;\">`[foobarbaz]´</div>CAN<br>ARY</body>"
        }
      },
      "FN:c_FONTf:a-2_SL": {
        "dM": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`foo[´<span style=\"font-family: courier;\">`bar´</span><font face=\"arial\"><span style=\"font-family: courier;\">`baz]´</span>`qoz´</font>",
          "innerHTML": "`foo[´<span style=\"font-family: courier;\">`bar´</span><font face=\"arial\"><span style=\"font-family: courier;\">`baz]´</span>`qoz´</font>",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo[´<span style=\"font-family: courier;\">`bar´</span><font face=\"arial\"><span style=\"font-family: courier;\">`baz]´</span>`qoz´</font></body>",
          "bodyInnerHTML": "`foo[´<span style=\"font-family: courier;\">`bar´</span><font face=\"arial\"><span style=\"font-family: courier;\">`baz]´</span>`qoz´</font>",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo[´<span style=\"font-family: courier;\">`bar´</span><font face=\"arial\"><span style=\"font-family: courier;\">`baz]´</span>`qoz´</font></body>"
        },
        "body": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`foo[´<span style=\"font-family: courier;\">`bar´</span><font face=\"arial\"><span style=\"font-family: courier;\">`baz]´</span>`qoz´</font>",
          "innerHTML": "`foo[´<span style=\"font-family: courier;\">`bar´</span><font face=\"arial\"><span style=\"font-family: courier;\">`baz]´</span>`qoz´</font>",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo[´<span style=\"font-family: courier;\">`bar´</span><font face=\"arial\"><span style=\"font-family: courier;\">`baz]´</span>`qoz´</font></body>",
          "bodyInnerHTML": "`foo[´<span style=\"font-family: courier;\">`bar´</span><font face=\"arial\"><span style=\"font-family: courier;\">`baz]´</span>`qoz´</font>",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo[´<span style=\"font-family: courier;\">`bar´</span><font face=\"arial\"><span style=\"font-family: courier;\">`baz]´</span>`qoz´</font></body>"
        },
        "div": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`foo[´<span style=\"font-family: courier;\">`bar´</span><font face=\"arial\"><span style=\"font-family: courier;\">`baz]´</span>`qoz´</font>",
          "innerHTML": "`foo[´<span style=\"font-family: courier;\">`bar´</span><font face=\"arial\"><span style=\"font-family: courier;\">`baz]´</span>`qoz´</font>",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\">`foo[´<span style=\"font-family: courier;\">`bar´</span><font face=\"arial\"><span style=\"font-family: courier;\">`baz]´</span>`qoz´</font></div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\">`foo[´<span style=\"font-family: courier;\">`bar´</span><font face=\"arial\"><span style=\"font-family: courier;\">`baz]´</span>`qoz´</font></div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\">`foo[´<span style=\"font-family: courier;\">`bar´</span><font face=\"arial\"><span style=\"font-family: courier;\">`baz]´</span>`qoz´</font></div>CAN<br>ARY</body>"
        }
      },
      "FS:1_SPANs:fs:l-1_SW": {
        "dM": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "<font size=\"1\"><span style=\"font-size: large\">`[foobarbaz]´</span></font>",
          "innerHTML": "<font size=\"1\"><span style=\"font-size: large\">`[foobarbaz]´</span></font>",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\"><font size=\"1\"><span style=\"font-size: large\">`[foobarbaz]´</span></font></body>",
          "bodyInnerHTML": "<font size=\"1\"><span style=\"font-size: large\">`[foobarbaz]´</span></font>",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\"><font size=\"1\"><span style=\"font-size: large\">`[foobarbaz]´</span></font></body>"
        },
        "body": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "<font size=\"1\"><span style=\"font-size: large\">`[foobarbaz]´</span></font>",
          "innerHTML": "<font size=\"1\"><span style=\"font-size: large\">`[foobarbaz]´</span></font>",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\"><font size=\"1\"><span style=\"font-size: large\">`[foobarbaz]´</span></font></body>",
          "bodyInnerHTML": "<font size=\"1\"><span style=\"font-size: large\">`[foobarbaz]´</span></font>",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\"><font size=\"1\"><span style=\"font-size: large\">`[foobarbaz]´</span></font></body>"
        },
        "div": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "<font size=\"1\"><span style=\"font-size: large\">`[foobarbaz]´</span></font>",
          "innerHTML": "<font size=\"1\"><span style=\"font-size: large\">`[foobarbaz]´</span></font>",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\"><font size=\"1\"><span style=\"font-size: large\">`[foobarbaz]´</span></font></div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\"><font size=\"1\"><span style=\"font-size: large\">`[foobarbaz]´</span></font></div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\"><font size=\"1\"><span style=\"font-size: large\">`[foobarbaz]´</span></font></div>CAN<br>ARY</body>"
        }
      },
      "FS:large_SPANs:fs:l-1_SW": {
        "dM": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "<font size=\"large\"><span style=\"font-size: large\">`[foobarbaz]´</span></font>",
          "innerHTML": "<font size=\"large\"><span style=\"font-size: large\">`[foobarbaz]´</span></font>",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\"><font size=\"large\"><span style=\"font-size: large\">`[foobarbaz]´</span></font></body>",
          "bodyInnerHTML": "<font size=\"large\"><span style=\"font-size: large\">`[foobarbaz]´</span></font>",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\"><font size=\"large\"><span style=\"font-size: large\">`[foobarbaz]´</span></font></body>"
        },
        "body": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "<font size=\"large\"><span style=\"font-size: large\">`[foobarbaz]´</span></font>",
          "innerHTML": "<font size=\"large\"><span style=\"font-size: large\">`[foobarbaz]´</span></font>",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\"><font size=\"large\"><span style=\"font-size: large\">`[foobarbaz]´</span></font></body>",
          "bodyInnerHTML": "<font size=\"large\"><span style=\"font-size: large\">`[foobarbaz]´</span></font>",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\"><font size=\"large\"><span style=\"font-size: large\">`[foobarbaz]´</span></font></body>"
        },
        "div": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "<font size=\"large\"><span style=\"font-size: large\">`[foobarbaz]´</span></font>",
          "innerHTML": "<font size=\"large\"><span style=\"font-size: large\">`[foobarbaz]´</span></font>",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\"><font size=\"large\"><span style=\"font-size: large\">`[foobarbaz]´</span></font></div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\"><font size=\"large\"><span style=\"font-size: large\">`[foobarbaz]´</span></font></div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\"><font size=\"large\"><span style=\"font-size: large\">`[foobarbaz]´</span></font></div>CAN<br>ARY</body>"
        }
      },
      "FS:18px_SPANs:fs:l-1_SW": {
        "dM": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "<font size=\"18px\"><span style=\"font-size: large\">`[foobarbaz]´</span></font>",
          "innerHTML": "<font size=\"18px\"><span style=\"font-size: large\">`[foobarbaz]´</span></font>",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\"><font size=\"18px\"><span style=\"font-size: large\">`[foobarbaz]´</span></font></body>",
          "bodyInnerHTML": "<font size=\"18px\"><span style=\"font-size: large\">`[foobarbaz]´</span></font>",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\"><font size=\"18px\"><span style=\"font-size: large\">`[foobarbaz]´</span></font></body>"
        },
        "body": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "<font size=\"18px\"><span style=\"font-size: large\">`[foobarbaz]´</span></font>",
          "innerHTML": "<font size=\"18px\"><span style=\"font-size: large\">`[foobarbaz]´</span></font>",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\"><font size=\"18px\"><span style=\"font-size: large\">`[foobarbaz]´</span></font></body>",
          "bodyInnerHTML": "<font size=\"18px\"><span style=\"font-size: large\">`[foobarbaz]´</span></font>",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\"><font size=\"18px\"><span style=\"font-size: large\">`[foobarbaz]´</span></font></body>"
        },
        "div": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "<font size=\"18px\"><span style=\"font-size: large\">`[foobarbaz]´</span></font>",
          "innerHTML": "<font size=\"18px\"><span style=\"font-size: large\">`[foobarbaz]´</span></font>",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\"><font size=\"18px\"><span style=\"font-size: large\">`[foobarbaz]´</span></font></div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\"><font size=\"18px\"><span style=\"font-size: large\">`[foobarbaz]´</span></font></div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\"><font size=\"18px\"><span style=\"font-size: large\">`[foobarbaz]´</span></font></div>CAN<br>ARY</body>"
        }
      },
      "FS:4_SPANs:fs:l-1_SW": {
        "dM": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "<font size=\"4\"><span style=\"font-size: large\">`[foobarbaz]´</span></font>",
          "innerHTML": "<font size=\"4\"><span style=\"font-size: large\">`[foobarbaz]´</span></font>",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\"><font size=\"4\"><span style=\"font-size: large\">`[foobarbaz]´</span></font></body>",
          "bodyInnerHTML": "<font size=\"4\"><span style=\"font-size: large\">`[foobarbaz]´</span></font>",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\"><font size=\"4\"><span style=\"font-size: large\">`[foobarbaz]´</span></font></body>"
        },
        "body": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "<font size=\"4\"><span style=\"font-size: large\">`[foobarbaz]´</span></font>",
          "innerHTML": "<font size=\"4\"><span style=\"font-size: large\">`[foobarbaz]´</span></font>",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\"><font size=\"4\"><span style=\"font-size: large\">`[foobarbaz]´</span></font></body>",
          "bodyInnerHTML": "<font size=\"4\"><span style=\"font-size: large\">`[foobarbaz]´</span></font>",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\"><font size=\"4\"><span style=\"font-size: large\">`[foobarbaz]´</span></font></body>"
        },
        "div": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "<font size=\"4\"><span style=\"font-size: large\">`[foobarbaz]´</span></font>",
          "innerHTML": "<font size=\"4\"><span style=\"font-size: large\">`[foobarbaz]´</span></font>",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\"><font size=\"4\"><span style=\"font-size: large\">`[foobarbaz]´</span></font></div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\"><font size=\"4\"><span style=\"font-size: large\">`[foobarbaz]´</span></font></div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\"><font size=\"4\"><span style=\"font-size: large\">`[foobarbaz]´</span></font></div>CAN<br>ARY</body>"
        }
      },
      "FS:4_SPANs:fs:18px-1_SW": {
        "dM": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "<font size=\"4\"><span style=\"font-size: 18px\">`[foobarbaz]´</span></font>",
          "innerHTML": "<font size=\"4\"><span style=\"font-size: 18px\">`[foobarbaz]´</span></font>",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\"><font size=\"4\"><span style=\"font-size: 18px\">`[foobarbaz]´</span></font></body>",
          "bodyInnerHTML": "<font size=\"4\"><span style=\"font-size: 18px\">`[foobarbaz]´</span></font>",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\"><font size=\"4\"><span style=\"font-size: 18px\">`[foobarbaz]´</span></font></body>"
        },
        "body": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "<font size=\"4\"><span style=\"font-size: 18px\">`[foobarbaz]´</span></font>",
          "innerHTML": "<font size=\"4\"><span style=\"font-size: 18px\">`[foobarbaz]´</span></font>",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\"><font size=\"4\"><span style=\"font-size: 18px\">`[foobarbaz]´</span></font></body>",
          "bodyInnerHTML": "<font size=\"4\"><span style=\"font-size: 18px\">`[foobarbaz]´</span></font>",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\"><font size=\"4\"><span style=\"font-size: 18px\">`[foobarbaz]´</span></font></body>"
        },
        "div": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "<font size=\"4\"><span style=\"font-size: 18px\">`[foobarbaz]´</span></font>",
          "innerHTML": "<font size=\"4\"><span style=\"font-size: 18px\">`[foobarbaz]´</span></font>",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\"><font size=\"4\"><span style=\"font-size: 18px\">`[foobarbaz]´</span></font></div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\"><font size=\"4\"><span style=\"font-size: 18px\">`[foobarbaz]´</span></font></div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\"><font size=\"4\"><span style=\"font-size: 18px\">`[foobarbaz]´</span></font></div>CAN<br>ARY</body>"
        }
      },
      "FS:larger_SPANs:fs:l-1_SI": {
        "dM": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 7,
          "selresult": 2,
          "output": "<span style=\"font-size: large\">`foo[´<font size=\"larger\">`bar]´</font>`baz´</span>",
          "innerHTML": "<span style=\"font-size: large\">`foo[´<font size=\"larger\">`bar]´</font>`baz´</span>",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\"><span style=\"font-size: large\">`foo[´<font size=\"larger\">`bar]´</font>`baz´</span></body>",
          "bodyInnerHTML": "<span style=\"font-size: large\">`foo[´<font size=\"larger\">`bar]´</font>`baz´</span>",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\"><span style=\"font-size: large\">`foo[´<font size=\"larger\">`bar]´</font>`baz´</span></body>"
        },
        "body": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 7,
          "selresult": 2,
          "output": "<span style=\"font-size: large\">`foo[´<font size=\"larger\">`bar]´</font>`baz´</span>",
          "innerHTML": "<span style=\"font-size: large\">`foo[´<font size=\"larger\">`bar]´</font>`baz´</span>",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\"><span style=\"font-size: large\">`foo[´<font size=\"larger\">`bar]´</font>`baz´</span></body>",
          "bodyInnerHTML": "<span style=\"font-size: large\">`foo[´<font size=\"larger\">`bar]´</font>`baz´</span>",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\"><span style=\"font-size: large\">`foo[´<font size=\"larger\">`bar]´</font>`baz´</span></body>"
        },
        "div": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 7,
          "selresult": 2,
          "output": "<span style=\"font-size: large\">`foo[´<font size=\"larger\">`bar]´</font>`baz´</span>",
          "innerHTML": "<span style=\"font-size: large\">`foo[´<font size=\"larger\">`bar]´</font>`baz´</span>",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\"><span style=\"font-size: large\">`foo[´<font size=\"larger\">`bar]´</font>`baz´</span></div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\"><span style=\"font-size: large\">`foo[´<font size=\"larger\">`bar]´</font>`baz´</span></div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\"><span style=\"font-size: large\">`foo[´<font size=\"larger\">`bar]´</font>`baz´</span></div>CAN<br>ARY</body>"
        }
      },
      "FS:smaller_SPANs:fs:l-1_SI": {
        "dM": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 7,
          "selresult": 2,
          "output": "<span style=\"font-size: large\">`foo[´<font size=\"smaller\">`bar]´</font>`baz´</span>",
          "innerHTML": "<span style=\"font-size: large\">`foo[´<font size=\"smaller\">`bar]´</font>`baz´</span>",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\"><span style=\"font-size: large\">`foo[´<font size=\"smaller\">`bar]´</font>`baz´</span></body>",
          "bodyInnerHTML": "<span style=\"font-size: large\">`foo[´<font size=\"smaller\">`bar]´</font>`baz´</span>",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\"><span style=\"font-size: large\">`foo[´<font size=\"smaller\">`bar]´</font>`baz´</span></body>"
        },
        "body": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 7,
          "selresult": 2,
          "output": "<span style=\"font-size: large\">`foo[´<font size=\"smaller\">`bar]´</font>`baz´</span>",
          "innerHTML": "<span style=\"font-size: large\">`foo[´<font size=\"smaller\">`bar]´</font>`baz´</span>",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\"><span style=\"font-size: large\">`foo[´<font size=\"smaller\">`bar]´</font>`baz´</span></body>",
          "bodyInnerHTML": "<span style=\"font-size: large\">`foo[´<font size=\"smaller\">`bar]´</font>`baz´</span>",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\"><span style=\"font-size: large\">`foo[´<font size=\"smaller\">`bar]´</font>`baz´</span></body>"
        },
        "div": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 7,
          "selresult": 2,
          "output": "<span style=\"font-size: large\">`foo[´<font size=\"smaller\">`bar]´</font>`baz´</span>",
          "innerHTML": "<span style=\"font-size: large\">`foo[´<font size=\"smaller\">`bar]´</font>`baz´</span>",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\"><span style=\"font-size: large\">`foo[´<font size=\"smaller\">`bar]´</font>`baz´</span></div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\"><span style=\"font-size: large\">`foo[´<font size=\"smaller\">`bar]´</font>`baz´</span></div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\"><span style=\"font-size: large\">`foo[´<font size=\"smaller\">`bar]´</font>`baz´</span></div>CAN<br>ARY</body>"
        }
      }
    }
  },
  "U": {
    "RFC": {
      "UNLINK_A-1_SO": {
        "dM": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`foo[´<a>`bar´</a>`]baz´",
          "innerHTML": "`foo[´<a>`bar´</a>`]baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo[´<a>`bar´</a>`]baz´</body>",
          "bodyInnerHTML": "`foo[´<a>`bar´</a>`]baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo[´<a>`bar´</a>`]baz´</body>"
        },
        "body": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`foo[´<a>`bar´</a>`]baz´",
          "innerHTML": "`foo[´<a>`bar´</a>`]baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo[´<a>`bar´</a>`]baz´</body>",
          "bodyInnerHTML": "`foo[´<a>`bar´</a>`]baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo[´<a>`bar´</a>`]baz´</body>"
        },
        "div": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`foo[´<a>`bar´</a>`]baz´",
          "innerHTML": "`foo[´<a>`bar´</a>`]baz´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\">`foo[´<a>`bar´</a>`]baz´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\">`foo[´<a>`bar´</a>`]baz´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\">`foo[´<a>`bar´</a>`]baz´</div>CAN<br>ARY</body>"
        }
      },
      "UNLINK_A-1_SW": {
        "dM": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`foo´<a>`[bar]´</a>`baz´",
          "innerHTML": "`foo´<a>`[bar]´</a>`baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo´<a>`[bar]´</a>`baz´</body>",
          "bodyInnerHTML": "`foo´<a>`[bar]´</a>`baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo´<a>`[bar]´</a>`baz´</body>"
        },
        "body": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`foo´<a>`[bar]´</a>`baz´",
          "innerHTML": "`foo´<a>`[bar]´</a>`baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo´<a>`[bar]´</a>`baz´</body>",
          "bodyInnerHTML": "`foo´<a>`[bar]´</a>`baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo´<a>`[bar]´</a>`baz´</body>"
        },
        "div": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`foo´<a>`[bar]´</a>`baz´",
          "innerHTML": "`foo´<a>`[bar]´</a>`baz´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\">`foo´<a>`[bar]´</a>`baz´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\">`foo´<a>`[bar]´</a>`baz´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\">`foo´<a>`[bar]´</a>`baz´</div>CAN<br>ARY</body>"
        }
      },
      "UNLINK_An:a.h:id-1_SO": {
        "dM": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`foo[bar]baz´",
          "innerHTML": "`foo[bar]baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo[bar]baz´</body>",
          "bodyInnerHTML": "`foo[bar]baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo[bar]baz´</body>"
        },
        "body": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`foo[bar]baz´",
          "innerHTML": "`foo[bar]baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo[bar]baz´</body>",
          "bodyInnerHTML": "`foo[bar]baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo[bar]baz´</body>"
        },
        "div": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`foo[´`bar´`]baz´",
          "innerHTML": "`foo[´`bar´`]baz´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\">`foo[´`bar´`]baz´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\">`foo[´`bar´`]baz´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\">`foo[´`bar´`]baz´</div>CAN<br>ARY</body>"
        }
      },
      "UNLINK_A-2_SO": {
        "dM": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`foo[b´<a>`a´</a>`r]baz´",
          "innerHTML": "`foo[b´<a>`a´</a>`r]baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo[b´<a>`a´</a>`r]baz´</body>",
          "bodyInnerHTML": "`foo[b´<a>`a´</a>`r]baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo[b´<a>`a´</a>`r]baz´</body>"
        },
        "body": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`foo[b´<a>`a´</a>`r]baz´",
          "innerHTML": "`foo[b´<a>`a´</a>`r]baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo[b´<a>`a´</a>`r]baz´</body>",
          "bodyInnerHTML": "`foo[b´<a>`a´</a>`r]baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo[b´<a>`a´</a>`r]baz´</body>"
        },
        "div": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`foo[b´<a>`a´</a>`r]baz´",
          "innerHTML": "`foo[b´<a>`a´</a>`r]baz´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\">`foo[b´<a>`a´</a>`r]baz´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\">`foo[b´<a>`a´</a>`r]baz´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\">`foo[b´<a>`a´</a>`r]baz´</div>CAN<br>ARY</body>"
        }
      },
      "UNLINK_A2-1_SO": {
        "dM": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`foo[´<a>`b´</a>`a´<a>`r´</a>`]baz´",
          "innerHTML": "`foo[´<a>`b´</a>`a´<a>`r´</a>`]baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo[´<a>`b´</a>`a´<a>`r´</a>`]baz´</body>",
          "bodyInnerHTML": "`foo[´<a>`b´</a>`a´<a>`r´</a>`]baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo[´<a>`b´</a>`a´<a>`r´</a>`]baz´</body>"
        },
        "body": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`foo[´<a>`b´</a>`a´<a>`r´</a>`]baz´",
          "innerHTML": "`foo[´<a>`b´</a>`a´<a>`r´</a>`]baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo[´<a>`b´</a>`a´<a>`r´</a>`]baz´</body>",
          "bodyInnerHTML": "`foo[´<a>`b´</a>`a´<a>`r´</a>`]baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo[´<a>`b´</a>`a´<a>`r´</a>`]baz´</body>"
        },
        "div": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`foo[´<a>`b´</a>`a´<a>`r´</a>`]baz´",
          "innerHTML": "`foo[´<a>`b´</a>`a´<a>`r´</a>`]baz´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\">`foo[´<a>`b´</a>`a´<a>`r´</a>`]baz´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\">`foo[´<a>`b´</a>`a´<a>`r´</a>`]baz´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\">`foo[´<a>`b´</a>`a´<a>`r´</a>`]baz´</div>CAN<br>ARY</body>"
        }
      }
    },
    "Proposed": {
      "B_B-1_SW": {
        "dM": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`foo[bar]baz´",
          "innerHTML": "`foo[bar]baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo[bar]baz´</body>",
          "bodyInnerHTML": "`foo[bar]baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo[bar]baz´</body>"
        },
        "body": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`foo[bar]baz´",
          "innerHTML": "`foo[bar]baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo[bar]baz´</body>",
          "bodyInnerHTML": "`foo[bar]baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo[bar]baz´</body>"
        },
        "div": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`foo´`[bar]´`baz´",
          "innerHTML": "`foo´`[bar]´`baz´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\">`foo´`[bar]´`baz´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\">`foo´`[bar]´`baz´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\">`foo´`[bar]´`baz´</div>CAN<br>ARY</body>"
        }
      },
      "B_B-1_SO": {
        "dM": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`foo[bar]baz´",
          "innerHTML": "`foo[bar]baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo[bar]baz´</body>",
          "bodyInnerHTML": "`foo[bar]baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo[bar]baz´</body>"
        },
        "body": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`foo[bar]baz´",
          "innerHTML": "`foo[bar]baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo[bar]baz´</body>",
          "bodyInnerHTML": "`foo[bar]baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo[bar]baz´</body>"
        },
        "div": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`foo[´`bar´`]baz´",
          "innerHTML": "`foo[´`bar´`]baz´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\">`foo[´`bar´`]baz´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\">`foo[´`bar´`]baz´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\">`foo[´`bar´`]baz´</div>CAN<br>ARY</body>"
        }
      },
      "B_B-1_SL": {
        "dM": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`foo[bar]baz´",
          "innerHTML": "`foo[bar]baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo[bar]baz´</body>",
          "bodyInnerHTML": "`foo[bar]baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo[bar]baz´</body>"
        },
        "body": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`foo[bar]baz´",
          "innerHTML": "`foo[bar]baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo[bar]baz´</body>",
          "bodyInnerHTML": "`foo[bar]baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo[bar]baz´</body>"
        },
        "div": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`foo[´`bar]´`baz´",
          "innerHTML": "`foo[´`bar]´`baz´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\">`foo[´`bar]´`baz´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\">`foo[´`bar]´`baz´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\">`foo[´`bar]´`baz´</div>CAN<br>ARY</body>"
        }
      },
      "B_B-1_SR": {
        "dM": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`foo[bar]baz´",
          "innerHTML": "`foo[bar]baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo[bar]baz´</body>",
          "bodyInnerHTML": "`foo[bar]baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo[bar]baz´</body>"
        },
        "body": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`foo[bar]baz´",
          "innerHTML": "`foo[bar]baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo[bar]baz´</body>",
          "bodyInnerHTML": "`foo[bar]baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo[bar]baz´</body>"
        },
        "div": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`foo´`[bar´`]baz´",
          "innerHTML": "`foo´`[bar´`]baz´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\">`foo´`[bar´`]baz´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\">`foo´`[bar´`]baz´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\">`foo´`[bar´`]baz´</div>CAN<br>ARY</body>"
        }
      },
      "B_STRONG-1_SW": {
        "dM": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`foo´<b><strong>`[bar]´</strong></b>`baz´",
          "innerHTML": "`foo´<b><strong>`[bar]´</strong></b>`baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo´<b><strong>`[bar]´</strong></b>`baz´</body>",
          "bodyInnerHTML": "`foo´<b><strong>`[bar]´</strong></b>`baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo´<b><strong>`[bar]´</strong></b>`baz´</body>"
        },
        "body": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`foo´<b><strong>`[bar]´</strong></b>`baz´",
          "innerHTML": "`foo´<b><strong>`[bar]´</strong></b>`baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo´<b><strong>`[bar]´</strong></b>`baz´</body>",
          "bodyInnerHTML": "`foo´<b><strong>`[bar]´</strong></b>`baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo´<b><strong>`[bar]´</strong></b>`baz´</body>"
        },
        "div": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`foo´<b><strong>`[bar]´</strong></b>`baz´",
          "innerHTML": "`foo´<b><strong>`[bar]´</strong></b>`baz´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\">`foo´<b><strong>`[bar]´</strong></b>`baz´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\">`foo´<b><strong>`[bar]´</strong></b>`baz´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\">`foo´<b><strong>`[bar]´</strong></b>`baz´</div>CAN<br>ARY</body>"
        }
      },
      "B_STRONG-1_SO": {
        "dM": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`foo[´<b><strong>`bar´</strong></b>`]baz´",
          "innerHTML": "`foo[´<b><strong>`bar´</strong></b>`]baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo[´<b><strong>`bar´</strong></b>`]baz´</body>",
          "bodyInnerHTML": "`foo[´<b><strong>`bar´</strong></b>`]baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo[´<b><strong>`bar´</strong></b>`]baz´</body>"
        },
        "body": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`foo[´<b><strong>`bar´</strong></b>`]baz´",
          "innerHTML": "`foo[´<b><strong>`bar´</strong></b>`]baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo[´<b><strong>`bar´</strong></b>`]baz´</body>",
          "bodyInnerHTML": "`foo[´<b><strong>`bar´</strong></b>`]baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo[´<b><strong>`bar´</strong></b>`]baz´</body>"
        },
        "div": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`foo[´<b><strong>`bar´</strong></b>`]baz´",
          "innerHTML": "`foo[´<b><strong>`bar´</strong></b>`]baz´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\">`foo[´<b><strong>`bar´</strong></b>`]baz´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\">`foo[´<b><strong>`bar´</strong></b>`]baz´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\">`foo[´<b><strong>`bar´</strong></b>`]baz´</div>CAN<br>ARY</body>"
        }
      },
      "B_STRONG-1_SL": {
        "dM": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`foo[´<b><strong>`bar]´</strong></b>`baz´",
          "innerHTML": "`foo[´<b><strong>`bar]´</strong></b>`baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo[´<b><strong>`bar]´</strong></b>`baz´</body>",
          "bodyInnerHTML": "`foo[´<b><strong>`bar]´</strong></b>`baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo[´<b><strong>`bar]´</strong></b>`baz´</body>"
        },
        "body": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`foo[´<b><strong>`bar]´</strong></b>`baz´",
          "innerHTML": "`foo[´<b><strong>`bar]´</strong></b>`baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo[´<b><strong>`bar]´</strong></b>`baz´</body>",
          "bodyInnerHTML": "`foo[´<b><strong>`bar]´</strong></b>`baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo[´<b><strong>`bar]´</strong></b>`baz´</body>"
        },
        "div": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`foo[´<b><strong>`bar]´</strong></b>`baz´",
          "innerHTML": "`foo[´<b><strong>`bar]´</strong></b>`baz´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\">`foo[´<b><strong>`bar]´</strong></b>`baz´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\">`foo[´<b><strong>`bar]´</strong></b>`baz´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\">`foo[´<b><strong>`bar]´</strong></b>`baz´</div>CAN<br>ARY</body>"
        }
      },
      "B_STRONG-1_SR": {
        "dM": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`foo´<b><strong>`[bar´</strong></b>`]baz´",
          "innerHTML": "`foo´<b><strong>`[bar´</strong></b>`]baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo´<b><strong>`[bar´</strong></b>`]baz´</body>",
          "bodyInnerHTML": "`foo´<b><strong>`[bar´</strong></b>`]baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo´<b><strong>`[bar´</strong></b>`]baz´</body>"
        },
        "body": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`foo´<b><strong>`[bar´</strong></b>`]baz´",
          "innerHTML": "`foo´<b><strong>`[bar´</strong></b>`]baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo´<b><strong>`[bar´</strong></b>`]baz´</body>",
          "bodyInnerHTML": "`foo´<b><strong>`[bar´</strong></b>`]baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo´<b><strong>`[bar´</strong></b>`]baz´</body>"
        },
        "div": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`foo´<b><strong>`[bar´</strong></b>`]baz´",
          "innerHTML": "`foo´<b><strong>`[bar´</strong></b>`]baz´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\">`foo´<b><strong>`[bar´</strong></b>`]baz´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\">`foo´<b><strong>`[bar´</strong></b>`]baz´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\">`foo´<b><strong>`[bar´</strong></b>`]baz´</div>CAN<br>ARY</body>"
        }
      },
      "B_SPANs:fw:b-1_SW": {
        "dM": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`foo´<b><span style=\"font-weight: bold\">`[bar]´</span></b>`baz´",
          "innerHTML": "`foo´<b><span style=\"font-weight: bold\">`[bar]´</span></b>`baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo´<b><span style=\"font-weight: bold\">`[bar]´</span></b>`baz´</body>",
          "bodyInnerHTML": "`foo´<b><span style=\"font-weight: bold\">`[bar]´</span></b>`baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo´<b><span style=\"font-weight: bold\">`[bar]´</span></b>`baz´</body>"
        },
        "body": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`foo´<b><span style=\"font-weight: bold\">`[bar]´</span></b>`baz´",
          "innerHTML": "`foo´<b><span style=\"font-weight: bold\">`[bar]´</span></b>`baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo´<b><span style=\"font-weight: bold\">`[bar]´</span></b>`baz´</body>",
          "bodyInnerHTML": "`foo´<b><span style=\"font-weight: bold\">`[bar]´</span></b>`baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo´<b><span style=\"font-weight: bold\">`[bar]´</span></b>`baz´</body>"
        },
        "div": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`foo´<b><span style=\"font-weight: bold\">`[bar]´</span></b>`baz´",
          "innerHTML": "`foo´<b><span style=\"font-weight: bold\">`[bar]´</span></b>`baz´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\">`foo´<b><span style=\"font-weight: bold\">`[bar]´</span></b>`baz´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\">`foo´<b><span style=\"font-weight: bold\">`[bar]´</span></b>`baz´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\">`foo´<b><span style=\"font-weight: bold\">`[bar]´</span></b>`baz´</div>CAN<br>ARY</body>"
        }
      },
      "B_SPANs:fw:b-1_SO": {
        "dM": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`foo[´<b><span style=\"font-weight: bold\">`bar´</span></b>`]baz´",
          "innerHTML": "`foo[´<b><span style=\"font-weight: bold\">`bar´</span></b>`]baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo[´<b><span style=\"font-weight: bold\">`bar´</span></b>`]baz´</body>",
          "bodyInnerHTML": "`foo[´<b><span style=\"font-weight: bold\">`bar´</span></b>`]baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo[´<b><span style=\"font-weight: bold\">`bar´</span></b>`]baz´</body>"
        },
        "body": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`foo[´<b><span style=\"font-weight: bold\">`bar´</span></b>`]baz´",
          "innerHTML": "`foo[´<b><span style=\"font-weight: bold\">`bar´</span></b>`]baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo[´<b><span style=\"font-weight: bold\">`bar´</span></b>`]baz´</body>",
          "bodyInnerHTML": "`foo[´<b><span style=\"font-weight: bold\">`bar´</span></b>`]baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo[´<b><span style=\"font-weight: bold\">`bar´</span></b>`]baz´</body>"
        },
        "div": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`foo[´<b><span style=\"font-weight: bold\">`bar´</span></b>`]baz´",
          "innerHTML": "`foo[´<b><span style=\"font-weight: bold\">`bar´</span></b>`]baz´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\">`foo[´<b><span style=\"font-weight: bold\">`bar´</span></b>`]baz´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\">`foo[´<b><span style=\"font-weight: bold\">`bar´</span></b>`]baz´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\">`foo[´<b><span style=\"font-weight: bold\">`bar´</span></b>`]baz´</div>CAN<br>ARY</body>"
        }
      },
      "B_SPANs:fw:b-1_SL": {
        "dM": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`foo[´<b><span style=\"font-weight: bold\">`bar]´</span></b>`baz´",
          "innerHTML": "`foo[´<b><span style=\"font-weight: bold\">`bar]´</span></b>`baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo[´<b><span style=\"font-weight: bold\">`bar]´</span></b>`baz´</body>",
          "bodyInnerHTML": "`foo[´<b><span style=\"font-weight: bold\">`bar]´</span></b>`baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo[´<b><span style=\"font-weight: bold\">`bar]´</span></b>`baz´</body>"
        },
        "body": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`foo[´<b><span style=\"font-weight: bold\">`bar]´</span></b>`baz´",
          "innerHTML": "`foo[´<b><span style=\"font-weight: bold\">`bar]´</span></b>`baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo[´<b><span style=\"font-weight: bold\">`bar]´</span></b>`baz´</body>",
          "bodyInnerHTML": "`foo[´<b><span style=\"font-weight: bold\">`bar]´</span></b>`baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo[´<b><span style=\"font-weight: bold\">`bar]´</span></b>`baz´</body>"
        },
        "div": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`foo[´<b><span style=\"font-weight: bold\">`bar]´</span></b>`baz´",
          "innerHTML": "`foo[´<b><span style=\"font-weight: bold\">`bar]´</span></b>`baz´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\">`foo[´<b><span style=\"font-weight: bold\">`bar]´</span></b>`baz´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\">`foo[´<b><span style=\"font-weight: bold\">`bar]´</span></b>`baz´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\">`foo[´<b><span style=\"font-weight: bold\">`bar]´</span></b>`baz´</div>CAN<br>ARY</body>"
        }
      },
      "B_SPANs:fw:b-1_SR": {
        "dM": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`foo´<b><span style=\"font-weight: bold\">`[bar´</span></b>`]baz´",
          "innerHTML": "`foo´<b><span style=\"font-weight: bold\">`[bar´</span></b>`]baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo´<b><span style=\"font-weight: bold\">`[bar´</span></b>`]baz´</body>",
          "bodyInnerHTML": "`foo´<b><span style=\"font-weight: bold\">`[bar´</span></b>`]baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo´<b><span style=\"font-weight: bold\">`[bar´</span></b>`]baz´</body>"
        },
        "body": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`foo´<b><span style=\"font-weight: bold\">`[bar´</span></b>`]baz´",
          "innerHTML": "`foo´<b><span style=\"font-weight: bold\">`[bar´</span></b>`]baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo´<b><span style=\"font-weight: bold\">`[bar´</span></b>`]baz´</body>",
          "bodyInnerHTML": "`foo´<b><span style=\"font-weight: bold\">`[bar´</span></b>`]baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo´<b><span style=\"font-weight: bold\">`[bar´</span></b>`]baz´</body>"
        },
        "div": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`foo´<b><span style=\"font-weight: bold\">`[bar´</span></b>`]baz´",
          "innerHTML": "`foo´<b><span style=\"font-weight: bold\">`[bar´</span></b>`]baz´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\">`foo´<b><span style=\"font-weight: bold\">`[bar´</span></b>`]baz´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\">`foo´<b><span style=\"font-weight: bold\">`[bar´</span></b>`]baz´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\">`foo´<b><span style=\"font-weight: bold\">`[bar´</span></b>`]baz´</div>CAN<br>ARY</body>"
        }
      },
      "B_B-P3-1_SO12": {
        "dM": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 2,
          "output": "{<p>`foo´</p><p>`bar´</p>}<b><p>`baz´</p></b>",
          "innerHTML": "{<p>`foo´</p><p>`bar´</p>}<b><p>`baz´</p></b>",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">{<p>`foo´</p><p>`bar´</p>}<b><p>`baz´</p></b></body>",
          "bodyInnerHTML": "{<p>`foo´</p><p>`bar´</p>}<b><p>`baz´</p></b>",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">{<p>`foo´</p><p>`bar´</p>}<b><p>`baz´</p></b></body>"
        },
        "body": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 2,
          "output": "{<p>`foo´</p><p>`bar´</p>}<b><p>`baz´</p></b>",
          "innerHTML": "{<p>`foo´</p><p>`bar´</p>}<b><p>`baz´</p></b>",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">{<p>`foo´</p><p>`bar´</p>}<b><p>`baz´</p></b></body>",
          "bodyInnerHTML": "{<p>`foo´</p><p>`bar´</p>}<b><p>`baz´</p></b>",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">{<p>`foo´</p><p>`bar´</p>}<b><p>`baz´</p></b></body>"
        },
        "div": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 2,
          "output": "{<p>`foo´</p><p>`bar´</p>}<b><p>`baz´</p></b>",
          "innerHTML": "{<p>`foo´</p><p>`bar´</p>}<b><p>`baz´</p></b>",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\">{<p>`foo´</p><p>`bar´</p>}<b><p>`baz´</p></b></div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\">{<p>`foo´</p><p>`bar´</p>}<b><p>`baz´</p></b></div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\">{<p>`foo´</p><p>`bar´</p>}<b><p>`baz´</p></b></div>CAN<br>ARY</body>"
        }
      },
      "B_B-P-I..P-1_SO-I": {
        "dM": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "<b><p>`foo[´<i>`bar´</i>`]´</p><p>`baz´</p></b>",
          "innerHTML": "<b><p>`foo[´<i>`bar´</i>`]´</p><p>`baz´</p></b>",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\"><b><p>`foo[´<i>`bar´</i>`]´</p><p>`baz´</p></b></body>",
          "bodyInnerHTML": "<b><p>`foo[´<i>`bar´</i>`]´</p><p>`baz´</p></b>",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\"><b><p>`foo[´<i>`bar´</i>`]´</p><p>`baz´</p></b></body>"
        },
        "body": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "<b><p>`foo[´<i>`bar´</i>`]´</p><p>`baz´</p></b>",
          "innerHTML": "<b><p>`foo[´<i>`bar´</i>`]´</p><p>`baz´</p></b>",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\"><b><p>`foo[´<i>`bar´</i>`]´</p><p>`baz´</p></b></body>",
          "bodyInnerHTML": "<b><p>`foo[´<i>`bar´</i>`]´</p><p>`baz´</p></b>",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\"><b><p>`foo[´<i>`bar´</i>`]´</p><p>`baz´</p></b></body>"
        },
        "div": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "<b><p>`foo[´<i>`bar´</i>`]´</p><p>`baz´</p></b>",
          "innerHTML": "<b><p>`foo[´<i>`bar´</i>`]´</p><p>`baz´</p></b>",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\"><b><p>`foo[´<i>`bar´</i>`]´</p><p>`baz´</p></b></div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\"><b><p>`foo[´<i>`bar´</i>`]´</p><p>`baz´</p></b></div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\"><b><p>`foo[´<i>`bar´</i>`]´</p><p>`baz´</p></b></div>CAN<br>ARY</body>"
        }
      },
      "B_B-2_SL": {
        "dM": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`foo [´<b>`bar ´`baz] qoz´</b>` quz sic´",
          "innerHTML": "`foo [´<b>`bar ´`baz] qoz´</b>` quz sic´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo [´<b>`bar ´`baz] qoz´</b>` quz sic´</body>",
          "bodyInnerHTML": "`foo [´<b>`bar ´`baz] qoz´</b>` quz sic´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo [´<b>`bar ´`baz] qoz´</b>` quz sic´</body>"
        },
        "body": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`foo [´<b>`bar ´`baz] qoz´</b>` quz sic´",
          "innerHTML": "`foo [´<b>`bar ´`baz] qoz´</b>` quz sic´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo [´<b>`bar ´`baz] qoz´</b>` quz sic´</body>",
          "bodyInnerHTML": "`foo [´<b>`bar ´`baz] qoz´</b>` quz sic´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo [´<b>`bar ´`baz] qoz´</b>` quz sic´</body>"
        },
        "div": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`foo [´<b>`bar ´`baz] qoz´</b>` quz sic´",
          "innerHTML": "`foo [´<b>`bar ´`baz] qoz´</b>` quz sic´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\">`foo [´<b>`bar ´`baz] qoz´</b>` quz sic´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\">`foo [´<b>`bar ´`baz] qoz´</b>` quz sic´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\">`foo [´<b>`bar ´`baz] qoz´</b>` quz sic´</div>CAN<br>ARY</body>"
        }
      },
      "B_B-2_SR": {
        "dM": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`foo bar ´<b>`baz [qoz´` quz]´</b>` sic´",
          "innerHTML": "`foo bar ´<b>`baz [qoz´` quz]´</b>` sic´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo bar ´<b>`baz [qoz´` quz]´</b>` sic´</body>",
          "bodyInnerHTML": "`foo bar ´<b>`baz [qoz´` quz]´</b>` sic´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo bar ´<b>`baz [qoz´` quz]´</b>` sic´</body>"
        },
        "body": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`foo bar ´<b>`baz [qoz´` quz]´</b>` sic´",
          "innerHTML": "`foo bar ´<b>`baz [qoz´` quz]´</b>` sic´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo bar ´<b>`baz [qoz´` quz]´</b>` sic´</body>",
          "bodyInnerHTML": "`foo bar ´<b>`baz [qoz´` quz]´</b>` sic´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo bar ´<b>`baz [qoz´` quz]´</b>` sic´</body>"
        },
        "div": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`foo bar ´<b>`baz [qoz´` quz]´</b>` sic´",
          "innerHTML": "`foo bar ´<b>`baz [qoz´` quz]´</b>` sic´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\">`foo bar ´<b>`baz [qoz´` quz]´</b>` sic´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\">`foo bar ´<b>`baz [qoz´` quz]´</b>` sic´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\">`foo bar ´<b>`baz [qoz´` quz]´</b>` sic´</div>CAN<br>ARY</body>"
        }
      },
      "I_I-1_SW": {
        "dM": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`foo[bar]baz´",
          "innerHTML": "`foo[bar]baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo[bar]baz´</body>",
          "bodyInnerHTML": "`foo[bar]baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo[bar]baz´</body>"
        },
        "body": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`foo[bar]baz´",
          "innerHTML": "`foo[bar]baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo[bar]baz´</body>",
          "bodyInnerHTML": "`foo[bar]baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo[bar]baz´</body>"
        },
        "div": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`foo´`[bar]´`baz´",
          "innerHTML": "`foo´`[bar]´`baz´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\">`foo´`[bar]´`baz´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\">`foo´`[bar]´`baz´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\">`foo´`[bar]´`baz´</div>CAN<br>ARY</body>"
        }
      },
      "I_I-1_SO": {
        "dM": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`foo[bar]baz´",
          "innerHTML": "`foo[bar]baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo[bar]baz´</body>",
          "bodyInnerHTML": "`foo[bar]baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo[bar]baz´</body>"
        },
        "body": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`foo[bar]baz´",
          "innerHTML": "`foo[bar]baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo[bar]baz´</body>",
          "bodyInnerHTML": "`foo[bar]baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo[bar]baz´</body>"
        },
        "div": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`foo[´`bar´`]baz´",
          "innerHTML": "`foo[´`bar´`]baz´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\">`foo[´`bar´`]baz´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\">`foo[´`bar´`]baz´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\">`foo[´`bar´`]baz´</div>CAN<br>ARY</body>"
        }
      },
      "I_I-1_SL": {
        "dM": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`foo[bar]baz´",
          "innerHTML": "`foo[bar]baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo[bar]baz´</body>",
          "bodyInnerHTML": "`foo[bar]baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo[bar]baz´</body>"
        },
        "body": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`foo[bar]baz´",
          "innerHTML": "`foo[bar]baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo[bar]baz´</body>",
          "bodyInnerHTML": "`foo[bar]baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo[bar]baz´</body>"
        },
        "div": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`foo[´`bar]´`baz´",
          "innerHTML": "`foo[´`bar]´`baz´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\">`foo[´`bar]´`baz´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\">`foo[´`bar]´`baz´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\">`foo[´`bar]´`baz´</div>CAN<br>ARY</body>"
        }
      },
      "I_I-1_SR": {
        "dM": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`foo[bar]baz´",
          "innerHTML": "`foo[bar]baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo[bar]baz´</body>",
          "bodyInnerHTML": "`foo[bar]baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo[bar]baz´</body>"
        },
        "body": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`foo[bar]baz´",
          "innerHTML": "`foo[bar]baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo[bar]baz´</body>",
          "bodyInnerHTML": "`foo[bar]baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo[bar]baz´</body>"
        },
        "div": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`foo´`[bar´`]baz´",
          "innerHTML": "`foo´`[bar´`]baz´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\">`foo´`[bar´`]baz´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\">`foo´`[bar´`]baz´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\">`foo´`[bar´`]baz´</div>CAN<br>ARY</body>"
        }
      },
      "I_EM-1_SW": {
        "dM": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`foo´<i><em>`[bar]´</em></i>`baz´",
          "innerHTML": "`foo´<i><em>`[bar]´</em></i>`baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo´<i><em>`[bar]´</em></i>`baz´</body>",
          "bodyInnerHTML": "`foo´<i><em>`[bar]´</em></i>`baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo´<i><em>`[bar]´</em></i>`baz´</body>"
        },
        "body": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`foo´<i><em>`[bar]´</em></i>`baz´",
          "innerHTML": "`foo´<i><em>`[bar]´</em></i>`baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo´<i><em>`[bar]´</em></i>`baz´</body>",
          "bodyInnerHTML": "`foo´<i><em>`[bar]´</em></i>`baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo´<i><em>`[bar]´</em></i>`baz´</body>"
        },
        "div": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`foo´<i><em>`[bar]´</em></i>`baz´",
          "innerHTML": "`foo´<i><em>`[bar]´</em></i>`baz´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\">`foo´<i><em>`[bar]´</em></i>`baz´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\">`foo´<i><em>`[bar]´</em></i>`baz´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\">`foo´<i><em>`[bar]´</em></i>`baz´</div>CAN<br>ARY</body>"
        }
      },
      "I_EM-1_SO": {
        "dM": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`foo[´<i><em>`bar´</em></i>`]baz´",
          "innerHTML": "`foo[´<i><em>`bar´</em></i>`]baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo[´<i><em>`bar´</em></i>`]baz´</body>",
          "bodyInnerHTML": "`foo[´<i><em>`bar´</em></i>`]baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo[´<i><em>`bar´</em></i>`]baz´</body>"
        },
        "body": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`foo[´<i><em>`bar´</em></i>`]baz´",
          "innerHTML": "`foo[´<i><em>`bar´</em></i>`]baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo[´<i><em>`bar´</em></i>`]baz´</body>",
          "bodyInnerHTML": "`foo[´<i><em>`bar´</em></i>`]baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo[´<i><em>`bar´</em></i>`]baz´</body>"
        },
        "div": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`foo[´<i><em>`bar´</em></i>`]baz´",
          "innerHTML": "`foo[´<i><em>`bar´</em></i>`]baz´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\">`foo[´<i><em>`bar´</em></i>`]baz´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\">`foo[´<i><em>`bar´</em></i>`]baz´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\">`foo[´<i><em>`bar´</em></i>`]baz´</div>CAN<br>ARY</body>"
        }
      },
      "I_EM-1_SL": {
        "dM": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`foo[´<i><em>`bar]´</em></i>`baz´",
          "innerHTML": "`foo[´<i><em>`bar]´</em></i>`baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo[´<i><em>`bar]´</em></i>`baz´</body>",
          "bodyInnerHTML": "`foo[´<i><em>`bar]´</em></i>`baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo[´<i><em>`bar]´</em></i>`baz´</body>"
        },
        "body": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`foo[´<i><em>`bar]´</em></i>`baz´",
          "innerHTML": "`foo[´<i><em>`bar]´</em></i>`baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo[´<i><em>`bar]´</em></i>`baz´</body>",
          "bodyInnerHTML": "`foo[´<i><em>`bar]´</em></i>`baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo[´<i><em>`bar]´</em></i>`baz´</body>"
        },
        "div": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`foo[´<i><em>`bar]´</em></i>`baz´",
          "innerHTML": "`foo[´<i><em>`bar]´</em></i>`baz´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\">`foo[´<i><em>`bar]´</em></i>`baz´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\">`foo[´<i><em>`bar]´</em></i>`baz´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\">`foo[´<i><em>`bar]´</em></i>`baz´</div>CAN<br>ARY</body>"
        }
      },
      "I_EM-1_SR": {
        "dM": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`foo´<i><em>`[bar´</em></i>`]baz´",
          "innerHTML": "`foo´<i><em>`[bar´</em></i>`]baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo´<i><em>`[bar´</em></i>`]baz´</body>",
          "bodyInnerHTML": "`foo´<i><em>`[bar´</em></i>`]baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo´<i><em>`[bar´</em></i>`]baz´</body>"
        },
        "body": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`foo´<i><em>`[bar´</em></i>`]baz´",
          "innerHTML": "`foo´<i><em>`[bar´</em></i>`]baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo´<i><em>`[bar´</em></i>`]baz´</body>",
          "bodyInnerHTML": "`foo´<i><em>`[bar´</em></i>`]baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo´<i><em>`[bar´</em></i>`]baz´</body>"
        },
        "div": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`foo´<i><em>`[bar´</em></i>`]baz´",
          "innerHTML": "`foo´<i><em>`[bar´</em></i>`]baz´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\">`foo´<i><em>`[bar´</em></i>`]baz´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\">`foo´<i><em>`[bar´</em></i>`]baz´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\">`foo´<i><em>`[bar´</em></i>`]baz´</div>CAN<br>ARY</body>"
        }
      },
      "I_SPANs:fs:i-1_SW": {
        "dM": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`foo´<i><span style=\"font-style: italic\">`[bar]´</span></i>`baz´",
          "innerHTML": "`foo´<i><span style=\"font-style: italic\">`[bar]´</span></i>`baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo´<i><span style=\"font-style: italic\">`[bar]´</span></i>`baz´</body>",
          "bodyInnerHTML": "`foo´<i><span style=\"font-style: italic\">`[bar]´</span></i>`baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo´<i><span style=\"font-style: italic\">`[bar]´</span></i>`baz´</body>"
        },
        "body": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`foo´<i><span style=\"font-style: italic\">`[bar]´</span></i>`baz´",
          "innerHTML": "`foo´<i><span style=\"font-style: italic\">`[bar]´</span></i>`baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo´<i><span style=\"font-style: italic\">`[bar]´</span></i>`baz´</body>",
          "bodyInnerHTML": "`foo´<i><span style=\"font-style: italic\">`[bar]´</span></i>`baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo´<i><span style=\"font-style: italic\">`[bar]´</span></i>`baz´</body>"
        },
        "div": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`foo´<i><span style=\"font-style: italic\">`[bar]´</span></i>`baz´",
          "innerHTML": "`foo´<i><span style=\"font-style: italic\">`[bar]´</span></i>`baz´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\">`foo´<i><span style=\"font-style: italic\">`[bar]´</span></i>`baz´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\">`foo´<i><span style=\"font-style: italic\">`[bar]´</span></i>`baz´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\">`foo´<i><span style=\"font-style: italic\">`[bar]´</span></i>`baz´</div>CAN<br>ARY</body>"
        }
      },
      "I_SPANs:fs:i-1_SO": {
        "dM": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`foo[´<i><span style=\"font-style: italic\">`bar´</span></i>`]baz´",
          "innerHTML": "`foo[´<i><span style=\"font-style: italic\">`bar´</span></i>`]baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo[´<i><span style=\"font-style: italic\">`bar´</span></i>`]baz´</body>",
          "bodyInnerHTML": "`foo[´<i><span style=\"font-style: italic\">`bar´</span></i>`]baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo[´<i><span style=\"font-style: italic\">`bar´</span></i>`]baz´</body>"
        },
        "body": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`foo[´<i><span style=\"font-style: italic\">`bar´</span></i>`]baz´",
          "innerHTML": "`foo[´<i><span style=\"font-style: italic\">`bar´</span></i>`]baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo[´<i><span style=\"font-style: italic\">`bar´</span></i>`]baz´</body>",
          "bodyInnerHTML": "`foo[´<i><span style=\"font-style: italic\">`bar´</span></i>`]baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo[´<i><span style=\"font-style: italic\">`bar´</span></i>`]baz´</body>"
        },
        "div": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`foo[´<i><span style=\"font-style: italic\">`bar´</span></i>`]baz´",
          "innerHTML": "`foo[´<i><span style=\"font-style: italic\">`bar´</span></i>`]baz´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\">`foo[´<i><span style=\"font-style: italic\">`bar´</span></i>`]baz´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\">`foo[´<i><span style=\"font-style: italic\">`bar´</span></i>`]baz´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\">`foo[´<i><span style=\"font-style: italic\">`bar´</span></i>`]baz´</div>CAN<br>ARY</body>"
        }
      },
      "I_SPANs:fs:i-1_SL": {
        "dM": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`foo[´<i><span style=\"font-style: italic\">`bar]´</span></i>`baz´",
          "innerHTML": "`foo[´<i><span style=\"font-style: italic\">`bar]´</span></i>`baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo[´<i><span style=\"font-style: italic\">`bar]´</span></i>`baz´</body>",
          "bodyInnerHTML": "`foo[´<i><span style=\"font-style: italic\">`bar]´</span></i>`baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo[´<i><span style=\"font-style: italic\">`bar]´</span></i>`baz´</body>"
        },
        "body": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`foo[´<i><span style=\"font-style: italic\">`bar]´</span></i>`baz´",
          "innerHTML": "`foo[´<i><span style=\"font-style: italic\">`bar]´</span></i>`baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo[´<i><span style=\"font-style: italic\">`bar]´</span></i>`baz´</body>",
          "bodyInnerHTML": "`foo[´<i><span style=\"font-style: italic\">`bar]´</span></i>`baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo[´<i><span style=\"font-style: italic\">`bar]´</span></i>`baz´</body>"
        },
        "div": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`foo[´<i><span style=\"font-style: italic\">`bar]´</span></i>`baz´",
          "innerHTML": "`foo[´<i><span style=\"font-style: italic\">`bar]´</span></i>`baz´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\">`foo[´<i><span style=\"font-style: italic\">`bar]´</span></i>`baz´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\">`foo[´<i><span style=\"font-style: italic\">`bar]´</span></i>`baz´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\">`foo[´<i><span style=\"font-style: italic\">`bar]´</span></i>`baz´</div>CAN<br>ARY</body>"
        }
      },
      "I_SPANs:fs:i-1_SR": {
        "dM": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`foo´<i><span style=\"font-style: italic\">`[bar´</span></i>`]baz´",
          "innerHTML": "`foo´<i><span style=\"font-style: italic\">`[bar´</span></i>`]baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo´<i><span style=\"font-style: italic\">`[bar´</span></i>`]baz´</body>",
          "bodyInnerHTML": "`foo´<i><span style=\"font-style: italic\">`[bar´</span></i>`]baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo´<i><span style=\"font-style: italic\">`[bar´</span></i>`]baz´</body>"
        },
        "body": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`foo´<i><span style=\"font-style: italic\">`[bar´</span></i>`]baz´",
          "innerHTML": "`foo´<i><span style=\"font-style: italic\">`[bar´</span></i>`]baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo´<i><span style=\"font-style: italic\">`[bar´</span></i>`]baz´</body>",
          "bodyInnerHTML": "`foo´<i><span style=\"font-style: italic\">`[bar´</span></i>`]baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo´<i><span style=\"font-style: italic\">`[bar´</span></i>`]baz´</body>"
        },
        "div": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`foo´<i><span style=\"font-style: italic\">`[bar´</span></i>`]baz´",
          "innerHTML": "`foo´<i><span style=\"font-style: italic\">`[bar´</span></i>`]baz´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\">`foo´<i><span style=\"font-style: italic\">`[bar´</span></i>`]baz´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\">`foo´<i><span style=\"font-style: italic\">`[bar´</span></i>`]baz´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\">`foo´<i><span style=\"font-style: italic\">`[bar´</span></i>`]baz´</div>CAN<br>ARY</body>"
        }
      },
      "I_I-P3-1_SO2": {
        "dM": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 2,
          "output": "<i><p>`foo´</p>{</i><p>`bar´</p>}<i><p>`baz´</p></i>",
          "innerHTML": "<i><p>`foo´</p>{</i><p>`bar´</p>}<i><p>`baz´</p></i>",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\"><i><p>`foo´</p>{</i><p>`bar´</p>}<i><p>`baz´</p></i></body>",
          "bodyInnerHTML": "<i><p>`foo´</p>{</i><p>`bar´</p>}<i><p>`baz´</p></i>",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\"><i><p>`foo´</p>{</i><p>`bar´</p>}<i><p>`baz´</p></i></body>"
        },
        "body": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 2,
          "output": "<i><p>`foo´</p>{</i><p>`bar´</p>}<i><p>`baz´</p></i>",
          "innerHTML": "<i><p>`foo´</p>{</i><p>`bar´</p>}<i><p>`baz´</p></i>",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\"><i><p>`foo´</p>{</i><p>`bar´</p>}<i><p>`baz´</p></i></body>",
          "bodyInnerHTML": "<i><p>`foo´</p>{</i><p>`bar´</p>}<i><p>`baz´</p></i>",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\"><i><p>`foo´</p>{</i><p>`bar´</p>}<i><p>`baz´</p></i></body>"
        },
        "div": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 2,
          "output": "<i><p>`foo´</p>{</i><p>`bar´</p>}<i><p>`baz´</p></i>",
          "innerHTML": "<i><p>`foo´</p>{</i><p>`bar´</p>}<i><p>`baz´</p></i>",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\"><i><p>`foo´</p>{</i><p>`bar´</p>}<i><p>`baz´</p></i></div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\"><i><p>`foo´</p>{</i><p>`bar´</p>}<i><p>`baz´</p></i></div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\"><i><p>`foo´</p>{</i><p>`bar´</p>}<i><p>`baz´</p></i></div>CAN<br>ARY</body>"
        }
      },
      "U_U-1_SW": {
        "dM": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`foo[bar]baz´",
          "innerHTML": "`foo[bar]baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo[bar]baz´</body>",
          "bodyInnerHTML": "`foo[bar]baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo[bar]baz´</body>"
        },
        "body": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`foo[bar]baz´",
          "innerHTML": "`foo[bar]baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo[bar]baz´</body>",
          "bodyInnerHTML": "`foo[bar]baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo[bar]baz´</body>"
        },
        "div": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`foo´`[bar]´`baz´",
          "innerHTML": "`foo´`[bar]´`baz´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\">`foo´`[bar]´`baz´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\">`foo´`[bar]´`baz´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\">`foo´`[bar]´`baz´</div>CAN<br>ARY</body>"
        }
      },
      "U_U-1_SO": {
        "dM": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`foo[bar]baz´",
          "innerHTML": "`foo[bar]baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo[bar]baz´</body>",
          "bodyInnerHTML": "`foo[bar]baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo[bar]baz´</body>"
        },
        "body": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`foo[bar]baz´",
          "innerHTML": "`foo[bar]baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo[bar]baz´</body>",
          "bodyInnerHTML": "`foo[bar]baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo[bar]baz´</body>"
        },
        "div": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`foo[´`bar´`]baz´",
          "innerHTML": "`foo[´`bar´`]baz´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\">`foo[´`bar´`]baz´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\">`foo[´`bar´`]baz´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\">`foo[´`bar´`]baz´</div>CAN<br>ARY</body>"
        }
      },
      "U_U-1_SL": {
        "dM": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`foo[bar]baz´",
          "innerHTML": "`foo[bar]baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo[bar]baz´</body>",
          "bodyInnerHTML": "`foo[bar]baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo[bar]baz´</body>"
        },
        "body": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`foo[bar]baz´",
          "innerHTML": "`foo[bar]baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo[bar]baz´</body>",
          "bodyInnerHTML": "`foo[bar]baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo[bar]baz´</body>"
        },
        "div": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`foo[´`bar]´`baz´",
          "innerHTML": "`foo[´`bar]´`baz´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\">`foo[´`bar]´`baz´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\">`foo[´`bar]´`baz´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\">`foo[´`bar]´`baz´</div>CAN<br>ARY</body>"
        }
      },
      "U_U-1_SR": {
        "dM": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`foo[bar]baz´",
          "innerHTML": "`foo[bar]baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo[bar]baz´</body>",
          "bodyInnerHTML": "`foo[bar]baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo[bar]baz´</body>"
        },
        "body": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`foo[bar]baz´",
          "innerHTML": "`foo[bar]baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo[bar]baz´</body>",
          "bodyInnerHTML": "`foo[bar]baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo[bar]baz´</body>"
        },
        "div": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`foo´`[bar´`]baz´",
          "innerHTML": "`foo´`[bar´`]baz´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\">`foo´`[bar´`]baz´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\">`foo´`[bar´`]baz´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\">`foo´`[bar´`]baz´</div>CAN<br>ARY</body>"
        }
      },
      "U_SPANs:td:u-1_SW": {
        "dM": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`foo´<u><span style=\"text-decoration: underline\">`[bar]´</span></u>`baz´",
          "innerHTML": "`foo´<u><span style=\"text-decoration: underline\">`[bar]´</span></u>`baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo´<u><span style=\"text-decoration: underline\">`[bar]´</span></u>`baz´</body>",
          "bodyInnerHTML": "`foo´<u><span style=\"text-decoration: underline\">`[bar]´</span></u>`baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo´<u><span style=\"text-decoration: underline\">`[bar]´</span></u>`baz´</body>"
        },
        "body": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`foo´<u><span style=\"text-decoration: underline\">`[bar]´</span></u>`baz´",
          "innerHTML": "`foo´<u><span style=\"text-decoration: underline\">`[bar]´</span></u>`baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo´<u><span style=\"text-decoration: underline\">`[bar]´</span></u>`baz´</body>",
          "bodyInnerHTML": "`foo´<u><span style=\"text-decoration: underline\">`[bar]´</span></u>`baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo´<u><span style=\"text-decoration: underline\">`[bar]´</span></u>`baz´</body>"
        },
        "div": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`foo´<u><span style=\"text-decoration: underline\">`[bar]´</span></u>`baz´",
          "innerHTML": "`foo´<u><span style=\"text-decoration: underline\">`[bar]´</span></u>`baz´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\">`foo´<u><span style=\"text-decoration: underline\">`[bar]´</span></u>`baz´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\">`foo´<u><span style=\"text-decoration: underline\">`[bar]´</span></u>`baz´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\">`foo´<u><span style=\"text-decoration: underline\">`[bar]´</span></u>`baz´</div>CAN<br>ARY</body>"
        }
      },
      "U_SPANs:td:u-1_SO": {
        "dM": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`foo[´<u><span style=\"text-decoration: underline\">`bar´</span></u>`]baz´",
          "innerHTML": "`foo[´<u><span style=\"text-decoration: underline\">`bar´</span></u>`]baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo[´<u><span style=\"text-decoration: underline\">`bar´</span></u>`]baz´</body>",
          "bodyInnerHTML": "`foo[´<u><span style=\"text-decoration: underline\">`bar´</span></u>`]baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo[´<u><span style=\"text-decoration: underline\">`bar´</span></u>`]baz´</body>"
        },
        "body": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`foo[´<u><span style=\"text-decoration: underline\">`bar´</span></u>`]baz´",
          "innerHTML": "`foo[´<u><span style=\"text-decoration: underline\">`bar´</span></u>`]baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo[´<u><span style=\"text-decoration: underline\">`bar´</span></u>`]baz´</body>",
          "bodyInnerHTML": "`foo[´<u><span style=\"text-decoration: underline\">`bar´</span></u>`]baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo[´<u><span style=\"text-decoration: underline\">`bar´</span></u>`]baz´</body>"
        },
        "div": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`foo[´<u><span style=\"text-decoration: underline\">`bar´</span></u>`]baz´",
          "innerHTML": "`foo[´<u><span style=\"text-decoration: underline\">`bar´</span></u>`]baz´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\">`foo[´<u><span style=\"text-decoration: underline\">`bar´</span></u>`]baz´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\">`foo[´<u><span style=\"text-decoration: underline\">`bar´</span></u>`]baz´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\">`foo[´<u><span style=\"text-decoration: underline\">`bar´</span></u>`]baz´</div>CAN<br>ARY</body>"
        }
      },
      "U_SPANs:td:u-1_SL": {
        "dM": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`foo[´<u><span style=\"text-decoration: underline\">`bar]´</span></u>`baz´",
          "innerHTML": "`foo[´<u><span style=\"text-decoration: underline\">`bar]´</span></u>`baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo[´<u><span style=\"text-decoration: underline\">`bar]´</span></u>`baz´</body>",
          "bodyInnerHTML": "`foo[´<u><span style=\"text-decoration: underline\">`bar]´</span></u>`baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo[´<u><span style=\"text-decoration: underline\">`bar]´</span></u>`baz´</body>"
        },
        "body": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`foo[´<u><span style=\"text-decoration: underline\">`bar]´</span></u>`baz´",
          "innerHTML": "`foo[´<u><span style=\"text-decoration: underline\">`bar]´</span></u>`baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo[´<u><span style=\"text-decoration: underline\">`bar]´</span></u>`baz´</body>",
          "bodyInnerHTML": "`foo[´<u><span style=\"text-decoration: underline\">`bar]´</span></u>`baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo[´<u><span style=\"text-decoration: underline\">`bar]´</span></u>`baz´</body>"
        },
        "div": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`foo[´<u><span style=\"text-decoration: underline\">`bar]´</span></u>`baz´",
          "innerHTML": "`foo[´<u><span style=\"text-decoration: underline\">`bar]´</span></u>`baz´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\">`foo[´<u><span style=\"text-decoration: underline\">`bar]´</span></u>`baz´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\">`foo[´<u><span style=\"text-decoration: underline\">`bar]´</span></u>`baz´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\">`foo[´<u><span style=\"text-decoration: underline\">`bar]´</span></u>`baz´</div>CAN<br>ARY</body>"
        }
      },
      "U_SPANs:td:u-1_SR": {
        "dM": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`foo´<u><span style=\"text-decoration: underline\">`[bar´</span></u>`]baz´",
          "innerHTML": "`foo´<u><span style=\"text-decoration: underline\">`[bar´</span></u>`]baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo´<u><span style=\"text-decoration: underline\">`[bar´</span></u>`]baz´</body>",
          "bodyInnerHTML": "`foo´<u><span style=\"text-decoration: underline\">`[bar´</span></u>`]baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo´<u><span style=\"text-decoration: underline\">`[bar´</span></u>`]baz´</body>"
        },
        "body": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`foo´<u><span style=\"text-decoration: underline\">`[bar´</span></u>`]baz´",
          "innerHTML": "`foo´<u><span style=\"text-decoration: underline\">`[bar´</span></u>`]baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo´<u><span style=\"text-decoration: underline\">`[bar´</span></u>`]baz´</body>",
          "bodyInnerHTML": "`foo´<u><span style=\"text-decoration: underline\">`[bar´</span></u>`]baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo´<u><span style=\"text-decoration: underline\">`[bar´</span></u>`]baz´</body>"
        },
        "div": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`foo´<u><span style=\"text-decoration: underline\">`[bar´</span></u>`]baz´",
          "innerHTML": "`foo´<u><span style=\"text-decoration: underline\">`[bar´</span></u>`]baz´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\">`foo´<u><span style=\"text-decoration: underline\">`[bar´</span></u>`]baz´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\">`foo´<u><span style=\"text-decoration: underline\">`[bar´</span></u>`]baz´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\">`foo´<u><span style=\"text-decoration: underline\">`[bar´</span></u>`]baz´</div>CAN<br>ARY</body>"
        }
      },
      "U_U-S-1_SO": {
        "dM": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 2,
          "output": "<u>`foo[´</u>`bar´<s>`baz´</s>`quoz]´",
          "innerHTML": "<u>`foo[´</u>`bar´<s>`baz´</s>`quoz]´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\"><u>`foo[´</u>`bar´<s>`baz´</s>`quoz]´</body>",
          "bodyInnerHTML": "<u>`foo[´</u>`bar´<s>`baz´</s>`quoz]´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\"><u>`foo[´</u>`bar´<s>`baz´</s>`quoz]´</body>"
        },
        "body": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 2,
          "output": "<u>`foo[´</u>`bar´<s>`baz´</s>`quoz]´",
          "innerHTML": "<u>`foo[´</u>`bar´<s>`baz´</s>`quoz]´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\"><u>`foo[´</u>`bar´<s>`baz´</s>`quoz]´</body>",
          "bodyInnerHTML": "<u>`foo[´</u>`bar´<s>`baz´</s>`quoz]´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\"><u>`foo[´</u>`bar´<s>`baz´</s>`quoz]´</body>"
        },
        "div": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 2,
          "output": "<u>`foo[´</u>`bar´<s>`baz´</s>`quoz]´",
          "innerHTML": "<u>`foo[´</u>`bar´<s>`baz´</s>`quoz]´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\"><u>`foo[´</u>`bar´<s>`baz´</s>`quoz]´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\"><u>`foo[´</u>`bar´<s>`baz´</s>`quoz]´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\"><u>`foo[´</u>`bar´<s>`baz´</s>`quoz]´</div>CAN<br>ARY</body>"
        }
      },
      "U_U-S-2_SI": {
        "dM": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "<u><s>`foo[´</s></u><s>`bar]´</s><u><s>`baz´</s>`quoz´</u>",
          "innerHTML": "<u><s>`foo[´</s></u><s>`bar]´</s><u><s>`baz´</s>`quoz´</u>",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\"><u><s>`foo[´</s></u><s>`bar]´</s><u><s>`baz´</s>`quoz´</u></body>",
          "bodyInnerHTML": "<u><s>`foo[´</s></u><s>`bar]´</s><u><s>`baz´</s>`quoz´</u>",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\"><u><s>`foo[´</s></u><s>`bar]´</s><u><s>`baz´</s>`quoz´</u></body>"
        },
        "body": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "<u><s>`foo[´</s></u><s>`bar]´</s><u><s>`baz´</s>`quoz´</u>",
          "innerHTML": "<u><s>`foo[´</s></u><s>`bar]´</s><u><s>`baz´</s>`quoz´</u>",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\"><u><s>`foo[´</s></u><s>`bar]´</s><u><s>`baz´</s>`quoz´</u></body>",
          "bodyInnerHTML": "<u><s>`foo[´</s></u><s>`bar]´</s><u><s>`baz´</s>`quoz´</u>",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\"><u><s>`foo[´</s></u><s>`bar]´</s><u><s>`baz´</s>`quoz´</u></body>"
        },
        "div": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "<u><s>`foo[´</s></u><s>`bar]´</s><u><s>`baz´</s>`quoz´</u>",
          "innerHTML": "<u><s>`foo[´</s></u><s>`bar]´</s><u><s>`baz´</s>`quoz´</u>",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\"><u><s>`foo[´</s></u><s>`bar]´</s><u><s>`baz´</s>`quoz´</u></div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\"><u><s>`foo[´</s></u><s>`bar]´</s><u><s>`baz´</s>`quoz´</u></div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\"><u><s>`foo[´</s></u><s>`bar]´</s><u><s>`baz´</s>`quoz´</u></div>CAN<br>ARY</body>"
        }
      },
      "U_U-P3-1_SO": {
        "dM": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 2,
          "output": "<u><p>`foo´</p>{</u><p>`bar´</p>}<u><p>`baz´</p></u>",
          "innerHTML": "<u><p>`foo´</p>{</u><p>`bar´</p>}<u><p>`baz´</p></u>",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\"><u><p>`foo´</p>{</u><p>`bar´</p>}<u><p>`baz´</p></u></body>",
          "bodyInnerHTML": "<u><p>`foo´</p>{</u><p>`bar´</p>}<u><p>`baz´</p></u>",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\"><u><p>`foo´</p>{</u><p>`bar´</p>}<u><p>`baz´</p></u></body>"
        },
        "body": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 2,
          "output": "<u><p>`foo´</p>{</u><p>`bar´</p>}<u><p>`baz´</p></u>",
          "innerHTML": "<u><p>`foo´</p>{</u><p>`bar´</p>}<u><p>`baz´</p></u>",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\"><u><p>`foo´</p>{</u><p>`bar´</p>}<u><p>`baz´</p></u></body>",
          "bodyInnerHTML": "<u><p>`foo´</p>{</u><p>`bar´</p>}<u><p>`baz´</p></u>",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\"><u><p>`foo´</p>{</u><p>`bar´</p>}<u><p>`baz´</p></u></body>"
        },
        "div": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 2,
          "output": "<u><p>`foo´</p>{</u><p>`bar´</p>}<u><p>`baz´</p></u>",
          "innerHTML": "<u><p>`foo´</p>{</u><p>`bar´</p>}<u><p>`baz´</p></u>",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\"><u><p>`foo´</p>{</u><p>`bar´</p>}<u><p>`baz´</p></u></div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\"><u><p>`foo´</p>{</u><p>`bar´</p>}<u><p>`baz´</p></u></div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\"><u><p>`foo´</p>{</u><p>`bar´</p>}<u><p>`baz´</p></u></div>CAN<br>ARY</body>"
        }
      },
      "S_S-1_SW": {
        "dM": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`foo´<strike><s>`[bar]´</s></strike>`baz´",
          "innerHTML": "`foo´<strike><s>`[bar]´</s></strike>`baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo´<strike><s>`[bar]´</s></strike>`baz´</body>",
          "bodyInnerHTML": "`foo´<strike><s>`[bar]´</s></strike>`baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo´<strike><s>`[bar]´</s></strike>`baz´</body>"
        },
        "body": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`foo´<strike><s>`[bar]´</s></strike>`baz´",
          "innerHTML": "`foo´<strike><s>`[bar]´</s></strike>`baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo´<strike><s>`[bar]´</s></strike>`baz´</body>",
          "bodyInnerHTML": "`foo´<strike><s>`[bar]´</s></strike>`baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo´<strike><s>`[bar]´</s></strike>`baz´</body>"
        },
        "div": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`foo´<strike><s>`[bar]´</s></strike>`baz´",
          "innerHTML": "`foo´<strike><s>`[bar]´</s></strike>`baz´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\">`foo´<strike><s>`[bar]´</s></strike>`baz´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\">`foo´<strike><s>`[bar]´</s></strike>`baz´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\">`foo´<strike><s>`[bar]´</s></strike>`baz´</div>CAN<br>ARY</body>"
        }
      },
      "S_S-1_SO": {
        "dM": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`foo[´<strike><s>`bar´</s></strike>`]baz´",
          "innerHTML": "`foo[´<strike><s>`bar´</s></strike>`]baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo[´<strike><s>`bar´</s></strike>`]baz´</body>",
          "bodyInnerHTML": "`foo[´<strike><s>`bar´</s></strike>`]baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo[´<strike><s>`bar´</s></strike>`]baz´</body>"
        },
        "body": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`foo[´<strike><s>`bar´</s></strike>`]baz´",
          "innerHTML": "`foo[´<strike><s>`bar´</s></strike>`]baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo[´<strike><s>`bar´</s></strike>`]baz´</body>",
          "bodyInnerHTML": "`foo[´<strike><s>`bar´</s></strike>`]baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo[´<strike><s>`bar´</s></strike>`]baz´</body>"
        },
        "div": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`foo[´<strike><s>`bar´</s></strike>`]baz´",
          "innerHTML": "`foo[´<strike><s>`bar´</s></strike>`]baz´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\">`foo[´<strike><s>`bar´</s></strike>`]baz´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\">`foo[´<strike><s>`bar´</s></strike>`]baz´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\">`foo[´<strike><s>`bar´</s></strike>`]baz´</div>CAN<br>ARY</body>"
        }
      },
      "S_S-1_SL": {
        "dM": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`foo[´<strike><s>`bar]´</s></strike>`baz´",
          "innerHTML": "`foo[´<strike><s>`bar]´</s></strike>`baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo[´<strike><s>`bar]´</s></strike>`baz´</body>",
          "bodyInnerHTML": "`foo[´<strike><s>`bar]´</s></strike>`baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo[´<strike><s>`bar]´</s></strike>`baz´</body>"
        },
        "body": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`foo[´<strike><s>`bar]´</s></strike>`baz´",
          "innerHTML": "`foo[´<strike><s>`bar]´</s></strike>`baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo[´<strike><s>`bar]´</s></strike>`baz´</body>",
          "bodyInnerHTML": "`foo[´<strike><s>`bar]´</s></strike>`baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo[´<strike><s>`bar]´</s></strike>`baz´</body>"
        },
        "div": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`foo[´<strike><s>`bar]´</s></strike>`baz´",
          "innerHTML": "`foo[´<strike><s>`bar]´</s></strike>`baz´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\">`foo[´<strike><s>`bar]´</s></strike>`baz´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\">`foo[´<strike><s>`bar]´</s></strike>`baz´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\">`foo[´<strike><s>`bar]´</s></strike>`baz´</div>CAN<br>ARY</body>"
        }
      },
      "S_S-1_SR": {
        "dM": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`foo´<strike><s>`[bar´</s></strike>`]baz´",
          "innerHTML": "`foo´<strike><s>`[bar´</s></strike>`]baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo´<strike><s>`[bar´</s></strike>`]baz´</body>",
          "bodyInnerHTML": "`foo´<strike><s>`[bar´</s></strike>`]baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo´<strike><s>`[bar´</s></strike>`]baz´</body>"
        },
        "body": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`foo´<strike><s>`[bar´</s></strike>`]baz´",
          "innerHTML": "`foo´<strike><s>`[bar´</s></strike>`]baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo´<strike><s>`[bar´</s></strike>`]baz´</body>",
          "bodyInnerHTML": "`foo´<strike><s>`[bar´</s></strike>`]baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo´<strike><s>`[bar´</s></strike>`]baz´</body>"
        },
        "div": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`foo´<strike><s>`[bar´</s></strike>`]baz´",
          "innerHTML": "`foo´<strike><s>`[bar´</s></strike>`]baz´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\">`foo´<strike><s>`[bar´</s></strike>`]baz´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\">`foo´<strike><s>`[bar´</s></strike>`]baz´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\">`foo´<strike><s>`[bar´</s></strike>`]baz´</div>CAN<br>ARY</body>"
        }
      },
      "S_STRIKE-1_SW": {
        "dM": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`foo[bar]baz´",
          "innerHTML": "`foo[bar]baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo[bar]baz´</body>",
          "bodyInnerHTML": "`foo[bar]baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo[bar]baz´</body>"
        },
        "body": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`foo[bar]baz´",
          "innerHTML": "`foo[bar]baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo[bar]baz´</body>",
          "bodyInnerHTML": "`foo[bar]baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo[bar]baz´</body>"
        },
        "div": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`foo´`[bar]´`baz´",
          "innerHTML": "`foo´`[bar]´`baz´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\">`foo´`[bar]´`baz´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\">`foo´`[bar]´`baz´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\">`foo´`[bar]´`baz´</div>CAN<br>ARY</body>"
        }
      },
      "S_STRIKE-1_SO": {
        "dM": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`foo[bar]baz´",
          "innerHTML": "`foo[bar]baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo[bar]baz´</body>",
          "bodyInnerHTML": "`foo[bar]baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo[bar]baz´</body>"
        },
        "body": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`foo[bar]baz´",
          "innerHTML": "`foo[bar]baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo[bar]baz´</body>",
          "bodyInnerHTML": "`foo[bar]baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo[bar]baz´</body>"
        },
        "div": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`foo[´`bar´`]baz´",
          "innerHTML": "`foo[´`bar´`]baz´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\">`foo[´`bar´`]baz´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\">`foo[´`bar´`]baz´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\">`foo[´`bar´`]baz´</div>CAN<br>ARY</body>"
        }
      },
      "S_STRIKE-1_SL": {
        "dM": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`foo[bar]baz´",
          "innerHTML": "`foo[bar]baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo[bar]baz´</body>",
          "bodyInnerHTML": "`foo[bar]baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo[bar]baz´</body>"
        },
        "body": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`foo[bar]baz´",
          "innerHTML": "`foo[bar]baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo[bar]baz´</body>",
          "bodyInnerHTML": "`foo[bar]baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo[bar]baz´</body>"
        },
        "div": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`foo[´`bar]´`baz´",
          "innerHTML": "`foo[´`bar]´`baz´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\">`foo[´`bar]´`baz´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\">`foo[´`bar]´`baz´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\">`foo[´`bar]´`baz´</div>CAN<br>ARY</body>"
        }
      },
      "S_STRIKE-2_SR": {
        "dM": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`foo[bar]baz´",
          "innerHTML": "`foo[bar]baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo[bar]baz´</body>",
          "bodyInnerHTML": "`foo[bar]baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo[bar]baz´</body>"
        },
        "body": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`foo[bar]baz´",
          "innerHTML": "`foo[bar]baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo[bar]baz´</body>",
          "bodyInnerHTML": "`foo[bar]baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo[bar]baz´</body>"
        },
        "div": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`foo´`[bar´`]baz´",
          "innerHTML": "`foo´`[bar´`]baz´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\">`foo´`[bar´`]baz´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\">`foo´`[bar´`]baz´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\">`foo´`[bar´`]baz´</div>CAN<br>ARY</body>"
        }
      },
      "S_DEL-1_SW": {
        "dM": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`foo´<strike><del>`[bar]´</del></strike>`baz´",
          "innerHTML": "`foo´<strike><del>`[bar]´</del></strike>`baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo´<strike><del>`[bar]´</del></strike>`baz´</body>",
          "bodyInnerHTML": "`foo´<strike><del>`[bar]´</del></strike>`baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo´<strike><del>`[bar]´</del></strike>`baz´</body>"
        },
        "body": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`foo´<strike><del>`[bar]´</del></strike>`baz´",
          "innerHTML": "`foo´<strike><del>`[bar]´</del></strike>`baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo´<strike><del>`[bar]´</del></strike>`baz´</body>",
          "bodyInnerHTML": "`foo´<strike><del>`[bar]´</del></strike>`baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo´<strike><del>`[bar]´</del></strike>`baz´</body>"
        },
        "div": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`foo´<strike><del>`[bar]´</del></strike>`baz´",
          "innerHTML": "`foo´<strike><del>`[bar]´</del></strike>`baz´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\">`foo´<strike><del>`[bar]´</del></strike>`baz´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\">`foo´<strike><del>`[bar]´</del></strike>`baz´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\">`foo´<strike><del>`[bar]´</del></strike>`baz´</div>CAN<br>ARY</body>"
        }
      },
      "S_SPANs:td:lt-1_SW": {
        "dM": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`foo´<strike><span style=\"text-decoration:line-through\">`[bar]´</span></strike>`baz´",
          "innerHTML": "`foo´<strike><span style=\"text-decoration:line-through\">`[bar]´</span></strike>`baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo´<strike><span style=\"text-decoration:line-through\">`[bar]´</span></strike>`baz´</body>",
          "bodyInnerHTML": "`foo´<strike><span style=\"text-decoration:line-through\">`[bar]´</span></strike>`baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo´<strike><span style=\"text-decoration:line-through\">`[bar]´</span></strike>`baz´</body>"
        },
        "body": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`foo´<strike><span style=\"text-decoration:line-through\">`[bar]´</span></strike>`baz´",
          "innerHTML": "`foo´<strike><span style=\"text-decoration:line-through\">`[bar]´</span></strike>`baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo´<strike><span style=\"text-decoration:line-through\">`[bar]´</span></strike>`baz´</body>",
          "bodyInnerHTML": "`foo´<strike><span style=\"text-decoration:line-through\">`[bar]´</span></strike>`baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo´<strike><span style=\"text-decoration:line-through\">`[bar]´</span></strike>`baz´</body>"
        },
        "div": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`foo´<strike><span style=\"text-decoration:line-through\">`[bar]´</span></strike>`baz´",
          "innerHTML": "`foo´<strike><span style=\"text-decoration:line-through\">`[bar]´</span></strike>`baz´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\">`foo´<strike><span style=\"text-decoration:line-through\">`[bar]´</span></strike>`baz´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\">`foo´<strike><span style=\"text-decoration:line-through\">`[bar]´</span></strike>`baz´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\">`foo´<strike><span style=\"text-decoration:line-through\">`[bar]´</span></strike>`baz´</div>CAN<br>ARY</body>"
        }
      },
      "S_SPANs:td:lt-1_SO": {
        "dM": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`foo[´<strike><span style=\"text-decoration:line-through\">`bar´</span></strike>`]baz´",
          "innerHTML": "`foo[´<strike><span style=\"text-decoration:line-through\">`bar´</span></strike>`]baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo[´<strike><span style=\"text-decoration:line-through\">`bar´</span></strike>`]baz´</body>",
          "bodyInnerHTML": "`foo[´<strike><span style=\"text-decoration:line-through\">`bar´</span></strike>`]baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo[´<strike><span style=\"text-decoration:line-through\">`bar´</span></strike>`]baz´</body>"
        },
        "body": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`foo[´<strike><span style=\"text-decoration:line-through\">`bar´</span></strike>`]baz´",
          "innerHTML": "`foo[´<strike><span style=\"text-decoration:line-through\">`bar´</span></strike>`]baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo[´<strike><span style=\"text-decoration:line-through\">`bar´</span></strike>`]baz´</body>",
          "bodyInnerHTML": "`foo[´<strike><span style=\"text-decoration:line-through\">`bar´</span></strike>`]baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo[´<strike><span style=\"text-decoration:line-through\">`bar´</span></strike>`]baz´</body>"
        },
        "div": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`foo[´<strike><span style=\"text-decoration:line-through\">`bar´</span></strike>`]baz´",
          "innerHTML": "`foo[´<strike><span style=\"text-decoration:line-through\">`bar´</span></strike>`]baz´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\">`foo[´<strike><span style=\"text-decoration:line-through\">`bar´</span></strike>`]baz´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\">`foo[´<strike><span style=\"text-decoration:line-through\">`bar´</span></strike>`]baz´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\">`foo[´<strike><span style=\"text-decoration:line-through\">`bar´</span></strike>`]baz´</div>CAN<br>ARY</body>"
        }
      },
      "S_SPANs:td:lt-1_SL": {
        "dM": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`foo[´<strike><span style=\"text-decoration:line-through\">`bar]´</span></strike>`baz´",
          "innerHTML": "`foo[´<strike><span style=\"text-decoration:line-through\">`bar]´</span></strike>`baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo[´<strike><span style=\"text-decoration:line-through\">`bar]´</span></strike>`baz´</body>",
          "bodyInnerHTML": "`foo[´<strike><span style=\"text-decoration:line-through\">`bar]´</span></strike>`baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo[´<strike><span style=\"text-decoration:line-through\">`bar]´</span></strike>`baz´</body>"
        },
        "body": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`foo[´<strike><span style=\"text-decoration:line-through\">`bar]´</span></strike>`baz´",
          "innerHTML": "`foo[´<strike><span style=\"text-decoration:line-through\">`bar]´</span></strike>`baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo[´<strike><span style=\"text-decoration:line-through\">`bar]´</span></strike>`baz´</body>",
          "bodyInnerHTML": "`foo[´<strike><span style=\"text-decoration:line-through\">`bar]´</span></strike>`baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo[´<strike><span style=\"text-decoration:line-through\">`bar]´</span></strike>`baz´</body>"
        },
        "div": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`foo[´<strike><span style=\"text-decoration:line-through\">`bar]´</span></strike>`baz´",
          "innerHTML": "`foo[´<strike><span style=\"text-decoration:line-through\">`bar]´</span></strike>`baz´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\">`foo[´<strike><span style=\"text-decoration:line-through\">`bar]´</span></strike>`baz´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\">`foo[´<strike><span style=\"text-decoration:line-through\">`bar]´</span></strike>`baz´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\">`foo[´<strike><span style=\"text-decoration:line-through\">`bar]´</span></strike>`baz´</div>CAN<br>ARY</body>"
        }
      },
      "S_SPANs:td:lt-1_SR": {
        "dM": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`foo´<strike><span style=\"text-decoration:line-through\">`[bar´</span></strike>`]baz´",
          "innerHTML": "`foo´<strike><span style=\"text-decoration:line-through\">`[bar´</span></strike>`]baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo´<strike><span style=\"text-decoration:line-through\">`[bar´</span></strike>`]baz´</body>",
          "bodyInnerHTML": "`foo´<strike><span style=\"text-decoration:line-through\">`[bar´</span></strike>`]baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo´<strike><span style=\"text-decoration:line-through\">`[bar´</span></strike>`]baz´</body>"
        },
        "body": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`foo´<strike><span style=\"text-decoration:line-through\">`[bar´</span></strike>`]baz´",
          "innerHTML": "`foo´<strike><span style=\"text-decoration:line-through\">`[bar´</span></strike>`]baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo´<strike><span style=\"text-decoration:line-through\">`[bar´</span></strike>`]baz´</body>",
          "bodyInnerHTML": "`foo´<strike><span style=\"text-decoration:line-through\">`[bar´</span></strike>`]baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo´<strike><span style=\"text-decoration:line-through\">`[bar´</span></strike>`]baz´</body>"
        },
        "div": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`foo´<strike><span style=\"text-decoration:line-through\">`[bar´</span></strike>`]baz´",
          "innerHTML": "`foo´<strike><span style=\"text-decoration:line-through\">`[bar´</span></strike>`]baz´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\">`foo´<strike><span style=\"text-decoration:line-through\">`[bar´</span></strike>`]baz´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\">`foo´<strike><span style=\"text-decoration:line-through\">`[bar´</span></strike>`]baz´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\">`foo´<strike><span style=\"text-decoration:line-through\">`[bar´</span></strike>`]baz´</div>CAN<br>ARY</body>"
        }
      },
      "S_S-U-1_SI": {
        "dM": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "<s><u>`foo[´<strike>`bar]´</strike>`baz´</u>`quoz´</s>",
          "innerHTML": "<s><u>`foo[´<strike>`bar]´</strike>`baz´</u>`quoz´</s>",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\"><s><u>`foo[´<strike>`bar]´</strike>`baz´</u>`quoz´</s></body>",
          "bodyInnerHTML": "<s><u>`foo[´<strike>`bar]´</strike>`baz´</u>`quoz´</s>",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\"><s><u>`foo[´<strike>`bar]´</strike>`baz´</u>`quoz´</s></body>"
        },
        "body": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "<s><u>`foo[´<strike>`bar]´</strike>`baz´</u>`quoz´</s>",
          "innerHTML": "<s><u>`foo[´<strike>`bar]´</strike>`baz´</u>`quoz´</s>",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\"><s><u>`foo[´<strike>`bar]´</strike>`baz´</u>`quoz´</s></body>",
          "bodyInnerHTML": "<s><u>`foo[´<strike>`bar]´</strike>`baz´</u>`quoz´</s>",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\"><s><u>`foo[´<strike>`bar]´</strike>`baz´</u>`quoz´</s></body>"
        },
        "div": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "<s><u>`foo[´<strike>`bar]´</strike>`baz´</u>`quoz´</s>",
          "innerHTML": "<s><u>`foo[´<strike>`bar]´</strike>`baz´</u>`quoz´</s>",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\"><s><u>`foo[´<strike>`bar]´</strike>`baz´</u>`quoz´</s></div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\"><s><u>`foo[´<strike>`bar]´</strike>`baz´</u>`quoz´</s></div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\"><s><u>`foo[´<strike>`bar]´</strike>`baz´</u>`quoz´</s></div>CAN<br>ARY</body>"
        }
      },
      "S_U-S-1_SI": {
        "dM": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "<u><s>`foo[´<strike>`bar]´</strike>`baz´</s>`quoz´</u>",
          "innerHTML": "<u><s>`foo[´<strike>`bar]´</strike>`baz´</s>`quoz´</u>",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\"><u><s>`foo[´<strike>`bar]´</strike>`baz´</s>`quoz´</u></body>",
          "bodyInnerHTML": "<u><s>`foo[´<strike>`bar]´</strike>`baz´</s>`quoz´</u>",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\"><u><s>`foo[´<strike>`bar]´</strike>`baz´</s>`quoz´</u></body>"
        },
        "body": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "<u><s>`foo[´<strike>`bar]´</strike>`baz´</s>`quoz´</u>",
          "innerHTML": "<u><s>`foo[´<strike>`bar]´</strike>`baz´</s>`quoz´</u>",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\"><u><s>`foo[´<strike>`bar]´</strike>`baz´</s>`quoz´</u></body>",
          "bodyInnerHTML": "<u><s>`foo[´<strike>`bar]´</strike>`baz´</s>`quoz´</u>",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\"><u><s>`foo[´<strike>`bar]´</strike>`baz´</s>`quoz´</u></body>"
        },
        "div": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "<u><s>`foo[´<strike>`bar]´</strike>`baz´</s>`quoz´</u>",
          "innerHTML": "<u><s>`foo[´<strike>`bar]´</strike>`baz´</s>`quoz´</u>",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\"><u><s>`foo[´<strike>`bar]´</strike>`baz´</s>`quoz´</u></div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\"><u><s>`foo[´<strike>`bar]´</strike>`baz´</s>`quoz´</u></div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\"><u><s>`foo[´<strike>`bar]´</strike>`baz´</s>`quoz´</u></div>CAN<br>ARY</body>"
        }
      },
      "SUB_SUB-1_SW": {
        "dM": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`foo[bar]baz´",
          "innerHTML": "`foo[bar]baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo[bar]baz´</body>",
          "bodyInnerHTML": "`foo[bar]baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo[bar]baz´</body>"
        },
        "body": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`foo[bar]baz´",
          "innerHTML": "`foo[bar]baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo[bar]baz´</body>",
          "bodyInnerHTML": "`foo[bar]baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo[bar]baz´</body>"
        },
        "div": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`foo´`[bar]´`baz´",
          "innerHTML": "`foo´`[bar]´`baz´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\">`foo´`[bar]´`baz´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\">`foo´`[bar]´`baz´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\">`foo´`[bar]´`baz´</div>CAN<br>ARY</body>"
        }
      },
      "SUB_SPANs:va:sub-1_SW": {
        "dM": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`foo´<sub><span style=\"vertical-align: sub\">`[bar]´</span></sub>`baz´",
          "innerHTML": "`foo´<sub><span style=\"vertical-align: sub\">`[bar]´</span></sub>`baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo´<sub><span style=\"vertical-align: sub\">`[bar]´</span></sub>`baz´</body>",
          "bodyInnerHTML": "`foo´<sub><span style=\"vertical-align: sub\">`[bar]´</span></sub>`baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo´<sub><span style=\"vertical-align: sub\">`[bar]´</span></sub>`baz´</body>"
        },
        "body": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`foo´<sub><span style=\"vertical-align: sub\">`[bar]´</span></sub>`baz´",
          "innerHTML": "`foo´<sub><span style=\"vertical-align: sub\">`[bar]´</span></sub>`baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo´<sub><span style=\"vertical-align: sub\">`[bar]´</span></sub>`baz´</body>",
          "bodyInnerHTML": "`foo´<sub><span style=\"vertical-align: sub\">`[bar]´</span></sub>`baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo´<sub><span style=\"vertical-align: sub\">`[bar]´</span></sub>`baz´</body>"
        },
        "div": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`foo´<sub><span style=\"vertical-align: sub\">`[bar]´</span></sub>`baz´",
          "innerHTML": "`foo´<sub><span style=\"vertical-align: sub\">`[bar]´</span></sub>`baz´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\">`foo´<sub><span style=\"vertical-align: sub\">`[bar]´</span></sub>`baz´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\">`foo´<sub><span style=\"vertical-align: sub\">`[bar]´</span></sub>`baz´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\">`foo´<sub><span style=\"vertical-align: sub\">`[bar]´</span></sub>`baz´</div>CAN<br>ARY</body>"
        }
      },
      "SUP_SUP-1_SW": {
        "dM": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`foo[bar]baz´",
          "innerHTML": "`foo[bar]baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo[bar]baz´</body>",
          "bodyInnerHTML": "`foo[bar]baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo[bar]baz´</body>"
        },
        "body": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`foo[bar]baz´",
          "innerHTML": "`foo[bar]baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo[bar]baz´</body>",
          "bodyInnerHTML": "`foo[bar]baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo[bar]baz´</body>"
        },
        "div": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`foo´`[bar]´`baz´",
          "innerHTML": "`foo´`[bar]´`baz´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\">`foo´`[bar]´`baz´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\">`foo´`[bar]´`baz´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\">`foo´`[bar]´`baz´</div>CAN<br>ARY</body>"
        }
      },
      "SUP_SPANs:va:super-1_SW": {
        "dM": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`foo´<sup><span style=\"vertical-align: super\">`[bar]´</span></sup>`baz´",
          "innerHTML": "`foo´<sup><span style=\"vertical-align: super\">`[bar]´</span></sup>`baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo´<sup><span style=\"vertical-align: super\">`[bar]´</span></sup>`baz´</body>",
          "bodyInnerHTML": "`foo´<sup><span style=\"vertical-align: super\">`[bar]´</span></sup>`baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo´<sup><span style=\"vertical-align: super\">`[bar]´</span></sup>`baz´</body>"
        },
        "body": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`foo´<sup><span style=\"vertical-align: super\">`[bar]´</span></sup>`baz´",
          "innerHTML": "`foo´<sup><span style=\"vertical-align: super\">`[bar]´</span></sup>`baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo´<sup><span style=\"vertical-align: super\">`[bar]´</span></sup>`baz´</body>",
          "bodyInnerHTML": "`foo´<sup><span style=\"vertical-align: super\">`[bar]´</span></sup>`baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo´<sup><span style=\"vertical-align: super\">`[bar]´</span></sup>`baz´</body>"
        },
        "div": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`foo´<sup><span style=\"vertical-align: super\">`[bar]´</span></sup>`baz´",
          "innerHTML": "`foo´<sup><span style=\"vertical-align: super\">`[bar]´</span></sup>`baz´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\">`foo´<sup><span style=\"vertical-align: super\">`[bar]´</span></sup>`baz´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\">`foo´<sup><span style=\"vertical-align: super\">`[bar]´</span></sup>`baz´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\">`foo´<sup><span style=\"vertical-align: super\">`[bar]´</span></sup>`baz´</div>CAN<br>ARY</body>"
        }
      },
      "UNLINK_Ahref:url-1_SW": {
        "dM": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`foo[bar]baz´",
          "innerHTML": "`foo[bar]baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo[bar]baz´</body>",
          "bodyInnerHTML": "`foo[bar]baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo[bar]baz´</body>"
        },
        "body": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`foo[bar]baz´",
          "innerHTML": "`foo[bar]baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo[bar]baz´</body>",
          "bodyInnerHTML": "`foo[bar]baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo[bar]baz´</body>"
        },
        "div": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`foo´`[bar]´`baz´",
          "innerHTML": "`foo´`[bar]´`baz´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\">`foo´`[bar]´`baz´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\">`foo´`[bar]´`baz´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\">`foo´`[bar]´`baz´</div>CAN<br>ARY</body>"
        }
      },
      "UNLINK_A-1_SC": {
        "dM": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`foo´<a>`ba^r´</a>`baz´",
          "innerHTML": "`foo´<a>`ba^r´</a>`baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo´<a>`ba^r´</a>`baz´</body>",
          "bodyInnerHTML": "`foo´<a>`ba^r´</a>`baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo´<a>`ba^r´</a>`baz´</body>"
        },
        "body": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`foo´<a>`ba^r´</a>`baz´",
          "innerHTML": "`foo´<a>`ba^r´</a>`baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo´<a>`ba^r´</a>`baz´</body>",
          "bodyInnerHTML": "`foo´<a>`ba^r´</a>`baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo´<a>`ba^r´</a>`baz´</body>"
        },
        "div": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`foo´<a>`ba^r´</a>`baz´",
          "innerHTML": "`foo´<a>`ba^r´</a>`baz´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\">`foo´<a>`ba^r´</a>`baz´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\">`foo´<a>`ba^r´</a>`baz´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\">`foo´<a>`ba^r´</a>`baz´</div>CAN<br>ARY</body>"
        }
      },
      "UNLINK_A-1_SI": {
        "dM": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`foo´<a>`b[a]r´</a>`baz´",
          "innerHTML": "`foo´<a>`b[a]r´</a>`baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo´<a>`b[a]r´</a>`baz´</body>",
          "bodyInnerHTML": "`foo´<a>`b[a]r´</a>`baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo´<a>`b[a]r´</a>`baz´</body>"
        },
        "body": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`foo´<a>`b[a]r´</a>`baz´",
          "innerHTML": "`foo´<a>`b[a]r´</a>`baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo´<a>`b[a]r´</a>`baz´</body>",
          "bodyInnerHTML": "`foo´<a>`b[a]r´</a>`baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo´<a>`b[a]r´</a>`baz´</body>"
        },
        "div": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`foo´<a>`b[a]r´</a>`baz´",
          "innerHTML": "`foo´<a>`b[a]r´</a>`baz´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\">`foo´<a>`b[a]r´</a>`baz´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\">`foo´<a>`b[a]r´</a>`baz´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\">`foo´<a>`b[a]r´</a>`baz´</div>CAN<br>ARY</body>"
        }
      },
      "UNLINK_A-2_SL": {
        "dM": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`foo[ba´<a>`r]ba´</a>`z´",
          "innerHTML": "`foo[ba´<a>`r]ba´</a>`z´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo[ba´<a>`r]ba´</a>`z´</body>",
          "bodyInnerHTML": "`foo[ba´<a>`r]ba´</a>`z´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo[ba´<a>`r]ba´</a>`z´</body>"
        },
        "body": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`foo[ba´<a>`r]ba´</a>`z´",
          "innerHTML": "`foo[ba´<a>`r]ba´</a>`z´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo[ba´<a>`r]ba´</a>`z´</body>",
          "bodyInnerHTML": "`foo[ba´<a>`r]ba´</a>`z´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo[ba´<a>`r]ba´</a>`z´</body>"
        },
        "div": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`foo[ba´<a>`r]ba´</a>`z´",
          "innerHTML": "`foo[ba´<a>`r]ba´</a>`z´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\">`foo[ba´<a>`r]ba´</a>`z´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\">`foo[ba´<a>`r]ba´</a>`z´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\">`foo[ba´<a>`r]ba´</a>`z´</div>CAN<br>ARY</body>"
        }
      },
      "UNLINK_A-3_SR": {
        "dM": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`fo´<a>`o[ba´</a>`r]baz´",
          "innerHTML": "`fo´<a>`o[ba´</a>`r]baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`fo´<a>`o[ba´</a>`r]baz´</body>",
          "bodyInnerHTML": "`fo´<a>`o[ba´</a>`r]baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`fo´<a>`o[ba´</a>`r]baz´</body>"
        },
        "body": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`fo´<a>`o[ba´</a>`r]baz´",
          "innerHTML": "`fo´<a>`o[ba´</a>`r]baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`fo´<a>`o[ba´</a>`r]baz´</body>",
          "bodyInnerHTML": "`fo´<a>`o[ba´</a>`r]baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`fo´<a>`o[ba´</a>`r]baz´</body>"
        },
        "div": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`fo´<a>`o[ba´</a>`r]baz´",
          "innerHTML": "`fo´<a>`o[ba´</a>`r]baz´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\">`fo´<a>`o[ba´</a>`r]baz´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\">`fo´<a>`o[ba´</a>`r]baz´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\">`fo´<a>`o[ba´</a>`r]baz´</div>CAN<br>ARY</body>"
        }
      },
      "UNLINK_As:d:b.fw:b-1_SW": {
        "dM": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`foo´<span style=\"display: block; font-weight: bold\">`[bar]´</span>`baz´",
          "innerHTML": "`foo´<span style=\"display: block; font-weight: bold\">`[bar]´</span>`baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo´<span style=\"display: block; font-weight: bold\">`[bar]´</span>`baz´</body>",
          "bodyInnerHTML": "`foo´<span style=\"display: block; font-weight: bold\">`[bar]´</span>`baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo´<span style=\"display: block; font-weight: bold\">`[bar]´</span>`baz´</body>"
        },
        "body": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`foo´<span style=\"display: block; font-weight: bold\">`[bar]´</span>`baz´",
          "innerHTML": "`foo´<span style=\"display: block; font-weight: bold\">`[bar]´</span>`baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo´<span style=\"display: block; font-weight: bold\">`[bar]´</span>`baz´</body>",
          "bodyInnerHTML": "`foo´<span style=\"display: block; font-weight: bold\">`[bar]´</span>`baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo´<span style=\"display: block; font-weight: bold\">`[bar]´</span>`baz´</body>"
        },
        "div": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`foo´<span style=\"display: block; font-weight: bold\">`[bar]´</span>`baz´",
          "innerHTML": "`foo´<span style=\"display: block; font-weight: bold\">`[bar]´</span>`baz´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\">`foo´<span style=\"display: block; font-weight: bold\">`[bar]´</span>`baz´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\">`foo´<span style=\"display: block; font-weight: bold\">`[bar]´</span>`baz´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\">`foo´<span style=\"display: block; font-weight: bold\">`[bar]´</span>`baz´</div>CAN<br>ARY</body>"
        }
      },
      "UNLINK_A-IMG-1_SO": {
        "dM": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "{<img src=\"pic.jpg\" align=\"right\" height=\"140\" width=\"200\">`abc]´",
          "innerHTML": "{<img src=\"pic.jpg\" align=\"right\" height=\"140\" width=\"200\">`abc]´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">{<img width=\"200\" height=\"140\" align=\"right\" src=\"pic.jpg\">`abc]´</body>",
          "bodyInnerHTML": "{<img src=\"pic.jpg\" align=\"right\" height=\"140\" width=\"200\">`abc]´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">{<img width=\"200\" height=\"140\" align=\"right\" src=\"pic.jpg\">`abc]´</body>"
        },
        "body": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "{<img src=\"pic.jpg\" align=\"right\" height=\"140\" width=\"200\">`abc]´",
          "innerHTML": "{<img src=\"pic.jpg\" align=\"right\" height=\"140\" width=\"200\">`abc]´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">{<img width=\"200\" height=\"140\" align=\"right\" src=\"pic.jpg\">`abc]´</body>",
          "bodyInnerHTML": "{<img src=\"pic.jpg\" align=\"right\" height=\"140\" width=\"200\">`abc]´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">{<img width=\"200\" height=\"140\" align=\"right\" src=\"pic.jpg\">`abc]´</body>"
        },
        "div": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "{<img src=\"pic.jpg\" align=\"right\" height=\"140\" width=\"200\">`abc]´",
          "innerHTML": "{<img src=\"pic.jpg\" align=\"right\" height=\"140\" width=\"200\">`abc]´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\">{<img width=\"200\" height=\"140\" align=\"right\" src=\"pic.jpg\">`abc]´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\">{<img src=\"pic.jpg\" align=\"right\" height=\"140\" width=\"200\">`abc]´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\">{<img width=\"200\" height=\"140\" align=\"right\" src=\"pic.jpg\">`abc]´</div>CAN<br>ARY</body>"
        }
      },
      "OUTDENT_BQ-1_SW": {
        "dM": {
          "valscore": 0,
          "selscore": 1,
          "valresult": 7,
          "selresult": 5,
          "output": "`foo´<br>`[bar]´<br>`baz´",
          "innerHTML": "`foo´<br>`[bar]´<br>`baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo´<br>`[bar]´<br>`baz´</body>",
          "bodyInnerHTML": "`foo´<br>`[bar]´<br>`baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo´<br>`[bar]´<br>`baz´</body>"
        },
        "body": {
          "valscore": 0,
          "selscore": 1,
          "valresult": 7,
          "selresult": 5,
          "output": "`foo´<br>`[bar]´<br>`baz´",
          "innerHTML": "`foo´<br>`[bar]´<br>`baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo´<br>`[bar]´<br>`baz´</body>",
          "bodyInnerHTML": "`foo´<br>`[bar]´<br>`baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo´<br>`[bar]´<br>`baz´</body>"
        },
        "div": {
          "valscore": 0,
          "selscore": 1,
          "valresult": 7,
          "selresult": 5,
          "output": "`foo´<br>`[bar]´<br>`baz´",
          "innerHTML": "`foo´<br>`[bar]´<br>`baz´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\">`foo´<br>`[bar]´<br>`baz´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\">`foo´<br>`[bar]´<br>`baz´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\">`foo´<br>`[bar]´<br>`baz´</div>CAN<br>ARY</body>"
        }
      },
      "OUTDENT_BQ.wibq.s:m:00040.b:n.p:0-1_SW": {
        "dM": {
          "valscore": 0,
          "selscore": 1,
          "valresult": 7,
          "selresult": 5,
          "output": "`foo´<br>`[bar]´<br>`baz´",
          "innerHTML": "`foo´<br>`[bar]´<br>`baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo´<br>`[bar]´<br>`baz´</body>",
          "bodyInnerHTML": "`foo´<br>`[bar]´<br>`baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo´<br>`[bar]´<br>`baz´</body>"
        },
        "body": {
          "valscore": 0,
          "selscore": 1,
          "valresult": 7,
          "selresult": 5,
          "output": "`foo´<br>`[bar]´<br>`baz´",
          "innerHTML": "`foo´<br>`[bar]´<br>`baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo´<br>`[bar]´<br>`baz´</body>",
          "bodyInnerHTML": "`foo´<br>`[bar]´<br>`baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo´<br>`[bar]´<br>`baz´</body>"
        },
        "div": {
          "valscore": 0,
          "selscore": 1,
          "valresult": 7,
          "selresult": 5,
          "output": "`foo´<br>`[bar]´<br>`baz´",
          "innerHTML": "`foo´<br>`[bar]´<br>`baz´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\">`foo´<br>`[bar]´<br>`baz´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\">`foo´<br>`[bar]´<br>`baz´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\">`foo´<br>`[bar]´<br>`baz´</div>CAN<br>ARY</body>"
        }
      },
      "OUTDENT_OL-LI-1_SW": {
        "dM": {
          "valscore": 0,
          "selscore": 1,
          "valresult": 7,
          "selresult": 5,
          "output": "`foo´<br>`[bar]´<br>`baz´",
          "innerHTML": "`foo´<br>`[bar]´<br>`baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo´<br>`[bar]´<br>`baz´</body>",
          "bodyInnerHTML": "`foo´<br>`[bar]´<br>`baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo´<br>`[bar]´<br>`baz´</body>"
        },
        "body": {
          "valscore": 0,
          "selscore": 1,
          "valresult": 7,
          "selresult": 5,
          "output": "`foo´<br>`[bar]´<br>`baz´",
          "innerHTML": "`foo´<br>`[bar]´<br>`baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo´<br>`[bar]´<br>`baz´</body>",
          "bodyInnerHTML": "`foo´<br>`[bar]´<br>`baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo´<br>`[bar]´<br>`baz´</body>"
        },
        "div": {
          "valscore": 0,
          "selscore": 1,
          "valresult": 7,
          "selresult": 5,
          "output": "`foo´<br>`[bar]´<br>`baz´",
          "innerHTML": "`foo´<br>`[bar]´<br>`baz´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\">`foo´<br>`[bar]´<br>`baz´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\">`foo´<br>`[bar]´<br>`baz´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\">`foo´<br>`[bar]´<br>`baz´</div>CAN<br>ARY</body>"
        }
      },
      "OUTDENT_UL-LI-1_SW": {
        "dM": {
          "valscore": 0,
          "selscore": 1,
          "valresult": 7,
          "selresult": 5,
          "output": "`foo´<br>`[bar]´<br>`baz´",
          "innerHTML": "`foo´<br>`[bar]´<br>`baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo´<br>`[bar]´<br>`baz´</body>",
          "bodyInnerHTML": "`foo´<br>`[bar]´<br>`baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo´<br>`[bar]´<br>`baz´</body>"
        },
        "body": {
          "valscore": 0,
          "selscore": 1,
          "valresult": 7,
          "selresult": 5,
          "output": "`foo´<br>`[bar]´<br>`baz´",
          "innerHTML": "`foo´<br>`[bar]´<br>`baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo´<br>`[bar]´<br>`baz´</body>",
          "bodyInnerHTML": "`foo´<br>`[bar]´<br>`baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo´<br>`[bar]´<br>`baz´</body>"
        },
        "div": {
          "valscore": 0,
          "selscore": 1,
          "valresult": 7,
          "selresult": 5,
          "output": "`foo´<br>`[bar]´<br>`baz´",
          "innerHTML": "`foo´<br>`[bar]´<br>`baz´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\">`foo´<br>`[bar]´<br>`baz´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\">`foo´<br>`[bar]´<br>`baz´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\">`foo´<br>`[bar]´<br>`baz´</div>CAN<br>ARY</body>"
        }
      },
      "OUTDENT_DIV-1_SW": {
        "dM": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`foo´<div style=\"margin-left: 40px;\">`[bar]´</div>`baz´",
          "innerHTML": "`foo´<div style=\"margin-left: 40px;\">`[bar]´</div>`baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo´<div style=\"margin-left: 40px;\">`[bar]´</div>`baz´</body>",
          "bodyInnerHTML": "`foo´<div style=\"margin-left: 40px;\">`[bar]´</div>`baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo´<div style=\"margin-left: 40px;\">`[bar]´</div>`baz´</body>"
        },
        "body": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`foo´<div style=\"margin-left: 40px;\">`[bar]´</div>`baz´",
          "innerHTML": "`foo´<div style=\"margin-left: 40px;\">`[bar]´</div>`baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo´<div style=\"margin-left: 40px;\">`[bar]´</div>`baz´</body>",
          "bodyInnerHTML": "`foo´<div style=\"margin-left: 40px;\">`[bar]´</div>`baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo´<div style=\"margin-left: 40px;\">`[bar]´</div>`baz´</body>"
        },
        "div": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`foo´<div style=\"margin-left: 40px;\">`[bar]´</div>`baz´",
          "innerHTML": "`foo´<div style=\"margin-left: 40px;\">`[bar]´</div>`baz´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\">`foo´<div style=\"margin-left: 40px;\">`[bar]´</div>`baz´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\">`foo´<div style=\"margin-left: 40px;\">`[bar]´</div>`baz´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\">`foo´<div style=\"margin-left: 40px;\">`[bar]´</div>`baz´</div>CAN<br>ARY</body>"
        }
      },
      "REMOVEFORMAT_B-1_SW": {
        "dM": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`foo[bar]baz´",
          "innerHTML": "`foo[bar]baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo[bar]baz´</body>",
          "bodyInnerHTML": "`foo[bar]baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo[bar]baz´</body>"
        },
        "body": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`foo[bar]baz´",
          "innerHTML": "`foo[bar]baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo[bar]baz´</body>",
          "bodyInnerHTML": "`foo[bar]baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo[bar]baz´</body>"
        },
        "div": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`foo´`[bar]´`baz´",
          "innerHTML": "`foo´`[bar]´`baz´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\">`foo´`[bar]´`baz´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\">`foo´`[bar]´`baz´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\">`foo´`[bar]´`baz´</div>CAN<br>ARY</body>"
        }
      },
      "REMOVEFORMAT_Ahref:url-1_SW": {
        "dM": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`foo´<a href=\"http://www.goo.gl\">`[bar]´</a>`baz´",
          "innerHTML": "`foo´<a href=\"http://www.goo.gl\">`[bar]´</a>`baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo´<a href=\"http://www.goo.gl\">`[bar]´</a>`baz´</body>",
          "bodyInnerHTML": "`foo´<a href=\"http://www.goo.gl\">`[bar]´</a>`baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo´<a href=\"http://www.goo.gl\">`[bar]´</a>`baz´</body>"
        },
        "body": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`foo´<a href=\"http://www.goo.gl\">`[bar]´</a>`baz´",
          "innerHTML": "`foo´<a href=\"http://www.goo.gl\">`[bar]´</a>`baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo´<a href=\"http://www.goo.gl\">`[bar]´</a>`baz´</body>",
          "bodyInnerHTML": "`foo´<a href=\"http://www.goo.gl\">`[bar]´</a>`baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo´<a href=\"http://www.goo.gl\">`[bar]´</a>`baz´</body>"
        },
        "div": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`foo´<a href=\"http://www.goo.gl\">`[bar]´</a>`baz´",
          "innerHTML": "`foo´<a href=\"http://www.goo.gl\">`[bar]´</a>`baz´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\">`foo´<a href=\"http://www.goo.gl\">`[bar]´</a>`baz´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\">`foo´<a href=\"http://www.goo.gl\">`[bar]´</a>`baz´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\">`foo´<a href=\"http://www.goo.gl\">`[bar]´</a>`baz´</div>CAN<br>ARY</body>"
        }
      },
      "REMOVEFORMAT_TABLE-TBODY-TR-TD-1_SW": {
        "dM": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`foo´<table><tbody><tr><td>`[bar]´</td></tr></tbody></table>`baz´",
          "innerHTML": "`foo´<table><tbody><tr><td>`[bar]´</td></tr></tbody></table>`baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo´<table><tbody><tr><td>`[bar]´</td></tr></tbody></table>`baz´</body>",
          "bodyInnerHTML": "`foo´<table><tbody><tr><td>`[bar]´</td></tr></tbody></table>`baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo´<table><tbody><tr><td>`[bar]´</td></tr></tbody></table>`baz´</body>"
        },
        "body": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`foo´<table><tbody><tr><td>`[bar]´</td></tr></tbody></table>`baz´",
          "innerHTML": "`foo´<table><tbody><tr><td>`[bar]´</td></tr></tbody></table>`baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo´<table><tbody><tr><td>`[bar]´</td></tr></tbody></table>`baz´</body>",
          "bodyInnerHTML": "`foo´<table><tbody><tr><td>`[bar]´</td></tr></tbody></table>`baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo´<table><tbody><tr><td>`[bar]´</td></tr></tbody></table>`baz´</body>"
        },
        "div": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`foo´<table><tbody><tr><td>`[bar]´</td></tr></tbody></table>`baz´",
          "innerHTML": "`foo´<table><tbody><tr><td>`[bar]´</td></tr></tbody></table>`baz´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\">`foo´<table><tbody><tr><td>`[bar]´</td></tr></tbody></table>`baz´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\">`foo´<table><tbody><tr><td>`[bar]´</td></tr></tbody></table>`baz´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\">`foo´<table><tbody><tr><td>`[bar]´</td></tr></tbody></table>`baz´</div>CAN<br>ARY</body>"
        }
      },
      "UNBOOKMARK_An:name-1_SW": {
        "dM": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`foo´<a name=\"bookmark\">`[bar]´</a>`baz´",
          "innerHTML": "`foo´<a name=\"bookmark\">`[bar]´</a>`baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo´<a name=\"bookmark\">`[bar]´</a>`baz´</body>",
          "bodyInnerHTML": "`foo´<a name=\"bookmark\">`[bar]´</a>`baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo´<a name=\"bookmark\">`[bar]´</a>`baz´</body>"
        },
        "body": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`foo´<a name=\"bookmark\">`[bar]´</a>`baz´",
          "innerHTML": "`foo´<a name=\"bookmark\">`[bar]´</a>`baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo´<a name=\"bookmark\">`[bar]´</a>`baz´</body>",
          "bodyInnerHTML": "`foo´<a name=\"bookmark\">`[bar]´</a>`baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo´<a name=\"bookmark\">`[bar]´</a>`baz´</body>"
        },
        "div": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`foo´<a name=\"bookmark\">`[bar]´</a>`baz´",
          "innerHTML": "`foo´<a name=\"bookmark\">`[bar]´</a>`baz´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\">`foo´<a name=\"bookmark\">`[bar]´</a>`baz´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\">`foo´<a name=\"bookmark\">`[bar]´</a>`baz´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\">`foo´<a name=\"bookmark\">`[bar]´</a>`baz´</div>CAN<br>ARY</body>"
        }
      }
    }
  },
  "UC": {
    "Proposed": {
      "B_B-1_SW": {
        "dM": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`foo[bar]baz´",
          "innerHTML": "`foo[bar]baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo[bar]baz´</body>",
          "bodyInnerHTML": "`foo[bar]baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo[bar]baz´</body>"
        },
        "body": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`foo[bar]baz´",
          "innerHTML": "`foo[bar]baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo[bar]baz´</body>",
          "bodyInnerHTML": "`foo[bar]baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo[bar]baz´</body>"
        },
        "div": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`foo´`[bar]´`baz´",
          "innerHTML": "`foo´`[bar]´`baz´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\">`foo´`[bar]´`baz´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\">`foo´`[bar]´`baz´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\">`foo´`[bar]´`baz´</div>CAN<br>ARY</body>"
        }
      },
      "B_B-1_SO": {
        "dM": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`foo[bar]baz´",
          "innerHTML": "`foo[bar]baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo[bar]baz´</body>",
          "bodyInnerHTML": "`foo[bar]baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo[bar]baz´</body>"
        },
        "body": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`foo[bar]baz´",
          "innerHTML": "`foo[bar]baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo[bar]baz´</body>",
          "bodyInnerHTML": "`foo[bar]baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo[bar]baz´</body>"
        },
        "div": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`foo[´`bar´`]baz´",
          "innerHTML": "`foo[´`bar´`]baz´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\">`foo[´`bar´`]baz´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\">`foo[´`bar´`]baz´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\">`foo[´`bar´`]baz´</div>CAN<br>ARY</body>"
        }
      },
      "B_B-1_SL": {
        "dM": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`foo[bar]baz´",
          "innerHTML": "`foo[bar]baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo[bar]baz´</body>",
          "bodyInnerHTML": "`foo[bar]baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo[bar]baz´</body>"
        },
        "body": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`foo[bar]baz´",
          "innerHTML": "`foo[bar]baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo[bar]baz´</body>",
          "bodyInnerHTML": "`foo[bar]baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo[bar]baz´</body>"
        },
        "div": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`foo[´`bar]´`baz´",
          "innerHTML": "`foo[´`bar]´`baz´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\">`foo[´`bar]´`baz´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\">`foo[´`bar]´`baz´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\">`foo[´`bar]´`baz´</div>CAN<br>ARY</body>"
        }
      },
      "B_B-1_SR": {
        "dM": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`foo[bar]baz´",
          "innerHTML": "`foo[bar]baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo[bar]baz´</body>",
          "bodyInnerHTML": "`foo[bar]baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo[bar]baz´</body>"
        },
        "body": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`foo[bar]baz´",
          "innerHTML": "`foo[bar]baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo[bar]baz´</body>",
          "bodyInnerHTML": "`foo[bar]baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo[bar]baz´</body>"
        },
        "div": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`foo´`[bar´`]baz´",
          "innerHTML": "`foo´`[bar´`]baz´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\">`foo´`[bar´`]baz´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\">`foo´`[bar´`]baz´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\">`foo´`[bar´`]baz´</div>CAN<br>ARY</body>"
        }
      },
      "B_STRONG-1_SW": {
        "dM": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`foo´<strong style=\"font-weight: normal;\">`[bar]´</strong>`baz´",
          "innerHTML": "`foo´<strong style=\"font-weight: normal;\">`[bar]´</strong>`baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo´<strong style=\"font-weight: normal;\">`[bar]´</strong>`baz´</body>",
          "bodyInnerHTML": "`foo´<strong style=\"font-weight: normal;\">`[bar]´</strong>`baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo´<strong style=\"font-weight: normal;\">`[bar]´</strong>`baz´</body>"
        },
        "body": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`foo´<strong style=\"font-weight: normal;\">`[bar]´</strong>`baz´",
          "innerHTML": "`foo´<strong style=\"font-weight: normal;\">`[bar]´</strong>`baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo´<strong style=\"font-weight: normal;\">`[bar]´</strong>`baz´</body>",
          "bodyInnerHTML": "`foo´<strong style=\"font-weight: normal;\">`[bar]´</strong>`baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo´<strong style=\"font-weight: normal;\">`[bar]´</strong>`baz´</body>"
        },
        "div": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`foo´<strong style=\"font-weight: normal;\">`[bar]´</strong>`baz´",
          "innerHTML": "`foo´<strong style=\"font-weight: normal;\">`[bar]´</strong>`baz´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\">`foo´<strong style=\"font-weight: normal;\">`[bar]´</strong>`baz´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\">`foo´<strong style=\"font-weight: normal;\">`[bar]´</strong>`baz´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\">`foo´<strong style=\"font-weight: normal;\">`[bar]´</strong>`baz´</div>CAN<br>ARY</body>"
        }
      },
      "B_STRONG-1_SO": {
        "dM": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`foo[´<strong style=\"font-weight: normal;\">`bar´</strong>`]baz´",
          "innerHTML": "`foo[´<strong style=\"font-weight: normal;\">`bar´</strong>`]baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo[´<strong style=\"font-weight: normal;\">`bar´</strong>`]baz´</body>",
          "bodyInnerHTML": "`foo[´<strong style=\"font-weight: normal;\">`bar´</strong>`]baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo[´<strong style=\"font-weight: normal;\">`bar´</strong>`]baz´</body>"
        },
        "body": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`foo[´<strong style=\"font-weight: normal;\">`bar´</strong>`]baz´",
          "innerHTML": "`foo[´<strong style=\"font-weight: normal;\">`bar´</strong>`]baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo[´<strong style=\"font-weight: normal;\">`bar´</strong>`]baz´</body>",
          "bodyInnerHTML": "`foo[´<strong style=\"font-weight: normal;\">`bar´</strong>`]baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo[´<strong style=\"font-weight: normal;\">`bar´</strong>`]baz´</body>"
        },
        "div": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`foo[´<strong style=\"font-weight: normal;\">`bar´</strong>`]baz´",
          "innerHTML": "`foo[´<strong style=\"font-weight: normal;\">`bar´</strong>`]baz´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\">`foo[´<strong style=\"font-weight: normal;\">`bar´</strong>`]baz´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\">`foo[´<strong style=\"font-weight: normal;\">`bar´</strong>`]baz´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\">`foo[´<strong style=\"font-weight: normal;\">`bar´</strong>`]baz´</div>CAN<br>ARY</body>"
        }
      },
      "B_STRONG-1_SL": {
        "dM": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`foo[´<strong style=\"font-weight: normal;\">`bar]´</strong>`baz´",
          "innerHTML": "`foo[´<strong style=\"font-weight: normal;\">`bar]´</strong>`baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo[´<strong style=\"font-weight: normal;\">`bar]´</strong>`baz´</body>",
          "bodyInnerHTML": "`foo[´<strong style=\"font-weight: normal;\">`bar]´</strong>`baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo[´<strong style=\"font-weight: normal;\">`bar]´</strong>`baz´</body>"
        },
        "body": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`foo[´<strong style=\"font-weight: normal;\">`bar]´</strong>`baz´",
          "innerHTML": "`foo[´<strong style=\"font-weight: normal;\">`bar]´</strong>`baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo[´<strong style=\"font-weight: normal;\">`bar]´</strong>`baz´</body>",
          "bodyInnerHTML": "`foo[´<strong style=\"font-weight: normal;\">`bar]´</strong>`baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo[´<strong style=\"font-weight: normal;\">`bar]´</strong>`baz´</body>"
        },
        "div": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`foo[´<strong style=\"font-weight: normal;\">`bar]´</strong>`baz´",
          "innerHTML": "`foo[´<strong style=\"font-weight: normal;\">`bar]´</strong>`baz´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\">`foo[´<strong style=\"font-weight: normal;\">`bar]´</strong>`baz´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\">`foo[´<strong style=\"font-weight: normal;\">`bar]´</strong>`baz´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\">`foo[´<strong style=\"font-weight: normal;\">`bar]´</strong>`baz´</div>CAN<br>ARY</body>"
        }
      },
      "B_STRONG-1_SR": {
        "dM": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`foo´<strong style=\"font-weight: normal;\">`[bar´</strong>`]baz´",
          "innerHTML": "`foo´<strong style=\"font-weight: normal;\">`[bar´</strong>`]baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo´<strong style=\"font-weight: normal;\">`[bar´</strong>`]baz´</body>",
          "bodyInnerHTML": "`foo´<strong style=\"font-weight: normal;\">`[bar´</strong>`]baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo´<strong style=\"font-weight: normal;\">`[bar´</strong>`]baz´</body>"
        },
        "body": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`foo´<strong style=\"font-weight: normal;\">`[bar´</strong>`]baz´",
          "innerHTML": "`foo´<strong style=\"font-weight: normal;\">`[bar´</strong>`]baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo´<strong style=\"font-weight: normal;\">`[bar´</strong>`]baz´</body>",
          "bodyInnerHTML": "`foo´<strong style=\"font-weight: normal;\">`[bar´</strong>`]baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo´<strong style=\"font-weight: normal;\">`[bar´</strong>`]baz´</body>"
        },
        "div": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`foo´<strong style=\"font-weight: normal;\">`[bar´</strong>`]baz´",
          "innerHTML": "`foo´<strong style=\"font-weight: normal;\">`[bar´</strong>`]baz´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\">`foo´<strong style=\"font-weight: normal;\">`[bar´</strong>`]baz´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\">`foo´<strong style=\"font-weight: normal;\">`[bar´</strong>`]baz´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\">`foo´<strong style=\"font-weight: normal;\">`[bar´</strong>`]baz´</div>CAN<br>ARY</body>"
        }
      },
      "B_SPANs:fw:b-1_SW": {
        "dM": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`foo[bar]baz´",
          "innerHTML": "`foo[bar]baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo[bar]baz´</body>",
          "bodyInnerHTML": "`foo[bar]baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo[bar]baz´</body>"
        },
        "body": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`foo[bar]baz´",
          "innerHTML": "`foo[bar]baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo[bar]baz´</body>",
          "bodyInnerHTML": "`foo[bar]baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo[bar]baz´</body>"
        },
        "div": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`foo´`[bar]´`baz´",
          "innerHTML": "`foo´`[bar]´`baz´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\">`foo´`[bar]´`baz´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\">`foo´`[bar]´`baz´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\">`foo´`[bar]´`baz´</div>CAN<br>ARY</body>"
        }
      },
      "B_SPANs:fw:b-1_SO": {
        "dM": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`foo[bar]baz´",
          "innerHTML": "`foo[bar]baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo[bar]baz´</body>",
          "bodyInnerHTML": "`foo[bar]baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo[bar]baz´</body>"
        },
        "body": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`foo[bar]baz´",
          "innerHTML": "`foo[bar]baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo[bar]baz´</body>",
          "bodyInnerHTML": "`foo[bar]baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo[bar]baz´</body>"
        },
        "div": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`foo[´`bar´`]baz´",
          "innerHTML": "`foo[´`bar´`]baz´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\">`foo[´`bar´`]baz´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\">`foo[´`bar´`]baz´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\">`foo[´`bar´`]baz´</div>CAN<br>ARY</body>"
        }
      },
      "B_SPANs:fw:b-1_SL": {
        "dM": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`foo[bar]baz´",
          "innerHTML": "`foo[bar]baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo[bar]baz´</body>",
          "bodyInnerHTML": "`foo[bar]baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo[bar]baz´</body>"
        },
        "body": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`foo[bar]baz´",
          "innerHTML": "`foo[bar]baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo[bar]baz´</body>",
          "bodyInnerHTML": "`foo[bar]baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo[bar]baz´</body>"
        },
        "div": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`foo[´`bar]´`baz´",
          "innerHTML": "`foo[´`bar]´`baz´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\">`foo[´`bar]´`baz´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\">`foo[´`bar]´`baz´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\">`foo[´`bar]´`baz´</div>CAN<br>ARY</body>"
        }
      },
      "B_SPANs:fw:b-1_SR": {
        "dM": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`foo[bar]baz´",
          "innerHTML": "`foo[bar]baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo[bar]baz´</body>",
          "bodyInnerHTML": "`foo[bar]baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo[bar]baz´</body>"
        },
        "body": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`foo[bar]baz´",
          "innerHTML": "`foo[bar]baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo[bar]baz´</body>",
          "bodyInnerHTML": "`foo[bar]baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo[bar]baz´</body>"
        },
        "div": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`foo´`[bar´`]baz´",
          "innerHTML": "`foo´`[bar´`]baz´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\">`foo´`[bar´`]baz´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\">`foo´`[bar´`]baz´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\">`foo´`[bar´`]baz´</div>CAN<br>ARY</body>"
        }
      },
      "I_I-1_SW": {
        "dM": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`foo[bar]baz´",
          "innerHTML": "`foo[bar]baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo[bar]baz´</body>",
          "bodyInnerHTML": "`foo[bar]baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo[bar]baz´</body>"
        },
        "body": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`foo[bar]baz´",
          "innerHTML": "`foo[bar]baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo[bar]baz´</body>",
          "bodyInnerHTML": "`foo[bar]baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo[bar]baz´</body>"
        },
        "div": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`foo´`[bar]´`baz´",
          "innerHTML": "`foo´`[bar]´`baz´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\">`foo´`[bar]´`baz´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\">`foo´`[bar]´`baz´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\">`foo´`[bar]´`baz´</div>CAN<br>ARY</body>"
        }
      },
      "I_I-1_SO": {
        "dM": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`foo[bar]baz´",
          "innerHTML": "`foo[bar]baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo[bar]baz´</body>",
          "bodyInnerHTML": "`foo[bar]baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo[bar]baz´</body>"
        },
        "body": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`foo[bar]baz´",
          "innerHTML": "`foo[bar]baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo[bar]baz´</body>",
          "bodyInnerHTML": "`foo[bar]baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo[bar]baz´</body>"
        },
        "div": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`foo[´`bar´`]baz´",
          "innerHTML": "`foo[´`bar´`]baz´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\">`foo[´`bar´`]baz´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\">`foo[´`bar´`]baz´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\">`foo[´`bar´`]baz´</div>CAN<br>ARY</body>"
        }
      },
      "I_I-1_SL": {
        "dM": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`foo[bar]baz´",
          "innerHTML": "`foo[bar]baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo[bar]baz´</body>",
          "bodyInnerHTML": "`foo[bar]baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo[bar]baz´</body>"
        },
        "body": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`foo[bar]baz´",
          "innerHTML": "`foo[bar]baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo[bar]baz´</body>",
          "bodyInnerHTML": "`foo[bar]baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo[bar]baz´</body>"
        },
        "div": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`foo[´`bar]´`baz´",
          "innerHTML": "`foo[´`bar]´`baz´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\">`foo[´`bar]´`baz´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\">`foo[´`bar]´`baz´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\">`foo[´`bar]´`baz´</div>CAN<br>ARY</body>"
        }
      },
      "I_I-1_SR": {
        "dM": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`foo[bar]baz´",
          "innerHTML": "`foo[bar]baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo[bar]baz´</body>",
          "bodyInnerHTML": "`foo[bar]baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo[bar]baz´</body>"
        },
        "body": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`foo[bar]baz´",
          "innerHTML": "`foo[bar]baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo[bar]baz´</body>",
          "bodyInnerHTML": "`foo[bar]baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo[bar]baz´</body>"
        },
        "div": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`foo´`[bar´`]baz´",
          "innerHTML": "`foo´`[bar´`]baz´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\">`foo´`[bar´`]baz´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\">`foo´`[bar´`]baz´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\">`foo´`[bar´`]baz´</div>CAN<br>ARY</body>"
        }
      },
      "I_EM-1_SW": {
        "dM": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`foo´<em>`[bar]´</em>`baz´",
          "innerHTML": "`foo´<em>`[bar]´</em>`baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo´<em>`[bar]´</em>`baz´</body>",
          "bodyInnerHTML": "`foo´<em>`[bar]´</em>`baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo´<em>`[bar]´</em>`baz´</body>"
        },
        "body": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`foo´<em>`[bar]´</em>`baz´",
          "innerHTML": "`foo´<em>`[bar]´</em>`baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo´<em>`[bar]´</em>`baz´</body>",
          "bodyInnerHTML": "`foo´<em>`[bar]´</em>`baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo´<em>`[bar]´</em>`baz´</body>"
        },
        "div": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`foo´<em>`[bar]´</em>`baz´",
          "innerHTML": "`foo´<em>`[bar]´</em>`baz´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\">`foo´<em>`[bar]´</em>`baz´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\">`foo´<em>`[bar]´</em>`baz´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\">`foo´<em>`[bar]´</em>`baz´</div>CAN<br>ARY</body>"
        }
      },
      "I_EM-1_SO": {
        "dM": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`foo[´<em>`bar´</em>`]baz´",
          "innerHTML": "`foo[´<em>`bar´</em>`]baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo[´<em>`bar´</em>`]baz´</body>",
          "bodyInnerHTML": "`foo[´<em>`bar´</em>`]baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo[´<em>`bar´</em>`]baz´</body>"
        },
        "body": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`foo[´<em>`bar´</em>`]baz´",
          "innerHTML": "`foo[´<em>`bar´</em>`]baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo[´<em>`bar´</em>`]baz´</body>",
          "bodyInnerHTML": "`foo[´<em>`bar´</em>`]baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo[´<em>`bar´</em>`]baz´</body>"
        },
        "div": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`foo[´<em>`bar´</em>`]baz´",
          "innerHTML": "`foo[´<em>`bar´</em>`]baz´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\">`foo[´<em>`bar´</em>`]baz´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\">`foo[´<em>`bar´</em>`]baz´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\">`foo[´<em>`bar´</em>`]baz´</div>CAN<br>ARY</body>"
        }
      },
      "I_EM-1_SL": {
        "dM": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`foo[´<em>`bar]´</em>`baz´",
          "innerHTML": "`foo[´<em>`bar]´</em>`baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo[´<em>`bar]´</em>`baz´</body>",
          "bodyInnerHTML": "`foo[´<em>`bar]´</em>`baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo[´<em>`bar]´</em>`baz´</body>"
        },
        "body": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`foo[´<em>`bar]´</em>`baz´",
          "innerHTML": "`foo[´<em>`bar]´</em>`baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo[´<em>`bar]´</em>`baz´</body>",
          "bodyInnerHTML": "`foo[´<em>`bar]´</em>`baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo[´<em>`bar]´</em>`baz´</body>"
        },
        "div": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`foo[´<em>`bar]´</em>`baz´",
          "innerHTML": "`foo[´<em>`bar]´</em>`baz´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\">`foo[´<em>`bar]´</em>`baz´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\">`foo[´<em>`bar]´</em>`baz´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\">`foo[´<em>`bar]´</em>`baz´</div>CAN<br>ARY</body>"
        }
      },
      "I_EM-1_SR": {
        "dM": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`foo´<em>`[bar´</em>`]baz´",
          "innerHTML": "`foo´<em>`[bar´</em>`]baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo´<em>`[bar´</em>`]baz´</body>",
          "bodyInnerHTML": "`foo´<em>`[bar´</em>`]baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo´<em>`[bar´</em>`]baz´</body>"
        },
        "body": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`foo´<em>`[bar´</em>`]baz´",
          "innerHTML": "`foo´<em>`[bar´</em>`]baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo´<em>`[bar´</em>`]baz´</body>",
          "bodyInnerHTML": "`foo´<em>`[bar´</em>`]baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo´<em>`[bar´</em>`]baz´</body>"
        },
        "div": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`foo´<em>`[bar´</em>`]baz´",
          "innerHTML": "`foo´<em>`[bar´</em>`]baz´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\">`foo´<em>`[bar´</em>`]baz´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\">`foo´<em>`[bar´</em>`]baz´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\">`foo´<em>`[bar´</em>`]baz´</div>CAN<br>ARY</body>"
        }
      },
      "I_SPANs:fs:i-1_SW": {
        "dM": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`foo[bar]baz´",
          "innerHTML": "`foo[bar]baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo[bar]baz´</body>",
          "bodyInnerHTML": "`foo[bar]baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo[bar]baz´</body>"
        },
        "body": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`foo[bar]baz´",
          "innerHTML": "`foo[bar]baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo[bar]baz´</body>",
          "bodyInnerHTML": "`foo[bar]baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo[bar]baz´</body>"
        },
        "div": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`foo´`[bar]´`baz´",
          "innerHTML": "`foo´`[bar]´`baz´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\">`foo´`[bar]´`baz´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\">`foo´`[bar]´`baz´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\">`foo´`[bar]´`baz´</div>CAN<br>ARY</body>"
        }
      },
      "I_SPANs:fs:i-1_SO": {
        "dM": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`foo[bar]baz´",
          "innerHTML": "`foo[bar]baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo[bar]baz´</body>",
          "bodyInnerHTML": "`foo[bar]baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo[bar]baz´</body>"
        },
        "body": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`foo[bar]baz´",
          "innerHTML": "`foo[bar]baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo[bar]baz´</body>",
          "bodyInnerHTML": "`foo[bar]baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo[bar]baz´</body>"
        },
        "div": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`foo[´`bar´`]baz´",
          "innerHTML": "`foo[´`bar´`]baz´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\">`foo[´`bar´`]baz´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\">`foo[´`bar´`]baz´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\">`foo[´`bar´`]baz´</div>CAN<br>ARY</body>"
        }
      },
      "I_SPANs:fs:i-1_SL": {
        "dM": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`foo[bar]baz´",
          "innerHTML": "`foo[bar]baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo[bar]baz´</body>",
          "bodyInnerHTML": "`foo[bar]baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo[bar]baz´</body>"
        },
        "body": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`foo[bar]baz´",
          "innerHTML": "`foo[bar]baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo[bar]baz´</body>",
          "bodyInnerHTML": "`foo[bar]baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo[bar]baz´</body>"
        },
        "div": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`foo[´`bar]´`baz´",
          "innerHTML": "`foo[´`bar]´`baz´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\">`foo[´`bar]´`baz´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\">`foo[´`bar]´`baz´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\">`foo[´`bar]´`baz´</div>CAN<br>ARY</body>"
        }
      },
      "I_SPANs:fs:i-1_SR": {
        "dM": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`foo[bar]baz´",
          "innerHTML": "`foo[bar]baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo[bar]baz´</body>",
          "bodyInnerHTML": "`foo[bar]baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo[bar]baz´</body>"
        },
        "body": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`foo[bar]baz´",
          "innerHTML": "`foo[bar]baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo[bar]baz´</body>",
          "bodyInnerHTML": "`foo[bar]baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo[bar]baz´</body>"
        },
        "div": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`foo´`[bar´`]baz´",
          "innerHTML": "`foo´`[bar´`]baz´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\">`foo´`[bar´`]baz´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\">`foo´`[bar´`]baz´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\">`foo´`[bar´`]baz´</div>CAN<br>ARY</body>"
        }
      },
      "U_U-1_SW": {
        "dM": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`foo[bar]baz´",
          "innerHTML": "`foo[bar]baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo[bar]baz´</body>",
          "bodyInnerHTML": "`foo[bar]baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo[bar]baz´</body>"
        },
        "body": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`foo[bar]baz´",
          "innerHTML": "`foo[bar]baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo[bar]baz´</body>",
          "bodyInnerHTML": "`foo[bar]baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo[bar]baz´</body>"
        },
        "div": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`foo´`[bar]´`baz´",
          "innerHTML": "`foo´`[bar]´`baz´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\">`foo´`[bar]´`baz´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\">`foo´`[bar]´`baz´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\">`foo´`[bar]´`baz´</div>CAN<br>ARY</body>"
        }
      },
      "U_U-1_SO": {
        "dM": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`foo[bar]baz´",
          "innerHTML": "`foo[bar]baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo[bar]baz´</body>",
          "bodyInnerHTML": "`foo[bar]baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo[bar]baz´</body>"
        },
        "body": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`foo[bar]baz´",
          "innerHTML": "`foo[bar]baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo[bar]baz´</body>",
          "bodyInnerHTML": "`foo[bar]baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo[bar]baz´</body>"
        },
        "div": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`foo[´`bar´`]baz´",
          "innerHTML": "`foo[´`bar´`]baz´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\">`foo[´`bar´`]baz´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\">`foo[´`bar´`]baz´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\">`foo[´`bar´`]baz´</div>CAN<br>ARY</body>"
        }
      },
      "U_U-1_SL": {
        "dM": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`foo[bar]baz´",
          "innerHTML": "`foo[bar]baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo[bar]baz´</body>",
          "bodyInnerHTML": "`foo[bar]baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo[bar]baz´</body>"
        },
        "body": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`foo[bar]baz´",
          "innerHTML": "`foo[bar]baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo[bar]baz´</body>",
          "bodyInnerHTML": "`foo[bar]baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo[bar]baz´</body>"
        },
        "div": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`foo[´`bar]´`baz´",
          "innerHTML": "`foo[´`bar]´`baz´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\">`foo[´`bar]´`baz´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\">`foo[´`bar]´`baz´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\">`foo[´`bar]´`baz´</div>CAN<br>ARY</body>"
        }
      },
      "U_U-1_SR": {
        "dM": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`foo[bar]baz´",
          "innerHTML": "`foo[bar]baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo[bar]baz´</body>",
          "bodyInnerHTML": "`foo[bar]baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo[bar]baz´</body>"
        },
        "body": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`foo[bar]baz´",
          "innerHTML": "`foo[bar]baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo[bar]baz´</body>",
          "bodyInnerHTML": "`foo[bar]baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo[bar]baz´</body>"
        },
        "div": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`foo´`[bar´`]baz´",
          "innerHTML": "`foo´`[bar´`]baz´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\">`foo´`[bar´`]baz´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\">`foo´`[bar´`]baz´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\">`foo´`[bar´`]baz´</div>CAN<br>ARY</body>"
        }
      },
      "U_SPANs:td:u-1_SW": {
        "dM": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`foo[bar]baz´",
          "innerHTML": "`foo[bar]baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo[bar]baz´</body>",
          "bodyInnerHTML": "`foo[bar]baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo[bar]baz´</body>"
        },
        "body": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`foo[bar]baz´",
          "innerHTML": "`foo[bar]baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo[bar]baz´</body>",
          "bodyInnerHTML": "`foo[bar]baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo[bar]baz´</body>"
        },
        "div": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`foo´`[bar]´`baz´",
          "innerHTML": "`foo´`[bar]´`baz´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\">`foo´`[bar]´`baz´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\">`foo´`[bar]´`baz´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\">`foo´`[bar]´`baz´</div>CAN<br>ARY</body>"
        }
      },
      "U_SPANs:td:u-1_SO": {
        "dM": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`foo[bar]baz´",
          "innerHTML": "`foo[bar]baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo[bar]baz´</body>",
          "bodyInnerHTML": "`foo[bar]baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo[bar]baz´</body>"
        },
        "body": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`foo[bar]baz´",
          "innerHTML": "`foo[bar]baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo[bar]baz´</body>",
          "bodyInnerHTML": "`foo[bar]baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo[bar]baz´</body>"
        },
        "div": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`foo[´`bar´`]baz´",
          "innerHTML": "`foo[´`bar´`]baz´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\">`foo[´`bar´`]baz´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\">`foo[´`bar´`]baz´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\">`foo[´`bar´`]baz´</div>CAN<br>ARY</body>"
        }
      },
      "U_SPANs:td:u-1_SL": {
        "dM": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`foo[bar]baz´",
          "innerHTML": "`foo[bar]baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo[bar]baz´</body>",
          "bodyInnerHTML": "`foo[bar]baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo[bar]baz´</body>"
        },
        "body": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`foo[bar]baz´",
          "innerHTML": "`foo[bar]baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo[bar]baz´</body>",
          "bodyInnerHTML": "`foo[bar]baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo[bar]baz´</body>"
        },
        "div": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`foo[´`bar]´`baz´",
          "innerHTML": "`foo[´`bar]´`baz´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\">`foo[´`bar]´`baz´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\">`foo[´`bar]´`baz´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\">`foo[´`bar]´`baz´</div>CAN<br>ARY</body>"
        }
      },
      "U_SPANs:td:u-1_SR": {
        "dM": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`foo[bar]baz´",
          "innerHTML": "`foo[bar]baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo[bar]baz´</body>",
          "bodyInnerHTML": "`foo[bar]baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo[bar]baz´</body>"
        },
        "body": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`foo[bar]baz´",
          "innerHTML": "`foo[bar]baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo[bar]baz´</body>",
          "bodyInnerHTML": "`foo[bar]baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo[bar]baz´</body>"
        },
        "div": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`foo´`[bar´`]baz´",
          "innerHTML": "`foo´`[bar´`]baz´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\">`foo´`[bar´`]baz´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\">`foo´`[bar´`]baz´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\">`foo´`[bar´`]baz´</div>CAN<br>ARY</body>"
        }
      },
      "S_S-1_SW": {
        "dM": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`foo´<s>`[bar]´</s>`baz´",
          "innerHTML": "`foo´<s>`[bar]´</s>`baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo´<s>`[bar]´</s>`baz´</body>",
          "bodyInnerHTML": "`foo´<s>`[bar]´</s>`baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo´<s>`[bar]´</s>`baz´</body>"
        },
        "body": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`foo´<s>`[bar]´</s>`baz´",
          "innerHTML": "`foo´<s>`[bar]´</s>`baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo´<s>`[bar]´</s>`baz´</body>",
          "bodyInnerHTML": "`foo´<s>`[bar]´</s>`baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo´<s>`[bar]´</s>`baz´</body>"
        },
        "div": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`foo´<s>`[bar]´</s>`baz´",
          "innerHTML": "`foo´<s>`[bar]´</s>`baz´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\">`foo´<s>`[bar]´</s>`baz´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\">`foo´<s>`[bar]´</s>`baz´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\">`foo´<s>`[bar]´</s>`baz´</div>CAN<br>ARY</body>"
        }
      },
      "S_S-1_SO": {
        "dM": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`foo[´<s>`bar´</s>`]baz´",
          "innerHTML": "`foo[´<s>`bar´</s>`]baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo[´<s>`bar´</s>`]baz´</body>",
          "bodyInnerHTML": "`foo[´<s>`bar´</s>`]baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo[´<s>`bar´</s>`]baz´</body>"
        },
        "body": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`foo[´<s>`bar´</s>`]baz´",
          "innerHTML": "`foo[´<s>`bar´</s>`]baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo[´<s>`bar´</s>`]baz´</body>",
          "bodyInnerHTML": "`foo[´<s>`bar´</s>`]baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo[´<s>`bar´</s>`]baz´</body>"
        },
        "div": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`foo[´<s>`bar´</s>`]baz´",
          "innerHTML": "`foo[´<s>`bar´</s>`]baz´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\">`foo[´<s>`bar´</s>`]baz´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\">`foo[´<s>`bar´</s>`]baz´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\">`foo[´<s>`bar´</s>`]baz´</div>CAN<br>ARY</body>"
        }
      },
      "S_S-1_SL": {
        "dM": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`foo[´<s>`bar]´</s>`baz´",
          "innerHTML": "`foo[´<s>`bar]´</s>`baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo[´<s>`bar]´</s>`baz´</body>",
          "bodyInnerHTML": "`foo[´<s>`bar]´</s>`baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo[´<s>`bar]´</s>`baz´</body>"
        },
        "body": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`foo[´<s>`bar]´</s>`baz´",
          "innerHTML": "`foo[´<s>`bar]´</s>`baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo[´<s>`bar]´</s>`baz´</body>",
          "bodyInnerHTML": "`foo[´<s>`bar]´</s>`baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo[´<s>`bar]´</s>`baz´</body>"
        },
        "div": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`foo[´<s>`bar]´</s>`baz´",
          "innerHTML": "`foo[´<s>`bar]´</s>`baz´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\">`foo[´<s>`bar]´</s>`baz´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\">`foo[´<s>`bar]´</s>`baz´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\">`foo[´<s>`bar]´</s>`baz´</div>CAN<br>ARY</body>"
        }
      },
      "S_S-1_SR": {
        "dM": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`foo´<s>`[bar´</s>`]baz´",
          "innerHTML": "`foo´<s>`[bar´</s>`]baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo´<s>`[bar´</s>`]baz´</body>",
          "bodyInnerHTML": "`foo´<s>`[bar´</s>`]baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo´<s>`[bar´</s>`]baz´</body>"
        },
        "body": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`foo´<s>`[bar´</s>`]baz´",
          "innerHTML": "`foo´<s>`[bar´</s>`]baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo´<s>`[bar´</s>`]baz´</body>",
          "bodyInnerHTML": "`foo´<s>`[bar´</s>`]baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo´<s>`[bar´</s>`]baz´</body>"
        },
        "div": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`foo´<s>`[bar´</s>`]baz´",
          "innerHTML": "`foo´<s>`[bar´</s>`]baz´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\">`foo´<s>`[bar´</s>`]baz´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\">`foo´<s>`[bar´</s>`]baz´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\">`foo´<s>`[bar´</s>`]baz´</div>CAN<br>ARY</body>"
        }
      },
      "S_STRIKE-1_SW": {
        "dM": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`foo[bar]baz´",
          "innerHTML": "`foo[bar]baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo[bar]baz´</body>",
          "bodyInnerHTML": "`foo[bar]baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo[bar]baz´</body>"
        },
        "body": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`foo[bar]baz´",
          "innerHTML": "`foo[bar]baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo[bar]baz´</body>",
          "bodyInnerHTML": "`foo[bar]baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo[bar]baz´</body>"
        },
        "div": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`foo´`[bar]´`baz´",
          "innerHTML": "`foo´`[bar]´`baz´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\">`foo´`[bar]´`baz´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\">`foo´`[bar]´`baz´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\">`foo´`[bar]´`baz´</div>CAN<br>ARY</body>"
        }
      },
      "S_STRIKE-1_SO": {
        "dM": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`foo[bar]baz´",
          "innerHTML": "`foo[bar]baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo[bar]baz´</body>",
          "bodyInnerHTML": "`foo[bar]baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo[bar]baz´</body>"
        },
        "body": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`foo[bar]baz´",
          "innerHTML": "`foo[bar]baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo[bar]baz´</body>",
          "bodyInnerHTML": "`foo[bar]baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo[bar]baz´</body>"
        },
        "div": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`foo[´`bar´`]baz´",
          "innerHTML": "`foo[´`bar´`]baz´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\">`foo[´`bar´`]baz´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\">`foo[´`bar´`]baz´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\">`foo[´`bar´`]baz´</div>CAN<br>ARY</body>"
        }
      },
      "S_STRIKE-1_SL": {
        "dM": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`foo[bar]baz´",
          "innerHTML": "`foo[bar]baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo[bar]baz´</body>",
          "bodyInnerHTML": "`foo[bar]baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo[bar]baz´</body>"
        },
        "body": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`foo[bar]baz´",
          "innerHTML": "`foo[bar]baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo[bar]baz´</body>",
          "bodyInnerHTML": "`foo[bar]baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo[bar]baz´</body>"
        },
        "div": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`foo[´`bar]´`baz´",
          "innerHTML": "`foo[´`bar]´`baz´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\">`foo[´`bar]´`baz´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\">`foo[´`bar]´`baz´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\">`foo[´`bar]´`baz´</div>CAN<br>ARY</body>"
        }
      },
      "S_STRIKE-1_SR": {
        "dM": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`foo[bar]baz´",
          "innerHTML": "`foo[bar]baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo[bar]baz´</body>",
          "bodyInnerHTML": "`foo[bar]baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo[bar]baz´</body>"
        },
        "body": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`foo[bar]baz´",
          "innerHTML": "`foo[bar]baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo[bar]baz´</body>",
          "bodyInnerHTML": "`foo[bar]baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo[bar]baz´</body>"
        },
        "div": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`foo´`[bar´`]baz´",
          "innerHTML": "`foo´`[bar´`]baz´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\">`foo´`[bar´`]baz´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\">`foo´`[bar´`]baz´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\">`foo´`[bar´`]baz´</div>CAN<br>ARY</body>"
        }
      },
      "S_SPANs:td:lt-1_SW": {
        "dM": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`foo[bar]baz´",
          "innerHTML": "`foo[bar]baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo[bar]baz´</body>",
          "bodyInnerHTML": "`foo[bar]baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo[bar]baz´</body>"
        },
        "body": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`foo[bar]baz´",
          "innerHTML": "`foo[bar]baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo[bar]baz´</body>",
          "bodyInnerHTML": "`foo[bar]baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo[bar]baz´</body>"
        },
        "div": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`foo´`[bar]´`baz´",
          "innerHTML": "`foo´`[bar]´`baz´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\">`foo´`[bar]´`baz´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\">`foo´`[bar]´`baz´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\">`foo´`[bar]´`baz´</div>CAN<br>ARY</body>"
        }
      },
      "S_SPANs:td:lt-1_SO": {
        "dM": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`foo[bar]baz´",
          "innerHTML": "`foo[bar]baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo[bar]baz´</body>",
          "bodyInnerHTML": "`foo[bar]baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo[bar]baz´</body>"
        },
        "body": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`foo[bar]baz´",
          "innerHTML": "`foo[bar]baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo[bar]baz´</body>",
          "bodyInnerHTML": "`foo[bar]baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo[bar]baz´</body>"
        },
        "div": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`foo[´`bar´`]baz´",
          "innerHTML": "`foo[´`bar´`]baz´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\">`foo[´`bar´`]baz´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\">`foo[´`bar´`]baz´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\">`foo[´`bar´`]baz´</div>CAN<br>ARY</body>"
        }
      },
      "S_SPANs:td:lt-1_SL": {
        "dM": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`foo[bar]baz´",
          "innerHTML": "`foo[bar]baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo[bar]baz´</body>",
          "bodyInnerHTML": "`foo[bar]baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo[bar]baz´</body>"
        },
        "body": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`foo[bar]baz´",
          "innerHTML": "`foo[bar]baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo[bar]baz´</body>",
          "bodyInnerHTML": "`foo[bar]baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo[bar]baz´</body>"
        },
        "div": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`foo[´`bar]´`baz´",
          "innerHTML": "`foo[´`bar]´`baz´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\">`foo[´`bar]´`baz´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\">`foo[´`bar]´`baz´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\">`foo[´`bar]´`baz´</div>CAN<br>ARY</body>"
        }
      },
      "S_SPANs:td:lt-1_SR": {
        "dM": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`foo[bar]baz´",
          "innerHTML": "`foo[bar]baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo[bar]baz´</body>",
          "bodyInnerHTML": "`foo[bar]baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo[bar]baz´</body>"
        },
        "body": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`foo[bar]baz´",
          "innerHTML": "`foo[bar]baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo[bar]baz´</body>",
          "bodyInnerHTML": "`foo[bar]baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo[bar]baz´</body>"
        },
        "div": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`foo´`[bar´`]baz´",
          "innerHTML": "`foo´`[bar´`]baz´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\">`foo´`[bar´`]baz´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\">`foo´`[bar´`]baz´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\">`foo´`[bar´`]baz´</div>CAN<br>ARY</body>"
        }
      },
      "S_SPANc:s-1_SW": {
        "dM": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`foo´<span class=\"s\">`[bar]´</span>`baz´",
          "innerHTML": "`foo´<span class=\"s\">`[bar]´</span>`baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo´<span class=\"s\">`[bar]´</span>`baz´</body>",
          "bodyInnerHTML": "`foo´<span class=\"s\">`[bar]´</span>`baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo´<span class=\"s\">`[bar]´</span>`baz´</body>"
        },
        "body": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`foo´<span class=\"s\">`[bar]´</span>`baz´",
          "innerHTML": "`foo´<span class=\"s\">`[bar]´</span>`baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo´<span class=\"s\">`[bar]´</span>`baz´</body>",
          "bodyInnerHTML": "`foo´<span class=\"s\">`[bar]´</span>`baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo´<span class=\"s\">`[bar]´</span>`baz´</body>"
        },
        "div": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`foo´<span class=\"s\">`[bar]´</span>`baz´",
          "innerHTML": "`foo´<span class=\"s\">`[bar]´</span>`baz´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\">`foo´<span class=\"s\">`[bar]´</span>`baz´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\">`foo´<span class=\"s\">`[bar]´</span>`baz´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\">`foo´<span class=\"s\">`[bar]´</span>`baz´</div>CAN<br>ARY</body>"
        }
      },
      "S_SPANc:s-2_SI": {
        "dM": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "<span class=\"s\">`foo[bar]baz´</span>",
          "innerHTML": "<span class=\"s\">`foo[bar]baz´</span>",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\"><span class=\"s\">`foo[bar]baz´</span></body>",
          "bodyInnerHTML": "<span class=\"s\">`foo[bar]baz´</span>",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\"><span class=\"s\">`foo[bar]baz´</span></body>"
        },
        "body": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "<span class=\"s\">`foo[bar]baz´</span>",
          "innerHTML": "<span class=\"s\">`foo[bar]baz´</span>",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\"><span class=\"s\">`foo[bar]baz´</span></body>",
          "bodyInnerHTML": "<span class=\"s\">`foo[bar]baz´</span>",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\"><span class=\"s\">`foo[bar]baz´</span></body>"
        },
        "div": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "<span class=\"s\">`foo[bar]baz´</span>",
          "innerHTML": "<span class=\"s\">`foo[bar]baz´</span>",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\"><span class=\"s\">`foo[bar]baz´</span></div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\"><span class=\"s\">`foo[bar]baz´</span></div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\"><span class=\"s\">`foo[bar]baz´</span></div>CAN<br>ARY</body>"
        }
      }
    }
  },
  "D": {
    "Proposed": {
      "CHAR-1_SC": {
        "dM": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`fo^barbaz´",
          "innerHTML": "`fo^barbaz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`fo^barbaz´</body>",
          "bodyInnerHTML": "`fo^barbaz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`fo^barbaz´</body>"
        },
        "body": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`fo^barbaz´",
          "innerHTML": "`fo^barbaz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`fo^barbaz´</body>",
          "bodyInnerHTML": "`fo^barbaz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`fo^barbaz´</body>"
        },
        "div": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`fo^barbaz´",
          "innerHTML": "`fo^barbaz´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\">`fo^barbaz´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\">`fo^barbaz´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\">`fo^barbaz´</div>CAN<br>ARY</body>"
        }
      },
      "CHAR-2_SC": {
        "dM": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`fo^barbaz´",
          "innerHTML": "`fo^barbaz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`fo^barbaz´</body>",
          "bodyInnerHTML": "`fo^barbaz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`fo^barbaz´</body>"
        },
        "body": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`fo^barbaz´",
          "innerHTML": "`fo^barbaz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`fo^barbaz´</body>",
          "bodyInnerHTML": "`fo^barbaz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`fo^barbaz´</body>"
        },
        "div": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`fo^barbaz´",
          "innerHTML": "`fo^barbaz´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\">`fo^barbaz´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\">`fo^barbaz´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\">`fo^barbaz´</div>CAN<br>ARY</body>"
        }
      },
      "CHAR-3_SC": {
        "dM": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`foo^barbaz´",
          "innerHTML": "`foo^barbaz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo^barbaz´</body>",
          "bodyInnerHTML": "`foo^barbaz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo^barbaz´</body>"
        },
        "body": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`foo^barbaz´",
          "innerHTML": "`foo^barbaz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo^barbaz´</body>",
          "bodyInnerHTML": "`foo^barbaz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo^barbaz´</body>"
        },
        "div": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`foo^barbaz´",
          "innerHTML": "`foo^barbaz´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\">`foo^barbaz´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\">`foo^barbaz´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\">`foo^barbaz´</div>CAN<br>ARY</body>"
        }
      },
      "CHAR-4_SC": {
        "dM": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`foo^barbaz´",
          "innerHTML": "`foo^barbaz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo^barbaz´</body>",
          "bodyInnerHTML": "`foo^barbaz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo^barbaz´</body>"
        },
        "body": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`foo^barbaz´",
          "innerHTML": "`foo^barbaz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo^barbaz´</body>",
          "bodyInnerHTML": "`foo^barbaz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo^barbaz´</body>"
        },
        "div": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`foo^barbaz´",
          "innerHTML": "`foo^barbaz´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\">`foo^barbaz´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\">`foo^barbaz´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\">`foo^barbaz´</div>CAN<br>ARY</body>"
        }
      },
      "CHAR-5_SC": {
        "dM": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`foö^barbaz´",
          "innerHTML": "`foö^barbaz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foö^barbaz´</body>",
          "bodyInnerHTML": "`foö^barbaz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foö^barbaz´</body>"
        },
        "body": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`foö^barbaz´",
          "innerHTML": "`foö^barbaz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foö^barbaz´</body>",
          "bodyInnerHTML": "`foö^barbaz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foö^barbaz´</body>"
        },
        "div": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`foö^barbaz´",
          "innerHTML": "`foö^barbaz´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\">`foö^barbaz´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\">`foö^barbaz´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\">`foö^barbaz´</div>CAN<br>ARY</body>"
        }
      },
      "CHAR-5_SI-1": {
        "dM": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`foo^̤barbaz´",
          "innerHTML": "`foo^̤barbaz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo^̤barbaz´</body>",
          "bodyInnerHTML": "`foo^̤barbaz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo^̤barbaz´</body>"
        },
        "body": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`foo^̤barbaz´",
          "innerHTML": "`foo^̤barbaz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo^̤barbaz´</body>",
          "bodyInnerHTML": "`foo^̤barbaz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo^̤barbaz´</body>"
        },
        "div": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`foo^̤barbaz´",
          "innerHTML": "`foo^̤barbaz´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\">`foo^̤barbaz´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\">`foo^̤barbaz´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\">`foo^̤barbaz´</div>CAN<br>ARY</body>"
        }
      },
      "CHAR-5_SI-2": {
        "dM": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`foö^barbaz´",
          "innerHTML": "`foö^barbaz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foö^barbaz´</body>",
          "bodyInnerHTML": "`foö^barbaz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foö^barbaz´</body>"
        },
        "body": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`foö^barbaz´",
          "innerHTML": "`foö^barbaz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foö^barbaz´</body>",
          "bodyInnerHTML": "`foö^barbaz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foö^barbaz´</body>"
        },
        "div": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`foö^barbaz´",
          "innerHTML": "`foö^barbaz´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\">`foö^barbaz´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\">`foö^barbaz´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\">`foö^barbaz´</div>CAN<br>ARY</body>"
        }
      },
      "CHAR-5_SR": {
        "dM": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`foö^baz´",
          "innerHTML": "`foö^baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foö^baz´</body>",
          "bodyInnerHTML": "`foö^baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foö^baz´</body>"
        },
        "body": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`foö^baz´",
          "innerHTML": "`foö^baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foö^baz´</body>",
          "bodyInnerHTML": "`foö^baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foö^baz´</body>"
        },
        "div": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`foö^baz´",
          "innerHTML": "`foö^baz´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\">`foö^baz´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\">`foö^baz´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\">`foö^baz´</div>CAN<br>ARY</body>"
        }
      },
      "CHAR-6_SC": {
        "dM": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`foo^barbaz´",
          "innerHTML": "`foo^barbaz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo^barbaz´</body>",
          "bodyInnerHTML": "`foo^barbaz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo^barbaz´</body>"
        },
        "body": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`foo^barbaz´",
          "innerHTML": "`foo^barbaz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo^barbaz´</body>",
          "bodyInnerHTML": "`foo^barbaz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo^barbaz´</body>"
        },
        "div": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`foo^barbaz´",
          "innerHTML": "`foo^barbaz´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\">`foo^barbaz´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\">`foo^barbaz´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\">`foo^barbaz´</div>CAN<br>ARY</body>"
        }
      },
      "CHAR-7_SC": {
        "dM": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`foo^barbaz´",
          "innerHTML": "`foo^barbaz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo^barbaz´</body>",
          "bodyInnerHTML": "`foo^barbaz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo^barbaz´</body>"
        },
        "body": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`foo^barbaz´",
          "innerHTML": "`foo^barbaz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo^barbaz´</body>",
          "bodyInnerHTML": "`foo^barbaz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo^barbaz´</body>"
        },
        "div": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`foo^barbaz´",
          "innerHTML": "`foo^barbaz´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\">`foo^barbaz´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\">`foo^barbaz´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\">`foo^barbaz´</div>CAN<br>ARY</body>"
        }
      },
      "TEXT-1_SI": {
        "dM": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`foo^baz´",
          "innerHTML": "`foo^baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo^baz´</body>",
          "bodyInnerHTML": "`foo^baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo^baz´</body>"
        },
        "body": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`foo^baz´",
          "innerHTML": "`foo^baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo^baz´</body>",
          "bodyInnerHTML": "`foo^baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo^baz´</body>"
        },
        "div": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`foo^baz´",
          "innerHTML": "`foo^baz´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\">`foo^baz´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\">`foo^baz´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\">`foo^baz´</div>CAN<br>ARY</body>"
        }
      },
      "B-1_SS": {
        "dM": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`fo^´<b>`bar´</b>`baz´",
          "innerHTML": "`fo^´<b>`bar´</b>`baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`fo^´<b>`bar´</b>`baz´</body>",
          "bodyInnerHTML": "`fo^´<b>`bar´</b>`baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`fo^´<b>`bar´</b>`baz´</body>"
        },
        "body": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`fo^´<b>`bar´</b>`baz´",
          "innerHTML": "`fo^´<b>`bar´</b>`baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`fo^´<b>`bar´</b>`baz´</body>",
          "bodyInnerHTML": "`fo^´<b>`bar´</b>`baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`fo^´<b>`bar´</b>`baz´</body>"
        },
        "div": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`fo^´<b>`bar´</b>`baz´",
          "innerHTML": "`fo^´<b>`bar´</b>`baz´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\">`fo^´<b>`bar´</b>`baz´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\">`fo^´<b>`bar´</b>`baz´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\">`fo^´<b>`bar´</b>`baz´</div>CAN<br>ARY</body>"
        }
      },
      "B-1_SA": {
        "dM": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`foo´<b>`ba^´</b>`baz´",
          "innerHTML": "`foo´<b>`ba^´</b>`baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo´<b>`ba^´</b>`baz´</body>",
          "bodyInnerHTML": "`foo´<b>`ba^´</b>`baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo´<b>`ba^´</b>`baz´</body>"
        },
        "body": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`foo´<b>`ba^´</b>`baz´",
          "innerHTML": "`foo´<b>`ba^´</b>`baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo´<b>`ba^´</b>`baz´</body>",
          "bodyInnerHTML": "`foo´<b>`ba^´</b>`baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo´<b>`ba^´</b>`baz´</body>"
        },
        "div": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`foo´<b>`ba^´</b>`baz´",
          "innerHTML": "`foo´<b>`ba^´</b>`baz´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\">`foo´<b>`ba^´</b>`baz´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\">`foo´<b>`ba^´</b>`baz´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\">`foo´<b>`ba^´</b>`baz´</div>CAN<br>ARY</body>"
        }
      },
      "B-1_SW": {
        "dM": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 2,
          "output": "`foo´|`baz´",
          "innerHTML": "`foo´|`baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo´|`baz´</body>",
          "bodyInnerHTML": "`foo´|`baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo´|`baz´</body>"
        },
        "body": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 2,
          "output": "`foo´|`baz´",
          "innerHTML": "`foo´|`baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo´|`baz´</body>",
          "bodyInnerHTML": "`foo´|`baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo´|`baz´</body>"
        },
        "div": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 2,
          "output": "`foo´|`baz´",
          "innerHTML": "`foo´|`baz´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\">`foo´|`baz´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\">`foo´|`baz´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\">`foo´|`baz´</div>CAN<br>ARY</body>"
        }
      },
      "B-1_SO": {
        "dM": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`foo^baz´",
          "innerHTML": "`foo^baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo^baz´</body>",
          "bodyInnerHTML": "`foo^baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo^baz´</body>"
        },
        "body": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`foo^baz´",
          "innerHTML": "`foo^baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo^baz´</body>",
          "bodyInnerHTML": "`foo^baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo^baz´</body>"
        },
        "div": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`foo´`^baz´",
          "innerHTML": "`foo´`^baz´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\">`foo´`^baz´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\">`foo´`^baz´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\">`foo´`^baz´</div>CAN<br>ARY</body>"
        }
      },
      "B-1_SL": {
        "dM": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 2,
          "output": "`foo´<b>`^quoz´</b>`quuz´",
          "innerHTML": "`foo´<b>`^quoz´</b>`quuz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo´<b>`^quoz´</b>`quuz´</body>",
          "bodyInnerHTML": "`foo´<b>`^quoz´</b>`quuz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo´<b>`^quoz´</b>`quuz´</body>"
        },
        "body": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 2,
          "output": "`foo´<b>`^quoz´</b>`quuz´",
          "innerHTML": "`foo´<b>`^quoz´</b>`quuz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo´<b>`^quoz´</b>`quuz´</body>",
          "bodyInnerHTML": "`foo´<b>`^quoz´</b>`quuz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo´<b>`^quoz´</b>`quuz´</body>"
        },
        "div": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 2,
          "output": "`foo´<b>`^quoz´</b>`quuz´",
          "innerHTML": "`foo´<b>`^quoz´</b>`quuz´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\">`foo´<b>`^quoz´</b>`quuz´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\">`foo´<b>`^quoz´</b>`quuz´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\">`foo´<b>`^quoz´</b>`quuz´</div>CAN<br>ARY</body>"
        }
      },
      "B-1_SR": {
        "dM": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 2,
          "output": "`foo´<b>`bar´</b>`^quuz´",
          "innerHTML": "`foo´<b>`bar´</b>`^quuz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo´<b>`bar´</b>`^quuz´</body>",
          "bodyInnerHTML": "`foo´<b>`bar´</b>`^quuz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo´<b>`bar´</b>`^quuz´</body>"
        },
        "body": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 2,
          "output": "`foo´<b>`bar´</b>`^quuz´",
          "innerHTML": "`foo´<b>`bar´</b>`^quuz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo´<b>`bar´</b>`^quuz´</body>",
          "bodyInnerHTML": "`foo´<b>`bar´</b>`^quuz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo´<b>`bar´</b>`^quuz´</body>"
        },
        "div": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 2,
          "output": "`foo´<b>`bar´</b>`^quuz´",
          "innerHTML": "`foo´<b>`bar´</b>`^quuz´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\">`foo´<b>`bar´</b>`^quuz´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\">`foo´<b>`bar´</b>`^quuz´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\">`foo´<b>`bar´</b>`^quuz´</div>CAN<br>ARY</body>"
        }
      },
      "B.I-1_SM": {
        "dM": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 2,
          "output": "`foo´<b>`bar´</b><i>`^quuz´</i>`quuuz´",
          "innerHTML": "`foo´<b>`bar´</b><i>`^quuz´</i>`quuuz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo´<b>`bar´</b><i>`^quuz´</i>`quuuz´</body>",
          "bodyInnerHTML": "`foo´<b>`bar´</b><i>`^quuz´</i>`quuuz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo´<b>`bar´</b><i>`^quuz´</i>`quuuz´</body>"
        },
        "body": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 2,
          "output": "`foo´<b>`bar´</b><i>`^quuz´</i>`quuuz´",
          "innerHTML": "`foo´<b>`bar´</b><i>`^quuz´</i>`quuuz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo´<b>`bar´</b><i>`^quuz´</i>`quuuz´</body>",
          "bodyInnerHTML": "`foo´<b>`bar´</b><i>`^quuz´</i>`quuuz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo´<b>`bar´</b><i>`^quuz´</i>`quuuz´</body>"
        },
        "div": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 2,
          "output": "`foo´<b>`bar´</b><i>`^quuz´</i>`quuuz´",
          "innerHTML": "`foo´<b>`bar´</b><i>`^quuz´</i>`quuuz´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\">`foo´<b>`bar´</b><i>`^quuz´</i>`quuuz´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\">`foo´<b>`bar´</b><i>`^quuz´</i>`quuuz´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\">`foo´<b>`bar´</b><i>`^quuz´</i>`quuuz´</div>CAN<br>ARY</body>"
        }
      },
      "GEN-1_SS": {
        "dM": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`fo^´<gen>`bar´</gen>`baz´",
          "innerHTML": "`fo^´<gen>`bar´</gen>`baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`fo^´<gen>`bar´</gen>`baz´</body>",
          "bodyInnerHTML": "`fo^´<gen>`bar´</gen>`baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`fo^´<gen>`bar´</gen>`baz´</body>"
        },
        "body": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`fo^´<gen>`bar´</gen>`baz´",
          "innerHTML": "`fo^´<gen>`bar´</gen>`baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`fo^´<gen>`bar´</gen>`baz´</body>",
          "bodyInnerHTML": "`fo^´<gen>`bar´</gen>`baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`fo^´<gen>`bar´</gen>`baz´</body>"
        },
        "div": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`fo^´<gen>`bar´</gen>`baz´",
          "innerHTML": "`fo^´<gen>`bar´</gen>`baz´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\">`fo^´<gen>`bar´</gen>`baz´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\">`fo^´<gen>`bar´</gen>`baz´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\">`fo^´<gen>`bar´</gen>`baz´</div>CAN<br>ARY</body>"
        }
      },
      "GEN-1_SA": {
        "dM": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`foo´<gen>`ba^´</gen>`baz´",
          "innerHTML": "`foo´<gen>`ba^´</gen>`baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo´<gen>`ba^´</gen>`baz´</body>",
          "bodyInnerHTML": "`foo´<gen>`ba^´</gen>`baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo´<gen>`ba^´</gen>`baz´</body>"
        },
        "body": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`foo´<gen>`ba^´</gen>`baz´",
          "innerHTML": "`foo´<gen>`ba^´</gen>`baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo´<gen>`ba^´</gen>`baz´</body>",
          "bodyInnerHTML": "`foo´<gen>`ba^´</gen>`baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo´<gen>`ba^´</gen>`baz´</body>"
        },
        "div": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`foo´<gen>`ba^´</gen>`baz´",
          "innerHTML": "`foo´<gen>`ba^´</gen>`baz´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\">`foo´<gen>`ba^´</gen>`baz´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\">`foo´<gen>`ba^´</gen>`baz´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\">`foo´<gen>`ba^´</gen>`baz´</div>CAN<br>ARY</body>"
        }
      },
      "P2-1_SS2": {
        "dM": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "<p>`foobar^bazqoz´</p>",
          "innerHTML": "<p>`foobar^bazqoz´</p>",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\"><p>`foobar^bazqoz´</p></body>",
          "bodyInnerHTML": "<p>`foobar^bazqoz´</p>",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\"><p>`foobar^bazqoz´</p></body>"
        },
        "body": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "<p>`foobar^bazqoz´</p>",
          "innerHTML": "<p>`foobar^bazqoz´</p>",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\"><p>`foobar^bazqoz´</p></body>",
          "bodyInnerHTML": "<p>`foobar^bazqoz´</p>",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\"><p>`foobar^bazqoz´</p></body>"
        },
        "div": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "<p>`foobar^bazqoz´</p>",
          "innerHTML": "<p>`foobar^bazqoz´</p>",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\"><p>`foobar^bazqoz´</p></div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\"><p>`foobar^bazqoz´</p></div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\"><p>`foobar^bazqoz´</p></div>CAN<br>ARY</body>"
        }
      },
      "P2-1_SI2": {
        "dM": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "<p>`foobar´</p><p>`^qoz´</p>",
          "innerHTML": "<p>`foobar´</p><p>`^qoz´</p>",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\"><p>`foobar´</p><p>`^qoz´</p></body>",
          "bodyInnerHTML": "<p>`foobar´</p><p>`^qoz´</p>",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\"><p>`foobar´</p><p>`^qoz´</p></body>"
        },
        "body": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "<p>`foobar´</p><p>`^qoz´</p>",
          "innerHTML": "<p>`foobar´</p><p>`^qoz´</p>",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\"><p>`foobar´</p><p>`^qoz´</p></body>",
          "bodyInnerHTML": "<p>`foobar´</p><p>`^qoz´</p>",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\"><p>`foobar´</p><p>`^qoz´</p></body>"
        },
        "div": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "<p>`foobar´</p><p>`^qoz´</p>",
          "innerHTML": "<p>`foobar´</p><p>`^qoz´</p>",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\"><p>`foobar´</p><p>`^qoz´</p></div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\"><p>`foobar´</p><p>`^qoz´</p></div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\"><p>`foobar´</p><p>`^qoz´</p></div>CAN<br>ARY</body>"
        }
      },
      "P2-1_SM": {
        "dM": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "<p>`foo^qoz´</p>",
          "innerHTML": "<p>`foo^qoz´</p>",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\"><p>`foo^qoz´</p></body>",
          "bodyInnerHTML": "<p>`foo^qoz´</p>",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\"><p>`foo^qoz´</p></body>"
        },
        "body": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "<p>`foo^qoz´</p>",
          "innerHTML": "<p>`foo^qoz´</p>",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\"><p>`foo^qoz´</p></body>",
          "bodyInnerHTML": "<p>`foo^qoz´</p>",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\"><p>`foo^qoz´</p></body>"
        },
        "div": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "<p>`foo^qoz´</p>",
          "innerHTML": "<p>`foo^qoz´</p>",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\"><p>`foo^qoz´</p></div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\"><p>`foo^qoz´</p></div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\"><p>`foo^qoz´</p></div>CAN<br>ARY</body>"
        }
      },
      "OL-LI2-1_SO1": {
        "dM": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 2,
          "output": "`foo^´<ol><li>`baz´</li></ol>`qoz´",
          "innerHTML": "`foo^´<ol><li>`baz´</li></ol>`qoz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo^´<ol><li>`baz´</li></ol>`qoz´</body>",
          "bodyInnerHTML": "`foo^´<ol><li>`baz´</li></ol>`qoz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo^´<ol><li>`baz´</li></ol>`qoz´</body>"
        },
        "body": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 2,
          "output": "`foo^´<ol><li>`baz´</li></ol>`qoz´",
          "innerHTML": "`foo^´<ol><li>`baz´</li></ol>`qoz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo^´<ol><li>`baz´</li></ol>`qoz´</body>",
          "bodyInnerHTML": "`foo^´<ol><li>`baz´</li></ol>`qoz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo^´<ol><li>`baz´</li></ol>`qoz´</body>"
        },
        "div": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 2,
          "output": "`foo^´<ol><li>`baz´</li></ol>`qoz´",
          "innerHTML": "`foo^´<ol><li>`baz´</li></ol>`qoz´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\">`foo^´<ol><li>`baz´</li></ol>`qoz´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\">`foo^´<ol><li>`baz´</li></ol>`qoz´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\">`foo^´<ol><li>`baz´</li></ol>`qoz´</div>CAN<br>ARY</body>"
        }
      },
      "OL-LI2-1_SM": {
        "dM": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`foo´<ol><li>`ba^az´</li></ol>`qoz´",
          "innerHTML": "`foo´<ol><li>`ba^az´</li></ol>`qoz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo´<ol><li>`ba^az´</li></ol>`qoz´</body>",
          "bodyInnerHTML": "`foo´<ol><li>`ba^az´</li></ol>`qoz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo´<ol><li>`ba^az´</li></ol>`qoz´</body>"
        },
        "body": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`foo´<ol><li>`ba^az´</li></ol>`qoz´",
          "innerHTML": "`foo´<ol><li>`ba^az´</li></ol>`qoz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo´<ol><li>`ba^az´</li></ol>`qoz´</body>",
          "bodyInnerHTML": "`foo´<ol><li>`ba^az´</li></ol>`qoz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo´<ol><li>`ba^az´</li></ol>`qoz´</body>"
        },
        "div": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`foo´<ol><li>`ba^az´</li></ol>`qoz´",
          "innerHTML": "`foo´<ol><li>`ba^az´</li></ol>`qoz´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\">`foo´<ol><li>`ba^az´</li></ol>`qoz´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\">`foo´<ol><li>`ba^az´</li></ol>`qoz´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\">`foo´<ol><li>`ba^az´</li></ol>`qoz´</div>CAN<br>ARY</body>"
        }
      },
      "OL-LI-1_SW": {
        "dM": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`foo´<ol><li>|<br></li></ol>`qoz´",
          "innerHTML": "`foo´<ol><li>|<br></li></ol>`qoz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo´<ol><li>|<br></li></ol>`qoz´</body>",
          "bodyInnerHTML": "`foo´<ol><li>|<br></li></ol>`qoz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo´<ol><li>|<br></li></ol>`qoz´</body>"
        },
        "body": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`foo´<ol><li>|<br></li></ol>`qoz´",
          "innerHTML": "`foo´<ol><li>|<br></li></ol>`qoz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo´<ol><li>|<br></li></ol>`qoz´</body>",
          "bodyInnerHTML": "`foo´<ol><li>|<br></li></ol>`qoz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo´<ol><li>|<br></li></ol>`qoz´</body>"
        },
        "div": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`foo´<ol><li>|<br></li></ol>`qoz´",
          "innerHTML": "`foo´<ol><li>|<br></li></ol>`qoz´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\">`foo´<ol><li>|<br></li></ol>`qoz´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\">`foo´<ol><li>|<br></li></ol>`qoz´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\">`foo´<ol><li>|<br></li></ol>`qoz´</div>CAN<br>ARY</body>"
        }
      },
      "OL-LI-1_SO": {
        "dM": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 2,
          "output": "`foo´|`qoz´",
          "innerHTML": "`foo´|`qoz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo´|`qoz´</body>",
          "bodyInnerHTML": "`foo´|`qoz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo´|`qoz´</body>"
        },
        "body": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 2,
          "output": "`foo´|`qoz´",
          "innerHTML": "`foo´|`qoz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo´|`qoz´</body>",
          "bodyInnerHTML": "`foo´|`qoz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo´|`qoz´</body>"
        },
        "div": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 2,
          "output": "`foo´|`qoz´",
          "innerHTML": "`foo´|`qoz´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\">`foo´|`qoz´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\">`foo´|`qoz´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\">`foo´|`qoz´</div>CAN<br>ARY</body>"
        }
      },
      "HR.BR-1_SM": {
        "dM": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 2,
          "output": "`foo^´<hr><br>`baz´",
          "innerHTML": "`foo^´<hr><br>`baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo^´<hr><br>`baz´</body>",
          "bodyInnerHTML": "`foo^´<hr><br>`baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo^´<hr><br>`baz´</body>"
        },
        "body": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 2,
          "output": "`foo^´<hr><br>`baz´",
          "innerHTML": "`foo^´<hr><br>`baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo^´<hr><br>`baz´</body>",
          "bodyInnerHTML": "`foo^´<hr><br>`baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo^´<hr><br>`baz´</body>"
        },
        "div": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 2,
          "output": "`foo^´<hr><br>`baz´",
          "innerHTML": "`foo^´<hr><br>`baz´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\">`foo^´<hr><br>`baz´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\">`foo^´<hr><br>`baz´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\">`foo^´<hr><br>`baz´</div>CAN<br>ARY</body>"
        }
      },
      "TABLE-1_SA": {
        "dM": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`foo´<table><tbody><tr><td>`bar´</td></tr></tbody></table>`^baz´",
          "innerHTML": "`foo´<table><tbody><tr><td>`bar´</td></tr></tbody></table>`^baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo´<table><tbody><tr><td>`bar´</td></tr></tbody></table>`^baz´</body>",
          "bodyInnerHTML": "`foo´<table><tbody><tr><td>`bar´</td></tr></tbody></table>`^baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo´<table><tbody><tr><td>`bar´</td></tr></tbody></table>`^baz´</body>"
        },
        "body": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`foo´<table><tbody><tr><td>`bar´</td></tr></tbody></table>`^baz´",
          "innerHTML": "`foo´<table><tbody><tr><td>`bar´</td></tr></tbody></table>`^baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo´<table><tbody><tr><td>`bar´</td></tr></tbody></table>`^baz´</body>",
          "bodyInnerHTML": "`foo´<table><tbody><tr><td>`bar´</td></tr></tbody></table>`^baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo´<table><tbody><tr><td>`bar´</td></tr></tbody></table>`^baz´</body>"
        },
        "div": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`foo´<table><tbody><tr><td>`bar´</td></tr></tbody></table>`^baz´",
          "innerHTML": "`foo´<table><tbody><tr><td>`bar´</td></tr></tbody></table>`^baz´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\">`foo´<table><tbody><tr><td>`bar´</td></tr></tbody></table>`^baz´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\">`foo´<table><tbody><tr><td>`bar´</td></tr></tbody></table>`^baz´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\">`foo´<table><tbody><tr><td>`bar´</td></tr></tbody></table>`^baz´</div>CAN<br>ARY</body>"
        }
      },
      "TD-1_SS": {
        "dM": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`foo´<table><tbody><tr><td>`^bar´</td></tr></tbody></table>`baz´",
          "innerHTML": "`foo´<table><tbody><tr><td>`^bar´</td></tr></tbody></table>`baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo´<table><tbody><tr><td>`^bar´</td></tr></tbody></table>`baz´</body>",
          "bodyInnerHTML": "`foo´<table><tbody><tr><td>`^bar´</td></tr></tbody></table>`baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo´<table><tbody><tr><td>`^bar´</td></tr></tbody></table>`baz´</body>"
        },
        "body": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`foo´<table><tbody><tr><td>`^bar´</td></tr></tbody></table>`baz´",
          "innerHTML": "`foo´<table><tbody><tr><td>`^bar´</td></tr></tbody></table>`baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo´<table><tbody><tr><td>`^bar´</td></tr></tbody></table>`baz´</body>",
          "bodyInnerHTML": "`foo´<table><tbody><tr><td>`^bar´</td></tr></tbody></table>`baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo´<table><tbody><tr><td>`^bar´</td></tr></tbody></table>`baz´</body>"
        },
        "div": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`foo´<table><tbody><tr><td>`^bar´</td></tr></tbody></table>`baz´",
          "innerHTML": "`foo´<table><tbody><tr><td>`^bar´</td></tr></tbody></table>`baz´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\">`foo´<table><tbody><tr><td>`^bar´</td></tr></tbody></table>`baz´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\">`foo´<table><tbody><tr><td>`^bar´</td></tr></tbody></table>`baz´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\">`foo´<table><tbody><tr><td>`^bar´</td></tr></tbody></table>`baz´</div>CAN<br>ARY</body>"
        }
      },
      "TD2-1_SS2": {
        "dM": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`foo´<table><tbody><tr><td>`bar´</td><td>`^baz´</td></tr></tbody></table>`quoz´",
          "innerHTML": "`foo´<table><tbody><tr><td>`bar´</td><td>`^baz´</td></tr></tbody></table>`quoz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo´<table><tbody><tr><td>`bar´</td><td>`^baz´</td></tr></tbody></table>`quoz´</body>",
          "bodyInnerHTML": "`foo´<table><tbody><tr><td>`bar´</td><td>`^baz´</td></tr></tbody></table>`quoz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo´<table><tbody><tr><td>`bar´</td><td>`^baz´</td></tr></tbody></table>`quoz´</body>"
        },
        "body": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`foo´<table><tbody><tr><td>`bar´</td><td>`^baz´</td></tr></tbody></table>`quoz´",
          "innerHTML": "`foo´<table><tbody><tr><td>`bar´</td><td>`^baz´</td></tr></tbody></table>`quoz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo´<table><tbody><tr><td>`bar´</td><td>`^baz´</td></tr></tbody></table>`quoz´</body>",
          "bodyInnerHTML": "`foo´<table><tbody><tr><td>`bar´</td><td>`^baz´</td></tr></tbody></table>`quoz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo´<table><tbody><tr><td>`bar´</td><td>`^baz´</td></tr></tbody></table>`quoz´</body>"
        },
        "div": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`foo´<table><tbody><tr><td>`bar´</td><td>`^baz´</td></tr></tbody></table>`quoz´",
          "innerHTML": "`foo´<table><tbody><tr><td>`bar´</td><td>`^baz´</td></tr></tbody></table>`quoz´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\">`foo´<table><tbody><tr><td>`bar´</td><td>`^baz´</td></tr></tbody></table>`quoz´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\">`foo´<table><tbody><tr><td>`bar´</td><td>`^baz´</td></tr></tbody></table>`quoz´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\">`foo´<table><tbody><tr><td>`bar´</td><td>`^baz´</td></tr></tbody></table>`quoz´</div>CAN<br>ARY</body>"
        }
      },
      "TD2-1_SM": {
        "dM": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`foo´<table><tbody><tr><td>`ba^´</td><td>`az´</td></tr></tbody></table>`quoz´",
          "innerHTML": "`foo´<table><tbody><tr><td>`ba^´</td><td>`az´</td></tr></tbody></table>`quoz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo´<table><tbody><tr><td>`ba^´</td><td>`az´</td></tr></tbody></table>`quoz´</body>",
          "bodyInnerHTML": "`foo´<table><tbody><tr><td>`ba^´</td><td>`az´</td></tr></tbody></table>`quoz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo´<table><tbody><tr><td>`ba^´</td><td>`az´</td></tr></tbody></table>`quoz´</body>"
        },
        "body": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`foo´<table><tbody><tr><td>`ba^´</td><td>`az´</td></tr></tbody></table>`quoz´",
          "innerHTML": "`foo´<table><tbody><tr><td>`ba^´</td><td>`az´</td></tr></tbody></table>`quoz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo´<table><tbody><tr><td>`ba^´</td><td>`az´</td></tr></tbody></table>`quoz´</body>",
          "bodyInnerHTML": "`foo´<table><tbody><tr><td>`ba^´</td><td>`az´</td></tr></tbody></table>`quoz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo´<table><tbody><tr><td>`ba^´</td><td>`az´</td></tr></tbody></table>`quoz´</body>"
        },
        "div": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`foo´<table><tbody><tr><td>`ba^´</td><td>`az´</td></tr></tbody></table>`quoz´",
          "innerHTML": "`foo´<table><tbody><tr><td>`ba^´</td><td>`az´</td></tr></tbody></table>`quoz´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\">`foo´<table><tbody><tr><td>`ba^´</td><td>`az´</td></tr></tbody></table>`quoz´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\">`foo´<table><tbody><tr><td>`ba^´</td><td>`az´</td></tr></tbody></table>`quoz´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\">`foo´<table><tbody><tr><td>`ba^´</td><td>`az´</td></tr></tbody></table>`quoz´</div>CAN<br>ARY</body>"
        }
      },
      "TR3-1_SO1": {
        "dM": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "<table><tbody>|<tr><td>`B´</td></tr><tr><td>`C´</td></tr></tbody></table>",
          "innerHTML": "<table><tbody>|<tr><td>`B´</td></tr><tr><td>`C´</td></tr></tbody></table>",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\"><table><tbody>|<tr><td>`B´</td></tr><tr><td>`C´</td></tr></tbody></table></body>",
          "bodyInnerHTML": "<table><tbody>|<tr><td>`B´</td></tr><tr><td>`C´</td></tr></tbody></table>",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\"><table><tbody>|<tr><td>`B´</td></tr><tr><td>`C´</td></tr></tbody></table></body>"
        },
        "body": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "<table><tbody>|<tr><td>`B´</td></tr><tr><td>`C´</td></tr></tbody></table>",
          "innerHTML": "<table><tbody>|<tr><td>`B´</td></tr><tr><td>`C´</td></tr></tbody></table>",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\"><table><tbody>|<tr><td>`B´</td></tr><tr><td>`C´</td></tr></tbody></table></body>",
          "bodyInnerHTML": "<table><tbody>|<tr><td>`B´</td></tr><tr><td>`C´</td></tr></tbody></table>",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\"><table><tbody>|<tr><td>`B´</td></tr><tr><td>`C´</td></tr></tbody></table></body>"
        },
        "div": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "<table><tbody>|<tr><td>`B´</td></tr><tr><td>`C´</td></tr></tbody></table>",
          "innerHTML": "<table><tbody>|<tr><td>`B´</td></tr><tr><td>`C´</td></tr></tbody></table>",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\"><table><tbody>|<tr><td>`B´</td></tr><tr><td>`C´</td></tr></tbody></table></div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\"><table><tbody>|<tr><td>`B´</td></tr><tr><td>`C´</td></tr></tbody></table></div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\"><table><tbody>|<tr><td>`B´</td></tr><tr><td>`C´</td></tr></tbody></table></div>CAN<br>ARY</body>"
        }
      },
      "TR3-1_SO2": {
        "dM": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "<table><tbody><tr><td>`A´</td></tr>|<tr><td>`C´</td></tr></tbody></table>",
          "innerHTML": "<table><tbody><tr><td>`A´</td></tr>|<tr><td>`C´</td></tr></tbody></table>",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\"><table><tbody><tr><td>`A´</td></tr>|<tr><td>`C´</td></tr></tbody></table></body>",
          "bodyInnerHTML": "<table><tbody><tr><td>`A´</td></tr>|<tr><td>`C´</td></tr></tbody></table>",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\"><table><tbody><tr><td>`A´</td></tr>|<tr><td>`C´</td></tr></tbody></table></body>"
        },
        "body": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "<table><tbody><tr><td>`A´</td></tr>|<tr><td>`C´</td></tr></tbody></table>",
          "innerHTML": "<table><tbody><tr><td>`A´</td></tr>|<tr><td>`C´</td></tr></tbody></table>",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\"><table><tbody><tr><td>`A´</td></tr>|<tr><td>`C´</td></tr></tbody></table></body>",
          "bodyInnerHTML": "<table><tbody><tr><td>`A´</td></tr>|<tr><td>`C´</td></tr></tbody></table>",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\"><table><tbody><tr><td>`A´</td></tr>|<tr><td>`C´</td></tr></tbody></table></body>"
        },
        "div": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "<table><tbody><tr><td>`A´</td></tr>|<tr><td>`C´</td></tr></tbody></table>",
          "innerHTML": "<table><tbody><tr><td>`A´</td></tr>|<tr><td>`C´</td></tr></tbody></table>",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\"><table><tbody><tr><td>`A´</td></tr>|<tr><td>`C´</td></tr></tbody></table></div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\"><table><tbody><tr><td>`A´</td></tr>|<tr><td>`C´</td></tr></tbody></table></div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\"><table><tbody><tr><td>`A´</td></tr>|<tr><td>`C´</td></tr></tbody></table></div>CAN<br>ARY</body>"
        }
      },
      "TR3-1_SO3": {
        "dM": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "<table><tbody><tr><td>`A´</td></tr><tr><td>`B´</td></tr>|</tbody></table>",
          "innerHTML": "<table><tbody><tr><td>`A´</td></tr><tr><td>`B´</td></tr>|</tbody></table>",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\"><table><tbody><tr><td>`A´</td></tr><tr><td>`B´</td></tr>|</tbody></table></body>",
          "bodyInnerHTML": "<table><tbody><tr><td>`A´</td></tr><tr><td>`B´</td></tr>|</tbody></table>",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\"><table><tbody><tr><td>`A´</td></tr><tr><td>`B´</td></tr>|</tbody></table></body>"
        },
        "body": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "<table><tbody><tr><td>`A´</td></tr><tr><td>`B´</td></tr>|</tbody></table>",
          "innerHTML": "<table><tbody><tr><td>`A´</td></tr><tr><td>`B´</td></tr>|</tbody></table>",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\"><table><tbody><tr><td>`A´</td></tr><tr><td>`B´</td></tr>|</tbody></table></body>",
          "bodyInnerHTML": "<table><tbody><tr><td>`A´</td></tr><tr><td>`B´</td></tr>|</tbody></table>",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\"><table><tbody><tr><td>`A´</td></tr><tr><td>`B´</td></tr>|</tbody></table></body>"
        },
        "div": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "<table><tbody><tr><td>`A´</td></tr><tr><td>`B´</td></tr>|</tbody></table>",
          "innerHTML": "<table><tbody><tr><td>`A´</td></tr><tr><td>`B´</td></tr>|</tbody></table>",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\"><table><tbody><tr><td>`A´</td></tr><tr><td>`B´</td></tr>|</tbody></table></div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\"><table><tbody><tr><td>`A´</td></tr><tr><td>`B´</td></tr>|</tbody></table></div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\"><table><tbody><tr><td>`A´</td></tr><tr><td>`B´</td></tr>|</tbody></table></div>CAN<br>ARY</body>"
        }
      },
      "TR2rs:2-1_SO1": {
        "dM": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "<table><tbody>|<tr><td>`B´</td></tr></tbody></table>",
          "innerHTML": "<table><tbody>|<tr><td>`B´</td></tr></tbody></table>",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\"><table><tbody>|<tr><td>`B´</td></tr></tbody></table></body>",
          "bodyInnerHTML": "<table><tbody>|<tr><td>`B´</td></tr></tbody></table>",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\"><table><tbody>|<tr><td>`B´</td></tr></tbody></table></body>"
        },
        "body": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "<table><tbody>|<tr><td>`B´</td></tr></tbody></table>",
          "innerHTML": "<table><tbody>|<tr><td>`B´</td></tr></tbody></table>",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\"><table><tbody>|<tr><td>`B´</td></tr></tbody></table></body>",
          "bodyInnerHTML": "<table><tbody>|<tr><td>`B´</td></tr></tbody></table>",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\"><table><tbody>|<tr><td>`B´</td></tr></tbody></table></body>"
        },
        "div": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "<table><tbody>|<tr><td>`B´</td></tr></tbody></table>",
          "innerHTML": "<table><tbody>|<tr><td>`B´</td></tr></tbody></table>",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\"><table><tbody>|<tr><td>`B´</td></tr></tbody></table></div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\"><table><tbody>|<tr><td>`B´</td></tr></tbody></table></div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\"><table><tbody>|<tr><td>`B´</td></tr></tbody></table></div>CAN<br>ARY</body>"
        }
      },
      "TR2rs:2-1_SO2": {
        "dM": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "<table><tbody><tr><td>`A´</td><td rowspan=\"2\">`R´</td></tr>|</tbody></table>",
          "innerHTML": "<table><tbody><tr><td>`A´</td><td rowspan=\"2\">`R´</td></tr>|</tbody></table>",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\"><table><tbody><tr><td>`A´</td><td rowspan=\"2\">`R´</td></tr>|</tbody></table></body>",
          "bodyInnerHTML": "<table><tbody><tr><td>`A´</td><td rowspan=\"2\">`R´</td></tr>|</tbody></table>",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\"><table><tbody><tr><td>`A´</td><td rowspan=\"2\">`R´</td></tr>|</tbody></table></body>"
        },
        "body": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "<table><tbody><tr><td>`A´</td><td rowspan=\"2\">`R´</td></tr>|</tbody></table>",
          "innerHTML": "<table><tbody><tr><td>`A´</td><td rowspan=\"2\">`R´</td></tr>|</tbody></table>",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\"><table><tbody><tr><td>`A´</td><td rowspan=\"2\">`R´</td></tr>|</tbody></table></body>",
          "bodyInnerHTML": "<table><tbody><tr><td>`A´</td><td rowspan=\"2\">`R´</td></tr>|</tbody></table>",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\"><table><tbody><tr><td>`A´</td><td rowspan=\"2\">`R´</td></tr>|</tbody></table></body>"
        },
        "div": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "<table><tbody><tr><td>`A´</td><td rowspan=\"2\">`R´</td></tr>|</tbody></table>",
          "innerHTML": "<table><tbody><tr><td>`A´</td><td rowspan=\"2\">`R´</td></tr>|</tbody></table>",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\"><table><tbody><tr><td>`A´</td><td rowspan=\"2\">`R´</td></tr>|</tbody></table></div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\"><table><tbody><tr><td>`A´</td><td rowspan=\"2\">`R´</td></tr>|</tbody></table></div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\"><table><tbody><tr><td>`A´</td><td rowspan=\"2\">`R´</td></tr>|</tbody></table></div>CAN<br>ARY</body>"
        }
      },
      "TR3rs:3-1_SO1": {
        "dM": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "<table><tbody>|<tr><td>`B´</td></tr><tr><td>`C´</td></tr></tbody></table>",
          "innerHTML": "<table><tbody>|<tr><td>`B´</td></tr><tr><td>`C´</td></tr></tbody></table>",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\"><table><tbody>|<tr><td>`B´</td></tr><tr><td>`C´</td></tr></tbody></table></body>",
          "bodyInnerHTML": "<table><tbody>|<tr><td>`B´</td></tr><tr><td>`C´</td></tr></tbody></table>",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\"><table><tbody>|<tr><td>`B´</td></tr><tr><td>`C´</td></tr></tbody></table></body>"
        },
        "body": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "<table><tbody>|<tr><td>`B´</td></tr><tr><td>`C´</td></tr></tbody></table>",
          "innerHTML": "<table><tbody>|<tr><td>`B´</td></tr><tr><td>`C´</td></tr></tbody></table>",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\"><table><tbody>|<tr><td>`B´</td></tr><tr><td>`C´</td></tr></tbody></table></body>",
          "bodyInnerHTML": "<table><tbody>|<tr><td>`B´</td></tr><tr><td>`C´</td></tr></tbody></table>",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\"><table><tbody>|<tr><td>`B´</td></tr><tr><td>`C´</td></tr></tbody></table></body>"
        },
        "div": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "<table><tbody>|<tr><td>`B´</td></tr><tr><td>`C´</td></tr></tbody></table>",
          "innerHTML": "<table><tbody>|<tr><td>`B´</td></tr><tr><td>`C´</td></tr></tbody></table>",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\"><table><tbody>|<tr><td>`B´</td></tr><tr><td>`C´</td></tr></tbody></table></div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\"><table><tbody>|<tr><td>`B´</td></tr><tr><td>`C´</td></tr></tbody></table></div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\"><table><tbody>|<tr><td>`B´</td></tr><tr><td>`C´</td></tr></tbody></table></div>CAN<br>ARY</body>"
        }
      },
      "TR3rs:3-1_SO2": {
        "dM": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "<table><tbody><tr><td>`A´</td><td rowspan=\"3\">`R´</td></tr>|<tr><td>`C´</td></tr></tbody></table>",
          "innerHTML": "<table><tbody><tr><td>`A´</td><td rowspan=\"3\">`R´</td></tr>|<tr><td>`C´</td></tr></tbody></table>",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\"><table><tbody><tr><td>`A´</td><td rowspan=\"3\">`R´</td></tr>|<tr><td>`C´</td></tr></tbody></table></body>",
          "bodyInnerHTML": "<table><tbody><tr><td>`A´</td><td rowspan=\"3\">`R´</td></tr>|<tr><td>`C´</td></tr></tbody></table>",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\"><table><tbody><tr><td>`A´</td><td rowspan=\"3\">`R´</td></tr>|<tr><td>`C´</td></tr></tbody></table></body>"
        },
        "body": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "<table><tbody><tr><td>`A´</td><td rowspan=\"3\">`R´</td></tr>|<tr><td>`C´</td></tr></tbody></table>",
          "innerHTML": "<table><tbody><tr><td>`A´</td><td rowspan=\"3\">`R´</td></tr>|<tr><td>`C´</td></tr></tbody></table>",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\"><table><tbody><tr><td>`A´</td><td rowspan=\"3\">`R´</td></tr>|<tr><td>`C´</td></tr></tbody></table></body>",
          "bodyInnerHTML": "<table><tbody><tr><td>`A´</td><td rowspan=\"3\">`R´</td></tr>|<tr><td>`C´</td></tr></tbody></table>",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\"><table><tbody><tr><td>`A´</td><td rowspan=\"3\">`R´</td></tr>|<tr><td>`C´</td></tr></tbody></table></body>"
        },
        "div": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "<table><tbody><tr><td>`A´</td><td rowspan=\"3\">`R´</td></tr>|<tr><td>`C´</td></tr></tbody></table>",
          "innerHTML": "<table><tbody><tr><td>`A´</td><td rowspan=\"3\">`R´</td></tr>|<tr><td>`C´</td></tr></tbody></table>",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\"><table><tbody><tr><td>`A´</td><td rowspan=\"3\">`R´</td></tr>|<tr><td>`C´</td></tr></tbody></table></div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\"><table><tbody><tr><td>`A´</td><td rowspan=\"3\">`R´</td></tr>|<tr><td>`C´</td></tr></tbody></table></div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\"><table><tbody><tr><td>`A´</td><td rowspan=\"3\">`R´</td></tr>|<tr><td>`C´</td></tr></tbody></table></div>CAN<br>ARY</body>"
        }
      },
      "TR3rs:3-1_SO3": {
        "dM": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "<table><tbody><tr><td>`A´</td><td rowspan=\"3\">`R´</td></tr><tr><td>`B´</td></tr>|</tbody></table>",
          "innerHTML": "<table><tbody><tr><td>`A´</td><td rowspan=\"3\">`R´</td></tr><tr><td>`B´</td></tr>|</tbody></table>",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\"><table><tbody><tr><td>`A´</td><td rowspan=\"3\">`R´</td></tr><tr><td>`B´</td></tr>|</tbody></table></body>",
          "bodyInnerHTML": "<table><tbody><tr><td>`A´</td><td rowspan=\"3\">`R´</td></tr><tr><td>`B´</td></tr>|</tbody></table>",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\"><table><tbody><tr><td>`A´</td><td rowspan=\"3\">`R´</td></tr><tr><td>`B´</td></tr>|</tbody></table></body>"
        },
        "body": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "<table><tbody><tr><td>`A´</td><td rowspan=\"3\">`R´</td></tr><tr><td>`B´</td></tr>|</tbody></table>",
          "innerHTML": "<table><tbody><tr><td>`A´</td><td rowspan=\"3\">`R´</td></tr><tr><td>`B´</td></tr>|</tbody></table>",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\"><table><tbody><tr><td>`A´</td><td rowspan=\"3\">`R´</td></tr><tr><td>`B´</td></tr>|</tbody></table></body>",
          "bodyInnerHTML": "<table><tbody><tr><td>`A´</td><td rowspan=\"3\">`R´</td></tr><tr><td>`B´</td></tr>|</tbody></table>",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\"><table><tbody><tr><td>`A´</td><td rowspan=\"3\">`R´</td></tr><tr><td>`B´</td></tr>|</tbody></table></body>"
        },
        "div": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "<table><tbody><tr><td>`A´</td><td rowspan=\"3\">`R´</td></tr><tr><td>`B´</td></tr>|</tbody></table>",
          "innerHTML": "<table><tbody><tr><td>`A´</td><td rowspan=\"3\">`R´</td></tr><tr><td>`B´</td></tr>|</tbody></table>",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\"><table><tbody><tr><td>`A´</td><td rowspan=\"3\">`R´</td></tr><tr><td>`B´</td></tr>|</tbody></table></div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\"><table><tbody><tr><td>`A´</td><td rowspan=\"3\">`R´</td></tr><tr><td>`B´</td></tr>|</tbody></table></div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\"><table><tbody><tr><td>`A´</td><td rowspan=\"3\">`R´</td></tr><tr><td>`B´</td></tr>|</tbody></table></div>CAN<br>ARY</body>"
        }
      },
      "DIV:ce:false-1_SO": {
        "dM": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`foo^qoz´",
          "innerHTML": "`foo^qoz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo^qoz´</body>",
          "bodyInnerHTML": "`foo^qoz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo^qoz´</body>"
        },
        "body": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`foo^qoz´",
          "innerHTML": "`foo^qoz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo^qoz´</body>",
          "bodyInnerHTML": "`foo^qoz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo^qoz´</body>"
        },
        "div": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`foo´`^qoz´",
          "innerHTML": "`foo´`^qoz´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\">`foo´`^qoz´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\">`foo´`^qoz´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\">`foo´`^qoz´</div>CAN<br>ARY</body>"
        }
      },
      "DIV:ce:false-1_SB": {
        "dM": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`foobar´<div contenteditable=\"false\">`NESTED´`^bazqoz´</div>",
          "innerHTML": "`foobar´<div contenteditable=\"false\">`NESTED´`^bazqoz´</div>",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foobar´<div contenteditable=\"false\">`NESTED´`^bazqoz´</div></body>",
          "bodyInnerHTML": "`foobar´<div contenteditable=\"false\">`NESTED´`^bazqoz´</div>",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foobar´<div contenteditable=\"false\">`NESTED´`^bazqoz´</div></body>"
        },
        "body": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 2,
          "selresult": 3,
          "output": "EXECUTION EXCEPTION: [Exception... \"Component returned failure code: 0x80004003 (NS_ERROR_INVALID_POINTER) [nsIDOMHTMLDocument.execCommand]\"  nsresult: \"0x80004003 (NS_ERROR_INVALID_POINTER)\"  location: \"JS frame :: http://mochi.test:8888/tests/editor/libeditor/html/tests/browserscope/lib/richtext2/richtext2/static/js/run.js :: runSingleTest :: line 143\"  data: no]"
        },
        "div": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 2,
          "selresult": 3,
          "output": "EXECUTION EXCEPTION: [Exception... \"Component returned failure code: 0x80004003 (NS_ERROR_INVALID_POINTER) [nsIDOMHTMLDocument.execCommand]\"  nsresult: \"0x80004003 (NS_ERROR_INVALID_POINTER)\"  location: \"JS frame :: http://mochi.test:8888/tests/editor/libeditor/html/tests/browserscope/lib/richtext2/richtext2/static/js/run.js :: runSingleTest :: line 143\"  data: no]"
        }
      },
      "DIV:ce:false-1_SL": {
        "dM": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`foo^TEDbazqoz´",
          "innerHTML": "`foo^TEDbazqoz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo^TEDbazqoz´</body>",
          "bodyInnerHTML": "`foo^TEDbazqoz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo^TEDbazqoz´</body>"
        },
        "body": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`foo[bar´<div contenteditable=\"false\">`NES]TED´</div>`bazqoz´",
          "innerHTML": "`foo[bar´<div contenteditable=\"false\">`NES]TED´</div>`bazqoz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo[bar´<div contenteditable=\"false\">`NES]TED´</div>`bazqoz´</body>",
          "bodyInnerHTML": "`foo[bar´<div contenteditable=\"false\">`NES]TED´</div>`bazqoz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo[bar´<div contenteditable=\"false\">`NES]TED´</div>`bazqoz´</body>"
        },
        "div": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`foo[bar´<div contenteditable=\"false\">`NES]TED´</div>`bazqoz´",
          "innerHTML": "`foo[bar´<div contenteditable=\"false\">`NES]TED´</div>`bazqoz´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\">`foo[bar´<div contenteditable=\"false\">`NES]TED´</div>`bazqoz´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\">`foo[bar´<div contenteditable=\"false\">`NES]TED´</div>`bazqoz´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\">`foo[bar´<div contenteditable=\"false\">`NES]TED´</div>`bazqoz´</div>CAN<br>ARY</body>"
        }
      },
      "DIV:ce:false-1_SR": {
        "dM": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`foobar´<div contenteditable=\"false\">`NES^´`qoz´</div>",
          "innerHTML": "`foobar´<div contenteditable=\"false\">`NES^´`qoz´</div>",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foobar´<div contenteditable=\"false\">`NES^´`qoz´</div></body>",
          "bodyInnerHTML": "`foobar´<div contenteditable=\"false\">`NES^´`qoz´</div>",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foobar´<div contenteditable=\"false\">`NES^´`qoz´</div></body>"
        },
        "body": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`foobar´<div contenteditable=\"false\">`NES[TED´</div>`baz]qoz´",
          "innerHTML": "`foobar´<div contenteditable=\"false\">`NES[TED´</div>`baz]qoz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foobar´<div contenteditable=\"false\">`NES[TED´</div>`baz]qoz´</body>",
          "bodyInnerHTML": "`foobar´<div contenteditable=\"false\">`NES[TED´</div>`baz]qoz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foobar´<div contenteditable=\"false\">`NES[TED´</div>`baz]qoz´</body>"
        },
        "div": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`foobar´<div contenteditable=\"false\">`NES[TED´</div>`baz]qoz´",
          "innerHTML": "`foobar´<div contenteditable=\"false\">`NES[TED´</div>`baz]qoz´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\">`foobar´<div contenteditable=\"false\">`NES[TED´</div>`baz]qoz´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\">`foobar´<div contenteditable=\"false\">`NES[TED´</div>`baz]qoz´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\">`foobar´<div contenteditable=\"false\">`NES[TED´</div>`baz]qoz´</div>CAN<br>ARY</body>"
        }
      },
      "DIV:ce:false-1_SI": {
        "dM": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`foobar´<div contenteditable=\"false\">`NE^ED´</div>`bazqoz´",
          "innerHTML": "`foobar´<div contenteditable=\"false\">`NE^ED´</div>`bazqoz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foobar´<div contenteditable=\"false\">`NE^ED´</div>`bazqoz´</body>",
          "bodyInnerHTML": "`foobar´<div contenteditable=\"false\">`NE^ED´</div>`bazqoz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foobar´<div contenteditable=\"false\">`NE^ED´</div>`bazqoz´</body>"
        },
        "body": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`foobar´<div contenteditable=\"false\">`NE[ST]ED´</div>`bazqoz´",
          "innerHTML": "`foobar´<div contenteditable=\"false\">`NE[ST]ED´</div>`bazqoz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foobar´<div contenteditable=\"false\">`NE[ST]ED´</div>`bazqoz´</body>",
          "bodyInnerHTML": "`foobar´<div contenteditable=\"false\">`NE[ST]ED´</div>`bazqoz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foobar´<div contenteditable=\"false\">`NE[ST]ED´</div>`bazqoz´</body>"
        },
        "div": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`foobar´<div contenteditable=\"false\">`NE[ST]ED´</div>`bazqoz´",
          "innerHTML": "`foobar´<div contenteditable=\"false\">`NE[ST]ED´</div>`bazqoz´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\">`foobar´<div contenteditable=\"false\">`NE[ST]ED´</div>`bazqoz´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\">`foobar´<div contenteditable=\"false\">`NE[ST]ED´</div>`bazqoz´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\">`foobar´<div contenteditable=\"false\">`NE[ST]ED´</div>`bazqoz´</div>CAN<br>ARY</body>"
        }
      },
      "SPAN:d:ib-1_SC": {
        "dM": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`foo´<span style=\"display: inline-block\">`ba^baz´</span>`qoz´",
          "innerHTML": "`foo´<span style=\"display: inline-block\">`ba^baz´</span>`qoz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo´<span style=\"display: inline-block\">`ba^baz´</span>`qoz´</body>",
          "bodyInnerHTML": "`foo´<span style=\"display: inline-block\">`ba^baz´</span>`qoz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo´<span style=\"display: inline-block\">`ba^baz´</span>`qoz´</body>"
        },
        "body": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`foo´<span style=\"display: inline-block\">`ba^baz´</span>`qoz´",
          "innerHTML": "`foo´<span style=\"display: inline-block\">`ba^baz´</span>`qoz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo´<span style=\"display: inline-block\">`ba^baz´</span>`qoz´</body>",
          "bodyInnerHTML": "`foo´<span style=\"display: inline-block\">`ba^baz´</span>`qoz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo´<span style=\"display: inline-block\">`ba^baz´</span>`qoz´</body>"
        },
        "div": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`foo´<span style=\"display: inline-block\">`ba^baz´</span>`qoz´",
          "innerHTML": "`foo´<span style=\"display: inline-block\">`ba^baz´</span>`qoz´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\">`foo´<span style=\"display: inline-block\">`ba^baz´</span>`qoz´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\">`foo´<span style=\"display: inline-block\">`ba^baz´</span>`qoz´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\">`foo´<span style=\"display: inline-block\">`ba^baz´</span>`qoz´</div>CAN<br>ARY</body>"
        }
      },
      "SPAN:d:ib-1_SA": {
        "dM": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`foo´<span style=\"display: inline-block\">`barba^´</span>`qoz´",
          "innerHTML": "`foo´<span style=\"display: inline-block\">`barba^´</span>`qoz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo´<span style=\"display: inline-block\">`barba^´</span>`qoz´</body>",
          "bodyInnerHTML": "`foo´<span style=\"display: inline-block\">`barba^´</span>`qoz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo´<span style=\"display: inline-block\">`barba^´</span>`qoz´</body>"
        },
        "body": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`foo´<span style=\"display: inline-block\">`barba^´</span>`qoz´",
          "innerHTML": "`foo´<span style=\"display: inline-block\">`barba^´</span>`qoz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo´<span style=\"display: inline-block\">`barba^´</span>`qoz´</body>",
          "bodyInnerHTML": "`foo´<span style=\"display: inline-block\">`barba^´</span>`qoz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo´<span style=\"display: inline-block\">`barba^´</span>`qoz´</body>"
        },
        "div": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`foo´<span style=\"display: inline-block\">`barba^´</span>`qoz´",
          "innerHTML": "`foo´<span style=\"display: inline-block\">`barba^´</span>`qoz´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\">`foo´<span style=\"display: inline-block\">`barba^´</span>`qoz´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\">`foo´<span style=\"display: inline-block\">`barba^´</span>`qoz´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\">`foo´<span style=\"display: inline-block\">`barba^´</span>`qoz´</div>CAN<br>ARY</body>"
        }
      },
      "SPAN:d:ib-2_SL": {
        "dM": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 2,
          "output": "`foo´<span style=\"display: inline-block\">`^bar´</span>`baz´",
          "innerHTML": "`foo´<span style=\"display: inline-block\">`^bar´</span>`baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo´<span style=\"display: inline-block\">`^bar´</span>`baz´</body>",
          "bodyInnerHTML": "`foo´<span style=\"display: inline-block\">`^bar´</span>`baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo´<span style=\"display: inline-block\">`^bar´</span>`baz´</body>"
        },
        "body": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 2,
          "output": "`foo´<span style=\"display: inline-block\">`^bar´</span>`baz´",
          "innerHTML": "`foo´<span style=\"display: inline-block\">`^bar´</span>`baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo´<span style=\"display: inline-block\">`^bar´</span>`baz´</body>",
          "bodyInnerHTML": "`foo´<span style=\"display: inline-block\">`^bar´</span>`baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo´<span style=\"display: inline-block\">`^bar´</span>`baz´</body>"
        },
        "div": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 2,
          "output": "`foo´<span style=\"display: inline-block\">`^bar´</span>`baz´",
          "innerHTML": "`foo´<span style=\"display: inline-block\">`^bar´</span>`baz´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\">`foo´<span style=\"display: inline-block\">`^bar´</span>`baz´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\">`foo´<span style=\"display: inline-block\">`^bar´</span>`baz´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\">`foo´<span style=\"display: inline-block\">`^bar´</span>`baz´</div>CAN<br>ARY</body>"
        }
      },
      "SPAN:d:ib-3_SR": {
        "dM": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 2,
          "output": "`foo´<span style=\"display: inline-block\">`bar´</span>`^baz´",
          "innerHTML": "`foo´<span style=\"display: inline-block\">`bar´</span>`^baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo´<span style=\"display: inline-block\">`bar´</span>`^baz´</body>",
          "bodyInnerHTML": "`foo´<span style=\"display: inline-block\">`bar´</span>`^baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo´<span style=\"display: inline-block\">`bar´</span>`^baz´</body>"
        },
        "body": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 2,
          "output": "`foo´<span style=\"display: inline-block\">`bar´</span>`^baz´",
          "innerHTML": "`foo´<span style=\"display: inline-block\">`bar´</span>`^baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo´<span style=\"display: inline-block\">`bar´</span>`^baz´</body>",
          "bodyInnerHTML": "`foo´<span style=\"display: inline-block\">`bar´</span>`^baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo´<span style=\"display: inline-block\">`bar´</span>`^baz´</body>"
        },
        "div": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 2,
          "output": "`foo´<span style=\"display: inline-block\">`bar´</span>`^baz´",
          "innerHTML": "`foo´<span style=\"display: inline-block\">`bar´</span>`^baz´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\">`foo´<span style=\"display: inline-block\">`bar´</span>`^baz´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\">`foo´<span style=\"display: inline-block\">`bar´</span>`^baz´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\">`foo´<span style=\"display: inline-block\">`bar´</span>`^baz´</div>CAN<br>ARY</body>"
        }
      },
      "SPAN:d:ib-4i_SI": {
        "dM": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`foo´<span style=\"display: inline-block\">`bar^baz´</span>`qoz´",
          "innerHTML": "`foo´<span style=\"display: inline-block\">`bar^baz´</span>`qoz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo´<span style=\"display: inline-block\">`bar^baz´</span>`qoz´</body>",
          "bodyInnerHTML": "`foo´<span style=\"display: inline-block\">`bar^baz´</span>`qoz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo´<span style=\"display: inline-block\">`bar^baz´</span>`qoz´</body>"
        },
        "body": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`foo´<span style=\"display: inline-block\">`bar^baz´</span>`qoz´",
          "innerHTML": "`foo´<span style=\"display: inline-block\">`bar^baz´</span>`qoz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo´<span style=\"display: inline-block\">`bar^baz´</span>`qoz´</body>",
          "bodyInnerHTML": "`foo´<span style=\"display: inline-block\">`bar^baz´</span>`qoz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo´<span style=\"display: inline-block\">`bar^baz´</span>`qoz´</body>"
        },
        "div": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`foo´<span style=\"display: inline-block\">`bar^baz´</span>`qoz´",
          "innerHTML": "`foo´<span style=\"display: inline-block\">`bar^baz´</span>`qoz´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\">`foo´<span style=\"display: inline-block\">`bar^baz´</span>`qoz´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\">`foo´<span style=\"display: inline-block\">`bar^baz´</span>`qoz´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\">`foo´<span style=\"display: inline-block\">`bar^baz´</span>`qoz´</div>CAN<br>ARY</body>"
        }
      },
      "SPAN:d:ib-4l_SI": {
        "dM": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`foo´<span style=\"display: inline-block\">`^barbaz´</span>`qoz´",
          "innerHTML": "`foo´<span style=\"display: inline-block\">`^barbaz´</span>`qoz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo´<span style=\"display: inline-block\">`^barbaz´</span>`qoz´</body>",
          "bodyInnerHTML": "`foo´<span style=\"display: inline-block\">`^barbaz´</span>`qoz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo´<span style=\"display: inline-block\">`^barbaz´</span>`qoz´</body>"
        },
        "body": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`foo´<span style=\"display: inline-block\">`^barbaz´</span>`qoz´",
          "innerHTML": "`foo´<span style=\"display: inline-block\">`^barbaz´</span>`qoz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo´<span style=\"display: inline-block\">`^barbaz´</span>`qoz´</body>",
          "bodyInnerHTML": "`foo´<span style=\"display: inline-block\">`^barbaz´</span>`qoz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo´<span style=\"display: inline-block\">`^barbaz´</span>`qoz´</body>"
        },
        "div": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`foo´<span style=\"display: inline-block\">`^barbaz´</span>`qoz´",
          "innerHTML": "`foo´<span style=\"display: inline-block\">`^barbaz´</span>`qoz´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\">`foo´<span style=\"display: inline-block\">`^barbaz´</span>`qoz´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\">`foo´<span style=\"display: inline-block\">`^barbaz´</span>`qoz´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\">`foo´<span style=\"display: inline-block\">`^barbaz´</span>`qoz´</div>CAN<br>ARY</body>"
        }
      },
      "SPAN:d:ib-4r_SI": {
        "dM": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`foo´<span style=\"display: inline-block\">`barbaz^´</span>`qoz´",
          "innerHTML": "`foo´<span style=\"display: inline-block\">`barbaz^´</span>`qoz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo´<span style=\"display: inline-block\">`barbaz^´</span>`qoz´</body>",
          "bodyInnerHTML": "`foo´<span style=\"display: inline-block\">`barbaz^´</span>`qoz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo´<span style=\"display: inline-block\">`barbaz^´</span>`qoz´</body>"
        },
        "body": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`foo´<span style=\"display: inline-block\">`barbaz^´</span>`qoz´",
          "innerHTML": "`foo´<span style=\"display: inline-block\">`barbaz^´</span>`qoz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo´<span style=\"display: inline-block\">`barbaz^´</span>`qoz´</body>",
          "bodyInnerHTML": "`foo´<span style=\"display: inline-block\">`barbaz^´</span>`qoz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo´<span style=\"display: inline-block\">`barbaz^´</span>`qoz´</body>"
        },
        "div": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`foo´<span style=\"display: inline-block\">`barbaz^´</span>`qoz´",
          "innerHTML": "`foo´<span style=\"display: inline-block\">`barbaz^´</span>`qoz´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\">`foo´<span style=\"display: inline-block\">`barbaz^´</span>`qoz´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\">`foo´<span style=\"display: inline-block\">`barbaz^´</span>`qoz´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\">`foo´<span style=\"display: inline-block\">`barbaz^´</span>`qoz´</div>CAN<br>ARY</body>"
        }
      }
    }
  },
  "FD": {
    "Proposed": {
      "CHAR-1_SC": {
        "dM": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`foo^barbaz´",
          "innerHTML": "`foo^barbaz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo^barbaz´</body>",
          "bodyInnerHTML": "`foo^barbaz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo^barbaz´</body>"
        },
        "body": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`foo^barbaz´",
          "innerHTML": "`foo^barbaz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo^barbaz´</body>",
          "bodyInnerHTML": "`foo^barbaz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo^barbaz´</body>"
        },
        "div": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`foo^barbaz´",
          "innerHTML": "`foo^barbaz´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\">`foo^barbaz´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\">`foo^barbaz´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\">`foo^barbaz´</div>CAN<br>ARY</body>"
        }
      },
      "CHAR-2_SC": {
        "dM": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`fo^öbarbaz´",
          "innerHTML": "`fo^öbarbaz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`fo^öbarbaz´</body>",
          "bodyInnerHTML": "`fo^öbarbaz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`fo^öbarbaz´</body>"
        },
        "body": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`fo^öbarbaz´",
          "innerHTML": "`fo^öbarbaz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`fo^öbarbaz´</body>",
          "bodyInnerHTML": "`fo^öbarbaz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`fo^öbarbaz´</body>"
        },
        "div": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`fo^öbarbaz´",
          "innerHTML": "`fo^öbarbaz´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\">`fo^öbarbaz´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\">`fo^öbarbaz´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\">`fo^öbarbaz´</div>CAN<br>ARY</body>"
        }
      },
      "CHAR-3_SC": {
        "dM": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`fo^öbarbaz´",
          "innerHTML": "`fo^öbarbaz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`fo^öbarbaz´</body>",
          "bodyInnerHTML": "`fo^öbarbaz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`fo^öbarbaz´</body>"
        },
        "body": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`fo^öbarbaz´",
          "innerHTML": "`fo^öbarbaz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`fo^öbarbaz´</body>",
          "bodyInnerHTML": "`fo^öbarbaz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`fo^öbarbaz´</body>"
        },
        "div": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`fo^öbarbaz´",
          "innerHTML": "`fo^öbarbaz´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\">`fo^öbarbaz´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\">`fo^öbarbaz´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\">`fo^öbarbaz´</div>CAN<br>ARY</body>"
        }
      },
      "CHAR-4_SC": {
        "dM": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`fo^o̤barbaz´",
          "innerHTML": "`fo^o̤barbaz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`fo^o̤barbaz´</body>",
          "bodyInnerHTML": "`fo^o̤barbaz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`fo^o̤barbaz´</body>"
        },
        "body": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`fo^o̤barbaz´",
          "innerHTML": "`fo^o̤barbaz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`fo^o̤barbaz´</body>",
          "bodyInnerHTML": "`fo^o̤barbaz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`fo^o̤barbaz´</body>"
        },
        "div": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`fo^o̤barbaz´",
          "innerHTML": "`fo^o̤barbaz´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\">`fo^o̤barbaz´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\">`fo^o̤barbaz´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\">`fo^o̤barbaz´</div>CAN<br>ARY</body>"
        }
      },
      "CHAR-5_SC": {
        "dM": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`fo^ö̤barbaz´",
          "innerHTML": "`fo^ö̤barbaz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`fo^ö̤barbaz´</body>",
          "bodyInnerHTML": "`fo^ö̤barbaz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`fo^ö̤barbaz´</body>"
        },
        "body": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`fo^ö̤barbaz´",
          "innerHTML": "`fo^ö̤barbaz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`fo^ö̤barbaz´</body>",
          "bodyInnerHTML": "`fo^ö̤barbaz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`fo^ö̤barbaz´</body>"
        },
        "div": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`fo^ö̤barbaz´",
          "innerHTML": "`fo^ö̤barbaz´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\">`fo^ö̤barbaz´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\">`fo^ö̤barbaz´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\">`fo^ö̤barbaz´</div>CAN<br>ARY</body>"
        }
      },
      "CHAR-6_SC": {
        "dM": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`fo^o⃞barbaz´",
          "innerHTML": "`fo^o⃞barbaz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`fo^o⃞barbaz´</body>",
          "bodyInnerHTML": "`fo^o⃞barbaz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`fo^o⃞barbaz´</body>"
        },
        "body": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`fo^o⃞barbaz´",
          "innerHTML": "`fo^o⃞barbaz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`fo^o⃞barbaz´</body>",
          "bodyInnerHTML": "`fo^o⃞barbaz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`fo^o⃞barbaz´</body>"
        },
        "div": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`fo^o⃞barbaz´",
          "innerHTML": "`fo^o⃞barbaz´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\">`fo^o⃞barbaz´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\">`fo^o⃞barbaz´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\">`fo^o⃞barbaz´</div>CAN<br>ARY</body>"
        }
      },
      "CHAR-7_SC": {
        "dM": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`fo^o̸barbaz´",
          "innerHTML": "`fo^o̸barbaz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`fo^o̸barbaz´</body>",
          "bodyInnerHTML": "`fo^o̸barbaz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`fo^o̸barbaz´</body>"
        },
        "body": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`fo^o̸barbaz´",
          "innerHTML": "`fo^o̸barbaz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`fo^o̸barbaz´</body>",
          "bodyInnerHTML": "`fo^o̸barbaz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`fo^o̸barbaz´</body>"
        },
        "div": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`fo^o̸barbaz´",
          "innerHTML": "`fo^o̸barbaz´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\">`fo^o̸barbaz´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\">`fo^o̸barbaz´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\">`fo^o̸barbaz´</div>CAN<br>ARY</body>"
        }
      },
      "TEXT-1_SI": {
        "dM": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`foo[bar]baz´",
          "innerHTML": "`foo[bar]baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo[bar]baz´</body>",
          "bodyInnerHTML": "`foo[bar]baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo[bar]baz´</body>"
        },
        "body": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`foo[bar]baz´",
          "innerHTML": "`foo[bar]baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo[bar]baz´</body>",
          "bodyInnerHTML": "`foo[bar]baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo[bar]baz´</body>"
        },
        "div": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`foo[bar]baz´",
          "innerHTML": "`foo[bar]baz´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\">`foo[bar]baz´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\">`foo[bar]baz´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\">`foo[bar]baz´</div>CAN<br>ARY</body>"
        }
      },
      "B-1_SE": {
        "dM": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`foo´<b>`bar^´</b>`baz´",
          "innerHTML": "`foo´<b>`bar^´</b>`baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo´<b>`bar^´</b>`baz´</body>",
          "bodyInnerHTML": "`foo´<b>`bar^´</b>`baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo´<b>`bar^´</b>`baz´</body>"
        },
        "body": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`foo´<b>`bar^´</b>`baz´",
          "innerHTML": "`foo´<b>`bar^´</b>`baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo´<b>`bar^´</b>`baz´</body>",
          "bodyInnerHTML": "`foo´<b>`bar^´</b>`baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo´<b>`bar^´</b>`baz´</body>"
        },
        "div": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`foo´<b>`bar^´</b>`baz´",
          "innerHTML": "`foo´<b>`bar^´</b>`baz´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\">`foo´<b>`bar^´</b>`baz´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\">`foo´<b>`bar^´</b>`baz´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\">`foo´<b>`bar^´</b>`baz´</div>CAN<br>ARY</body>"
        }
      },
      "B-1_SB": {
        "dM": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`foo^´<b>`bar´</b>`baz´",
          "innerHTML": "`foo^´<b>`bar´</b>`baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo^´<b>`bar´</b>`baz´</body>",
          "bodyInnerHTML": "`foo^´<b>`bar´</b>`baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo^´<b>`bar´</b>`baz´</body>"
        },
        "body": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`foo^´<b>`bar´</b>`baz´",
          "innerHTML": "`foo^´<b>`bar´</b>`baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo^´<b>`bar´</b>`baz´</body>",
          "bodyInnerHTML": "`foo^´<b>`bar´</b>`baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo^´<b>`bar´</b>`baz´</body>"
        },
        "div": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`foo^´<b>`bar´</b>`baz´",
          "innerHTML": "`foo^´<b>`bar´</b>`baz´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\">`foo^´<b>`bar´</b>`baz´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\">`foo^´<b>`bar´</b>`baz´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\">`foo^´<b>`bar´</b>`baz´</div>CAN<br>ARY</body>"
        }
      },
      "B-1_SW": {
        "dM": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`foo´<b>`[bar]´</b>`baz´",
          "innerHTML": "`foo´<b>`[bar]´</b>`baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo´<b>`[bar]´</b>`baz´</body>",
          "bodyInnerHTML": "`foo´<b>`[bar]´</b>`baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo´<b>`[bar]´</b>`baz´</body>"
        },
        "body": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`foo´<b>`[bar]´</b>`baz´",
          "innerHTML": "`foo´<b>`[bar]´</b>`baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo´<b>`[bar]´</b>`baz´</body>",
          "bodyInnerHTML": "`foo´<b>`[bar]´</b>`baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo´<b>`[bar]´</b>`baz´</body>"
        },
        "div": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`foo´<b>`[bar]´</b>`baz´",
          "innerHTML": "`foo´<b>`[bar]´</b>`baz´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\">`foo´<b>`[bar]´</b>`baz´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\">`foo´<b>`[bar]´</b>`baz´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\">`foo´<b>`[bar]´</b>`baz´</div>CAN<br>ARY</body>"
        }
      },
      "B-1_SO": {
        "dM": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`foo[´<b>`bar´</b>`]baz´",
          "innerHTML": "`foo[´<b>`bar´</b>`]baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo[´<b>`bar´</b>`]baz´</body>",
          "bodyInnerHTML": "`foo[´<b>`bar´</b>`]baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo[´<b>`bar´</b>`]baz´</body>"
        },
        "body": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`foo[´<b>`bar´</b>`]baz´",
          "innerHTML": "`foo[´<b>`bar´</b>`]baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo[´<b>`bar´</b>`]baz´</body>",
          "bodyInnerHTML": "`foo[´<b>`bar´</b>`]baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo[´<b>`bar´</b>`]baz´</body>"
        },
        "div": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`foo[´<b>`bar´</b>`]baz´",
          "innerHTML": "`foo[´<b>`bar´</b>`]baz´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\">`foo[´<b>`bar´</b>`]baz´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\">`foo[´<b>`bar´</b>`]baz´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\">`foo[´<b>`bar´</b>`]baz´</div>CAN<br>ARY</body>"
        }
      },
      "B-1_SL": {
        "dM": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`foo[bar´<b>`baz]quoz´</b>`quuz´",
          "innerHTML": "`foo[bar´<b>`baz]quoz´</b>`quuz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo[bar´<b>`baz]quoz´</b>`quuz´</body>",
          "bodyInnerHTML": "`foo[bar´<b>`baz]quoz´</b>`quuz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo[bar´<b>`baz]quoz´</b>`quuz´</body>"
        },
        "body": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`foo[bar´<b>`baz]quoz´</b>`quuz´",
          "innerHTML": "`foo[bar´<b>`baz]quoz´</b>`quuz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo[bar´<b>`baz]quoz´</b>`quuz´</body>",
          "bodyInnerHTML": "`foo[bar´<b>`baz]quoz´</b>`quuz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo[bar´<b>`baz]quoz´</b>`quuz´</body>"
        },
        "div": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`foo[bar´<b>`baz]quoz´</b>`quuz´",
          "innerHTML": "`foo[bar´<b>`baz]quoz´</b>`quuz´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\">`foo[bar´<b>`baz]quoz´</b>`quuz´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\">`foo[bar´<b>`baz]quoz´</b>`quuz´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\">`foo[bar´<b>`baz]quoz´</b>`quuz´</div>CAN<br>ARY</body>"
        }
      },
      "B-1_SR": {
        "dM": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`foo´<b>`bar[baz´</b>`quoz]quuz´",
          "innerHTML": "`foo´<b>`bar[baz´</b>`quoz]quuz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo´<b>`bar[baz´</b>`quoz]quuz´</body>",
          "bodyInnerHTML": "`foo´<b>`bar[baz´</b>`quoz]quuz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo´<b>`bar[baz´</b>`quoz]quuz´</body>"
        },
        "body": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`foo´<b>`bar[baz´</b>`quoz]quuz´",
          "innerHTML": "`foo´<b>`bar[baz´</b>`quoz]quuz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo´<b>`bar[baz´</b>`quoz]quuz´</body>",
          "bodyInnerHTML": "`foo´<b>`bar[baz´</b>`quoz]quuz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo´<b>`bar[baz´</b>`quoz]quuz´</body>"
        },
        "div": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`foo´<b>`bar[baz´</b>`quoz]quuz´",
          "innerHTML": "`foo´<b>`bar[baz´</b>`quoz]quuz´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\">`foo´<b>`bar[baz´</b>`quoz]quuz´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\">`foo´<b>`bar[baz´</b>`quoz]quuz´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\">`foo´<b>`bar[baz´</b>`quoz]quuz´</div>CAN<br>ARY</body>"
        }
      },
      "B.I-1_SM": {
        "dM": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`foo´<b>`bar[baz´</b><i>`qoz]quuz´</i>`quuuz´",
          "innerHTML": "`foo´<b>`bar[baz´</b><i>`qoz]quuz´</i>`quuuz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo´<b>`bar[baz´</b><i>`qoz]quuz´</i>`quuuz´</body>",
          "bodyInnerHTML": "`foo´<b>`bar[baz´</b><i>`qoz]quuz´</i>`quuuz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo´<b>`bar[baz´</b><i>`qoz]quuz´</i>`quuuz´</body>"
        },
        "body": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`foo´<b>`bar[baz´</b><i>`qoz]quuz´</i>`quuuz´",
          "innerHTML": "`foo´<b>`bar[baz´</b><i>`qoz]quuz´</i>`quuuz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo´<b>`bar[baz´</b><i>`qoz]quuz´</i>`quuuz´</body>",
          "bodyInnerHTML": "`foo´<b>`bar[baz´</b><i>`qoz]quuz´</i>`quuuz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo´<b>`bar[baz´</b><i>`qoz]quuz´</i>`quuuz´</body>"
        },
        "div": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`foo´<b>`bar[baz´</b><i>`qoz]quuz´</i>`quuuz´",
          "innerHTML": "`foo´<b>`bar[baz´</b><i>`qoz]quuz´</i>`quuuz´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\">`foo´<b>`bar[baz´</b><i>`qoz]quuz´</i>`quuuz´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\">`foo´<b>`bar[baz´</b><i>`qoz]quuz´</i>`quuuz´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\">`foo´<b>`bar[baz´</b><i>`qoz]quuz´</i>`quuuz´</div>CAN<br>ARY</body>"
        }
      },
      "GEN-1_SE": {
        "dM": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`foo´<gen>`bar^´</gen>`baz´",
          "innerHTML": "`foo´<gen>`bar^´</gen>`baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo´<gen>`bar^´</gen>`baz´</body>",
          "bodyInnerHTML": "`foo´<gen>`bar^´</gen>`baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo´<gen>`bar^´</gen>`baz´</body>"
        },
        "body": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`foo´<gen>`bar^´</gen>`baz´",
          "innerHTML": "`foo´<gen>`bar^´</gen>`baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo´<gen>`bar^´</gen>`baz´</body>",
          "bodyInnerHTML": "`foo´<gen>`bar^´</gen>`baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo´<gen>`bar^´</gen>`baz´</body>"
        },
        "div": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`foo´<gen>`bar^´</gen>`baz´",
          "innerHTML": "`foo´<gen>`bar^´</gen>`baz´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\">`foo´<gen>`bar^´</gen>`baz´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\">`foo´<gen>`bar^´</gen>`baz´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\">`foo´<gen>`bar^´</gen>`baz´</div>CAN<br>ARY</body>"
        }
      },
      "GEN-1_SB": {
        "dM": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`foo^´<gen>`bar´</gen>`baz´",
          "innerHTML": "`foo^´<gen>`bar´</gen>`baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo^´<gen>`bar´</gen>`baz´</body>",
          "bodyInnerHTML": "`foo^´<gen>`bar´</gen>`baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo^´<gen>`bar´</gen>`baz´</body>"
        },
        "body": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`foo^´<gen>`bar´</gen>`baz´",
          "innerHTML": "`foo^´<gen>`bar´</gen>`baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo^´<gen>`bar´</gen>`baz´</body>",
          "bodyInnerHTML": "`foo^´<gen>`bar´</gen>`baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo^´<gen>`bar´</gen>`baz´</body>"
        },
        "div": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`foo^´<gen>`bar´</gen>`baz´",
          "innerHTML": "`foo^´<gen>`bar´</gen>`baz´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\">`foo^´<gen>`bar´</gen>`baz´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\">`foo^´<gen>`bar´</gen>`baz´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\">`foo^´<gen>`bar´</gen>`baz´</div>CAN<br>ARY</body>"
        }
      },
      "P2-1_SE1": {
        "dM": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "<p>`foobar^´</p><p>`bazqoz´</p>",
          "innerHTML": "<p>`foobar^´</p><p>`bazqoz´</p>",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\"><p>`foobar^´</p><p>`bazqoz´</p></body>",
          "bodyInnerHTML": "<p>`foobar^´</p><p>`bazqoz´</p>",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\"><p>`foobar^´</p><p>`bazqoz´</p></body>"
        },
        "body": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "<p>`foobar^´</p><p>`bazqoz´</p>",
          "innerHTML": "<p>`foobar^´</p><p>`bazqoz´</p>",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\"><p>`foobar^´</p><p>`bazqoz´</p></body>",
          "bodyInnerHTML": "<p>`foobar^´</p><p>`bazqoz´</p>",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\"><p>`foobar^´</p><p>`bazqoz´</p></body>"
        },
        "div": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "<p>`foobar^´</p><p>`bazqoz´</p>",
          "innerHTML": "<p>`foobar^´</p><p>`bazqoz´</p>",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\"><p>`foobar^´</p><p>`bazqoz´</p></div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\"><p>`foobar^´</p><p>`bazqoz´</p></div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\"><p>`foobar^´</p><p>`bazqoz´</p></div>CAN<br>ARY</body>"
        }
      },
      "P2-1_SI1": {
        "dM": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "<p>`foo[bar]´</p><p>`bazqoz´</p>",
          "innerHTML": "<p>`foo[bar]´</p><p>`bazqoz´</p>",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\"><p>`foo[bar]´</p><p>`bazqoz´</p></body>",
          "bodyInnerHTML": "<p>`foo[bar]´</p><p>`bazqoz´</p>",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\"><p>`foo[bar]´</p><p>`bazqoz´</p></body>"
        },
        "body": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "<p>`foo[bar]´</p><p>`bazqoz´</p>",
          "innerHTML": "<p>`foo[bar]´</p><p>`bazqoz´</p>",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\"><p>`foo[bar]´</p><p>`bazqoz´</p></body>",
          "bodyInnerHTML": "<p>`foo[bar]´</p><p>`bazqoz´</p>",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\"><p>`foo[bar]´</p><p>`bazqoz´</p></body>"
        },
        "div": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "<p>`foo[bar]´</p><p>`bazqoz´</p>",
          "innerHTML": "<p>`foo[bar]´</p><p>`bazqoz´</p>",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\"><p>`foo[bar]´</p><p>`bazqoz´</p></div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\"><p>`foo[bar]´</p><p>`bazqoz´</p></div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\"><p>`foo[bar]´</p><p>`bazqoz´</p></div>CAN<br>ARY</body>"
        }
      },
      "P2-1_SM": {
        "dM": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "<p>`foo[bar´</p><p>`baz]qoz´</p>",
          "innerHTML": "<p>`foo[bar´</p><p>`baz]qoz´</p>",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\"><p>`foo[bar´</p><p>`baz]qoz´</p></body>",
          "bodyInnerHTML": "<p>`foo[bar´</p><p>`baz]qoz´</p>",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\"><p>`foo[bar´</p><p>`baz]qoz´</p></body>"
        },
        "body": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "<p>`foo[bar´</p><p>`baz]qoz´</p>",
          "innerHTML": "<p>`foo[bar´</p><p>`baz]qoz´</p>",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\"><p>`foo[bar´</p><p>`baz]qoz´</p></body>",
          "bodyInnerHTML": "<p>`foo[bar´</p><p>`baz]qoz´</p>",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\"><p>`foo[bar´</p><p>`baz]qoz´</p></body>"
        },
        "div": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "<p>`foo[bar´</p><p>`baz]qoz´</p>",
          "innerHTML": "<p>`foo[bar´</p><p>`baz]qoz´</p>",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\"><p>`foo[bar´</p><p>`baz]qoz´</p></div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\"><p>`foo[bar´</p><p>`baz]qoz´</p></div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\"><p>`foo[bar´</p><p>`baz]qoz´</p></div>CAN<br>ARY</body>"
        }
      },
      "OL-LI2-1_SO1": {
        "dM": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`foo´<ol>{<li>`bar´</li>}<li>`baz´</li></ol>`qoz´",
          "innerHTML": "`foo´<ol>{<li>`bar´</li>}<li>`baz´</li></ol>`qoz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo´<ol>{<li>`bar´</li>}<li>`baz´</li></ol>`qoz´</body>",
          "bodyInnerHTML": "`foo´<ol>{<li>`bar´</li>}<li>`baz´</li></ol>`qoz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo´<ol>{<li>`bar´</li>}<li>`baz´</li></ol>`qoz´</body>"
        },
        "body": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`foo´<ol>{<li>`bar´</li>}<li>`baz´</li></ol>`qoz´",
          "innerHTML": "`foo´<ol>{<li>`bar´</li>}<li>`baz´</li></ol>`qoz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo´<ol>{<li>`bar´</li>}<li>`baz´</li></ol>`qoz´</body>",
          "bodyInnerHTML": "`foo´<ol>{<li>`bar´</li>}<li>`baz´</li></ol>`qoz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo´<ol>{<li>`bar´</li>}<li>`baz´</li></ol>`qoz´</body>"
        },
        "div": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`foo´<ol>{<li>`bar´</li>}<li>`baz´</li></ol>`qoz´",
          "innerHTML": "`foo´<ol>{<li>`bar´</li>}<li>`baz´</li></ol>`qoz´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\">`foo´<ol>{<li>`bar´</li>}<li>`baz´</li></ol>`qoz´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\">`foo´<ol>{<li>`bar´</li>}<li>`baz´</li></ol>`qoz´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\">`foo´<ol>{<li>`bar´</li>}<li>`baz´</li></ol>`qoz´</div>CAN<br>ARY</body>"
        }
      },
      "OL-LI2-1_SM": {
        "dM": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`foo´<ol><li>`ba[r´</li><li>`b]az´</li></ol>`qoz´",
          "innerHTML": "`foo´<ol><li>`ba[r´</li><li>`b]az´</li></ol>`qoz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo´<ol><li>`ba[r´</li><li>`b]az´</li></ol>`qoz´</body>",
          "bodyInnerHTML": "`foo´<ol><li>`ba[r´</li><li>`b]az´</li></ol>`qoz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo´<ol><li>`ba[r´</li><li>`b]az´</li></ol>`qoz´</body>"
        },
        "body": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`foo´<ol><li>`ba[r´</li><li>`b]az´</li></ol>`qoz´",
          "innerHTML": "`foo´<ol><li>`ba[r´</li><li>`b]az´</li></ol>`qoz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo´<ol><li>`ba[r´</li><li>`b]az´</li></ol>`qoz´</body>",
          "bodyInnerHTML": "`foo´<ol><li>`ba[r´</li><li>`b]az´</li></ol>`qoz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo´<ol><li>`ba[r´</li><li>`b]az´</li></ol>`qoz´</body>"
        },
        "div": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`foo´<ol><li>`ba[r´</li><li>`b]az´</li></ol>`qoz´",
          "innerHTML": "`foo´<ol><li>`ba[r´</li><li>`b]az´</li></ol>`qoz´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\">`foo´<ol><li>`ba[r´</li><li>`b]az´</li></ol>`qoz´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\">`foo´<ol><li>`ba[r´</li><li>`b]az´</li></ol>`qoz´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\">`foo´<ol><li>`ba[r´</li><li>`b]az´</li></ol>`qoz´</div>CAN<br>ARY</body>"
        }
      },
      "OL-LI-1_SW": {
        "dM": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`foo´<ol><li>`[foo]´</li></ol>`qoz´",
          "innerHTML": "`foo´<ol><li>`[foo]´</li></ol>`qoz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo´<ol><li>`[foo]´</li></ol>`qoz´</body>",
          "bodyInnerHTML": "`foo´<ol><li>`[foo]´</li></ol>`qoz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo´<ol><li>`[foo]´</li></ol>`qoz´</body>"
        },
        "body": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`foo´<ol><li>`[foo]´</li></ol>`qoz´",
          "innerHTML": "`foo´<ol><li>`[foo]´</li></ol>`qoz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo´<ol><li>`[foo]´</li></ol>`qoz´</body>",
          "bodyInnerHTML": "`foo´<ol><li>`[foo]´</li></ol>`qoz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo´<ol><li>`[foo]´</li></ol>`qoz´</body>"
        },
        "div": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`foo´<ol><li>`[foo]´</li></ol>`qoz´",
          "innerHTML": "`foo´<ol><li>`[foo]´</li></ol>`qoz´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\">`foo´<ol><li>`[foo]´</li></ol>`qoz´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\">`foo´<ol><li>`[foo]´</li></ol>`qoz´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\">`foo´<ol><li>`[foo]´</li></ol>`qoz´</div>CAN<br>ARY</body>"
        }
      },
      "OL-LI-1_SO": {
        "dM": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`foo´<ol>{<li>`foo´</li>}</ol>`qoz´",
          "innerHTML": "`foo´<ol>{<li>`foo´</li>}</ol>`qoz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo´<ol>{<li>`foo´</li>}</ol>`qoz´</body>",
          "bodyInnerHTML": "`foo´<ol>{<li>`foo´</li>}</ol>`qoz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo´<ol>{<li>`foo´</li>}</ol>`qoz´</body>"
        },
        "body": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`foo´<ol>{<li>`foo´</li>}</ol>`qoz´",
          "innerHTML": "`foo´<ol>{<li>`foo´</li>}</ol>`qoz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo´<ol>{<li>`foo´</li>}</ol>`qoz´</body>",
          "bodyInnerHTML": "`foo´<ol>{<li>`foo´</li>}</ol>`qoz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo´<ol>{<li>`foo´</li>}</ol>`qoz´</body>"
        },
        "div": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`foo´<ol>{<li>`foo´</li>}</ol>`qoz´",
          "innerHTML": "`foo´<ol>{<li>`foo´</li>}</ol>`qoz´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\">`foo´<ol>{<li>`foo´</li>}</ol>`qoz´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\">`foo´<ol>{<li>`foo´</li>}</ol>`qoz´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\">`foo´<ol>{<li>`foo´</li>}</ol>`qoz´</div>CAN<br>ARY</body>"
        }
      },
      "HR.BR-1_SM": {
        "dM": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`foo´<hr>{`bar´}<br>`baz´",
          "innerHTML": "`foo´<hr>{`bar´}<br>`baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo´<hr>{`bar´}<br>`baz´</body>",
          "bodyInnerHTML": "`foo´<hr>{`bar´}<br>`baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo´<hr>{`bar´}<br>`baz´</body>"
        },
        "body": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`foo´<hr>{`bar´}<br>`baz´",
          "innerHTML": "`foo´<hr>{`bar´}<br>`baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo´<hr>{`bar´}<br>`baz´</body>",
          "bodyInnerHTML": "`foo´<hr>{`bar´}<br>`baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo´<hr>{`bar´}<br>`baz´</body>"
        },
        "div": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`foo´<hr>{`bar´}<br>`baz´",
          "innerHTML": "`foo´<hr>{`bar´}<br>`baz´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\">`foo´<hr>{`bar´}<br>`baz´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\">`foo´<hr>{`bar´}<br>`baz´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\">`foo´<hr>{`bar´}<br>`baz´</div>CAN<br>ARY</body>"
        }
      },
      "TABLE-1_SB": {
        "dM": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`foo^´<table><tbody><tr><td>`bar´</td></tr></tbody></table>`baz´",
          "innerHTML": "`foo^´<table><tbody><tr><td>`bar´</td></tr></tbody></table>`baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo^´<table><tbody><tr><td>`bar´</td></tr></tbody></table>`baz´</body>",
          "bodyInnerHTML": "`foo^´<table><tbody><tr><td>`bar´</td></tr></tbody></table>`baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo^´<table><tbody><tr><td>`bar´</td></tr></tbody></table>`baz´</body>"
        },
        "body": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`foo^´<table><tbody><tr><td>`bar´</td></tr></tbody></table>`baz´",
          "innerHTML": "`foo^´<table><tbody><tr><td>`bar´</td></tr></tbody></table>`baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo^´<table><tbody><tr><td>`bar´</td></tr></tbody></table>`baz´</body>",
          "bodyInnerHTML": "`foo^´<table><tbody><tr><td>`bar´</td></tr></tbody></table>`baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo^´<table><tbody><tr><td>`bar´</td></tr></tbody></table>`baz´</body>"
        },
        "div": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`foo^´<table><tbody><tr><td>`bar´</td></tr></tbody></table>`baz´",
          "innerHTML": "`foo^´<table><tbody><tr><td>`bar´</td></tr></tbody></table>`baz´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\">`foo^´<table><tbody><tr><td>`bar´</td></tr></tbody></table>`baz´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\">`foo^´<table><tbody><tr><td>`bar´</td></tr></tbody></table>`baz´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\">`foo^´<table><tbody><tr><td>`bar´</td></tr></tbody></table>`baz´</div>CAN<br>ARY</body>"
        }
      },
      "TD-1_SE": {
        "dM": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`foo´<table><tbody><tr><td>`bar^´</td></tr></tbody></table>`baz´",
          "innerHTML": "`foo´<table><tbody><tr><td>`bar^´</td></tr></tbody></table>`baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo´<table><tbody><tr><td>`bar^´</td></tr></tbody></table>`baz´</body>",
          "bodyInnerHTML": "`foo´<table><tbody><tr><td>`bar^´</td></tr></tbody></table>`baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo´<table><tbody><tr><td>`bar^´</td></tr></tbody></table>`baz´</body>"
        },
        "body": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`foo´<table><tbody><tr><td>`bar^´</td></tr></tbody></table>`baz´",
          "innerHTML": "`foo´<table><tbody><tr><td>`bar^´</td></tr></tbody></table>`baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo´<table><tbody><tr><td>`bar^´</td></tr></tbody></table>`baz´</body>",
          "bodyInnerHTML": "`foo´<table><tbody><tr><td>`bar^´</td></tr></tbody></table>`baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo´<table><tbody><tr><td>`bar^´</td></tr></tbody></table>`baz´</body>"
        },
        "div": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`foo´<table><tbody><tr><td>`bar^´</td></tr></tbody></table>`baz´",
          "innerHTML": "`foo´<table><tbody><tr><td>`bar^´</td></tr></tbody></table>`baz´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\">`foo´<table><tbody><tr><td>`bar^´</td></tr></tbody></table>`baz´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\">`foo´<table><tbody><tr><td>`bar^´</td></tr></tbody></table>`baz´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\">`foo´<table><tbody><tr><td>`bar^´</td></tr></tbody></table>`baz´</div>CAN<br>ARY</body>"
        }
      },
      "TD2-1_SE1": {
        "dM": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`foo´<table><tbody><tr><td>`bar^´</td><td>`baz´</td></tr></tbody></table>`quoz´",
          "innerHTML": "`foo´<table><tbody><tr><td>`bar^´</td><td>`baz´</td></tr></tbody></table>`quoz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo´<table><tbody><tr><td>`bar^´</td><td>`baz´</td></tr></tbody></table>`quoz´</body>",
          "bodyInnerHTML": "`foo´<table><tbody><tr><td>`bar^´</td><td>`baz´</td></tr></tbody></table>`quoz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo´<table><tbody><tr><td>`bar^´</td><td>`baz´</td></tr></tbody></table>`quoz´</body>"
        },
        "body": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`foo´<table><tbody><tr><td>`bar^´</td><td>`baz´</td></tr></tbody></table>`quoz´",
          "innerHTML": "`foo´<table><tbody><tr><td>`bar^´</td><td>`baz´</td></tr></tbody></table>`quoz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo´<table><tbody><tr><td>`bar^´</td><td>`baz´</td></tr></tbody></table>`quoz´</body>",
          "bodyInnerHTML": "`foo´<table><tbody><tr><td>`bar^´</td><td>`baz´</td></tr></tbody></table>`quoz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo´<table><tbody><tr><td>`bar^´</td><td>`baz´</td></tr></tbody></table>`quoz´</body>"
        },
        "div": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`foo´<table><tbody><tr><td>`bar^´</td><td>`baz´</td></tr></tbody></table>`quoz´",
          "innerHTML": "`foo´<table><tbody><tr><td>`bar^´</td><td>`baz´</td></tr></tbody></table>`quoz´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\">`foo´<table><tbody><tr><td>`bar^´</td><td>`baz´</td></tr></tbody></table>`quoz´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\">`foo´<table><tbody><tr><td>`bar^´</td><td>`baz´</td></tr></tbody></table>`quoz´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\">`foo´<table><tbody><tr><td>`bar^´</td><td>`baz´</td></tr></tbody></table>`quoz´</div>CAN<br>ARY</body>"
        }
      },
      "TD2-1_SM": {
        "dM": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`foo´<table><tbody><tr><td>`ba[r´</td><td>`b]az´</td></tr></tbody></table>`quoz´",
          "innerHTML": "`foo´<table><tbody><tr><td>`ba[r´</td><td>`b]az´</td></tr></tbody></table>`quoz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo´<table><tbody><tr><td>`ba[r´</td><td>`b]az´</td></tr></tbody></table>`quoz´</body>",
          "bodyInnerHTML": "`foo´<table><tbody><tr><td>`ba[r´</td><td>`b]az´</td></tr></tbody></table>`quoz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo´<table><tbody><tr><td>`ba[r´</td><td>`b]az´</td></tr></tbody></table>`quoz´</body>"
        },
        "body": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`foo´<table><tbody><tr><td>`ba[r´</td><td>`b]az´</td></tr></tbody></table>`quoz´",
          "innerHTML": "`foo´<table><tbody><tr><td>`ba[r´</td><td>`b]az´</td></tr></tbody></table>`quoz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo´<table><tbody><tr><td>`ba[r´</td><td>`b]az´</td></tr></tbody></table>`quoz´</body>",
          "bodyInnerHTML": "`foo´<table><tbody><tr><td>`ba[r´</td><td>`b]az´</td></tr></tbody></table>`quoz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo´<table><tbody><tr><td>`ba[r´</td><td>`b]az´</td></tr></tbody></table>`quoz´</body>"
        },
        "div": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`foo´<table><tbody><tr><td>`ba[r´</td><td>`b]az´</td></tr></tbody></table>`quoz´",
          "innerHTML": "`foo´<table><tbody><tr><td>`ba[r´</td><td>`b]az´</td></tr></tbody></table>`quoz´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\">`foo´<table><tbody><tr><td>`ba[r´</td><td>`b]az´</td></tr></tbody></table>`quoz´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\">`foo´<table><tbody><tr><td>`ba[r´</td><td>`b]az´</td></tr></tbody></table>`quoz´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\">`foo´<table><tbody><tr><td>`ba[r´</td><td>`b]az´</td></tr></tbody></table>`quoz´</div>CAN<br>ARY</body>"
        }
      },
      "TR3-1_SO1": {
        "dM": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "<table><tbody>{<tr><td>`A´</td></tr>}<tr><td>`B´</td></tr><tr><td>`C´</td></tr></tbody></table>",
          "innerHTML": "<table><tbody>{<tr><td>`A´</td></tr>}<tr><td>`B´</td></tr><tr><td>`C´</td></tr></tbody></table>",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\"><table><tbody>{<tr><td>`A´</td></tr>}<tr><td>`B´</td></tr><tr><td>`C´</td></tr></tbody></table></body>",
          "bodyInnerHTML": "<table><tbody>{<tr><td>`A´</td></tr>}<tr><td>`B´</td></tr><tr><td>`C´</td></tr></tbody></table>",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\"><table><tbody>{<tr><td>`A´</td></tr>}<tr><td>`B´</td></tr><tr><td>`C´</td></tr></tbody></table></body>"
        },
        "body": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "<table><tbody>{<tr><td>`A´</td></tr>}<tr><td>`B´</td></tr><tr><td>`C´</td></tr></tbody></table>",
          "innerHTML": "<table><tbody>{<tr><td>`A´</td></tr>}<tr><td>`B´</td></tr><tr><td>`C´</td></tr></tbody></table>",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\"><table><tbody>{<tr><td>`A´</td></tr>}<tr><td>`B´</td></tr><tr><td>`C´</td></tr></tbody></table></body>",
          "bodyInnerHTML": "<table><tbody>{<tr><td>`A´</td></tr>}<tr><td>`B´</td></tr><tr><td>`C´</td></tr></tbody></table>",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\"><table><tbody>{<tr><td>`A´</td></tr>}<tr><td>`B´</td></tr><tr><td>`C´</td></tr></tbody></table></body>"
        },
        "div": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "<table><tbody>{<tr><td>`A´</td></tr>}<tr><td>`B´</td></tr><tr><td>`C´</td></tr></tbody></table>",
          "innerHTML": "<table><tbody>{<tr><td>`A´</td></tr>}<tr><td>`B´</td></tr><tr><td>`C´</td></tr></tbody></table>",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\"><table><tbody>{<tr><td>`A´</td></tr>}<tr><td>`B´</td></tr><tr><td>`C´</td></tr></tbody></table></div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\"><table><tbody>{<tr><td>`A´</td></tr>}<tr><td>`B´</td></tr><tr><td>`C´</td></tr></tbody></table></div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\"><table><tbody>{<tr><td>`A´</td></tr>}<tr><td>`B´</td></tr><tr><td>`C´</td></tr></tbody></table></div>CAN<br>ARY</body>"
        }
      },
      "TR3-1_SO2": {
        "dM": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "<table><tbody><tr><td>`A´</td></tr>{<tr><td>`B´</td></tr>}<tr><td>`C´</td></tr></tbody></table>",
          "innerHTML": "<table><tbody><tr><td>`A´</td></tr>{<tr><td>`B´</td></tr>}<tr><td>`C´</td></tr></tbody></table>",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\"><table><tbody><tr><td>`A´</td></tr>{<tr><td>`B´</td></tr>}<tr><td>`C´</td></tr></tbody></table></body>",
          "bodyInnerHTML": "<table><tbody><tr><td>`A´</td></tr>{<tr><td>`B´</td></tr>}<tr><td>`C´</td></tr></tbody></table>",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\"><table><tbody><tr><td>`A´</td></tr>{<tr><td>`B´</td></tr>}<tr><td>`C´</td></tr></tbody></table></body>"
        },
        "body": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "<table><tbody><tr><td>`A´</td></tr>{<tr><td>`B´</td></tr>}<tr><td>`C´</td></tr></tbody></table>",
          "innerHTML": "<table><tbody><tr><td>`A´</td></tr>{<tr><td>`B´</td></tr>}<tr><td>`C´</td></tr></tbody></table>",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\"><table><tbody><tr><td>`A´</td></tr>{<tr><td>`B´</td></tr>}<tr><td>`C´</td></tr></tbody></table></body>",
          "bodyInnerHTML": "<table><tbody><tr><td>`A´</td></tr>{<tr><td>`B´</td></tr>}<tr><td>`C´</td></tr></tbody></table>",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\"><table><tbody><tr><td>`A´</td></tr>{<tr><td>`B´</td></tr>}<tr><td>`C´</td></tr></tbody></table></body>"
        },
        "div": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "<table><tbody><tr><td>`A´</td></tr>{<tr><td>`B´</td></tr>}<tr><td>`C´</td></tr></tbody></table>",
          "innerHTML": "<table><tbody><tr><td>`A´</td></tr>{<tr><td>`B´</td></tr>}<tr><td>`C´</td></tr></tbody></table>",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\"><table><tbody><tr><td>`A´</td></tr>{<tr><td>`B´</td></tr>}<tr><td>`C´</td></tr></tbody></table></div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\"><table><tbody><tr><td>`A´</td></tr>{<tr><td>`B´</td></tr>}<tr><td>`C´</td></tr></tbody></table></div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\"><table><tbody><tr><td>`A´</td></tr>{<tr><td>`B´</td></tr>}<tr><td>`C´</td></tr></tbody></table></div>CAN<br>ARY</body>"
        }
      },
      "TR3-1_SO3": {
        "dM": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "<table><tbody><tr><td>`A´</td></tr><tr><td>`B´</td></tr>{<tr><td>`C´</td></tr>}</tbody></table>",
          "innerHTML": "<table><tbody><tr><td>`A´</td></tr><tr><td>`B´</td></tr>{<tr><td>`C´</td></tr>}</tbody></table>",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\"><table><tbody><tr><td>`A´</td></tr><tr><td>`B´</td></tr>{<tr><td>`C´</td></tr>}</tbody></table></body>",
          "bodyInnerHTML": "<table><tbody><tr><td>`A´</td></tr><tr><td>`B´</td></tr>{<tr><td>`C´</td></tr>}</tbody></table>",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\"><table><tbody><tr><td>`A´</td></tr><tr><td>`B´</td></tr>{<tr><td>`C´</td></tr>}</tbody></table></body>"
        },
        "body": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "<table><tbody><tr><td>`A´</td></tr><tr><td>`B´</td></tr>{<tr><td>`C´</td></tr>}</tbody></table>",
          "innerHTML": "<table><tbody><tr><td>`A´</td></tr><tr><td>`B´</td></tr>{<tr><td>`C´</td></tr>}</tbody></table>",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\"><table><tbody><tr><td>`A´</td></tr><tr><td>`B´</td></tr>{<tr><td>`C´</td></tr>}</tbody></table></body>",
          "bodyInnerHTML": "<table><tbody><tr><td>`A´</td></tr><tr><td>`B´</td></tr>{<tr><td>`C´</td></tr>}</tbody></table>",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\"><table><tbody><tr><td>`A´</td></tr><tr><td>`B´</td></tr>{<tr><td>`C´</td></tr>}</tbody></table></body>"
        },
        "div": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "<table><tbody><tr><td>`A´</td></tr><tr><td>`B´</td></tr>{<tr><td>`C´</td></tr>}</tbody></table>",
          "innerHTML": "<table><tbody><tr><td>`A´</td></tr><tr><td>`B´</td></tr>{<tr><td>`C´</td></tr>}</tbody></table>",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\"><table><tbody><tr><td>`A´</td></tr><tr><td>`B´</td></tr>{<tr><td>`C´</td></tr>}</tbody></table></div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\"><table><tbody><tr><td>`A´</td></tr><tr><td>`B´</td></tr>{<tr><td>`C´</td></tr>}</tbody></table></div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\"><table><tbody><tr><td>`A´</td></tr><tr><td>`B´</td></tr>{<tr><td>`C´</td></tr>}</tbody></table></div>CAN<br>ARY</body>"
        }
      },
      "TR2rs:2-1_SO1": {
        "dM": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "<table><tbody>{<tr><td>`A´</td><td rowspan=\"2\">`R´</td></tr>}<tr><td>`B´</td></tr></tbody></table>",
          "innerHTML": "<table><tbody>{<tr><td>`A´</td><td rowspan=\"2\">`R´</td></tr>}<tr><td>`B´</td></tr></tbody></table>",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\"><table><tbody>{<tr><td>`A´</td><td rowspan=\"2\">`R´</td></tr>}<tr><td>`B´</td></tr></tbody></table></body>",
          "bodyInnerHTML": "<table><tbody>{<tr><td>`A´</td><td rowspan=\"2\">`R´</td></tr>}<tr><td>`B´</td></tr></tbody></table>",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\"><table><tbody>{<tr><td>`A´</td><td rowspan=\"2\">`R´</td></tr>}<tr><td>`B´</td></tr></tbody></table></body>"
        },
        "body": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "<table><tbody>{<tr><td>`A´</td><td rowspan=\"2\">`R´</td></tr>}<tr><td>`B´</td></tr></tbody></table>",
          "innerHTML": "<table><tbody>{<tr><td>`A´</td><td rowspan=\"2\">`R´</td></tr>}<tr><td>`B´</td></tr></tbody></table>",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\"><table><tbody>{<tr><td>`A´</td><td rowspan=\"2\">`R´</td></tr>}<tr><td>`B´</td></tr></tbody></table></body>",
          "bodyInnerHTML": "<table><tbody>{<tr><td>`A´</td><td rowspan=\"2\">`R´</td></tr>}<tr><td>`B´</td></tr></tbody></table>",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\"><table><tbody>{<tr><td>`A´</td><td rowspan=\"2\">`R´</td></tr>}<tr><td>`B´</td></tr></tbody></table></body>"
        },
        "div": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "<table><tbody>{<tr><td>`A´</td><td rowspan=\"2\">`R´</td></tr>}<tr><td>`B´</td></tr></tbody></table>",
          "innerHTML": "<table><tbody>{<tr><td>`A´</td><td rowspan=\"2\">`R´</td></tr>}<tr><td>`B´</td></tr></tbody></table>",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\"><table><tbody>{<tr><td>`A´</td><td rowspan=\"2\">`R´</td></tr>}<tr><td>`B´</td></tr></tbody></table></div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\"><table><tbody>{<tr><td>`A´</td><td rowspan=\"2\">`R´</td></tr>}<tr><td>`B´</td></tr></tbody></table></div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\"><table><tbody>{<tr><td>`A´</td><td rowspan=\"2\">`R´</td></tr>}<tr><td>`B´</td></tr></tbody></table></div>CAN<br>ARY</body>"
        }
      },
      "TR2rs:2-1_SO2": {
        "dM": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "<table><tbody><tr><td>`A´</td><td rowspan=\"2\">`R´</td></tr>{<tr><td>`B´</td></tr>}</tbody></table>",
          "innerHTML": "<table><tbody><tr><td>`A´</td><td rowspan=\"2\">`R´</td></tr>{<tr><td>`B´</td></tr>}</tbody></table>",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\"><table><tbody><tr><td>`A´</td><td rowspan=\"2\">`R´</td></tr>{<tr><td>`B´</td></tr>}</tbody></table></body>",
          "bodyInnerHTML": "<table><tbody><tr><td>`A´</td><td rowspan=\"2\">`R´</td></tr>{<tr><td>`B´</td></tr>}</tbody></table>",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\"><table><tbody><tr><td>`A´</td><td rowspan=\"2\">`R´</td></tr>{<tr><td>`B´</td></tr>}</tbody></table></body>"
        },
        "body": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "<table><tbody><tr><td>`A´</td><td rowspan=\"2\">`R´</td></tr>{<tr><td>`B´</td></tr>}</tbody></table>",
          "innerHTML": "<table><tbody><tr><td>`A´</td><td rowspan=\"2\">`R´</td></tr>{<tr><td>`B´</td></tr>}</tbody></table>",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\"><table><tbody><tr><td>`A´</td><td rowspan=\"2\">`R´</td></tr>{<tr><td>`B´</td></tr>}</tbody></table></body>",
          "bodyInnerHTML": "<table><tbody><tr><td>`A´</td><td rowspan=\"2\">`R´</td></tr>{<tr><td>`B´</td></tr>}</tbody></table>",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\"><table><tbody><tr><td>`A´</td><td rowspan=\"2\">`R´</td></tr>{<tr><td>`B´</td></tr>}</tbody></table></body>"
        },
        "div": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "<table><tbody><tr><td>`A´</td><td rowspan=\"2\">`R´</td></tr>{<tr><td>`B´</td></tr>}</tbody></table>",
          "innerHTML": "<table><tbody><tr><td>`A´</td><td rowspan=\"2\">`R´</td></tr>{<tr><td>`B´</td></tr>}</tbody></table>",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\"><table><tbody><tr><td>`A´</td><td rowspan=\"2\">`R´</td></tr>{<tr><td>`B´</td></tr>}</tbody></table></div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\"><table><tbody><tr><td>`A´</td><td rowspan=\"2\">`R´</td></tr>{<tr><td>`B´</td></tr>}</tbody></table></div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\"><table><tbody><tr><td>`A´</td><td rowspan=\"2\">`R´</td></tr>{<tr><td>`B´</td></tr>}</tbody></table></div>CAN<br>ARY</body>"
        }
      },
      "TR3rs:3-1_SO1": {
        "dM": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "<table><tbody>{<tr><td>`A´</td><td rowspan=\"3\">`R´</td></tr>}<tr><td>`B´</td></tr><tr><td>`C´</td></tr></tbody></table>",
          "innerHTML": "<table><tbody>{<tr><td>`A´</td><td rowspan=\"3\">`R´</td></tr>}<tr><td>`B´</td></tr><tr><td>`C´</td></tr></tbody></table>",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\"><table><tbody>{<tr><td>`A´</td><td rowspan=\"3\">`R´</td></tr>}<tr><td>`B´</td></tr><tr><td>`C´</td></tr></tbody></table></body>",
          "bodyInnerHTML": "<table><tbody>{<tr><td>`A´</td><td rowspan=\"3\">`R´</td></tr>}<tr><td>`B´</td></tr><tr><td>`C´</td></tr></tbody></table>",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\"><table><tbody>{<tr><td>`A´</td><td rowspan=\"3\">`R´</td></tr>}<tr><td>`B´</td></tr><tr><td>`C´</td></tr></tbody></table></body>"
        },
        "body": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "<table><tbody>{<tr><td>`A´</td><td rowspan=\"3\">`R´</td></tr>}<tr><td>`B´</td></tr><tr><td>`C´</td></tr></tbody></table>",
          "innerHTML": "<table><tbody>{<tr><td>`A´</td><td rowspan=\"3\">`R´</td></tr>}<tr><td>`B´</td></tr><tr><td>`C´</td></tr></tbody></table>",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\"><table><tbody>{<tr><td>`A´</td><td rowspan=\"3\">`R´</td></tr>}<tr><td>`B´</td></tr><tr><td>`C´</td></tr></tbody></table></body>",
          "bodyInnerHTML": "<table><tbody>{<tr><td>`A´</td><td rowspan=\"3\">`R´</td></tr>}<tr><td>`B´</td></tr><tr><td>`C´</td></tr></tbody></table>",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\"><table><tbody>{<tr><td>`A´</td><td rowspan=\"3\">`R´</td></tr>}<tr><td>`B´</td></tr><tr><td>`C´</td></tr></tbody></table></body>"
        },
        "div": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "<table><tbody>{<tr><td>`A´</td><td rowspan=\"3\">`R´</td></tr>}<tr><td>`B´</td></tr><tr><td>`C´</td></tr></tbody></table>",
          "innerHTML": "<table><tbody>{<tr><td>`A´</td><td rowspan=\"3\">`R´</td></tr>}<tr><td>`B´</td></tr><tr><td>`C´</td></tr></tbody></table>",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\"><table><tbody>{<tr><td>`A´</td><td rowspan=\"3\">`R´</td></tr>}<tr><td>`B´</td></tr><tr><td>`C´</td></tr></tbody></table></div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\"><table><tbody>{<tr><td>`A´</td><td rowspan=\"3\">`R´</td></tr>}<tr><td>`B´</td></tr><tr><td>`C´</td></tr></tbody></table></div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\"><table><tbody>{<tr><td>`A´</td><td rowspan=\"3\">`R´</td></tr>}<tr><td>`B´</td></tr><tr><td>`C´</td></tr></tbody></table></div>CAN<br>ARY</body>"
        }
      },
      "TR3rs:3-1_SO2": {
        "dM": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "<table><tbody><tr><td>`A´</td><td rowspan=\"3\">`R´</td></tr>{<tr><td>`B´</td></tr>}<tr><td>`C´</td></tr></tbody></table>",
          "innerHTML": "<table><tbody><tr><td>`A´</td><td rowspan=\"3\">`R´</td></tr>{<tr><td>`B´</td></tr>}<tr><td>`C´</td></tr></tbody></table>",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\"><table><tbody><tr><td>`A´</td><td rowspan=\"3\">`R´</td></tr>{<tr><td>`B´</td></tr>}<tr><td>`C´</td></tr></tbody></table></body>",
          "bodyInnerHTML": "<table><tbody><tr><td>`A´</td><td rowspan=\"3\">`R´</td></tr>{<tr><td>`B´</td></tr>}<tr><td>`C´</td></tr></tbody></table>",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\"><table><tbody><tr><td>`A´</td><td rowspan=\"3\">`R´</td></tr>{<tr><td>`B´</td></tr>}<tr><td>`C´</td></tr></tbody></table></body>"
        },
        "body": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "<table><tbody><tr><td>`A´</td><td rowspan=\"3\">`R´</td></tr>{<tr><td>`B´</td></tr>}<tr><td>`C´</td></tr></tbody></table>",
          "innerHTML": "<table><tbody><tr><td>`A´</td><td rowspan=\"3\">`R´</td></tr>{<tr><td>`B´</td></tr>}<tr><td>`C´</td></tr></tbody></table>",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\"><table><tbody><tr><td>`A´</td><td rowspan=\"3\">`R´</td></tr>{<tr><td>`B´</td></tr>}<tr><td>`C´</td></tr></tbody></table></body>",
          "bodyInnerHTML": "<table><tbody><tr><td>`A´</td><td rowspan=\"3\">`R´</td></tr>{<tr><td>`B´</td></tr>}<tr><td>`C´</td></tr></tbody></table>",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\"><table><tbody><tr><td>`A´</td><td rowspan=\"3\">`R´</td></tr>{<tr><td>`B´</td></tr>}<tr><td>`C´</td></tr></tbody></table></body>"
        },
        "div": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "<table><tbody><tr><td>`A´</td><td rowspan=\"3\">`R´</td></tr>{<tr><td>`B´</td></tr>}<tr><td>`C´</td></tr></tbody></table>",
          "innerHTML": "<table><tbody><tr><td>`A´</td><td rowspan=\"3\">`R´</td></tr>{<tr><td>`B´</td></tr>}<tr><td>`C´</td></tr></tbody></table>",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\"><table><tbody><tr><td>`A´</td><td rowspan=\"3\">`R´</td></tr>{<tr><td>`B´</td></tr>}<tr><td>`C´</td></tr></tbody></table></div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\"><table><tbody><tr><td>`A´</td><td rowspan=\"3\">`R´</td></tr>{<tr><td>`B´</td></tr>}<tr><td>`C´</td></tr></tbody></table></div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\"><table><tbody><tr><td>`A´</td><td rowspan=\"3\">`R´</td></tr>{<tr><td>`B´</td></tr>}<tr><td>`C´</td></tr></tbody></table></div>CAN<br>ARY</body>"
        }
      },
      "TR3rs:3-1_SO3": {
        "dM": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "<table><tbody><tr><td>`A´</td><td rowspan=\"3\">`R´</td></tr><tr><td>`B´</td></tr>{<tr><td>`C´</td></tr>}</tbody></table>",
          "innerHTML": "<table><tbody><tr><td>`A´</td><td rowspan=\"3\">`R´</td></tr><tr><td>`B´</td></tr>{<tr><td>`C´</td></tr>}</tbody></table>",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\"><table><tbody><tr><td>`A´</td><td rowspan=\"3\">`R´</td></tr><tr><td>`B´</td></tr>{<tr><td>`C´</td></tr>}</tbody></table></body>",
          "bodyInnerHTML": "<table><tbody><tr><td>`A´</td><td rowspan=\"3\">`R´</td></tr><tr><td>`B´</td></tr>{<tr><td>`C´</td></tr>}</tbody></table>",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\"><table><tbody><tr><td>`A´</td><td rowspan=\"3\">`R´</td></tr><tr><td>`B´</td></tr>{<tr><td>`C´</td></tr>}</tbody></table></body>"
        },
        "body": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "<table><tbody><tr><td>`A´</td><td rowspan=\"3\">`R´</td></tr><tr><td>`B´</td></tr>{<tr><td>`C´</td></tr>}</tbody></table>",
          "innerHTML": "<table><tbody><tr><td>`A´</td><td rowspan=\"3\">`R´</td></tr><tr><td>`B´</td></tr>{<tr><td>`C´</td></tr>}</tbody></table>",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\"><table><tbody><tr><td>`A´</td><td rowspan=\"3\">`R´</td></tr><tr><td>`B´</td></tr>{<tr><td>`C´</td></tr>}</tbody></table></body>",
          "bodyInnerHTML": "<table><tbody><tr><td>`A´</td><td rowspan=\"3\">`R´</td></tr><tr><td>`B´</td></tr>{<tr><td>`C´</td></tr>}</tbody></table>",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\"><table><tbody><tr><td>`A´</td><td rowspan=\"3\">`R´</td></tr><tr><td>`B´</td></tr>{<tr><td>`C´</td></tr>}</tbody></table></body>"
        },
        "div": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "<table><tbody><tr><td>`A´</td><td rowspan=\"3\">`R´</td></tr><tr><td>`B´</td></tr>{<tr><td>`C´</td></tr>}</tbody></table>",
          "innerHTML": "<table><tbody><tr><td>`A´</td><td rowspan=\"3\">`R´</td></tr><tr><td>`B´</td></tr>{<tr><td>`C´</td></tr>}</tbody></table>",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\"><table><tbody><tr><td>`A´</td><td rowspan=\"3\">`R´</td></tr><tr><td>`B´</td></tr>{<tr><td>`C´</td></tr>}</tbody></table></div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\"><table><tbody><tr><td>`A´</td><td rowspan=\"3\">`R´</td></tr><tr><td>`B´</td></tr>{<tr><td>`C´</td></tr>}</tbody></table></div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\"><table><tbody><tr><td>`A´</td><td rowspan=\"3\">`R´</td></tr><tr><td>`B´</td></tr>{<tr><td>`C´</td></tr>}</tbody></table></div>CAN<br>ARY</body>"
        }
      },
      "DIV:ce:false-1_SO": {
        "dM": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`foo[bar´<div contenteditable=\"false\">`NESTED´</div>`baz]qoz´",
          "innerHTML": "`foo[bar´<div contenteditable=\"false\">`NESTED´</div>`baz]qoz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo[bar´<div contenteditable=\"false\">`NESTED´</div>`baz]qoz´</body>",
          "bodyInnerHTML": "`foo[bar´<div contenteditable=\"false\">`NESTED´</div>`baz]qoz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo[bar´<div contenteditable=\"false\">`NESTED´</div>`baz]qoz´</body>"
        },
        "body": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`foo[bar´<div contenteditable=\"false\">`NESTED´</div>`baz]qoz´",
          "innerHTML": "`foo[bar´<div contenteditable=\"false\">`NESTED´</div>`baz]qoz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo[bar´<div contenteditable=\"false\">`NESTED´</div>`baz]qoz´</body>",
          "bodyInnerHTML": "`foo[bar´<div contenteditable=\"false\">`NESTED´</div>`baz]qoz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo[bar´<div contenteditable=\"false\">`NESTED´</div>`baz]qoz´</body>"
        },
        "div": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`foo[bar´<div contenteditable=\"false\">`NESTED´</div>`baz]qoz´",
          "innerHTML": "`foo[bar´<div contenteditable=\"false\">`NESTED´</div>`baz]qoz´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\">`foo[bar´<div contenteditable=\"false\">`NESTED´</div>`baz]qoz´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\">`foo[bar´<div contenteditable=\"false\">`NESTED´</div>`baz]qoz´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\">`foo[bar´<div contenteditable=\"false\">`NESTED´</div>`baz]qoz´</div>CAN<br>ARY</body>"
        }
      },
      "DIV:ce:false-1_SB": {
        "dM": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`foobar^´<div contenteditable=\"false\">`NESTED´</div>`bazqoz´",
          "innerHTML": "`foobar^´<div contenteditable=\"false\">`NESTED´</div>`bazqoz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foobar^´<div contenteditable=\"false\">`NESTED´</div>`bazqoz´</body>",
          "bodyInnerHTML": "`foobar^´<div contenteditable=\"false\">`NESTED´</div>`bazqoz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foobar^´<div contenteditable=\"false\">`NESTED´</div>`bazqoz´</body>"
        },
        "body": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`foobar^´<div contenteditable=\"false\">`NESTED´</div>`bazqoz´",
          "innerHTML": "`foobar^´<div contenteditable=\"false\">`NESTED´</div>`bazqoz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foobar^´<div contenteditable=\"false\">`NESTED´</div>`bazqoz´</body>",
          "bodyInnerHTML": "`foobar^´<div contenteditable=\"false\">`NESTED´</div>`bazqoz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foobar^´<div contenteditable=\"false\">`NESTED´</div>`bazqoz´</body>"
        },
        "div": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`foobar^´<div contenteditable=\"false\">`NESTED´</div>`bazqoz´",
          "innerHTML": "`foobar^´<div contenteditable=\"false\">`NESTED´</div>`bazqoz´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\">`foobar^´<div contenteditable=\"false\">`NESTED´</div>`bazqoz´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\">`foobar^´<div contenteditable=\"false\">`NESTED´</div>`bazqoz´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\">`foobar^´<div contenteditable=\"false\">`NESTED´</div>`bazqoz´</div>CAN<br>ARY</body>"
        }
      },
      "DIV:ce:false-1_SL": {
        "dM": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`foo[bar´<div contenteditable=\"false\">`NES]TED´</div>`bazqoz´",
          "innerHTML": "`foo[bar´<div contenteditable=\"false\">`NES]TED´</div>`bazqoz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo[bar´<div contenteditable=\"false\">`NES]TED´</div>`bazqoz´</body>",
          "bodyInnerHTML": "`foo[bar´<div contenteditable=\"false\">`NES]TED´</div>`bazqoz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo[bar´<div contenteditable=\"false\">`NES]TED´</div>`bazqoz´</body>"
        },
        "body": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`foo[bar´<div contenteditable=\"false\">`NES]TED´</div>`bazqoz´",
          "innerHTML": "`foo[bar´<div contenteditable=\"false\">`NES]TED´</div>`bazqoz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo[bar´<div contenteditable=\"false\">`NES]TED´</div>`bazqoz´</body>",
          "bodyInnerHTML": "`foo[bar´<div contenteditable=\"false\">`NES]TED´</div>`bazqoz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo[bar´<div contenteditable=\"false\">`NES]TED´</div>`bazqoz´</body>"
        },
        "div": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`foo[bar´<div contenteditable=\"false\">`NES]TED´</div>`bazqoz´",
          "innerHTML": "`foo[bar´<div contenteditable=\"false\">`NES]TED´</div>`bazqoz´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\">`foo[bar´<div contenteditable=\"false\">`NES]TED´</div>`bazqoz´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\">`foo[bar´<div contenteditable=\"false\">`NES]TED´</div>`bazqoz´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\">`foo[bar´<div contenteditable=\"false\">`NES]TED´</div>`bazqoz´</div>CAN<br>ARY</body>"
        }
      },
      "DIV:ce:false-1_SR": {
        "dM": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`foobar´<div contenteditable=\"false\">`NES[TED´</div>`baz]qoz´",
          "innerHTML": "`foobar´<div contenteditable=\"false\">`NES[TED´</div>`baz]qoz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foobar´<div contenteditable=\"false\">`NES[TED´</div>`baz]qoz´</body>",
          "bodyInnerHTML": "`foobar´<div contenteditable=\"false\">`NES[TED´</div>`baz]qoz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foobar´<div contenteditable=\"false\">`NES[TED´</div>`baz]qoz´</body>"
        },
        "body": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`foobar´<div contenteditable=\"false\">`NES[TED´</div>`baz]qoz´",
          "innerHTML": "`foobar´<div contenteditable=\"false\">`NES[TED´</div>`baz]qoz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foobar´<div contenteditable=\"false\">`NES[TED´</div>`baz]qoz´</body>",
          "bodyInnerHTML": "`foobar´<div contenteditable=\"false\">`NES[TED´</div>`baz]qoz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foobar´<div contenteditable=\"false\">`NES[TED´</div>`baz]qoz´</body>"
        },
        "div": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`foobar´<div contenteditable=\"false\">`NES[TED´</div>`baz]qoz´",
          "innerHTML": "`foobar´<div contenteditable=\"false\">`NES[TED´</div>`baz]qoz´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\">`foobar´<div contenteditable=\"false\">`NES[TED´</div>`baz]qoz´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\">`foobar´<div contenteditable=\"false\">`NES[TED´</div>`baz]qoz´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\">`foobar´<div contenteditable=\"false\">`NES[TED´</div>`baz]qoz´</div>CAN<br>ARY</body>"
        }
      },
      "DIV:ce:false-1_SI": {
        "dM": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`foobar´<div contenteditable=\"false\">`NE[ST]ED´</div>`bazqoz´",
          "innerHTML": "`foobar´<div contenteditable=\"false\">`NE[ST]ED´</div>`bazqoz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foobar´<div contenteditable=\"false\">`NE[ST]ED´</div>`bazqoz´</body>",
          "bodyInnerHTML": "`foobar´<div contenteditable=\"false\">`NE[ST]ED´</div>`bazqoz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foobar´<div contenteditable=\"false\">`NE[ST]ED´</div>`bazqoz´</body>"
        },
        "body": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`foobar´<div contenteditable=\"false\">`NE[ST]ED´</div>`bazqoz´",
          "innerHTML": "`foobar´<div contenteditable=\"false\">`NE[ST]ED´</div>`bazqoz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foobar´<div contenteditable=\"false\">`NE[ST]ED´</div>`bazqoz´</body>",
          "bodyInnerHTML": "`foobar´<div contenteditable=\"false\">`NE[ST]ED´</div>`bazqoz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foobar´<div contenteditable=\"false\">`NE[ST]ED´</div>`bazqoz´</body>"
        },
        "div": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`foobar´<div contenteditable=\"false\">`NE[ST]ED´</div>`bazqoz´",
          "innerHTML": "`foobar´<div contenteditable=\"false\">`NE[ST]ED´</div>`bazqoz´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\">`foobar´<div contenteditable=\"false\">`NE[ST]ED´</div>`bazqoz´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\">`foobar´<div contenteditable=\"false\">`NE[ST]ED´</div>`bazqoz´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\">`foobar´<div contenteditable=\"false\">`NE[ST]ED´</div>`bazqoz´</div>CAN<br>ARY</body>"
        }
      },
      "SPAN:d:ib-1_SC": {
        "dM": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`foo´<span style=\"display: inline-block\">`bar^baz´</span>`qoz´",
          "innerHTML": "`foo´<span style=\"display: inline-block\">`bar^baz´</span>`qoz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo´<span style=\"display: inline-block\">`bar^baz´</span>`qoz´</body>",
          "bodyInnerHTML": "`foo´<span style=\"display: inline-block\">`bar^baz´</span>`qoz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo´<span style=\"display: inline-block\">`bar^baz´</span>`qoz´</body>"
        },
        "body": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`foo´<span style=\"display: inline-block\">`bar^baz´</span>`qoz´",
          "innerHTML": "`foo´<span style=\"display: inline-block\">`bar^baz´</span>`qoz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo´<span style=\"display: inline-block\">`bar^baz´</span>`qoz´</body>",
          "bodyInnerHTML": "`foo´<span style=\"display: inline-block\">`bar^baz´</span>`qoz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo´<span style=\"display: inline-block\">`bar^baz´</span>`qoz´</body>"
        },
        "div": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`foo´<span style=\"display: inline-block\">`bar^baz´</span>`qoz´",
          "innerHTML": "`foo´<span style=\"display: inline-block\">`bar^baz´</span>`qoz´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\">`foo´<span style=\"display: inline-block\">`bar^baz´</span>`qoz´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\">`foo´<span style=\"display: inline-block\">`bar^baz´</span>`qoz´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\">`foo´<span style=\"display: inline-block\">`bar^baz´</span>`qoz´</div>CAN<br>ARY</body>"
        }
      },
      "SPAN:d:ib-1_SA": {
        "dM": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`foo^´<span style=\"display: inline-block\">`barbaz´</span>`qoz´",
          "innerHTML": "`foo^´<span style=\"display: inline-block\">`barbaz´</span>`qoz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo^´<span style=\"display: inline-block\">`barbaz´</span>`qoz´</body>",
          "bodyInnerHTML": "`foo^´<span style=\"display: inline-block\">`barbaz´</span>`qoz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo^´<span style=\"display: inline-block\">`barbaz´</span>`qoz´</body>"
        },
        "body": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`foo^´<span style=\"display: inline-block\">`barbaz´</span>`qoz´",
          "innerHTML": "`foo^´<span style=\"display: inline-block\">`barbaz´</span>`qoz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo^´<span style=\"display: inline-block\">`barbaz´</span>`qoz´</body>",
          "bodyInnerHTML": "`foo^´<span style=\"display: inline-block\">`barbaz´</span>`qoz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo^´<span style=\"display: inline-block\">`barbaz´</span>`qoz´</body>"
        },
        "div": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`foo^´<span style=\"display: inline-block\">`barbaz´</span>`qoz´",
          "innerHTML": "`foo^´<span style=\"display: inline-block\">`barbaz´</span>`qoz´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\">`foo^´<span style=\"display: inline-block\">`barbaz´</span>`qoz´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\">`foo^´<span style=\"display: inline-block\">`barbaz´</span>`qoz´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\">`foo^´<span style=\"display: inline-block\">`barbaz´</span>`qoz´</div>CAN<br>ARY</body>"
        }
      },
      "SPAN:d:ib-2_SL": {
        "dM": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`foo[DEL´<span style=\"display: inline-block\">`ETE]bar´</span>`baz´",
          "innerHTML": "`foo[DEL´<span style=\"display: inline-block\">`ETE]bar´</span>`baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo[DEL´<span style=\"display: inline-block\">`ETE]bar´</span>`baz´</body>",
          "bodyInnerHTML": "`foo[DEL´<span style=\"display: inline-block\">`ETE]bar´</span>`baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo[DEL´<span style=\"display: inline-block\">`ETE]bar´</span>`baz´</body>"
        },
        "body": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`foo[DEL´<span style=\"display: inline-block\">`ETE]bar´</span>`baz´",
          "innerHTML": "`foo[DEL´<span style=\"display: inline-block\">`ETE]bar´</span>`baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo[DEL´<span style=\"display: inline-block\">`ETE]bar´</span>`baz´</body>",
          "bodyInnerHTML": "`foo[DEL´<span style=\"display: inline-block\">`ETE]bar´</span>`baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo[DEL´<span style=\"display: inline-block\">`ETE]bar´</span>`baz´</body>"
        },
        "div": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`foo[DEL´<span style=\"display: inline-block\">`ETE]bar´</span>`baz´",
          "innerHTML": "`foo[DEL´<span style=\"display: inline-block\">`ETE]bar´</span>`baz´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\">`foo[DEL´<span style=\"display: inline-block\">`ETE]bar´</span>`baz´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\">`foo[DEL´<span style=\"display: inline-block\">`ETE]bar´</span>`baz´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\">`foo[DEL´<span style=\"display: inline-block\">`ETE]bar´</span>`baz´</div>CAN<br>ARY</body>"
        }
      },
      "SPAN:d:ib-3_SR": {
        "dM": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`foo´<span style=\"display: inline-block\">`bar[DEL´</span>`ETE]baz´",
          "innerHTML": "`foo´<span style=\"display: inline-block\">`bar[DEL´</span>`ETE]baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo´<span style=\"display: inline-block\">`bar[DEL´</span>`ETE]baz´</body>",
          "bodyInnerHTML": "`foo´<span style=\"display: inline-block\">`bar[DEL´</span>`ETE]baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo´<span style=\"display: inline-block\">`bar[DEL´</span>`ETE]baz´</body>"
        },
        "body": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`foo´<span style=\"display: inline-block\">`bar[DEL´</span>`ETE]baz´",
          "innerHTML": "`foo´<span style=\"display: inline-block\">`bar[DEL´</span>`ETE]baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo´<span style=\"display: inline-block\">`bar[DEL´</span>`ETE]baz´</body>",
          "bodyInnerHTML": "`foo´<span style=\"display: inline-block\">`bar[DEL´</span>`ETE]baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo´<span style=\"display: inline-block\">`bar[DEL´</span>`ETE]baz´</body>"
        },
        "div": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`foo´<span style=\"display: inline-block\">`bar[DEL´</span>`ETE]baz´",
          "innerHTML": "`foo´<span style=\"display: inline-block\">`bar[DEL´</span>`ETE]baz´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\">`foo´<span style=\"display: inline-block\">`bar[DEL´</span>`ETE]baz´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\">`foo´<span style=\"display: inline-block\">`bar[DEL´</span>`ETE]baz´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\">`foo´<span style=\"display: inline-block\">`bar[DEL´</span>`ETE]baz´</div>CAN<br>ARY</body>"
        }
      },
      "SPAN:d:ib-4i_SI": {
        "dM": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`foo´<span style=\"display: inline-block\">`bar[DELETE]baz´</span>`qoz´",
          "innerHTML": "`foo´<span style=\"display: inline-block\">`bar[DELETE]baz´</span>`qoz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo´<span style=\"display: inline-block\">`bar[DELETE]baz´</span>`qoz´</body>",
          "bodyInnerHTML": "`foo´<span style=\"display: inline-block\">`bar[DELETE]baz´</span>`qoz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo´<span style=\"display: inline-block\">`bar[DELETE]baz´</span>`qoz´</body>"
        },
        "body": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`foo´<span style=\"display: inline-block\">`bar[DELETE]baz´</span>`qoz´",
          "innerHTML": "`foo´<span style=\"display: inline-block\">`bar[DELETE]baz´</span>`qoz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo´<span style=\"display: inline-block\">`bar[DELETE]baz´</span>`qoz´</body>",
          "bodyInnerHTML": "`foo´<span style=\"display: inline-block\">`bar[DELETE]baz´</span>`qoz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo´<span style=\"display: inline-block\">`bar[DELETE]baz´</span>`qoz´</body>"
        },
        "div": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`foo´<span style=\"display: inline-block\">`bar[DELETE]baz´</span>`qoz´",
          "innerHTML": "`foo´<span style=\"display: inline-block\">`bar[DELETE]baz´</span>`qoz´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\">`foo´<span style=\"display: inline-block\">`bar[DELETE]baz´</span>`qoz´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\">`foo´<span style=\"display: inline-block\">`bar[DELETE]baz´</span>`qoz´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\">`foo´<span style=\"display: inline-block\">`bar[DELETE]baz´</span>`qoz´</div>CAN<br>ARY</body>"
        }
      },
      "SPAN:d:ib-4l_SI": {
        "dM": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`foo´<span style=\"display: inline-block\">`[DELETE]barbaz´</span>`qoz´",
          "innerHTML": "`foo´<span style=\"display: inline-block\">`[DELETE]barbaz´</span>`qoz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo´<span style=\"display: inline-block\">`[DELETE]barbaz´</span>`qoz´</body>",
          "bodyInnerHTML": "`foo´<span style=\"display: inline-block\">`[DELETE]barbaz´</span>`qoz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo´<span style=\"display: inline-block\">`[DELETE]barbaz´</span>`qoz´</body>"
        },
        "body": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`foo´<span style=\"display: inline-block\">`[DELETE]barbaz´</span>`qoz´",
          "innerHTML": "`foo´<span style=\"display: inline-block\">`[DELETE]barbaz´</span>`qoz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo´<span style=\"display: inline-block\">`[DELETE]barbaz´</span>`qoz´</body>",
          "bodyInnerHTML": "`foo´<span style=\"display: inline-block\">`[DELETE]barbaz´</span>`qoz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo´<span style=\"display: inline-block\">`[DELETE]barbaz´</span>`qoz´</body>"
        },
        "div": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`foo´<span style=\"display: inline-block\">`[DELETE]barbaz´</span>`qoz´",
          "innerHTML": "`foo´<span style=\"display: inline-block\">`[DELETE]barbaz´</span>`qoz´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\">`foo´<span style=\"display: inline-block\">`[DELETE]barbaz´</span>`qoz´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\">`foo´<span style=\"display: inline-block\">`[DELETE]barbaz´</span>`qoz´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\">`foo´<span style=\"display: inline-block\">`[DELETE]barbaz´</span>`qoz´</div>CAN<br>ARY</body>"
        }
      },
      "SPAN:d:ib-4r_SI": {
        "dM": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`foo´<span style=\"display: inline-block\">`barbaz[DELETE]´</span>`qoz´",
          "innerHTML": "`foo´<span style=\"display: inline-block\">`barbaz[DELETE]´</span>`qoz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo´<span style=\"display: inline-block\">`barbaz[DELETE]´</span>`qoz´</body>",
          "bodyInnerHTML": "`foo´<span style=\"display: inline-block\">`barbaz[DELETE]´</span>`qoz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo´<span style=\"display: inline-block\">`barbaz[DELETE]´</span>`qoz´</body>"
        },
        "body": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`foo´<span style=\"display: inline-block\">`barbaz[DELETE]´</span>`qoz´",
          "innerHTML": "`foo´<span style=\"display: inline-block\">`barbaz[DELETE]´</span>`qoz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo´<span style=\"display: inline-block\">`barbaz[DELETE]´</span>`qoz´</body>",
          "bodyInnerHTML": "`foo´<span style=\"display: inline-block\">`barbaz[DELETE]´</span>`qoz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo´<span style=\"display: inline-block\">`barbaz[DELETE]´</span>`qoz´</body>"
        },
        "div": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`foo´<span style=\"display: inline-block\">`barbaz[DELETE]´</span>`qoz´",
          "innerHTML": "`foo´<span style=\"display: inline-block\">`barbaz[DELETE]´</span>`qoz´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\">`foo´<span style=\"display: inline-block\">`barbaz[DELETE]´</span>`qoz´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\">`foo´<span style=\"display: inline-block\">`barbaz[DELETE]´</span>`qoz´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\">`foo´<span style=\"display: inline-block\">`barbaz[DELETE]´</span>`qoz´</div>CAN<br>ARY</body>"
        }
      }
    }
  },
  "I": {
    "Proposed": {
      "IHR_TEXT-1_SC": {
        "dM": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 4,
          "output": "`foo´<hr size=\"2\" width=\"100%\">|`bar´",
          "innerHTML": "`foo´<hr size=\"2\" width=\"100%\">|`bar´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo´<hr width=\"100%\" size=\"2\">|`bar´</body>",
          "bodyInnerHTML": "`foo´<hr size=\"2\" width=\"100%\">|`bar´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo´<hr width=\"100%\" size=\"2\">|`bar´</body>"
        },
        "body": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 4,
          "output": "`foo´<hr size=\"2\" width=\"100%\">|`bar´",
          "innerHTML": "`foo´<hr size=\"2\" width=\"100%\">|`bar´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo´<hr width=\"100%\" size=\"2\">|`bar´</body>",
          "bodyInnerHTML": "`foo´<hr size=\"2\" width=\"100%\">|`bar´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo´<hr width=\"100%\" size=\"2\">|`bar´</body>"
        },
        "div": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 4,
          "output": "`foo´<hr size=\"2\" width=\"100%\">|`bar´",
          "innerHTML": "`foo´<hr size=\"2\" width=\"100%\">|`bar´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\">`foo´<hr width=\"100%\" size=\"2\">|`bar´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\">`foo´<hr size=\"2\" width=\"100%\">|`bar´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\">`foo´<hr width=\"100%\" size=\"2\">|`bar´</div>CAN<br>ARY</body>"
        }
      },
      "IHR_TEXT-1_SI": {
        "dM": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 4,
          "output": "`foo´<hr size=\"2\" width=\"100%\">|`baz´",
          "innerHTML": "`foo´<hr size=\"2\" width=\"100%\">|`baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo´<hr width=\"100%\" size=\"2\">|`baz´</body>",
          "bodyInnerHTML": "`foo´<hr size=\"2\" width=\"100%\">|`baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo´<hr width=\"100%\" size=\"2\">|`baz´</body>"
        },
        "body": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 4,
          "output": "`foo´<hr size=\"2\" width=\"100%\">|`baz´",
          "innerHTML": "`foo´<hr size=\"2\" width=\"100%\">|`baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo´<hr width=\"100%\" size=\"2\">|`baz´</body>",
          "bodyInnerHTML": "`foo´<hr size=\"2\" width=\"100%\">|`baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo´<hr width=\"100%\" size=\"2\">|`baz´</body>"
        },
        "div": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 4,
          "output": "`foo´<hr size=\"2\" width=\"100%\">|`baz´",
          "innerHTML": "`foo´<hr size=\"2\" width=\"100%\">|`baz´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\">`foo´<hr width=\"100%\" size=\"2\">|`baz´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\">`foo´<hr size=\"2\" width=\"100%\">|`baz´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\">`foo´<hr width=\"100%\" size=\"2\">|`baz´</div>CAN<br>ARY</body>"
        }
      },
      "IHR_DIV-B-1_SX": {
        "dM": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "<div><b>`foo´</b><hr size=\"2\" width=\"100%\">|<b>`bar´</b></div>",
          "innerHTML": "<div><b>`foo´</b><hr size=\"2\" width=\"100%\">|<b>`bar´</b></div>",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\"><div><b>`foo´</b><hr width=\"100%\" size=\"2\">|<b>`bar´</b></div></body>",
          "bodyInnerHTML": "<div><b>`foo´</b><hr size=\"2\" width=\"100%\">|<b>`bar´</b></div>",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\"><div><b>`foo´</b><hr width=\"100%\" size=\"2\">|<b>`bar´</b></div></body>"
        },
        "body": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "<div><b>`foo´</b><hr size=\"2\" width=\"100%\">|<b>`bar´</b></div>",
          "innerHTML": "<div><b>`foo´</b><hr size=\"2\" width=\"100%\">|<b>`bar´</b></div>",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\"><div><b>`foo´</b><hr width=\"100%\" size=\"2\">|<b>`bar´</b></div></body>",
          "bodyInnerHTML": "<div><b>`foo´</b><hr size=\"2\" width=\"100%\">|<b>`bar´</b></div>",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\"><div><b>`foo´</b><hr width=\"100%\" size=\"2\">|<b>`bar´</b></div></body>"
        },
        "div": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "<div><b>`foo´</b><hr size=\"2\" width=\"100%\">|<b>`bar´</b></div>",
          "innerHTML": "<div><b>`foo´</b><hr size=\"2\" width=\"100%\">|<b>`bar´</b></div>",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\"><div><b>`foo´</b><hr width=\"100%\" size=\"2\">|<b>`bar´</b></div></div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\"><div><b>`foo´</b><hr size=\"2\" width=\"100%\">|<b>`bar´</b></div></div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\"><div><b>`foo´</b><hr width=\"100%\" size=\"2\">|<b>`bar´</b></div></div>CAN<br>ARY</body>"
        }
      },
      "IHR_DIV-B-2_SO": {
        "dM": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "<div><b>`foo´</b><hr size=\"2\" width=\"100%\">|<b>`baz´</b></div>",
          "innerHTML": "<div><b>`foo´</b><hr size=\"2\" width=\"100%\">|<b>`baz´</b></div>",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\"><div><b>`foo´</b><hr width=\"100%\" size=\"2\">|<b>`baz´</b></div></body>",
          "bodyInnerHTML": "<div><b>`foo´</b><hr size=\"2\" width=\"100%\">|<b>`baz´</b></div>",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\"><div><b>`foo´</b><hr width=\"100%\" size=\"2\">|<b>`baz´</b></div></body>"
        },
        "body": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "<div><b>`foo´</b><hr size=\"2\" width=\"100%\">|<b>`baz´</b></div>",
          "innerHTML": "<div><b>`foo´</b><hr size=\"2\" width=\"100%\">|<b>`baz´</b></div>",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\"><div><b>`foo´</b><hr width=\"100%\" size=\"2\">|<b>`baz´</b></div></body>",
          "bodyInnerHTML": "<div><b>`foo´</b><hr size=\"2\" width=\"100%\">|<b>`baz´</b></div>",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\"><div><b>`foo´</b><hr width=\"100%\" size=\"2\">|<b>`baz´</b></div></body>"
        },
        "div": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "<div><b>`foo´</b><hr size=\"2\" width=\"100%\">|<b>`baz´</b></div>",
          "innerHTML": "<div><b>`foo´</b><hr size=\"2\" width=\"100%\">|<b>`baz´</b></div>",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\"><div><b>`foo´</b><hr width=\"100%\" size=\"2\">|<b>`baz´</b></div></div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\"><div><b>`foo´</b><hr size=\"2\" width=\"100%\">|<b>`baz´</b></div></div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\"><div><b>`foo´</b><hr width=\"100%\" size=\"2\">|<b>`baz´</b></div></div>CAN<br>ARY</body>"
        }
      },
      "IHR_B-1_SC": {
        "dM": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 2,
          "output": "<b>`foo´</b><hr size=\"2\" width=\"100%\">|<b>`bar´</b>",
          "innerHTML": "<b>`foo´</b><hr size=\"2\" width=\"100%\">|<b>`bar´</b>",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\"><b>`foo´</b><hr width=\"100%\" size=\"2\">|<b>`bar´</b></body>",
          "bodyInnerHTML": "<b>`foo´</b><hr size=\"2\" width=\"100%\">|<b>`bar´</b>",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\"><b>`foo´</b><hr width=\"100%\" size=\"2\">|<b>`bar´</b></body>"
        },
        "body": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 2,
          "output": "<b>`foo´</b><hr size=\"2\" width=\"100%\">|<b>`bar´</b>",
          "innerHTML": "<b>`foo´</b><hr size=\"2\" width=\"100%\">|<b>`bar´</b>",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\"><b>`foo´</b><hr width=\"100%\" size=\"2\">|<b>`bar´</b></body>",
          "bodyInnerHTML": "<b>`foo´</b><hr size=\"2\" width=\"100%\">|<b>`bar´</b>",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\"><b>`foo´</b><hr width=\"100%\" size=\"2\">|<b>`bar´</b></body>"
        },
        "div": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 2,
          "output": "<b>`foo´</b><hr size=\"2\" width=\"100%\">|<b>`bar´</b>",
          "innerHTML": "<b>`foo´</b><hr size=\"2\" width=\"100%\">|<b>`bar´</b>",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\"><b>`foo´</b><hr width=\"100%\" size=\"2\">|<b>`bar´</b></div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\"><b>`foo´</b><hr size=\"2\" width=\"100%\">|<b>`bar´</b></div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\"><b>`foo´</b><hr width=\"100%\" size=\"2\">|<b>`bar´</b></div>CAN<br>ARY</body>"
        }
      },
      "IHR_B-1_SS": {
        "dM": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 2,
          "output": "<hr size=\"2\" width=\"100%\">|<b>`foobar´</b>",
          "innerHTML": "<hr size=\"2\" width=\"100%\">|<b>`foobar´</b>",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\"><hr width=\"100%\" size=\"2\">|<b>`foobar´</b></body>",
          "bodyInnerHTML": "<hr size=\"2\" width=\"100%\">|<b>`foobar´</b>",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\"><hr width=\"100%\" size=\"2\">|<b>`foobar´</b></body>"
        },
        "body": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 2,
          "output": "<hr size=\"2\" width=\"100%\">|<b>`foobar´</b>",
          "innerHTML": "<hr size=\"2\" width=\"100%\">|<b>`foobar´</b>",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\"><hr width=\"100%\" size=\"2\">|<b>`foobar´</b></body>",
          "bodyInnerHTML": "<hr size=\"2\" width=\"100%\">|<b>`foobar´</b>",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\"><hr width=\"100%\" size=\"2\">|<b>`foobar´</b></body>"
        },
        "div": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 2,
          "output": "<hr size=\"2\" width=\"100%\">|<b>`foobar´</b>",
          "innerHTML": "<hr size=\"2\" width=\"100%\">|<b>`foobar´</b>",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\"><hr width=\"100%\" size=\"2\">|<b>`foobar´</b></div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\"><hr size=\"2\" width=\"100%\">|<b>`foobar´</b></div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\"><hr width=\"100%\" size=\"2\">|<b>`foobar´</b></div>CAN<br>ARY</body>"
        }
      },
      "IHR_B-1_SE": {
        "dM": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "<b>`foobar´</b><hr size=\"2\" width=\"100%\">|",
          "innerHTML": "<b>`foobar´</b><hr size=\"2\" width=\"100%\">|",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\"><b>`foobar´</b><hr width=\"100%\" size=\"2\">|</body>",
          "bodyInnerHTML": "<b>`foobar´</b><hr size=\"2\" width=\"100%\">|",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\"><b>`foobar´</b><hr width=\"100%\" size=\"2\">|</body>"
        },
        "body": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "<b>`foobar´</b><hr size=\"2\" width=\"100%\">|",
          "innerHTML": "<b>`foobar´</b><hr size=\"2\" width=\"100%\">|",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\"><b>`foobar´</b><hr width=\"100%\" size=\"2\">|</body>",
          "bodyInnerHTML": "<b>`foobar´</b><hr size=\"2\" width=\"100%\">|",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\"><b>`foobar´</b><hr width=\"100%\" size=\"2\">|</body>"
        },
        "div": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "<b>`foobar´</b><hr size=\"2\" width=\"100%\">|",
          "innerHTML": "<b>`foobar´</b><hr size=\"2\" width=\"100%\">|",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\"><b>`foobar´</b><hr width=\"100%\" size=\"2\">|</div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\"><b>`foobar´</b><hr size=\"2\" width=\"100%\">|</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\"><b>`foobar´</b><hr width=\"100%\" size=\"2\">|</div>CAN<br>ARY</body>"
        }
      },
      "IHR_B-2_SL": {
        "dM": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`foo´<hr size=\"2\" width=\"100%\">|<b>`qoz´</b>",
          "innerHTML": "`foo´<hr size=\"2\" width=\"100%\">|<b>`qoz´</b>",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo´<hr width=\"100%\" size=\"2\">|<b>`qoz´</b></body>",
          "bodyInnerHTML": "`foo´<hr size=\"2\" width=\"100%\">|<b>`qoz´</b>",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo´<hr width=\"100%\" size=\"2\">|<b>`qoz´</b></body>"
        },
        "body": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`foo´<hr size=\"2\" width=\"100%\">|<b>`qoz´</b>",
          "innerHTML": "`foo´<hr size=\"2\" width=\"100%\">|<b>`qoz´</b>",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo´<hr width=\"100%\" size=\"2\">|<b>`qoz´</b></body>",
          "bodyInnerHTML": "`foo´<hr size=\"2\" width=\"100%\">|<b>`qoz´</b>",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo´<hr width=\"100%\" size=\"2\">|<b>`qoz´</b></body>"
        },
        "div": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`foo´<hr size=\"2\" width=\"100%\">|<b>`qoz´</b>",
          "innerHTML": "`foo´<hr size=\"2\" width=\"100%\">|<b>`qoz´</b>",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\">`foo´<hr width=\"100%\" size=\"2\">|<b>`qoz´</b></div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\">`foo´<hr size=\"2\" width=\"100%\">|<b>`qoz´</b></div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\">`foo´<hr width=\"100%\" size=\"2\">|<b>`qoz´</b></div>CAN<br>ARY</body>"
        }
      },
      "IHR_B-2_SLR": {
        "dM": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`foo´<hr size=\"2\" width=\"100%\">|<b>`qoz´</b>",
          "innerHTML": "`foo´<hr size=\"2\" width=\"100%\">|<b>`qoz´</b>",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo´<hr width=\"100%\" size=\"2\">|<b>`qoz´</b></body>",
          "bodyInnerHTML": "`foo´<hr size=\"2\" width=\"100%\">|<b>`qoz´</b>",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo´<hr width=\"100%\" size=\"2\">|<b>`qoz´</b></body>"
        },
        "body": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`foo´<hr size=\"2\" width=\"100%\">|<b>`qoz´</b>",
          "innerHTML": "`foo´<hr size=\"2\" width=\"100%\">|<b>`qoz´</b>",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo´<hr width=\"100%\" size=\"2\">|<b>`qoz´</b></body>",
          "bodyInnerHTML": "`foo´<hr size=\"2\" width=\"100%\">|<b>`qoz´</b>",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo´<hr width=\"100%\" size=\"2\">|<b>`qoz´</b></body>"
        },
        "div": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`foo´<hr size=\"2\" width=\"100%\">|<b>`qoz´</b>",
          "innerHTML": "`foo´<hr size=\"2\" width=\"100%\">|<b>`qoz´</b>",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\">`foo´<hr width=\"100%\" size=\"2\">|<b>`qoz´</b></div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\">`foo´<hr size=\"2\" width=\"100%\">|<b>`qoz´</b></div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\">`foo´<hr width=\"100%\" size=\"2\">|<b>`qoz´</b></div>CAN<br>ARY</body>"
        }
      },
      "IHR_B-3_SR": {
        "dM": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "<b>`foo´</b><hr size=\"2\" width=\"100%\">|`quoz´",
          "innerHTML": "<b>`foo´</b><hr size=\"2\" width=\"100%\">|`quoz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\"><b>`foo´</b><hr width=\"100%\" size=\"2\">|`quoz´</body>",
          "bodyInnerHTML": "<b>`foo´</b><hr size=\"2\" width=\"100%\">|`quoz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\"><b>`foo´</b><hr width=\"100%\" size=\"2\">|`quoz´</body>"
        },
        "body": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "<b>`foo´</b><hr size=\"2\" width=\"100%\">|`quoz´",
          "innerHTML": "<b>`foo´</b><hr size=\"2\" width=\"100%\">|`quoz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\"><b>`foo´</b><hr width=\"100%\" size=\"2\">|`quoz´</body>",
          "bodyInnerHTML": "<b>`foo´</b><hr size=\"2\" width=\"100%\">|`quoz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\"><b>`foo´</b><hr width=\"100%\" size=\"2\">|`quoz´</body>"
        },
        "div": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "<b>`foo´</b><hr size=\"2\" width=\"100%\">|`quoz´",
          "innerHTML": "<b>`foo´</b><hr size=\"2\" width=\"100%\">|`quoz´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\"><b>`foo´</b><hr width=\"100%\" size=\"2\">|`quoz´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\"><b>`foo´</b><hr size=\"2\" width=\"100%\">|`quoz´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\"><b>`foo´</b><hr width=\"100%\" size=\"2\">|`quoz´</div>CAN<br>ARY</body>"
        }
      },
      "IHR_B-3_SRR": {
        "dM": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "<b>`foo´</b><hr size=\"2\" width=\"100%\">|`quoz´",
          "innerHTML": "<b>`foo´</b><hr size=\"2\" width=\"100%\">|`quoz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\"><b>`foo´</b><hr width=\"100%\" size=\"2\">|`quoz´</body>",
          "bodyInnerHTML": "<b>`foo´</b><hr size=\"2\" width=\"100%\">|`quoz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\"><b>`foo´</b><hr width=\"100%\" size=\"2\">|`quoz´</body>"
        },
        "body": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "<b>`foo´</b><hr size=\"2\" width=\"100%\">|`quoz´",
          "innerHTML": "<b>`foo´</b><hr size=\"2\" width=\"100%\">|`quoz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\"><b>`foo´</b><hr width=\"100%\" size=\"2\">|`quoz´</body>",
          "bodyInnerHTML": "<b>`foo´</b><hr size=\"2\" width=\"100%\">|`quoz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\"><b>`foo´</b><hr width=\"100%\" size=\"2\">|`quoz´</body>"
        },
        "div": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "<b>`foo´</b><hr size=\"2\" width=\"100%\">|`quoz´",
          "innerHTML": "<b>`foo´</b><hr size=\"2\" width=\"100%\">|`quoz´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\"><b>`foo´</b><hr width=\"100%\" size=\"2\">|`quoz´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\"><b>`foo´</b><hr size=\"2\" width=\"100%\">|`quoz´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\"><b>`foo´</b><hr width=\"100%\" size=\"2\">|`quoz´</div>CAN<br>ARY</body>"
        }
      },
      "IHR_B-I-1_SM": {
        "dM": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "<b>`foo´</b><hr size=\"2\" width=\"100%\">|<i>`quoz´</i>",
          "innerHTML": "<b>`foo´</b><hr size=\"2\" width=\"100%\">|<i>`quoz´</i>",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\"><b>`foo´</b><hr width=\"100%\" size=\"2\">|<i>`quoz´</i></body>",
          "bodyInnerHTML": "<b>`foo´</b><hr size=\"2\" width=\"100%\">|<i>`quoz´</i>",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\"><b>`foo´</b><hr width=\"100%\" size=\"2\">|<i>`quoz´</i></body>"
        },
        "body": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "<b>`foo´</b><hr size=\"2\" width=\"100%\">|<i>`quoz´</i>",
          "innerHTML": "<b>`foo´</b><hr size=\"2\" width=\"100%\">|<i>`quoz´</i>",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\"><b>`foo´</b><hr width=\"100%\" size=\"2\">|<i>`quoz´</i></body>",
          "bodyInnerHTML": "<b>`foo´</b><hr size=\"2\" width=\"100%\">|<i>`quoz´</i>",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\"><b>`foo´</b><hr width=\"100%\" size=\"2\">|<i>`quoz´</i></body>"
        },
        "div": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "<b>`foo´</b><hr size=\"2\" width=\"100%\">|<i>`quoz´</i>",
          "innerHTML": "<b>`foo´</b><hr size=\"2\" width=\"100%\">|<i>`quoz´</i>",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\"><b>`foo´</b><hr width=\"100%\" size=\"2\">|<i>`quoz´</i></div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\"><b>`foo´</b><hr size=\"2\" width=\"100%\">|<i>`quoz´</i></div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\"><b>`foo´</b><hr width=\"100%\" size=\"2\">|<i>`quoz´</i></div>CAN<br>ARY</body>"
        }
      },
      "IHR_B-I-1_SMR": {
        "dM": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 2,
          "output": "<b>`foo´</b><hr size=\"2\" width=\"100%\">|<i>`quoz´</i>",
          "innerHTML": "<b>`foo´</b><hr size=\"2\" width=\"100%\">|<i>`quoz´</i>",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\"><b>`foo´</b><hr width=\"100%\" size=\"2\">|<i>`quoz´</i></body>",
          "bodyInnerHTML": "<b>`foo´</b><hr size=\"2\" width=\"100%\">|<i>`quoz´</i>",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\"><b>`foo´</b><hr width=\"100%\" size=\"2\">|<i>`quoz´</i></body>"
        },
        "body": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 2,
          "output": "<b>`foo´</b><hr size=\"2\" width=\"100%\">|<i>`quoz´</i>",
          "innerHTML": "<b>`foo´</b><hr size=\"2\" width=\"100%\">|<i>`quoz´</i>",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\"><b>`foo´</b><hr width=\"100%\" size=\"2\">|<i>`quoz´</i></body>",
          "bodyInnerHTML": "<b>`foo´</b><hr size=\"2\" width=\"100%\">|<i>`quoz´</i>",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\"><b>`foo´</b><hr width=\"100%\" size=\"2\">|<i>`quoz´</i></body>"
        },
        "div": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 2,
          "output": "<b>`foo´</b><hr size=\"2\" width=\"100%\">|<i>`quoz´</i>",
          "innerHTML": "<b>`foo´</b><hr size=\"2\" width=\"100%\">|<i>`quoz´</i>",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\"><b>`foo´</b><hr width=\"100%\" size=\"2\">|<i>`quoz´</i></div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\"><b>`foo´</b><hr size=\"2\" width=\"100%\">|<i>`quoz´</i></div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\"><b>`foo´</b><hr width=\"100%\" size=\"2\">|<i>`quoz´</i></div>CAN<br>ARY</body>"
        }
      },
      "IHR_P-1_SC": {
        "dM": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "<p>`foo´</p><hr size=\"2\" width=\"100%\">|<p>`bar´</p>",
          "innerHTML": "<p>`foo´</p><hr size=\"2\" width=\"100%\">|<p>`bar´</p>",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\"><p>`foo´</p><hr width=\"100%\" size=\"2\">|<p>`bar´</p></body>",
          "bodyInnerHTML": "<p>`foo´</p><hr size=\"2\" width=\"100%\">|<p>`bar´</p>",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\"><p>`foo´</p><hr width=\"100%\" size=\"2\">|<p>`bar´</p></body>"
        },
        "body": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "<p>`foo´</p><hr size=\"2\" width=\"100%\">|<p>`bar´</p>",
          "innerHTML": "<p>`foo´</p><hr size=\"2\" width=\"100%\">|<p>`bar´</p>",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\"><p>`foo´</p><hr width=\"100%\" size=\"2\">|<p>`bar´</p></body>",
          "bodyInnerHTML": "<p>`foo´</p><hr size=\"2\" width=\"100%\">|<p>`bar´</p>",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\"><p>`foo´</p><hr width=\"100%\" size=\"2\">|<p>`bar´</p></body>"
        },
        "div": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "<p>`foo´</p><hr size=\"2\" width=\"100%\">|<p>`bar´</p>",
          "innerHTML": "<p>`foo´</p><hr size=\"2\" width=\"100%\">|<p>`bar´</p>",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\"><p>`foo´</p><hr width=\"100%\" size=\"2\">|<p>`bar´</p></div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\"><p>`foo´</p><hr size=\"2\" width=\"100%\">|<p>`bar´</p></div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\"><p>`foo´</p><hr width=\"100%\" size=\"2\">|<p>`bar´</p></div>CAN<br>ARY</body>"
        }
      },
      "IHR_P-1_SS": {
        "dM": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "<hr size=\"2\" width=\"100%\">|<p>`foobar´</p>",
          "innerHTML": "<hr size=\"2\" width=\"100%\">|<p>`foobar´</p>",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\"><hr width=\"100%\" size=\"2\">|<p>`foobar´</p></body>",
          "bodyInnerHTML": "<hr size=\"2\" width=\"100%\">|<p>`foobar´</p>",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\"><hr width=\"100%\" size=\"2\">|<p>`foobar´</p></body>"
        },
        "body": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "<hr size=\"2\" width=\"100%\">|<p>`foobar´</p>",
          "innerHTML": "<hr size=\"2\" width=\"100%\">|<p>`foobar´</p>",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\"><hr width=\"100%\" size=\"2\">|<p>`foobar´</p></body>",
          "bodyInnerHTML": "<hr size=\"2\" width=\"100%\">|<p>`foobar´</p>",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\"><hr width=\"100%\" size=\"2\">|<p>`foobar´</p></body>"
        },
        "div": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "<hr size=\"2\" width=\"100%\">|<p>`foobar´</p>",
          "innerHTML": "<hr size=\"2\" width=\"100%\">|<p>`foobar´</p>",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\"><hr width=\"100%\" size=\"2\">|<p>`foobar´</p></div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\"><hr size=\"2\" width=\"100%\">|<p>`foobar´</p></div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\"><hr width=\"100%\" size=\"2\">|<p>`foobar´</p></div>CAN<br>ARY</body>"
        }
      },
      "IHR_P-1_SE": {
        "dM": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "<p>`foobar´</p><hr size=\"2\" width=\"100%\">|",
          "innerHTML": "<p>`foobar´</p><hr size=\"2\" width=\"100%\">|",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\"><p>`foobar´</p><hr width=\"100%\" size=\"2\">|</body>",
          "bodyInnerHTML": "<p>`foobar´</p><hr size=\"2\" width=\"100%\">|",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\"><p>`foobar´</p><hr width=\"100%\" size=\"2\">|</body>"
        },
        "body": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "<p>`foobar´</p><hr size=\"2\" width=\"100%\">|",
          "innerHTML": "<p>`foobar´</p><hr size=\"2\" width=\"100%\">|",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\"><p>`foobar´</p><hr width=\"100%\" size=\"2\">|</body>",
          "bodyInnerHTML": "<p>`foobar´</p><hr size=\"2\" width=\"100%\">|",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\"><p>`foobar´</p><hr width=\"100%\" size=\"2\">|</body>"
        },
        "div": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "<p>`foobar´</p><hr size=\"2\" width=\"100%\">|",
          "innerHTML": "<p>`foobar´</p><hr size=\"2\" width=\"100%\">|",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\"><p>`foobar´</p><hr width=\"100%\" size=\"2\">|</div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\"><p>`foobar´</p><hr size=\"2\" width=\"100%\">|</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\"><p>`foobar´</p><hr width=\"100%\" size=\"2\">|</div>CAN<br>ARY</body>"
        }
      },
      "IP_P-1_SC": {
        "dM": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "<p>`foo^bar´</p>",
          "innerHTML": "<p>`foo^bar´</p>",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\"><p>`foo^bar´</p></body>",
          "bodyInnerHTML": "<p>`foo^bar´</p>",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\"><p>`foo^bar´</p></body>"
        },
        "body": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "<p>`foo^bar´</p>",
          "innerHTML": "<p>`foo^bar´</p>",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\"><p>`foo^bar´</p></body>",
          "bodyInnerHTML": "<p>`foo^bar´</p>",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\"><p>`foo^bar´</p></body>"
        },
        "div": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "<p>`foo^bar´</p>",
          "innerHTML": "<p>`foo^bar´</p>",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\"><p>`foo^bar´</p></div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\"><p>`foo^bar´</p></div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\"><p>`foo^bar´</p></div>CAN<br>ARY</body>"
        }
      },
      "IP_UL-LI-1_SC": {
        "dM": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "<ul><li><p>`foo^bar´</p></li></ul>",
          "innerHTML": "<ul><li><p>`foo^bar´</p></li></ul>",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\"><ul><li><p>`foo^bar´</p></li></ul></body>",
          "bodyInnerHTML": "<ul><li><p>`foo^bar´</p></li></ul>",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\"><ul><li><p>`foo^bar´</p></li></ul></body>"
        },
        "body": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "<ul><li><p>`foo^bar´</p></li></ul>",
          "innerHTML": "<ul><li><p>`foo^bar´</p></li></ul>",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\"><ul><li><p>`foo^bar´</p></li></ul></body>",
          "bodyInnerHTML": "<ul><li><p>`foo^bar´</p></li></ul>",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\"><ul><li><p>`foo^bar´</p></li></ul></body>"
        },
        "div": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "<ul><li><p>`foo^bar´</p></li></ul>",
          "innerHTML": "<ul><li><p>`foo^bar´</p></li></ul>",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\"><ul><li><p>`foo^bar´</p></li></ul></div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\"><ul><li><p>`foo^bar´</p></li></ul></div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\"><ul><li><p>`foo^bar´</p></li></ul></div>CAN<br>ARY</body>"
        }
      },
      "ITEXT:text_TEXT-1_SC": {
        "dM": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`foo^bar´",
          "innerHTML": "`foo^bar´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo^bar´</body>",
          "bodyInnerHTML": "`foo^bar´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo^bar´</body>"
        },
        "body": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`foo^bar´",
          "innerHTML": "`foo^bar´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo^bar´</body>",
          "bodyInnerHTML": "`foo^bar´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo^bar´</body>"
        },
        "div": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`foo^bar´",
          "innerHTML": "`foo^bar´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\">`foo^bar´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\">`foo^bar´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\">`foo^bar´</div>CAN<br>ARY</body>"
        }
      },
      "ITEXT:text_TEXT-1_SI": {
        "dM": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`foo[bar]baz´",
          "innerHTML": "`foo[bar]baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo[bar]baz´</body>",
          "bodyInnerHTML": "`foo[bar]baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo[bar]baz´</body>"
        },
        "body": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`foo[bar]baz´",
          "innerHTML": "`foo[bar]baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo[bar]baz´</body>",
          "bodyInnerHTML": "`foo[bar]baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo[bar]baz´</body>"
        },
        "div": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`foo[bar]baz´",
          "innerHTML": "`foo[bar]baz´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\">`foo[bar]baz´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\">`foo[bar]baz´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\">`foo[bar]baz´</div>CAN<br>ARY</body>"
        }
      },
      "IBR_TEXT-1_SC": {
        "dM": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`foo^bar´",
          "innerHTML": "`foo^bar´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo^bar´</body>",
          "bodyInnerHTML": "`foo^bar´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo^bar´</body>"
        },
        "body": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`foo^bar´",
          "innerHTML": "`foo^bar´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo^bar´</body>",
          "bodyInnerHTML": "`foo^bar´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo^bar´</body>"
        },
        "div": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`foo^bar´",
          "innerHTML": "`foo^bar´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\">`foo^bar´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\">`foo^bar´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\">`foo^bar´</div>CAN<br>ARY</body>"
        }
      },
      "IBR_TEXT-1_SI": {
        "dM": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`foo[bar]baz´",
          "innerHTML": "`foo[bar]baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo[bar]baz´</body>",
          "bodyInnerHTML": "`foo[bar]baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo[bar]baz´</body>"
        },
        "body": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`foo[bar]baz´",
          "innerHTML": "`foo[bar]baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo[bar]baz´</body>",
          "bodyInnerHTML": "`foo[bar]baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo[bar]baz´</body>"
        },
        "div": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "`foo[bar]baz´",
          "innerHTML": "`foo[bar]baz´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\">`foo[bar]baz´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\">`foo[bar]baz´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\">`foo[bar]baz´</div>CAN<br>ARY</body>"
        }
      },
      "IBR_LI-1_SC": {
        "dM": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "<ul><li>`foo^bar´</li></ul>",
          "innerHTML": "<ul><li>`foo^bar´</li></ul>",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\"><ul><li>`foo^bar´</li></ul></body>",
          "bodyInnerHTML": "<ul><li>`foo^bar´</li></ul>",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\"><ul><li>`foo^bar´</li></ul></body>"
        },
        "body": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "<ul><li>`foo^bar´</li></ul>",
          "innerHTML": "<ul><li>`foo^bar´</li></ul>",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\"><ul><li>`foo^bar´</li></ul></body>",
          "bodyInnerHTML": "<ul><li>`foo^bar´</li></ul>",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\"><ul><li>`foo^bar´</li></ul></body>"
        },
        "div": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "<ul><li>`foo^bar´</li></ul>",
          "innerHTML": "<ul><li>`foo^bar´</li></ul>",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\"><ul><li>`foo^bar´</li></ul></div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\"><ul><li>`foo^bar´</li></ul></div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\"><ul><li>`foo^bar´</li></ul></div>CAN<br>ARY</body>"
        }
      },
      "IIMG:url_TEXT-1_SC": {
        "dM": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`foo´<img src=\"http://goo.gl/bar.png\">|`bar´",
          "innerHTML": "`foo´<img src=\"http://goo.gl/bar.png\">|`bar´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo´<img src=\"http://goo.gl/bar.png\">|`bar´</body>",
          "bodyInnerHTML": "`foo´<img src=\"http://goo.gl/bar.png\">|`bar´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo´<img src=\"http://goo.gl/bar.png\">|`bar´</body>"
        },
        "body": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`foo´<img src=\"http://goo.gl/bar.png\">|`bar´",
          "innerHTML": "`foo´<img src=\"http://goo.gl/bar.png\">|`bar´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo´<img src=\"http://goo.gl/bar.png\">|`bar´</body>",
          "bodyInnerHTML": "`foo´<img src=\"http://goo.gl/bar.png\">|`bar´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo´<img src=\"http://goo.gl/bar.png\">|`bar´</body>"
        },
        "div": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`foo´<img src=\"http://goo.gl/bar.png\">|`bar´",
          "innerHTML": "`foo´<img src=\"http://goo.gl/bar.png\">|`bar´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\">`foo´<img src=\"http://goo.gl/bar.png\">|`bar´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\">`foo´<img src=\"http://goo.gl/bar.png\">|`bar´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\">`foo´<img src=\"http://goo.gl/bar.png\">|`bar´</div>CAN<br>ARY</body>"
        }
      },
      "IIMG:url_IMG-1_SO": {
        "dM": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "<span>`foo´<img src=\"http://baz.com/quz.png\">|`bar´</span>",
          "innerHTML": "<span>`foo´<img src=\"http://baz.com/quz.png\">|`bar´</span>",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\"><span>`foo´<img src=\"http://baz.com/quz.png\">|`bar´</span></body>",
          "bodyInnerHTML": "<span>`foo´<img src=\"http://baz.com/quz.png\">|`bar´</span>",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\"><span>`foo´<img src=\"http://baz.com/quz.png\">|`bar´</span></body>"
        },
        "body": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "<span>`foo´<img src=\"http://baz.com/quz.png\">|`bar´</span>",
          "innerHTML": "<span>`foo´<img src=\"http://baz.com/quz.png\">|`bar´</span>",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\"><span>`foo´<img src=\"http://baz.com/quz.png\">|`bar´</span></body>",
          "bodyInnerHTML": "<span>`foo´<img src=\"http://baz.com/quz.png\">|`bar´</span>",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\"><span>`foo´<img src=\"http://baz.com/quz.png\">|`bar´</span></body>"
        },
        "div": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "<span>`foo´<img src=\"http://baz.com/quz.png\">|`bar´</span>",
          "innerHTML": "<span>`foo´<img src=\"http://baz.com/quz.png\">|`bar´</span>",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\"><span>`foo´<img src=\"http://baz.com/quz.png\">|`bar´</span></div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\"><span>`foo´<img src=\"http://baz.com/quz.png\">|`bar´</span></div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\"><span>`foo´<img src=\"http://baz.com/quz.png\">|`bar´</span></div>CAN<br>ARY</body>"
        }
      },
      "IIMG:url_SPAN-IMG-1_SO": {
        "dM": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`foo´<img src=\"http://baz.com/quz.png\">|`bar´",
          "innerHTML": "`foo´<img src=\"http://baz.com/quz.png\">|`bar´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo´<img src=\"http://baz.com/quz.png\">|`bar´</body>",
          "bodyInnerHTML": "`foo´<img src=\"http://baz.com/quz.png\">|`bar´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo´<img src=\"http://baz.com/quz.png\">|`bar´</body>"
        },
        "body": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`foo´<img src=\"http://baz.com/quz.png\">|`bar´",
          "innerHTML": "`foo´<img src=\"http://baz.com/quz.png\">|`bar´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo´<img src=\"http://baz.com/quz.png\">|`bar´</body>",
          "bodyInnerHTML": "`foo´<img src=\"http://baz.com/quz.png\">|`bar´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo´<img src=\"http://baz.com/quz.png\">|`bar´</body>"
        },
        "div": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`foo´<img src=\"http://baz.com/quz.png\">|`bar´",
          "innerHTML": "`foo´<img src=\"http://baz.com/quz.png\">|`bar´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\">`foo´<img src=\"http://baz.com/quz.png\">|`bar´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\">`foo´<img src=\"http://baz.com/quz.png\">|`bar´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\">`foo´<img src=\"http://baz.com/quz.png\">|`bar´</div>CAN<br>ARY</body>"
        }
      },
      "IIMG:._SPAN-IMG-1_SO": {
        "dM": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 2,
          "selresult": 3,
          "output": "EXECUTION EXCEPTION: [Exception... \"Component returned failure code: 0x80004001 (NS_ERROR_NOT_IMPLEMENTED) [nsIDOMHTMLDocument.execCommand]\"  nsresult: \"0x80004001 (NS_ERROR_NOT_IMPLEMENTED)\"  location: \"JS frame :: http://mochi.test:8888/tests/editor/libeditor/html/tests/browserscope/lib/richtext2/richtext2/static/js/run.js :: runSingleTest :: line 143\"  data: no]"
        },
        "body": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 2,
          "selresult": 3,
          "output": "EXECUTION EXCEPTION: [Exception... \"Component returned failure code: 0x80004001 (NS_ERROR_NOT_IMPLEMENTED) [nsIDOMHTMLDocument.execCommand]\"  nsresult: \"0x80004001 (NS_ERROR_NOT_IMPLEMENTED)\"  location: \"JS frame :: http://mochi.test:8888/tests/editor/libeditor/html/tests/browserscope/lib/richtext2/richtext2/static/js/run.js :: runSingleTest :: line 143\"  data: no]"
        },
        "div": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 2,
          "selresult": 3,
          "output": "EXECUTION EXCEPTION: [Exception... \"Component returned failure code: 0x80004001 (NS_ERROR_NOT_IMPLEMENTED) [nsIDOMHTMLDocument.execCommand]\"  nsresult: \"0x80004001 (NS_ERROR_NOT_IMPLEMENTED)\"  location: \"JS frame :: http://mochi.test:8888/tests/editor/libeditor/html/tests/browserscope/lib/richtext2/richtext2/static/js/run.js :: runSingleTest :: line 143\"  data: no]"
        }
      },
      "IIMG:._IMG-1_SO": {
        "dM": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 2,
          "selresult": 3,
          "output": "EXECUTION EXCEPTION: [Exception... \"Component returned failure code: 0x80004001 (NS_ERROR_NOT_IMPLEMENTED) [nsIDOMHTMLDocument.execCommand]\"  nsresult: \"0x80004001 (NS_ERROR_NOT_IMPLEMENTED)\"  location: \"JS frame :: http://mochi.test:8888/tests/editor/libeditor/html/tests/browserscope/lib/richtext2/richtext2/static/js/run.js :: runSingleTest :: line 143\"  data: no]"
        },
        "body": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 2,
          "selresult": 3,
          "output": "EXECUTION EXCEPTION: [Exception... \"Component returned failure code: 0x80004001 (NS_ERROR_NOT_IMPLEMENTED) [nsIDOMHTMLDocument.execCommand]\"  nsresult: \"0x80004001 (NS_ERROR_NOT_IMPLEMENTED)\"  location: \"JS frame :: http://mochi.test:8888/tests/editor/libeditor/html/tests/browserscope/lib/richtext2/richtext2/static/js/run.js :: runSingleTest :: line 143\"  data: no]"
        },
        "div": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 2,
          "selresult": 3,
          "output": "EXECUTION EXCEPTION: [Exception... \"Component returned failure code: 0x80004001 (NS_ERROR_NOT_IMPLEMENTED) [nsIDOMHTMLDocument.execCommand]\"  nsresult: \"0x80004001 (NS_ERROR_NOT_IMPLEMENTED)\"  location: \"JS frame :: http://mochi.test:8888/tests/editor/libeditor/html/tests/browserscope/lib/richtext2/richtext2/static/js/run.js :: runSingleTest :: line 143\"  data: no]"
        }
      },
      "IOL_TEXT-1_SC": {
        "dM": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "<ol><li>`foo^bar´</li></ol>",
          "innerHTML": "<ol><li>`foo^bar´</li></ol>",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\"><ol><li>`foo^bar´</li></ol></body>",
          "bodyInnerHTML": "<ol><li>`foo^bar´</li></ol>",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\"><ol><li>`foo^bar´</li></ol></body>"
        },
        "body": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "<ol><li>`foo^bar´</li></ol>",
          "innerHTML": "<ol><li>`foo^bar´</li></ol>",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\"><ol><li>`foo^bar´</li></ol></body>",
          "bodyInnerHTML": "<ol><li>`foo^bar´</li></ol>",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\"><ol><li>`foo^bar´</li></ol></body>"
        },
        "div": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "<ol><li>`foo^bar´</li></ol>",
          "innerHTML": "<ol><li>`foo^bar´</li></ol>",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\"><ol><li>`foo^bar´</li></ol></div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\"><ol><li>`foo^bar´</li></ol></div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\"><ol><li>`foo^bar´</li></ol></div>CAN<br>ARY</body>"
        }
      },
      "IOL_TEXT-1_SI": {
        "dM": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "<ol><li>`foo[bar]baz´</li></ol>",
          "innerHTML": "<ol><li>`foo[bar]baz´</li></ol>",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\"><ol><li>`foo[bar]baz´</li></ol></body>",
          "bodyInnerHTML": "<ol><li>`foo[bar]baz´</li></ol>",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\"><ol><li>`foo[bar]baz´</li></ol></body>"
        },
        "body": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "<ol><li>`foo[bar]baz´</li></ol>",
          "innerHTML": "<ol><li>`foo[bar]baz´</li></ol>",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\"><ol><li>`foo[bar]baz´</li></ol></body>",
          "bodyInnerHTML": "<ol><li>`foo[bar]baz´</li></ol>",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\"><ol><li>`foo[bar]baz´</li></ol></body>"
        },
        "div": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "<ol><li>`foo[bar]baz´</li></ol>",
          "innerHTML": "<ol><li>`foo[bar]baz´</li></ol>",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\"><ol><li>`foo[bar]baz´</li></ol></div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\"><ol><li>`foo[bar]baz´</li></ol></div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\"><ol><li>`foo[bar]baz´</li></ol></div>CAN<br>ARY</body>"
        }
      },
      "IUL_TEXT-1_SC": {
        "dM": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "<ul><li>`foo^bar´</li></ul>",
          "innerHTML": "<ul><li>`foo^bar´</li></ul>",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\"><ul><li>`foo^bar´</li></ul></body>",
          "bodyInnerHTML": "<ul><li>`foo^bar´</li></ul>",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\"><ul><li>`foo^bar´</li></ul></body>"
        },
        "body": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "<ul><li>`foo^bar´</li></ul>",
          "innerHTML": "<ul><li>`foo^bar´</li></ul>",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\"><ul><li>`foo^bar´</li></ul></body>",
          "bodyInnerHTML": "<ul><li>`foo^bar´</li></ul>",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\"><ul><li>`foo^bar´</li></ul></body>"
        },
        "div": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "<ul><li>`foo^bar´</li></ul>",
          "innerHTML": "<ul><li>`foo^bar´</li></ul>",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\"><ul><li>`foo^bar´</li></ul></div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\"><ul><li>`foo^bar´</li></ul></div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\"><ul><li>`foo^bar´</li></ul></div>CAN<br>ARY</body>"
        }
      },
      "IUL_TEXT-1_SI": {
        "dM": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "<ul><li>`foo[bar]baz´</li></ul>",
          "innerHTML": "<ul><li>`foo[bar]baz´</li></ul>",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\"><ul><li>`foo[bar]baz´</li></ul></body>",
          "bodyInnerHTML": "<ul><li>`foo[bar]baz´</li></ul>",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\"><ul><li>`foo[bar]baz´</li></ul></body>"
        },
        "body": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "<ul><li>`foo[bar]baz´</li></ul>",
          "innerHTML": "<ul><li>`foo[bar]baz´</li></ul>",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\"><ul><li>`foo[bar]baz´</li></ul></body>",
          "bodyInnerHTML": "<ul><li>`foo[bar]baz´</li></ul>",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\"><ul><li>`foo[bar]baz´</li></ul></body>"
        },
        "div": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "<ul><li>`foo[bar]baz´</li></ul>",
          "innerHTML": "<ul><li>`foo[bar]baz´</li></ul>",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\"><ul><li>`foo[bar]baz´</li></ul></div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\"><ul><li>`foo[bar]baz´</li></ul></div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\"><ul><li>`foo[bar]baz´</li></ul></div>CAN<br>ARY</body>"
        }
      },
      "IHTML:BR_TEXT-1_SC": {
        "dM": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 2,
          "output": "`foo´<br>|`barbaz´",
          "innerHTML": "`foo´<br>|`barbaz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo´<br>|`barbaz´</body>",
          "bodyInnerHTML": "`foo´<br>|`barbaz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo´<br>|`barbaz´</body>"
        },
        "body": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 2,
          "output": "`foo´<br>|`barbaz´",
          "innerHTML": "`foo´<br>|`barbaz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo´<br>|`barbaz´</body>",
          "bodyInnerHTML": "`foo´<br>|`barbaz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo´<br>|`barbaz´</body>"
        },
        "div": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 2,
          "output": "`foo´<br>|`barbaz´",
          "innerHTML": "`foo´<br>|`barbaz´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\">`foo´<br>|`barbaz´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\">`foo´<br>|`barbaz´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\">`foo´<br>|`barbaz´</div>CAN<br>ARY</body>"
        }
      },
      "IHTML:text_TEXT-1_SI": {
        "dM": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`fooNEW^baz´",
          "innerHTML": "`fooNEW^baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`fooNEW^baz´</body>",
          "bodyInnerHTML": "`fooNEW^baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`fooNEW^baz´</body>"
        },
        "body": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`fooNEW^baz´",
          "innerHTML": "`fooNEW^baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`fooNEW^baz´</body>",
          "bodyInnerHTML": "`fooNEW^baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`fooNEW^baz´</body>"
        },
        "div": {
          "valscore": 1,
          "selscore": 1,
          "valresult": 8,
          "selresult": 5,
          "output": "`foo´`NEW^´`baz´",
          "innerHTML": "`foo´`NEW^´`baz´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\">`foo´`NEW^´`baz´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\">`foo´`NEW^´`baz´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\">`foo´`NEW^´`baz´</div>CAN<br>ARY</body>"
        }
      },
      "IHTML:S_TEXT-1_SI": {
        "dM": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 2,
          "output": "`foo´<span>`NEW^´</span>`baz´",
          "innerHTML": "`foo´<span>`NEW^´</span>`baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo´<span>`NEW^´</span>`baz´</body>",
          "bodyInnerHTML": "`foo´<span>`NEW^´</span>`baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo´<span>`NEW^´</span>`baz´</body>"
        },
        "body": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 2,
          "output": "`foo´<span>`NEW^´</span>`baz´",
          "innerHTML": "`foo´<span>`NEW^´</span>`baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo´<span>`NEW^´</span>`baz´</body>",
          "bodyInnerHTML": "`foo´<span>`NEW^´</span>`baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo´<span>`NEW^´</span>`baz´</body>"
        },
        "div": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 2,
          "output": "`foo´<span>`NEW^´</span>`baz´",
          "innerHTML": "`foo´<span>`NEW^´</span>`baz´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\">`foo´<span>`NEW^´</span>`baz´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\">`foo´<span>`NEW^´</span>`baz´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\">`foo´<span>`NEW^´</span>`baz´</div>CAN<br>ARY</body>"
        }
      },
      "IHTML:H1.H2_TEXT-1_SI": {
        "dM": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 2,
          "output": "`foo´<h1>`NEW´</h1><h2>`HTML^´</h2>`baz´",
          "innerHTML": "`foo´<h1>`NEW´</h1><h2>`HTML^´</h2>`baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo´<h1>`NEW´</h1><h2>`HTML^´</h2>`baz´</body>",
          "bodyInnerHTML": "`foo´<h1>`NEW´</h1><h2>`HTML^´</h2>`baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo´<h1>`NEW´</h1><h2>`HTML^´</h2>`baz´</body>"
        },
        "body": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 2,
          "output": "`foo´<h1>`NEW´</h1><h2>`HTML^´</h2>`baz´",
          "innerHTML": "`foo´<h1>`NEW´</h1><h2>`HTML^´</h2>`baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo´<h1>`NEW´</h1><h2>`HTML^´</h2>`baz´</body>",
          "bodyInnerHTML": "`foo´<h1>`NEW´</h1><h2>`HTML^´</h2>`baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo´<h1>`NEW´</h1><h2>`HTML^´</h2>`baz´</body>"
        },
        "div": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 2,
          "output": "`foo´<h1>`NEW´</h1><h2>`HTML^´</h2>`baz´",
          "innerHTML": "`foo´<h1>`NEW´</h1><h2>`HTML^´</h2>`baz´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\">`foo´<h1>`NEW´</h1><h2>`HTML^´</h2>`baz´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\">`foo´<h1>`NEW´</h1><h2>`HTML^´</h2>`baz´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\">`foo´<h1>`NEW´</h1><h2>`HTML^´</h2>`baz´</div>CAN<br>ARY</body>"
        }
      },
      "IHTML:P-B_TEXT-1_SI": {
        "dM": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 2,
          "output": "`foo´<p>`NEW´<b>`HTML´</b>`!^´</p>`baz´",
          "innerHTML": "`foo´<p>`NEW´<b>`HTML´</b>`!^´</p>`baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo´<p>`NEW´<b>`HTML´</b>`!^´</p>`baz´</body>",
          "bodyInnerHTML": "`foo´<p>`NEW´<b>`HTML´</b>`!^´</p>`baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" onload=\"setDesignMode()\">`foo´<p>`NEW´<b>`HTML´</b>`!^´</p>`baz´</body>"
        },
        "body": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 2,
          "output": "`foo´<p>`NEW´<b>`HTML´</b>`!^´</p>`baz´",
          "innerHTML": "`foo´<p>`NEW´<b>`HTML´</b>`!^´</p>`baz´",
          "outerHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo´<p>`NEW´<b>`HTML´</b>`!^´</p>`baz´</body>",
          "bodyInnerHTML": "`foo´<p>`NEW´<b>`HTML´</b>`!^´</p>`baz´",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\">`foo´<p>`NEW´<b>`HTML´</b>`!^´</p>`baz´</body>"
        },
        "div": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 2,
          "output": "`foo´<p>`NEW´<b>`HTML´</b>`!^´</p>`baz´",
          "innerHTML": "`foo´<p>`NEW´<b>`HTML´</b>`!^´</p>`baz´",
          "outerHTML": "<div xmlns=\"http://www.w3.org/1999/xhtml\" contenteditable=\"true\" id=\"editor-div\">`foo´<p>`NEW´<b>`HTML´</b>`!^´</p>`baz´</div>",
          "bodyInnerHTML": "CAN<br>ARY<div id=\"editor-div\" contenteditable=\"true\">`foo´<p>`NEW´<b>`HTML´</b>`!^´</p>`baz´</div>CAN<br>ARY",
          "bodyOuterHTML": "<body xmlns=\"http://www.w3.org/1999/xhtml\">CAN<br>ARY<div contenteditable=\"true\" id=\"editor-div\">`foo´<p>`NEW´<b>`HTML´</b>`!^´</p>`baz´</div>CAN<br>ARY</body>"
        }
      }
    }
  },
  "Q": {
    "Proposed": {
      "SELECTALL_TEXT-1": {
        "dM": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": true
        },
        "body": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": true
        },
        "div": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": true
        }
      },
      "UNSELECT_TEXT-1": {
        "dM": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": false
        },
        "body": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": false
        },
        "div": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": false
        }
      },
      "UNDO_TEXT-1": {
        "dM": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": true
        },
        "body": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": true
        },
        "div": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": true
        }
      },
      "REDO_TEXT-1": {
        "dM": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": true
        },
        "body": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": true
        },
        "div": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": true
        }
      },
      "BOLD_TEXT-1": {
        "dM": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": true
        },
        "body": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": true
        },
        "div": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": true
        }
      },
      "BOLD_B": {
        "dM": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": true
        },
        "body": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": true
        },
        "div": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": true
        }
      },
      "ITALIC_TEXT-1": {
        "dM": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": true
        },
        "body": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": true
        },
        "div": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": true
        }
      },
      "ITALIC_I": {
        "dM": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": true
        },
        "body": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": true
        },
        "div": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": true
        }
      },
      "UNDERLINE_TEXT-1": {
        "dM": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": true
        },
        "body": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": true
        },
        "div": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": true
        }
      },
      "STRIKETHROUGH_TEXT-1": {
        "dM": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": true
        },
        "body": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": true
        },
        "div": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": true
        }
      },
      "SUBSCRIPT_TEXT-1": {
        "dM": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": true
        },
        "body": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": true
        },
        "div": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": true
        }
      },
      "SUPERSCRIPT_TEXT-1": {
        "dM": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": true
        },
        "body": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": true
        },
        "div": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": true
        }
      },
      "FORMATBLOCK_TEXT-1": {
        "dM": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": true
        },
        "body": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": true
        },
        "div": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": true
        }
      },
      "CREATELINK_TEXT-1": {
        "dM": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": true
        },
        "body": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": true
        },
        "div": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": true
        }
      },
      "UNLINK_TEXT-1": {
        "dM": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": true
        },
        "body": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": true
        },
        "div": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": true
        }
      },
      "INSERTHTML_TEXT-1": {
        "dM": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": true
        },
        "body": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": true
        },
        "div": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": true
        }
      },
      "INSERTHORIZONTALRULE_TEXT-1": {
        "dM": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": true
        },
        "body": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": true
        },
        "div": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": true
        }
      },
      "INSERTIMAGE_TEXT-1": {
        "dM": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": true
        },
        "body": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": true
        },
        "div": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": true
        }
      },
      "INSERTLINEBREAK_TEXT-1": {
        "dM": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": false
        },
        "body": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": false
        },
        "div": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": false
        }
      },
      "INSERTPARAGRAPH_TEXT-1": {
        "dM": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": true
        },
        "body": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": true
        },
        "div": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": true
        }
      },
      "INSERTORDEREDLIST_TEXT-1": {
        "dM": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": true
        },
        "body": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": true
        },
        "div": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": true
        }
      },
      "INSERTUNORDEREDLIST_TEXT-1": {
        "dM": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": true
        },
        "body": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": true
        },
        "div": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": true
        }
      },
      "INSERTTEXT_TEXT-1": {
        "dM": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": false
        },
        "body": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": false
        },
        "div": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": false
        }
      },
      "DELETE_TEXT-1": {
        "dM": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": true
        },
        "body": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": true
        },
        "div": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": true
        }
      },
      "FORWARDDELETE_TEXT-1": {
        "dM": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": false
        },
        "body": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": false
        },
        "div": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": false
        }
      },
      "STYLEWITHCSS_TEXT-1": {
        "dM": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": true
        },
        "body": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": true
        },
        "div": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": true
        }
      },
      "CONTENTREADONLY_TEXT-1": {
        "dM": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": true
        },
        "body": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": true
        },
        "div": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": true
        }
      },
      "BACKCOLOR_TEXT-1": {
        "dM": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": true
        },
        "body": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": true
        },
        "div": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": true
        }
      },
      "FORECOLOR_TEXT-1": {
        "dM": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": true
        },
        "body": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": true
        },
        "div": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": true
        }
      },
      "HILITECOLOR_TEXT-1": {
        "dM": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": true
        },
        "body": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": true
        },
        "div": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": true
        }
      },
      "FONTNAME_TEXT-1": {
        "dM": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": true
        },
        "body": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": true
        },
        "div": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": true
        }
      },
      "FONTSIZE_TEXT-1": {
        "dM": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": true
        },
        "body": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": true
        },
        "div": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": true
        }
      },
      "INCREASEFONTSIZE_TEXT-1": {
        "dM": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": true
        },
        "body": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": true
        },
        "div": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": true
        }
      },
      "DECREASEFONTSIZE_TEXT-1": {
        "dM": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": true
        },
        "body": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": true
        },
        "div": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": true
        }
      },
      "HEADING_TEXT-1": {
        "dM": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": true
        },
        "body": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": true
        },
        "div": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": true
        }
      },
      "INDENT_TEXT-1": {
        "dM": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": true
        },
        "body": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": true
        },
        "div": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": true
        }
      },
      "OUTDENT_TEXT-1": {
        "dM": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": true
        },
        "body": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": true
        },
        "div": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": true
        }
      },
      "CREATEBOOKMARK_TEXT-1": {
        "dM": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": false
        },
        "body": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": false
        },
        "div": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": false
        }
      },
      "UNBOOKMARK_TEXT-1": {
        "dM": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": false
        },
        "body": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": false
        },
        "div": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": false
        }
      },
      "JUSTIFYCENTER_TEXT-1": {
        "dM": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": true
        },
        "body": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": true
        },
        "div": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": true
        }
      },
      "JUSTIFYFULL_TEXT-1": {
        "dM": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": true
        },
        "body": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": true
        },
        "div": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": true
        }
      },
      "JUSTIFYLEFT_TEXT-1": {
        "dM": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": true
        },
        "body": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": true
        },
        "div": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": true
        }
      },
      "JUSTIFYRIGHT_TEXT-1": {
        "dM": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": true
        },
        "body": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": true
        },
        "div": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": true
        }
      },
      "REMOVEFORMAT_TEXT-1": {
        "dM": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": true
        },
        "body": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": true
        },
        "div": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": true
        }
      },
      "COPY_TEXT-1": {
        "dM": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": true
        },
        "body": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": true
        },
        "div": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": true
        }
      },
      "CUT_TEXT-1": {
        "dM": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": true
        },
        "body": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": true
        },
        "div": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": true
        }
      },
      "PASTE_TEXT-1": {
        "dM": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": true
        },
        "body": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": true
        },
        "div": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": true
        }
      },
      "garbage-1_TEXT-1": {
        "dM": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": false
        },
        "body": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": false
        },
        "div": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": false
        }
      }
    }
  },
  "QE": {
    "Proposed": {
      "SELECTALL_TEXT-1": {
        "dM": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": true
        },
        "body": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": true
        },
        "div": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": true
        }
      },
      "UNSELECT_TEXT-1": {
        "dM": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": false
        },
        "body": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": false
        },
        "div": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": false
        }
      },
      "UNDO_TEXT-1": {
        "dM": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": true
        },
        "body": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": true
        },
        "div": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": true
        }
      },
      "REDO_TEXT-1": {
        "dM": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": false
        },
        "body": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": false
        },
        "div": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": false
        }
      },
      "BOLD_TEXT-1": {
        "dM": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": true
        },
        "body": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": true
        },
        "div": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": true
        }
      },
      "ITALIC_TEXT-1": {
        "dM": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": true
        },
        "body": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": true
        },
        "div": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": true
        }
      },
      "UNDERLINE_TEXT-1": {
        "dM": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": true
        },
        "body": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": true
        },
        "div": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": true
        }
      },
      "STRIKETHROUGH_TEXT-1": {
        "dM": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": true
        },
        "body": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": true
        },
        "div": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": true
        }
      },
      "SUBSCRIPT_TEXT-1": {
        "dM": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": true
        },
        "body": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": true
        },
        "div": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": true
        }
      },
      "SUPERSCRIPT_TEXT-1": {
        "dM": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": true
        },
        "body": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": true
        },
        "div": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": true
        }
      },
      "FORMATBLOCK_TEXT-1": {
        "dM": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": true
        },
        "body": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": true
        },
        "div": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": true
        }
      },
      "CREATELINK_TEXT-1": {
        "dM": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": true
        },
        "body": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": true
        },
        "div": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": true
        }
      },
      "UNLINK_TEXT-1": {
        "dM": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": true
        },
        "body": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": true
        },
        "div": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": true
        }
      },
      "INSERTHTML_TEXT-1": {
        "dM": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": true
        },
        "body": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": true
        },
        "div": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": true
        }
      },
      "INSERTHORIZONTALRULE_TEXT-1": {
        "dM": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": true
        },
        "body": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": true
        },
        "div": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": true
        }
      },
      "INSERTIMAGE_TEXT-1": {
        "dM": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": true
        },
        "body": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": true
        },
        "div": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": true
        }
      },
      "INSERTLINEBREAK_TEXT-1": {
        "dM": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": false
        },
        "body": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": false
        },
        "div": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": false
        }
      },
      "INSERTPARAGRAPH_TEXT-1": {
        "dM": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": true
        },
        "body": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": true
        },
        "div": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": true
        }
      },
      "INSERTORDEREDLIST_TEXT-1": {
        "dM": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": true
        },
        "body": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": true
        },
        "div": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": true
        }
      },
      "INSERTUNORDEREDLIST_TEXT-1": {
        "dM": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": true
        },
        "body": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": true
        },
        "div": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": true
        }
      },
      "INSERTTEXT_TEXT-1": {
        "dM": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": false
        },
        "body": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": false
        },
        "div": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": false
        }
      },
      "DELETE_TEXT-1": {
        "dM": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": true
        },
        "body": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": true
        },
        "div": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": true
        }
      },
      "FORWARDDELETE_TEXT-1": {
        "dM": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": false
        },
        "body": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": false
        },
        "div": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": false
        }
      },
      "STYLEWITHCSS_TEXT-1": {
        "dM": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": true
        },
        "body": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": true
        },
        "div": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": true
        }
      },
      "CONTENTREADONLY_TEXT-1": {
        "dM": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": true
        },
        "body": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": true
        },
        "div": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": true
        }
      },
      "BACKCOLOR_TEXT-1": {
        "dM": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": true
        },
        "body": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": true
        },
        "div": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": true
        }
      },
      "FORECOLOR_TEXT-1": {
        "dM": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": true
        },
        "body": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": true
        },
        "div": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": true
        }
      },
      "HILITECOLOR_TEXT-1": {
        "dM": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": true
        },
        "body": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": true
        },
        "div": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": true
        }
      },
      "FONTNAME_TEXT-1": {
        "dM": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": true
        },
        "body": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": true
        },
        "div": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": true
        }
      },
      "FONTSIZE_TEXT-1": {
        "dM": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": true
        },
        "body": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": true
        },
        "div": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": true
        }
      },
      "INCREASEFONTSIZE_TEXT-1": {
        "dM": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": true
        },
        "body": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": true
        },
        "div": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": true
        }
      },
      "DECREASEFONTSIZE_TEXT-1": {
        "dM": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": true
        },
        "body": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": true
        },
        "div": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": true
        }
      },
      "HEADING_TEXT-1": {
        "dM": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": true
        },
        "body": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": true
        },
        "div": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": true
        }
      },
      "INDENT_TEXT-1": {
        "dM": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": true
        },
        "body": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": true
        },
        "div": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": true
        }
      },
      "OUTDENT_TEXT-1": {
        "dM": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": false
        },
        "body": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": false
        },
        "div": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": false
        }
      },
      "CREATEBOOKMARK_TEXT-1": {
        "dM": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": false
        },
        "body": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": false
        },
        "div": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": false
        }
      },
      "UNBOOKMARK_TEXT-1": {
        "dM": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": false
        },
        "body": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": false
        },
        "div": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": false
        }
      },
      "JUSTIFYCENTER_TEXT-1": {
        "dM": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": true
        },
        "body": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": true
        },
        "div": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": true
        }
      },
      "JUSTIFYFULL_TEXT-1": {
        "dM": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": true
        },
        "body": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": true
        },
        "div": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": true
        }
      },
      "JUSTIFYLEFT_TEXT-1": {
        "dM": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": true
        },
        "body": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": true
        },
        "div": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": true
        }
      },
      "JUSTIFYRIGHT_TEXT-1": {
        "dM": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": true
        },
        "body": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": true
        },
        "div": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": true
        }
      },
      "REMOVEFORMAT_TEXT-1": {
        "dM": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": true
        },
        "body": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": true
        },
        "div": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": true
        }
      },
      "COPY_TEXT-1": {
        "dM": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": true
        },
        "body": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": true
        },
        "div": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": true
        }
      },
      "CUT_TEXT-1": {
        "dM": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": true
        },
        "body": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": true
        },
        "div": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": true
        }
      },
      "PASTE_TEXT-1": {
        "dM": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": true
        },
        "body": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": true
        },
        "div": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": true
        }
      },
      "garbage-1_TEXT-1": {
        "dM": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": false
        },
        "body": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": false
        },
        "div": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": false
        }
      }
    }
  },
  "QI": {
    "Proposed": {
      "SELECTALL_TEXT-1": {
        "dM": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 2,
          "selresult": 3,
          "output": "EXECUTION EXCEPTION: [Exception... \"Component returned failure code: 0x80004005 (NS_ERROR_FAILURE) [nsIDOMHTMLDocument.queryCommandIndeterm]\"  nsresult: \"0x80004005 (NS_ERROR_FAILURE)\"  location: \"JS frame :: http://mochi.test:8888/tests/editor/libeditor/html/tests/browserscope/lib/richtext2/richtext2/static/js/run.js :: runSingleTest :: line 152\"  data: no]"
        },
        "body": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 2,
          "selresult": 3,
          "output": "EXECUTION EXCEPTION: [Exception... \"Component returned failure code: 0x80004005 (NS_ERROR_FAILURE) [nsIDOMHTMLDocument.queryCommandIndeterm]\"  nsresult: \"0x80004005 (NS_ERROR_FAILURE)\"  location: \"JS frame :: http://mochi.test:8888/tests/editor/libeditor/html/tests/browserscope/lib/richtext2/richtext2/static/js/run.js :: runSingleTest :: line 152\"  data: no]"
        },
        "div": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 2,
          "selresult": 3,
          "output": "EXECUTION EXCEPTION: [Exception... \"Component returned failure code: 0x80004005 (NS_ERROR_FAILURE) [nsIDOMHTMLDocument.queryCommandIndeterm]\"  nsresult: \"0x80004005 (NS_ERROR_FAILURE)\"  location: \"JS frame :: http://mochi.test:8888/tests/editor/libeditor/html/tests/browserscope/lib/richtext2/richtext2/static/js/run.js :: runSingleTest :: line 152\"  data: no]"
        }
      },
      "UNSELECT_TEXT-1": {
        "dM": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 2,
          "selresult": 3,
          "output": "EXECUTION EXCEPTION: [Exception... \"Component returned failure code: 0x80004001 (NS_ERROR_NOT_IMPLEMENTED) [nsIDOMHTMLDocument.queryCommandIndeterm]\"  nsresult: \"0x80004001 (NS_ERROR_NOT_IMPLEMENTED)\"  location: \"JS frame :: http://mochi.test:8888/tests/editor/libeditor/html/tests/browserscope/lib/richtext2/richtext2/static/js/run.js :: runSingleTest :: line 152\"  data: no]"
        },
        "body": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 2,
          "selresult": 3,
          "output": "EXECUTION EXCEPTION: [Exception... \"Component returned failure code: 0x80004001 (NS_ERROR_NOT_IMPLEMENTED) [nsIDOMHTMLDocument.queryCommandIndeterm]\"  nsresult: \"0x80004001 (NS_ERROR_NOT_IMPLEMENTED)\"  location: \"JS frame :: http://mochi.test:8888/tests/editor/libeditor/html/tests/browserscope/lib/richtext2/richtext2/static/js/run.js :: runSingleTest :: line 152\"  data: no]"
        },
        "div": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 2,
          "selresult": 3,
          "output": "EXECUTION EXCEPTION: [Exception... \"Component returned failure code: 0x80004001 (NS_ERROR_NOT_IMPLEMENTED) [nsIDOMHTMLDocument.queryCommandIndeterm]\"  nsresult: \"0x80004001 (NS_ERROR_NOT_IMPLEMENTED)\"  location: \"JS frame :: http://mochi.test:8888/tests/editor/libeditor/html/tests/browserscope/lib/richtext2/richtext2/static/js/run.js :: runSingleTest :: line 152\"  data: no]"
        }
      },
      "UNDO_TEXT-1": {
        "dM": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 2,
          "selresult": 3,
          "output": "EXECUTION EXCEPTION: [Exception... \"Component returned failure code: 0x80004005 (NS_ERROR_FAILURE) [nsIDOMHTMLDocument.queryCommandIndeterm]\"  nsresult: \"0x80004005 (NS_ERROR_FAILURE)\"  location: \"JS frame :: http://mochi.test:8888/tests/editor/libeditor/html/tests/browserscope/lib/richtext2/richtext2/static/js/run.js :: runSingleTest :: line 152\"  data: no]"
        },
        "body": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 2,
          "selresult": 3,
          "output": "EXECUTION EXCEPTION: [Exception... \"Component returned failure code: 0x80004005 (NS_ERROR_FAILURE) [nsIDOMHTMLDocument.queryCommandIndeterm]\"  nsresult: \"0x80004005 (NS_ERROR_FAILURE)\"  location: \"JS frame :: http://mochi.test:8888/tests/editor/libeditor/html/tests/browserscope/lib/richtext2/richtext2/static/js/run.js :: runSingleTest :: line 152\"  data: no]"
        },
        "div": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 2,
          "selresult": 3,
          "output": "EXECUTION EXCEPTION: [Exception... \"Component returned failure code: 0x80004005 (NS_ERROR_FAILURE) [nsIDOMHTMLDocument.queryCommandIndeterm]\"  nsresult: \"0x80004005 (NS_ERROR_FAILURE)\"  location: \"JS frame :: http://mochi.test:8888/tests/editor/libeditor/html/tests/browserscope/lib/richtext2/richtext2/static/js/run.js :: runSingleTest :: line 152\"  data: no]"
        }
      },
      "REDO_TEXT-1": {
        "dM": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 2,
          "selresult": 3,
          "output": "EXECUTION EXCEPTION: [Exception... \"Component returned failure code: 0x80004005 (NS_ERROR_FAILURE) [nsIDOMHTMLDocument.queryCommandIndeterm]\"  nsresult: \"0x80004005 (NS_ERROR_FAILURE)\"  location: \"JS frame :: http://mochi.test:8888/tests/editor/libeditor/html/tests/browserscope/lib/richtext2/richtext2/static/js/run.js :: runSingleTest :: line 152\"  data: no]"
        },
        "body": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 2,
          "selresult": 3,
          "output": "EXECUTION EXCEPTION: [Exception... \"Component returned failure code: 0x80004005 (NS_ERROR_FAILURE) [nsIDOMHTMLDocument.queryCommandIndeterm]\"  nsresult: \"0x80004005 (NS_ERROR_FAILURE)\"  location: \"JS frame :: http://mochi.test:8888/tests/editor/libeditor/html/tests/browserscope/lib/richtext2/richtext2/static/js/run.js :: runSingleTest :: line 152\"  data: no]"
        },
        "div": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 2,
          "selresult": 3,
          "output": "EXECUTION EXCEPTION: [Exception... \"Component returned failure code: 0x80004005 (NS_ERROR_FAILURE) [nsIDOMHTMLDocument.queryCommandIndeterm]\"  nsresult: \"0x80004005 (NS_ERROR_FAILURE)\"  location: \"JS frame :: http://mochi.test:8888/tests/editor/libeditor/html/tests/browserscope/lib/richtext2/richtext2/static/js/run.js :: runSingleTest :: line 152\"  data: no]"
        }
      },
      "BOLD_TEXT-1": {
        "dM": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": false
        },
        "body": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": false
        },
        "div": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": false
        }
      },
      "ITALIC_TEXT-1": {
        "dM": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": false
        },
        "body": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": false
        },
        "div": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": false
        }
      },
      "UNDERLINE_TEXT-1": {
        "dM": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": false
        },
        "body": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": false
        },
        "div": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": false
        }
      },
      "STRIKETHROUGH_TEXT-1": {
        "dM": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": false
        },
        "body": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": false
        },
        "div": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": false
        }
      },
      "SUBSCRIPT_TEXT-1": {
        "dM": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": false
        },
        "body": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": false
        },
        "div": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": false
        }
      },
      "SUPERSCRIPT_TEXT-1": {
        "dM": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": false
        },
        "body": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": false
        },
        "div": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": false
        }
      },
      "FORMATBLOCK_TEXT-1": {
        "dM": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 2,
          "selresult": 3,
          "output": "EXECUTION EXCEPTION: [Exception... \"Component returned failure code: 0x80004001 (NS_ERROR_NOT_IMPLEMENTED) [nsIDOMHTMLDocument.queryCommandIndeterm]\"  nsresult: \"0x80004001 (NS_ERROR_NOT_IMPLEMENTED)\"  location: \"JS frame :: http://mochi.test:8888/tests/editor/libeditor/html/tests/browserscope/lib/richtext2/richtext2/static/js/run.js :: runSingleTest :: line 152\"  data: no]"
        },
        "body": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 2,
          "selresult": 3,
          "output": "EXECUTION EXCEPTION: [Exception... \"Component returned failure code: 0x80004001 (NS_ERROR_NOT_IMPLEMENTED) [nsIDOMHTMLDocument.queryCommandIndeterm]\"  nsresult: \"0x80004001 (NS_ERROR_NOT_IMPLEMENTED)\"  location: \"JS frame :: http://mochi.test:8888/tests/editor/libeditor/html/tests/browserscope/lib/richtext2/richtext2/static/js/run.js :: runSingleTest :: line 152\"  data: no]"
        },
        "div": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 2,
          "selresult": 3,
          "output": "EXECUTION EXCEPTION: [Exception... \"Component returned failure code: 0x80004001 (NS_ERROR_NOT_IMPLEMENTED) [nsIDOMHTMLDocument.queryCommandIndeterm]\"  nsresult: \"0x80004001 (NS_ERROR_NOT_IMPLEMENTED)\"  location: \"JS frame :: http://mochi.test:8888/tests/editor/libeditor/html/tests/browserscope/lib/richtext2/richtext2/static/js/run.js :: runSingleTest :: line 152\"  data: no]"
        }
      },
      "CREATELINK_TEXT-1": {
        "dM": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 2,
          "selresult": 3,
          "output": "EXECUTION EXCEPTION: [Exception... \"Component returned failure code: 0x80004005 (NS_ERROR_FAILURE) [nsIDOMHTMLDocument.queryCommandIndeterm]\"  nsresult: \"0x80004005 (NS_ERROR_FAILURE)\"  location: \"JS frame :: http://mochi.test:8888/tests/editor/libeditor/html/tests/browserscope/lib/richtext2/richtext2/static/js/run.js :: runSingleTest :: line 152\"  data: no]"
        },
        "body": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 2,
          "selresult": 3,
          "output": "EXECUTION EXCEPTION: [Exception... \"Component returned failure code: 0x80004005 (NS_ERROR_FAILURE) [nsIDOMHTMLDocument.queryCommandIndeterm]\"  nsresult: \"0x80004005 (NS_ERROR_FAILURE)\"  location: \"JS frame :: http://mochi.test:8888/tests/editor/libeditor/html/tests/browserscope/lib/richtext2/richtext2/static/js/run.js :: runSingleTest :: line 152\"  data: no]"
        },
        "div": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 2,
          "selresult": 3,
          "output": "EXECUTION EXCEPTION: [Exception... \"Component returned failure code: 0x80004005 (NS_ERROR_FAILURE) [nsIDOMHTMLDocument.queryCommandIndeterm]\"  nsresult: \"0x80004005 (NS_ERROR_FAILURE)\"  location: \"JS frame :: http://mochi.test:8888/tests/editor/libeditor/html/tests/browserscope/lib/richtext2/richtext2/static/js/run.js :: runSingleTest :: line 152\"  data: no]"
        }
      },
      "UNLINK_TEXT-1": {
        "dM": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": false
        },
        "body": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": false
        },
        "div": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": false
        }
      },
      "INSERTHTML_TEXT-1": {
        "dM": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 2,
          "selresult": 3,
          "output": "EXECUTION EXCEPTION: [Exception... \"Component returned failure code: 0x80004005 (NS_ERROR_FAILURE) [nsIDOMHTMLDocument.queryCommandIndeterm]\"  nsresult: \"0x80004005 (NS_ERROR_FAILURE)\"  location: \"JS frame :: http://mochi.test:8888/tests/editor/libeditor/html/tests/browserscope/lib/richtext2/richtext2/static/js/run.js :: runSingleTest :: line 152\"  data: no]"
        },
        "body": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 2,
          "selresult": 3,
          "output": "EXECUTION EXCEPTION: [Exception... \"Component returned failure code: 0x80004005 (NS_ERROR_FAILURE) [nsIDOMHTMLDocument.queryCommandIndeterm]\"  nsresult: \"0x80004005 (NS_ERROR_FAILURE)\"  location: \"JS frame :: http://mochi.test:8888/tests/editor/libeditor/html/tests/browserscope/lib/richtext2/richtext2/static/js/run.js :: runSingleTest :: line 152\"  data: no]"
        },
        "div": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 2,
          "selresult": 3,
          "output": "EXECUTION EXCEPTION: [Exception... \"Component returned failure code: 0x80004005 (NS_ERROR_FAILURE) [nsIDOMHTMLDocument.queryCommandIndeterm]\"  nsresult: \"0x80004005 (NS_ERROR_FAILURE)\"  location: \"JS frame :: http://mochi.test:8888/tests/editor/libeditor/html/tests/browserscope/lib/richtext2/richtext2/static/js/run.js :: runSingleTest :: line 152\"  data: no]"
        }
      },
      "INSERTHORIZONTALRULE_TEXT-1": {
        "dM": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 2,
          "selresult": 3,
          "output": "EXECUTION EXCEPTION: [Exception... \"Component returned failure code: 0x80004005 (NS_ERROR_FAILURE) [nsIDOMHTMLDocument.queryCommandIndeterm]\"  nsresult: \"0x80004005 (NS_ERROR_FAILURE)\"  location: \"JS frame :: http://mochi.test:8888/tests/editor/libeditor/html/tests/browserscope/lib/richtext2/richtext2/static/js/run.js :: runSingleTest :: line 152\"  data: no]"
        },
        "body": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 2,
          "selresult": 3,
          "output": "EXECUTION EXCEPTION: [Exception... \"Component returned failure code: 0x80004005 (NS_ERROR_FAILURE) [nsIDOMHTMLDocument.queryCommandIndeterm]\"  nsresult: \"0x80004005 (NS_ERROR_FAILURE)\"  location: \"JS frame :: http://mochi.test:8888/tests/editor/libeditor/html/tests/browserscope/lib/richtext2/richtext2/static/js/run.js :: runSingleTest :: line 152\"  data: no]"
        },
        "div": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 2,
          "selresult": 3,
          "output": "EXECUTION EXCEPTION: [Exception... \"Component returned failure code: 0x80004005 (NS_ERROR_FAILURE) [nsIDOMHTMLDocument.queryCommandIndeterm]\"  nsresult: \"0x80004005 (NS_ERROR_FAILURE)\"  location: \"JS frame :: http://mochi.test:8888/tests/editor/libeditor/html/tests/browserscope/lib/richtext2/richtext2/static/js/run.js :: runSingleTest :: line 152\"  data: no]"
        }
      },
      "INSERTIMAGE_TEXT-1": {
        "dM": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 2,
          "selresult": 3,
          "output": "EXECUTION EXCEPTION: [Exception... \"Component returned failure code: 0x80004005 (NS_ERROR_FAILURE) [nsIDOMHTMLDocument.queryCommandIndeterm]\"  nsresult: \"0x80004005 (NS_ERROR_FAILURE)\"  location: \"JS frame :: http://mochi.test:8888/tests/editor/libeditor/html/tests/browserscope/lib/richtext2/richtext2/static/js/run.js :: runSingleTest :: line 152\"  data: no]"
        },
        "body": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 2,
          "selresult": 3,
          "output": "EXECUTION EXCEPTION: [Exception... \"Component returned failure code: 0x80004005 (NS_ERROR_FAILURE) [nsIDOMHTMLDocument.queryCommandIndeterm]\"  nsresult: \"0x80004005 (NS_ERROR_FAILURE)\"  location: \"JS frame :: http://mochi.test:8888/tests/editor/libeditor/html/tests/browserscope/lib/richtext2/richtext2/static/js/run.js :: runSingleTest :: line 152\"  data: no]"
        },
        "div": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 2,
          "selresult": 3,
          "output": "EXECUTION EXCEPTION: [Exception... \"Component returned failure code: 0x80004005 (NS_ERROR_FAILURE) [nsIDOMHTMLDocument.queryCommandIndeterm]\"  nsresult: \"0x80004005 (NS_ERROR_FAILURE)\"  location: \"JS frame :: http://mochi.test:8888/tests/editor/libeditor/html/tests/browserscope/lib/richtext2/richtext2/static/js/run.js :: runSingleTest :: line 152\"  data: no]"
        }
      },
      "INSERTLINEBREAK_TEXT-1": {
        "dM": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 2,
          "selresult": 3,
          "output": "EXECUTION EXCEPTION: [Exception... \"Component returned failure code: 0x80004001 (NS_ERROR_NOT_IMPLEMENTED) [nsIDOMHTMLDocument.queryCommandIndeterm]\"  nsresult: \"0x80004001 (NS_ERROR_NOT_IMPLEMENTED)\"  location: \"JS frame :: http://mochi.test:8888/tests/editor/libeditor/html/tests/browserscope/lib/richtext2/richtext2/static/js/run.js :: runSingleTest :: line 152\"  data: no]"
        },
        "body": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 2,
          "selresult": 3,
          "output": "EXECUTION EXCEPTION: [Exception... \"Component returned failure code: 0x80004001 (NS_ERROR_NOT_IMPLEMENTED) [nsIDOMHTMLDocument.queryCommandIndeterm]\"  nsresult: \"0x80004001 (NS_ERROR_NOT_IMPLEMENTED)\"  location: \"JS frame :: http://mochi.test:8888/tests/editor/libeditor/html/tests/browserscope/lib/richtext2/richtext2/static/js/run.js :: runSingleTest :: line 152\"  data: no]"
        },
        "div": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 2,
          "selresult": 3,
          "output": "EXECUTION EXCEPTION: [Exception... \"Component returned failure code: 0x80004001 (NS_ERROR_NOT_IMPLEMENTED) [nsIDOMHTMLDocument.queryCommandIndeterm]\"  nsresult: \"0x80004001 (NS_ERROR_NOT_IMPLEMENTED)\"  location: \"JS frame :: http://mochi.test:8888/tests/editor/libeditor/html/tests/browserscope/lib/richtext2/richtext2/static/js/run.js :: runSingleTest :: line 152\"  data: no]"
        }
      },
      "INSERTPARAGRAPH_TEXT-1": {
        "dM": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": false
        },
        "body": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": false
        },
        "div": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": false
        }
      },
      "INSERTORDEREDLIST_TEXT-1": {
        "dM": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": false
        },
        "body": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": false
        },
        "div": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": false
        }
      },
      "INSERTUNORDEREDLIST_TEXT-1": {
        "dM": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": false
        },
        "body": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": false
        },
        "div": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": false
        }
      },
      "INSERTTEXT_TEXT-1": {
        "dM": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 2,
          "selresult": 3,
          "output": "EXECUTION EXCEPTION: [Exception... \"Component returned failure code: 0x80004001 (NS_ERROR_NOT_IMPLEMENTED) [nsIDOMHTMLDocument.queryCommandIndeterm]\"  nsresult: \"0x80004001 (NS_ERROR_NOT_IMPLEMENTED)\"  location: \"JS frame :: http://mochi.test:8888/tests/editor/libeditor/html/tests/browserscope/lib/richtext2/richtext2/static/js/run.js :: runSingleTest :: line 152\"  data: no]"
        },
        "body": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 2,
          "selresult": 3,
          "output": "EXECUTION EXCEPTION: [Exception... \"Component returned failure code: 0x80004001 (NS_ERROR_NOT_IMPLEMENTED) [nsIDOMHTMLDocument.queryCommandIndeterm]\"  nsresult: \"0x80004001 (NS_ERROR_NOT_IMPLEMENTED)\"  location: \"JS frame :: http://mochi.test:8888/tests/editor/libeditor/html/tests/browserscope/lib/richtext2/richtext2/static/js/run.js :: runSingleTest :: line 152\"  data: no]"
        },
        "div": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 2,
          "selresult": 3,
          "output": "EXECUTION EXCEPTION: [Exception... \"Component returned failure code: 0x80004001 (NS_ERROR_NOT_IMPLEMENTED) [nsIDOMHTMLDocument.queryCommandIndeterm]\"  nsresult: \"0x80004001 (NS_ERROR_NOT_IMPLEMENTED)\"  location: \"JS frame :: http://mochi.test:8888/tests/editor/libeditor/html/tests/browserscope/lib/richtext2/richtext2/static/js/run.js :: runSingleTest :: line 152\"  data: no]"
        }
      },
      "DELETE_TEXT-1": {
        "dM": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 2,
          "selresult": 3,
          "output": "EXECUTION EXCEPTION: [Exception... \"Component returned failure code: 0x80004005 (NS_ERROR_FAILURE) [nsIDOMHTMLDocument.queryCommandIndeterm]\"  nsresult: \"0x80004005 (NS_ERROR_FAILURE)\"  location: \"JS frame :: http://mochi.test:8888/tests/editor/libeditor/html/tests/browserscope/lib/richtext2/richtext2/static/js/run.js :: runSingleTest :: line 152\"  data: no]"
        },
        "body": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 2,
          "selresult": 3,
          "output": "EXECUTION EXCEPTION: [Exception... \"Component returned failure code: 0x80004005 (NS_ERROR_FAILURE) [nsIDOMHTMLDocument.queryCommandIndeterm]\"  nsresult: \"0x80004005 (NS_ERROR_FAILURE)\"  location: \"JS frame :: http://mochi.test:8888/tests/editor/libeditor/html/tests/browserscope/lib/richtext2/richtext2/static/js/run.js :: runSingleTest :: line 152\"  data: no]"
        },
        "div": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 2,
          "selresult": 3,
          "output": "EXECUTION EXCEPTION: [Exception... \"Component returned failure code: 0x80004005 (NS_ERROR_FAILURE) [nsIDOMHTMLDocument.queryCommandIndeterm]\"  nsresult: \"0x80004005 (NS_ERROR_FAILURE)\"  location: \"JS frame :: http://mochi.test:8888/tests/editor/libeditor/html/tests/browserscope/lib/richtext2/richtext2/static/js/run.js :: runSingleTest :: line 152\"  data: no]"
        }
      },
      "FORWARDDELETE_TEXT-1": {
        "dM": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 2,
          "selresult": 3,
          "output": "EXECUTION EXCEPTION: [Exception... \"Component returned failure code: 0x80004001 (NS_ERROR_NOT_IMPLEMENTED) [nsIDOMHTMLDocument.queryCommandIndeterm]\"  nsresult: \"0x80004001 (NS_ERROR_NOT_IMPLEMENTED)\"  location: \"JS frame :: http://mochi.test:8888/tests/editor/libeditor/html/tests/browserscope/lib/richtext2/richtext2/static/js/run.js :: runSingleTest :: line 152\"  data: no]"
        },
        "body": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 2,
          "selresult": 3,
          "output": "EXECUTION EXCEPTION: [Exception... \"Component returned failure code: 0x80004001 (NS_ERROR_NOT_IMPLEMENTED) [nsIDOMHTMLDocument.queryCommandIndeterm]\"  nsresult: \"0x80004001 (NS_ERROR_NOT_IMPLEMENTED)\"  location: \"JS frame :: http://mochi.test:8888/tests/editor/libeditor/html/tests/browserscope/lib/richtext2/richtext2/static/js/run.js :: runSingleTest :: line 152\"  data: no]"
        },
        "div": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 2,
          "selresult": 3,
          "output": "EXECUTION EXCEPTION: [Exception... \"Component returned failure code: 0x80004001 (NS_ERROR_NOT_IMPLEMENTED) [nsIDOMHTMLDocument.queryCommandIndeterm]\"  nsresult: \"0x80004001 (NS_ERROR_NOT_IMPLEMENTED)\"  location: \"JS frame :: http://mochi.test:8888/tests/editor/libeditor/html/tests/browserscope/lib/richtext2/richtext2/static/js/run.js :: runSingleTest :: line 152\"  data: no]"
        }
      },
      "STYLEWITHCSS_TEXT-1": {
        "dM": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 2,
          "selresult": 3,
          "output": "EXECUTION EXCEPTION: [Exception... \"Component returned failure code: 0x80004005 (NS_ERROR_FAILURE) [nsIDOMHTMLDocument.queryCommandIndeterm]\"  nsresult: \"0x80004005 (NS_ERROR_FAILURE)\"  location: \"JS frame :: http://mochi.test:8888/tests/editor/libeditor/html/tests/browserscope/lib/richtext2/richtext2/static/js/run.js :: runSingleTest :: line 152\"  data: no]"
        },
        "body": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 2,
          "selresult": 3,
          "output": "EXECUTION EXCEPTION: [Exception... \"Component returned failure code: 0x80004005 (NS_ERROR_FAILURE) [nsIDOMHTMLDocument.queryCommandIndeterm]\"  nsresult: \"0x80004005 (NS_ERROR_FAILURE)\"  location: \"JS frame :: http://mochi.test:8888/tests/editor/libeditor/html/tests/browserscope/lib/richtext2/richtext2/static/js/run.js :: runSingleTest :: line 152\"  data: no]"
        },
        "div": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 2,
          "selresult": 3,
          "output": "EXECUTION EXCEPTION: [Exception... \"Component returned failure code: 0x80004005 (NS_ERROR_FAILURE) [nsIDOMHTMLDocument.queryCommandIndeterm]\"  nsresult: \"0x80004005 (NS_ERROR_FAILURE)\"  location: \"JS frame :: http://mochi.test:8888/tests/editor/libeditor/html/tests/browserscope/lib/richtext2/richtext2/static/js/run.js :: runSingleTest :: line 152\"  data: no]"
        }
      },
      "CONTENTREADONLY_TEXT-1": {
        "dM": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 2,
          "selresult": 3,
          "output": "EXECUTION EXCEPTION: [Exception... \"Component returned failure code: 0x80004005 (NS_ERROR_FAILURE) [nsIDOMHTMLDocument.queryCommandIndeterm]\"  nsresult: \"0x80004005 (NS_ERROR_FAILURE)\"  location: \"JS frame :: http://mochi.test:8888/tests/editor/libeditor/html/tests/browserscope/lib/richtext2/richtext2/static/js/run.js :: runSingleTest :: line 152\"  data: no]"
        },
        "body": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 2,
          "selresult": 3,
          "output": "EXECUTION EXCEPTION: [Exception... \"Component returned failure code: 0x80004005 (NS_ERROR_FAILURE) [nsIDOMHTMLDocument.queryCommandIndeterm]\"  nsresult: \"0x80004005 (NS_ERROR_FAILURE)\"  location: \"JS frame :: http://mochi.test:8888/tests/editor/libeditor/html/tests/browserscope/lib/richtext2/richtext2/static/js/run.js :: runSingleTest :: line 152\"  data: no]"
        },
        "div": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 2,
          "selresult": 3,
          "output": "EXECUTION EXCEPTION: [Exception... \"Component returned failure code: 0x80004005 (NS_ERROR_FAILURE) [nsIDOMHTMLDocument.queryCommandIndeterm]\"  nsresult: \"0x80004005 (NS_ERROR_FAILURE)\"  location: \"JS frame :: http://mochi.test:8888/tests/editor/libeditor/html/tests/browserscope/lib/richtext2/richtext2/static/js/run.js :: runSingleTest :: line 152\"  data: no]"
        }
      },
      "BACKCOLOR_TEXT-1": {
        "dM": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": false
        },
        "body": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": false
        },
        "div": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": false
        }
      },
      "FORECOLOR_TEXT-1": {
        "dM": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": false
        },
        "body": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": false
        },
        "div": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": false
        }
      },
      "HILITECOLOR_TEXT-1": {
        "dM": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": false
        },
        "body": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": false
        },
        "div": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": false
        }
      },
      "FONTNAME_TEXT-1": {
        "dM": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": false
        },
        "body": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": false
        },
        "div": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": false
        }
      },
      "FONTSIZE_TEXT-1": {
        "dM": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": false
        },
        "body": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": false
        },
        "div": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": false
        }
      },
      "INCREASEFONTSIZE_TEXT-1": {
        "dM": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 2,
          "selresult": 3,
          "output": "EXECUTION EXCEPTION: [Exception... \"Component returned failure code: 0x80004005 (NS_ERROR_FAILURE) [nsIDOMHTMLDocument.queryCommandIndeterm]\"  nsresult: \"0x80004005 (NS_ERROR_FAILURE)\"  location: \"JS frame :: http://mochi.test:8888/tests/editor/libeditor/html/tests/browserscope/lib/richtext2/richtext2/static/js/run.js :: runSingleTest :: line 152\"  data: no]"
        },
        "body": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 2,
          "selresult": 3,
          "output": "EXECUTION EXCEPTION: [Exception... \"Component returned failure code: 0x80004005 (NS_ERROR_FAILURE) [nsIDOMHTMLDocument.queryCommandIndeterm]\"  nsresult: \"0x80004005 (NS_ERROR_FAILURE)\"  location: \"JS frame :: http://mochi.test:8888/tests/editor/libeditor/html/tests/browserscope/lib/richtext2/richtext2/static/js/run.js :: runSingleTest :: line 152\"  data: no]"
        },
        "div": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 2,
          "selresult": 3,
          "output": "EXECUTION EXCEPTION: [Exception... \"Component returned failure code: 0x80004005 (NS_ERROR_FAILURE) [nsIDOMHTMLDocument.queryCommandIndeterm]\"  nsresult: \"0x80004005 (NS_ERROR_FAILURE)\"  location: \"JS frame :: http://mochi.test:8888/tests/editor/libeditor/html/tests/browserscope/lib/richtext2/richtext2/static/js/run.js :: runSingleTest :: line 152\"  data: no]"
        }
      },
      "DECREASEFONTSIZE_TEXT-1": {
        "dM": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 2,
          "selresult": 3,
          "output": "EXECUTION EXCEPTION: [Exception... \"Component returned failure code: 0x80004005 (NS_ERROR_FAILURE) [nsIDOMHTMLDocument.queryCommandIndeterm]\"  nsresult: \"0x80004005 (NS_ERROR_FAILURE)\"  location: \"JS frame :: http://mochi.test:8888/tests/editor/libeditor/html/tests/browserscope/lib/richtext2/richtext2/static/js/run.js :: runSingleTest :: line 152\"  data: no]"
        },
        "body": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 2,
          "selresult": 3,
          "output": "EXECUTION EXCEPTION: [Exception... \"Component returned failure code: 0x80004005 (NS_ERROR_FAILURE) [nsIDOMHTMLDocument.queryCommandIndeterm]\"  nsresult: \"0x80004005 (NS_ERROR_FAILURE)\"  location: \"JS frame :: http://mochi.test:8888/tests/editor/libeditor/html/tests/browserscope/lib/richtext2/richtext2/static/js/run.js :: runSingleTest :: line 152\"  data: no]"
        },
        "div": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 2,
          "selresult": 3,
          "output": "EXECUTION EXCEPTION: [Exception... \"Component returned failure code: 0x80004005 (NS_ERROR_FAILURE) [nsIDOMHTMLDocument.queryCommandIndeterm]\"  nsresult: \"0x80004005 (NS_ERROR_FAILURE)\"  location: \"JS frame :: http://mochi.test:8888/tests/editor/libeditor/html/tests/browserscope/lib/richtext2/richtext2/static/js/run.js :: runSingleTest :: line 152\"  data: no]"
        }
      },
      "HEADING_TEXT-1": {
        "dM": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 2,
          "selresult": 3,
          "output": "EXECUTION EXCEPTION: [Exception... \"Component returned failure code: 0x80004001 (NS_ERROR_NOT_IMPLEMENTED) [nsIDOMHTMLDocument.queryCommandIndeterm]\"  nsresult: \"0x80004001 (NS_ERROR_NOT_IMPLEMENTED)\"  location: \"JS frame :: http://mochi.test:8888/tests/editor/libeditor/html/tests/browserscope/lib/richtext2/richtext2/static/js/run.js :: runSingleTest :: line 152\"  data: no]"
        },
        "body": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 2,
          "selresult": 3,
          "output": "EXECUTION EXCEPTION: [Exception... \"Component returned failure code: 0x80004001 (NS_ERROR_NOT_IMPLEMENTED) [nsIDOMHTMLDocument.queryCommandIndeterm]\"  nsresult: \"0x80004001 (NS_ERROR_NOT_IMPLEMENTED)\"  location: \"JS frame :: http://mochi.test:8888/tests/editor/libeditor/html/tests/browserscope/lib/richtext2/richtext2/static/js/run.js :: runSingleTest :: line 152\"  data: no]"
        },
        "div": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 2,
          "selresult": 3,
          "output": "EXECUTION EXCEPTION: [Exception... \"Component returned failure code: 0x80004001 (NS_ERROR_NOT_IMPLEMENTED) [nsIDOMHTMLDocument.queryCommandIndeterm]\"  nsresult: \"0x80004001 (NS_ERROR_NOT_IMPLEMENTED)\"  location: \"JS frame :: http://mochi.test:8888/tests/editor/libeditor/html/tests/browserscope/lib/richtext2/richtext2/static/js/run.js :: runSingleTest :: line 152\"  data: no]"
        }
      },
      "INDENT_TEXT-1": {
        "dM": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 2,
          "selresult": 3,
          "output": "EXECUTION EXCEPTION: [Exception... \"Component returned failure code: 0x80004005 (NS_ERROR_FAILURE) [nsIDOMHTMLDocument.queryCommandIndeterm]\"  nsresult: \"0x80004005 (NS_ERROR_FAILURE)\"  location: \"JS frame :: http://mochi.test:8888/tests/editor/libeditor/html/tests/browserscope/lib/richtext2/richtext2/static/js/run.js :: runSingleTest :: line 152\"  data: no]"
        },
        "body": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 2,
          "selresult": 3,
          "output": "EXECUTION EXCEPTION: [Exception... \"Component returned failure code: 0x80004005 (NS_ERROR_FAILURE) [nsIDOMHTMLDocument.queryCommandIndeterm]\"  nsresult: \"0x80004005 (NS_ERROR_FAILURE)\"  location: \"JS frame :: http://mochi.test:8888/tests/editor/libeditor/html/tests/browserscope/lib/richtext2/richtext2/static/js/run.js :: runSingleTest :: line 152\"  data: no]"
        },
        "div": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 2,
          "selresult": 3,
          "output": "EXECUTION EXCEPTION: [Exception... \"Component returned failure code: 0x80004005 (NS_ERROR_FAILURE) [nsIDOMHTMLDocument.queryCommandIndeterm]\"  nsresult: \"0x80004005 (NS_ERROR_FAILURE)\"  location: \"JS frame :: http://mochi.test:8888/tests/editor/libeditor/html/tests/browserscope/lib/richtext2/richtext2/static/js/run.js :: runSingleTest :: line 152\"  data: no]"
        }
      },
      "OUTDENT_TEXT-1": {
        "dM": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 2,
          "selresult": 3,
          "output": "EXECUTION EXCEPTION: [Exception... \"Component returned failure code: 0x80004005 (NS_ERROR_FAILURE) [nsIDOMHTMLDocument.queryCommandIndeterm]\"  nsresult: \"0x80004005 (NS_ERROR_FAILURE)\"  location: \"JS frame :: http://mochi.test:8888/tests/editor/libeditor/html/tests/browserscope/lib/richtext2/richtext2/static/js/run.js :: runSingleTest :: line 152\"  data: no]"
        },
        "body": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 2,
          "selresult": 3,
          "output": "EXECUTION EXCEPTION: [Exception... \"Component returned failure code: 0x80004005 (NS_ERROR_FAILURE) [nsIDOMHTMLDocument.queryCommandIndeterm]\"  nsresult: \"0x80004005 (NS_ERROR_FAILURE)\"  location: \"JS frame :: http://mochi.test:8888/tests/editor/libeditor/html/tests/browserscope/lib/richtext2/richtext2/static/js/run.js :: runSingleTest :: line 152\"  data: no]"
        },
        "div": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 2,
          "selresult": 3,
          "output": "EXECUTION EXCEPTION: [Exception... \"Component returned failure code: 0x80004005 (NS_ERROR_FAILURE) [nsIDOMHTMLDocument.queryCommandIndeterm]\"  nsresult: \"0x80004005 (NS_ERROR_FAILURE)\"  location: \"JS frame :: http://mochi.test:8888/tests/editor/libeditor/html/tests/browserscope/lib/richtext2/richtext2/static/js/run.js :: runSingleTest :: line 152\"  data: no]"
        }
      },
      "CREATEBOOKMARK_TEXT-1": {
        "dM": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 2,
          "selresult": 3,
          "output": "EXECUTION EXCEPTION: [Exception... \"Component returned failure code: 0x80004001 (NS_ERROR_NOT_IMPLEMENTED) [nsIDOMHTMLDocument.queryCommandIndeterm]\"  nsresult: \"0x80004001 (NS_ERROR_NOT_IMPLEMENTED)\"  location: \"JS frame :: http://mochi.test:8888/tests/editor/libeditor/html/tests/browserscope/lib/richtext2/richtext2/static/js/run.js :: runSingleTest :: line 152\"  data: no]"
        },
        "body": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 2,
          "selresult": 3,
          "output": "EXECUTION EXCEPTION: [Exception... \"Component returned failure code: 0x80004001 (NS_ERROR_NOT_IMPLEMENTED) [nsIDOMHTMLDocument.queryCommandIndeterm]\"  nsresult: \"0x80004001 (NS_ERROR_NOT_IMPLEMENTED)\"  location: \"JS frame :: http://mochi.test:8888/tests/editor/libeditor/html/tests/browserscope/lib/richtext2/richtext2/static/js/run.js :: runSingleTest :: line 152\"  data: no]"
        },
        "div": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 2,
          "selresult": 3,
          "output": "EXECUTION EXCEPTION: [Exception... \"Component returned failure code: 0x80004001 (NS_ERROR_NOT_IMPLEMENTED) [nsIDOMHTMLDocument.queryCommandIndeterm]\"  nsresult: \"0x80004001 (NS_ERROR_NOT_IMPLEMENTED)\"  location: \"JS frame :: http://mochi.test:8888/tests/editor/libeditor/html/tests/browserscope/lib/richtext2/richtext2/static/js/run.js :: runSingleTest :: line 152\"  data: no]"
        }
      },
      "UNBOOKMARK_TEXT-1": {
        "dM": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 2,
          "selresult": 3,
          "output": "EXECUTION EXCEPTION: [Exception... \"Component returned failure code: 0x80004001 (NS_ERROR_NOT_IMPLEMENTED) [nsIDOMHTMLDocument.queryCommandIndeterm]\"  nsresult: \"0x80004001 (NS_ERROR_NOT_IMPLEMENTED)\"  location: \"JS frame :: http://mochi.test:8888/tests/editor/libeditor/html/tests/browserscope/lib/richtext2/richtext2/static/js/run.js :: runSingleTest :: line 152\"  data: no]"
        },
        "body": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 2,
          "selresult": 3,
          "output": "EXECUTION EXCEPTION: [Exception... \"Component returned failure code: 0x80004001 (NS_ERROR_NOT_IMPLEMENTED) [nsIDOMHTMLDocument.queryCommandIndeterm]\"  nsresult: \"0x80004001 (NS_ERROR_NOT_IMPLEMENTED)\"  location: \"JS frame :: http://mochi.test:8888/tests/editor/libeditor/html/tests/browserscope/lib/richtext2/richtext2/static/js/run.js :: runSingleTest :: line 152\"  data: no]"
        },
        "div": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 2,
          "selresult": 3,
          "output": "EXECUTION EXCEPTION: [Exception... \"Component returned failure code: 0x80004001 (NS_ERROR_NOT_IMPLEMENTED) [nsIDOMHTMLDocument.queryCommandIndeterm]\"  nsresult: \"0x80004001 (NS_ERROR_NOT_IMPLEMENTED)\"  location: \"JS frame :: http://mochi.test:8888/tests/editor/libeditor/html/tests/browserscope/lib/richtext2/richtext2/static/js/run.js :: runSingleTest :: line 152\"  data: no]"
        }
      },
      "JUSTIFYCENTER_TEXT-1": {
        "dM": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": false
        },
        "body": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": false
        },
        "div": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": false
        }
      },
      "JUSTIFYFULL_TEXT-1": {
        "dM": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": false
        },
        "body": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": false
        },
        "div": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": false
        }
      },
      "JUSTIFYLEFT_TEXT-1": {
        "dM": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": false
        },
        "body": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": false
        },
        "div": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": false
        }
      },
      "JUSTIFYRIGHT_TEXT-1": {
        "dM": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": false
        },
        "body": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": false
        },
        "div": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": false
        }
      },
      "REMOVEFORMAT_TEXT-1": {
        "dM": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 2,
          "selresult": 3,
          "output": "EXECUTION EXCEPTION: [Exception... \"Component returned failure code: 0x80004005 (NS_ERROR_FAILURE) [nsIDOMHTMLDocument.queryCommandIndeterm]\"  nsresult: \"0x80004005 (NS_ERROR_FAILURE)\"  location: \"JS frame :: http://mochi.test:8888/tests/editor/libeditor/html/tests/browserscope/lib/richtext2/richtext2/static/js/run.js :: runSingleTest :: line 152\"  data: no]"
        },
        "body": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 2,
          "selresult": 3,
          "output": "EXECUTION EXCEPTION: [Exception... \"Component returned failure code: 0x80004005 (NS_ERROR_FAILURE) [nsIDOMHTMLDocument.queryCommandIndeterm]\"  nsresult: \"0x80004005 (NS_ERROR_FAILURE)\"  location: \"JS frame :: http://mochi.test:8888/tests/editor/libeditor/html/tests/browserscope/lib/richtext2/richtext2/static/js/run.js :: runSingleTest :: line 152\"  data: no]"
        },
        "div": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 2,
          "selresult": 3,
          "output": "EXECUTION EXCEPTION: [Exception... \"Component returned failure code: 0x80004005 (NS_ERROR_FAILURE) [nsIDOMHTMLDocument.queryCommandIndeterm]\"  nsresult: \"0x80004005 (NS_ERROR_FAILURE)\"  location: \"JS frame :: http://mochi.test:8888/tests/editor/libeditor/html/tests/browserscope/lib/richtext2/richtext2/static/js/run.js :: runSingleTest :: line 152\"  data: no]"
        }
      },
      "COPY_TEXT-1": {
        "dM": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 2,
          "selresult": 3,
          "output": "EXECUTION EXCEPTION: [Exception... \"Component returned failure code: 0x80004005 (NS_ERROR_FAILURE) [nsIDOMHTMLDocument.queryCommandIndeterm]\"  nsresult: \"0x80004005 (NS_ERROR_FAILURE)\"  location: \"JS frame :: http://mochi.test:8888/tests/editor/libeditor/html/tests/browserscope/lib/richtext2/richtext2/static/js/run.js :: runSingleTest :: line 152\"  data: no]"
        },
        "body": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 2,
          "selresult": 3,
          "output": "EXECUTION EXCEPTION: [Exception... \"Component returned failure code: 0x80004005 (NS_ERROR_FAILURE) [nsIDOMHTMLDocument.queryCommandIndeterm]\"  nsresult: \"0x80004005 (NS_ERROR_FAILURE)\"  location: \"JS frame :: http://mochi.test:8888/tests/editor/libeditor/html/tests/browserscope/lib/richtext2/richtext2/static/js/run.js :: runSingleTest :: line 152\"  data: no]"
        },
        "div": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 2,
          "selresult": 3,
          "output": "EXECUTION EXCEPTION: [Exception... \"Component returned failure code: 0x80004005 (NS_ERROR_FAILURE) [nsIDOMHTMLDocument.queryCommandIndeterm]\"  nsresult: \"0x80004005 (NS_ERROR_FAILURE)\"  location: \"JS frame :: http://mochi.test:8888/tests/editor/libeditor/html/tests/browserscope/lib/richtext2/richtext2/static/js/run.js :: runSingleTest :: line 152\"  data: no]"
        }
      },
      "CUT_TEXT-1": {
        "dM": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 2,
          "selresult": 3,
          "output": "EXECUTION EXCEPTION: [Exception... \"Component returned failure code: 0x80004005 (NS_ERROR_FAILURE) [nsIDOMHTMLDocument.queryCommandIndeterm]\"  nsresult: \"0x80004005 (NS_ERROR_FAILURE)\"  location: \"JS frame :: http://mochi.test:8888/tests/editor/libeditor/html/tests/browserscope/lib/richtext2/richtext2/static/js/run.js :: runSingleTest :: line 152\"  data: no]"
        },
        "body": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 2,
          "selresult": 3,
          "output": "EXECUTION EXCEPTION: [Exception... \"Component returned failure code: 0x80004005 (NS_ERROR_FAILURE) [nsIDOMHTMLDocument.queryCommandIndeterm]\"  nsresult: \"0x80004005 (NS_ERROR_FAILURE)\"  location: \"JS frame :: http://mochi.test:8888/tests/editor/libeditor/html/tests/browserscope/lib/richtext2/richtext2/static/js/run.js :: runSingleTest :: line 152\"  data: no]"
        },
        "div": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 2,
          "selresult": 3,
          "output": "EXECUTION EXCEPTION: [Exception... \"Component returned failure code: 0x80004005 (NS_ERROR_FAILURE) [nsIDOMHTMLDocument.queryCommandIndeterm]\"  nsresult: \"0x80004005 (NS_ERROR_FAILURE)\"  location: \"JS frame :: http://mochi.test:8888/tests/editor/libeditor/html/tests/browserscope/lib/richtext2/richtext2/static/js/run.js :: runSingleTest :: line 152\"  data: no]"
        }
      },
      "PASTE_TEXT-1": {
        "dM": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 2,
          "selresult": 3,
          "output": "EXECUTION EXCEPTION: [Exception... \"Component returned failure code: 0x80004005 (NS_ERROR_FAILURE) [nsIDOMHTMLDocument.queryCommandIndeterm]\"  nsresult: \"0x80004005 (NS_ERROR_FAILURE)\"  location: \"JS frame :: http://mochi.test:8888/tests/editor/libeditor/html/tests/browserscope/lib/richtext2/richtext2/static/js/run.js :: runSingleTest :: line 152\"  data: no]"
        },
        "body": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 2,
          "selresult": 3,
          "output": "EXECUTION EXCEPTION: [Exception... \"Component returned failure code: 0x80004005 (NS_ERROR_FAILURE) [nsIDOMHTMLDocument.queryCommandIndeterm]\"  nsresult: \"0x80004005 (NS_ERROR_FAILURE)\"  location: \"JS frame :: http://mochi.test:8888/tests/editor/libeditor/html/tests/browserscope/lib/richtext2/richtext2/static/js/run.js :: runSingleTest :: line 152\"  data: no]"
        },
        "div": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 2,
          "selresult": 3,
          "output": "EXECUTION EXCEPTION: [Exception... \"Component returned failure code: 0x80004005 (NS_ERROR_FAILURE) [nsIDOMHTMLDocument.queryCommandIndeterm]\"  nsresult: \"0x80004005 (NS_ERROR_FAILURE)\"  location: \"JS frame :: http://mochi.test:8888/tests/editor/libeditor/html/tests/browserscope/lib/richtext2/richtext2/static/js/run.js :: runSingleTest :: line 152\"  data: no]"
        }
      },
      "garbage-1_TEXT-1": {
        "dM": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 2,
          "selresult": 3,
          "output": "EXECUTION EXCEPTION: [Exception... \"Component returned failure code: 0x80004001 (NS_ERROR_NOT_IMPLEMENTED) [nsIDOMHTMLDocument.queryCommandIndeterm]\"  nsresult: \"0x80004001 (NS_ERROR_NOT_IMPLEMENTED)\"  location: \"JS frame :: http://mochi.test:8888/tests/editor/libeditor/html/tests/browserscope/lib/richtext2/richtext2/static/js/run.js :: runSingleTest :: line 152\"  data: no]"
        },
        "body": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 2,
          "selresult": 3,
          "output": "EXECUTION EXCEPTION: [Exception... \"Component returned failure code: 0x80004001 (NS_ERROR_NOT_IMPLEMENTED) [nsIDOMHTMLDocument.queryCommandIndeterm]\"  nsresult: \"0x80004001 (NS_ERROR_NOT_IMPLEMENTED)\"  location: \"JS frame :: http://mochi.test:8888/tests/editor/libeditor/html/tests/browserscope/lib/richtext2/richtext2/static/js/run.js :: runSingleTest :: line 152\"  data: no]"
        },
        "div": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 2,
          "selresult": 3,
          "output": "EXECUTION EXCEPTION: [Exception... \"Component returned failure code: 0x80004001 (NS_ERROR_NOT_IMPLEMENTED) [nsIDOMHTMLDocument.queryCommandIndeterm]\"  nsresult: \"0x80004001 (NS_ERROR_NOT_IMPLEMENTED)\"  location: \"JS frame :: http://mochi.test:8888/tests/editor/libeditor/html/tests/browserscope/lib/richtext2/richtext2/static/js/run.js :: runSingleTest :: line 152\"  data: no]"
        }
      }
    }
  },
  "QS": {
    "Proposed": {
      "B_TEXT_SI": {
        "dM": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": false
        },
        "body": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": false
        },
        "div": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": false
        }
      },
      "B_B-1_SI": {
        "dM": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": true
        },
        "body": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": true
        },
        "div": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": true
        }
      },
      "B_STRONG-1_SI": {
        "dM": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": false
        },
        "body": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": false
        },
        "div": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": false
        }
      },
      "B_SPANs:fw:b-1_SI": {
        "dM": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": false
        },
        "body": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": false
        },
        "div": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": false
        }
      },
      "B_SPANs:fw:n-1_SI": {
        "dM": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": false
        },
        "body": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": false
        },
        "div": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": false
        }
      },
      "B_Bs:fw:n-1_SI": {
        "dM": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": false
        },
        "body": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": false
        },
        "div": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": false
        }
      },
      "B_B-SPANs:fw:n-1_SI": {
        "dM": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": true
        },
        "body": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": true
        },
        "div": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": true
        }
      },
      "B_SPAN.b-1-SI": {
        "dM": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": false
        },
        "body": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": false
        },
        "div": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": false
        }
      },
      "B_MYB-1-SI": {
        "dM": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": false
        },
        "body": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": false
        },
        "div": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": false
        }
      },
      "B_B-I-1_SC": {
        "dM": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": true
        },
        "body": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": true
        },
        "div": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": true
        }
      },
      "B_B-I-1_SL": {
        "dM": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": true
        },
        "body": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": true
        },
        "div": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": true
        }
      },
      "B_B-I-1_SR": {
        "dM": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": true
        },
        "body": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": true
        },
        "div": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": true
        }
      },
      "B_STRONG-I-1_SC": {
        "dM": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": false
        },
        "body": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": false
        },
        "div": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": false
        }
      },
      "B_B-I-U-1_SC": {
        "dM": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": true
        },
        "body": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": true
        },
        "div": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": true
        }
      },
      "B_B-I-U-1_SM": {
        "dM": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": true
        },
        "body": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": true
        },
        "div": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": true
        }
      },
      "B_TEXT-B-1_SO-1": {
        "dM": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": true
        },
        "body": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": true
        },
        "div": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": true
        }
      },
      "B_TEXT-B-1_SO-2": {
        "dM": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": true
        },
        "body": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": true
        },
        "div": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": true
        }
      },
      "B_TEXT-B-1_SL": {
        "dM": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": false
        },
        "body": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": false
        },
        "div": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": false
        }
      },
      "B_TEXT-B-1_SR": {
        "dM": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": false
        },
        "body": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": false
        },
        "div": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": false
        }
      },
      "B_TEXT-B-1_SO-3": {
        "dM": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": false
        },
        "body": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": false
        },
        "div": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": false
        }
      },
      "B_B.TEXT.B-1_SM": {
        "dM": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": false
        },
        "body": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": false
        },
        "div": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": false
        }
      },
      "B_B.B.B-1_SM": {
        "dM": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": true
        },
        "body": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": true
        },
        "div": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": true
        }
      },
      "B_B.STRONG.B-1_SM": {
        "dM": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": false
        },
        "body": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": false
        },
        "div": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": false
        }
      },
      "B_SPAN.b.MYB.SPANs:fw:b-1_SM": {
        "dM": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": false
        },
        "body": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": false
        },
        "div": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": false
        }
      },
      "I_TEXT_SI": {
        "dM": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": false
        },
        "body": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": false
        },
        "div": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": false
        }
      },
      "I_I-1_SI": {
        "dM": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": true
        },
        "body": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": true
        },
        "div": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": true
        }
      },
      "I_EM-1_SI": {
        "dM": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": false
        },
        "body": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": false
        },
        "div": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": false
        }
      },
      "I_SPANs:fs:i-1_SI": {
        "dM": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": false
        },
        "body": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": false
        },
        "div": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": false
        }
      },
      "I_SPANs:fs:n-1_SI": {
        "dM": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": false
        },
        "body": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": false
        },
        "div": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": false
        }
      },
      "I_I-SPANs:fs:n-1_SI": {
        "dM": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": true
        },
        "body": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": true
        },
        "div": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": true
        }
      },
      "I_SPAN.i-1-SI": {
        "dM": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": false
        },
        "body": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": false
        },
        "div": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": false
        }
      },
      "I_MYI-1-SI": {
        "dM": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": false
        },
        "body": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": false
        },
        "div": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": false
        }
      },
      "U_TEXT_SI": {
        "dM": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": false
        },
        "body": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": false
        },
        "div": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": false
        }
      },
      "U_U-1_SI": {
        "dM": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": true
        },
        "body": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": true
        },
        "div": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": true
        }
      },
      "U_Us:td:n-1_SI": {
        "dM": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": true
        },
        "body": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": true
        },
        "div": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": true
        }
      },
      "U_Ah:url-1_SI": {
        "dM": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": false
        },
        "body": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": false
        },
        "div": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": false
        }
      },
      "U_Ah:url.s:td:n-1_SI": {
        "dM": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": false
        },
        "body": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": false
        },
        "div": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": false
        }
      },
      "U_SPANs:td:u-1_SI": {
        "dM": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": false
        },
        "body": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": false
        },
        "div": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": false
        }
      },
      "U_SPAN.u-1-SI": {
        "dM": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": false
        },
        "body": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": false
        },
        "div": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": false
        }
      },
      "U_MYU-1-SI": {
        "dM": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": false
        },
        "body": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": false
        },
        "div": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": false
        }
      },
      "S_TEXT_SI": {
        "dM": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": false
        },
        "body": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": false
        },
        "div": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": false
        }
      },
      "S_S-1_SI": {
        "dM": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": false
        },
        "body": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": false
        },
        "div": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": false
        }
      },
      "S_STRIKE-1_SI": {
        "dM": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": true
        },
        "body": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": true
        },
        "div": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": true
        }
      },
      "S_STRIKEs:td:n-1_SI": {
        "dM": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": true
        },
        "body": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": true
        },
        "div": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": true
        }
      },
      "S_DEL-1_SI": {
        "dM": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": false
        },
        "body": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": false
        },
        "div": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": false
        }
      },
      "S_SPANs:td:lt-1_SI": {
        "dM": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": false
        },
        "body": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": false
        },
        "div": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": false
        }
      },
      "S_SPAN.s-1-SI": {
        "dM": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": false
        },
        "body": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": false
        },
        "div": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": false
        }
      },
      "S_MYS-1-SI": {
        "dM": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": false
        },
        "body": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": false
        },
        "div": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": false
        }
      },
      "S_S.STRIKE.DEL-1_SM": {
        "dM": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": false
        },
        "body": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": false
        },
        "div": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": false
        }
      },
      "SUB_TEXT_SI": {
        "dM": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": false
        },
        "body": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": false
        },
        "div": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": false
        }
      },
      "SUB_SUB-1_SI": {
        "dM": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": true
        },
        "body": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": true
        },
        "div": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": true
        }
      },
      "SUB_SPAN.sub-1-SI": {
        "dM": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": false
        },
        "body": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": false
        },
        "div": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": false
        }
      },
      "SUB_MYSUB-1-SI": {
        "dM": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": false
        },
        "body": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": false
        },
        "div": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": false
        }
      },
      "SUP_TEXT_SI": {
        "dM": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": false
        },
        "body": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": false
        },
        "div": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": false
        }
      },
      "SUP_SUP-1_SI": {
        "dM": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": true
        },
        "body": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": true
        },
        "div": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": true
        }
      },
      "IOL_TEXT_SI": {
        "dM": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": false
        },
        "body": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": false
        },
        "div": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": false
        }
      },
      "SUP_SPAN.sup-1-SI": {
        "dM": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": false
        },
        "body": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": false
        },
        "div": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": false
        }
      },
      "SUP_MYSUP-1-SI": {
        "dM": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": false
        },
        "body": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": false
        },
        "div": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": false
        }
      },
      "IOL_TEXT-1_SI": {
        "dM": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": false
        },
        "body": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": false
        },
        "div": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": false
        }
      },
      "IOL_OL-LI-1_SI": {
        "dM": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": true
        },
        "body": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": true
        },
        "div": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": true
        }
      },
      "IOL_UL_LI-1_SI": {
        "dM": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": false
        },
        "body": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": false
        },
        "div": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": false
        }
      },
      "IUL_TEXT_SI": {
        "dM": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": false
        },
        "body": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": false
        },
        "div": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": false
        }
      },
      "IUL_OL-LI-1_SI": {
        "dM": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": false
        },
        "body": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": false
        },
        "div": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": false
        }
      },
      "IUL_UL-LI-1_SI": {
        "dM": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": true
        },
        "body": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": true
        },
        "div": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": true
        }
      },
      "JC_TEXT_SI": {
        "dM": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": false
        },
        "body": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": false
        },
        "div": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": false
        }
      },
      "JC_DIVa:c-1_SI": {
        "dM": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": true
        },
        "body": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": true
        },
        "div": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": true
        }
      },
      "JC_Pa:c-1_SI": {
        "dM": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": true
        },
        "body": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": true
        },
        "div": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": true
        }
      },
      "JC_SPANs:ta:c-1_SI": {
        "dM": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": false
        },
        "body": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": false
        },
        "div": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": false
        }
      },
      "JC_SPAN.jc-1-SI": {
        "dM": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": false
        },
        "body": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": false
        },
        "div": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": false
        }
      },
      "JC_MYJC-1-SI": {
        "dM": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": false
        },
        "body": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": false
        },
        "div": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": false
        }
      },
      "JF_TEXT_SI": {
        "dM": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": false
        },
        "body": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": false
        },
        "div": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": false
        }
      },
      "JF_DIVa:j-1_SI": {
        "dM": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": true
        },
        "body": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": true
        },
        "div": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": true
        }
      },
      "JF_Pa:j-1_SI": {
        "dM": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": true
        },
        "body": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": true
        },
        "div": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": true
        }
      },
      "JF_SPANs:ta:j-1_SI": {
        "dM": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": false
        },
        "body": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": false
        },
        "div": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": false
        }
      },
      "JF_SPAN.jf-1-SI": {
        "dM": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": false
        },
        "body": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": false
        },
        "div": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": false
        }
      },
      "JF_MYJF-1-SI": {
        "dM": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": false
        },
        "body": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": false
        },
        "div": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": false
        }
      },
      "JL_TEXT_SI": {
        "dM": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": true
        },
        "body": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": true
        },
        "div": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": true
        }
      },
      "JL_DIVa:l-1_SI": {
        "dM": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": true
        },
        "body": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": true
        },
        "div": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": true
        }
      },
      "JL_Pa:l-1_SI": {
        "dM": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": true
        },
        "body": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": true
        },
        "div": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": true
        }
      },
      "JL_SPANs:ta:l-1_SI": {
        "dM": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": true
        },
        "body": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": true
        },
        "div": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": true
        }
      },
      "JL_SPAN.jl-1-SI": {
        "dM": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": true
        },
        "body": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": true
        },
        "div": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": true
        }
      },
      "JL_MYJL-1-SI": {
        "dM": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": true
        },
        "body": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": true
        },
        "div": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": true
        }
      },
      "JR_TEXT_SI": {
        "dM": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": false
        },
        "body": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": false
        },
        "div": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": false
        }
      },
      "JR_DIVa:r-1_SI": {
        "dM": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": true
        },
        "body": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": true
        },
        "div": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": true
        }
      },
      "JR_Pa:r-1_SI": {
        "dM": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": true
        },
        "body": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": true
        },
        "div": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": true
        }
      },
      "JR_SPANs:ta:r-1_SI": {
        "dM": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": false
        },
        "body": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": false
        },
        "div": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": false
        }
      },
      "JR_SPAN.jr-1-SI": {
        "dM": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": false
        },
        "body": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": false
        },
        "div": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": false
        }
      },
      "JR_MYJR-1-SI": {
        "dM": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": false
        },
        "body": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": false
        },
        "div": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": false
        }
      }
    }
  },
  "QV": {
    "Proposed": {
      "B_TEXT_SI": {
        "dM": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": ""
        },
        "body": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": ""
        },
        "div": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": ""
        }
      },
      "B_B-1_SI": {
        "dM": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": ""
        },
        "body": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": ""
        },
        "div": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": ""
        }
      },
      "B_STRONG-1_SI": {
        "dM": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": ""
        },
        "body": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": ""
        },
        "div": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": ""
        }
      },
      "B_SPANs:fw:b-1_SI": {
        "dM": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": ""
        },
        "body": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": ""
        },
        "div": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": ""
        }
      },
      "B_SPANs:fw:n-1_SI": {
        "dM": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": ""
        },
        "body": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": ""
        },
        "div": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": ""
        }
      },
      "B_Bs:fw:n-1_SI": {
        "dM": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": ""
        },
        "body": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": ""
        },
        "div": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": ""
        }
      },
      "B_SPAN.b-1_SI": {
        "dM": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": ""
        },
        "body": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": ""
        },
        "div": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": ""
        }
      },
      "B_MYB-1-SI": {
        "dM": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": ""
        },
        "body": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": ""
        },
        "div": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": ""
        }
      },
      "I_TEXT_SI": {
        "dM": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": ""
        },
        "body": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": ""
        },
        "div": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": ""
        }
      },
      "I_I-1_SI": {
        "dM": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": ""
        },
        "body": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": ""
        },
        "div": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": ""
        }
      },
      "I_EM-1_SI": {
        "dM": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": ""
        },
        "body": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": ""
        },
        "div": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": ""
        }
      },
      "I_SPANs:fs:i-1_SI": {
        "dM": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": ""
        },
        "body": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": ""
        },
        "div": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": ""
        }
      },
      "I_SPANs:fs:n-1_SI": {
        "dM": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": ""
        },
        "body": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": ""
        },
        "div": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": ""
        }
      },
      "I_I-SPANs:fs:n-1_SI": {
        "dM": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": ""
        },
        "body": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": ""
        },
        "div": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": ""
        }
      },
      "I_SPAN.i-1_SI": {
        "dM": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": ""
        },
        "body": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": ""
        },
        "div": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": ""
        }
      },
      "I_MYI-1-SI": {
        "dM": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": ""
        },
        "body": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": ""
        },
        "div": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": ""
        }
      },
      "FB_TEXT-1_SC": {
        "dM": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": ""
        },
        "body": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": ""
        },
        "div": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": ""
        }
      },
      "FB_H1-1_SC": {
        "dM": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": "h1"
        },
        "body": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": "h1"
        },
        "div": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": "h1"
        }
      },
      "FB_PRE-1_SC": {
        "dM": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": "pre"
        },
        "body": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": "pre"
        },
        "div": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": "pre"
        }
      },
      "FB_BQ-1_SC": {
        "dM": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": ""
        },
        "body": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": ""
        },
        "div": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": ""
        }
      },
      "FB_ADDRESS-1_SC": {
        "dM": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": "address"
        },
        "body": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": "address"
        },
        "div": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": "address"
        }
      },
      "FB_H1-H2-1_SC": {
        "dM": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": "h2"
        },
        "body": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": "h2"
        },
        "div": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": "h2"
        }
      },
      "FB_H1-H2-1_SL": {
        "dM": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "h2"
        },
        "body": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "h2"
        },
        "div": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "h2"
        }
      },
      "FB_H1-H2-1_SR": {
        "dM": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": ""
        },
        "body": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": ""
        },
        "div": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": ""
        }
      },
      "FB_TEXT-ADDRESS-1_SL": {
        "dM": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "address"
        },
        "body": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "address"
        },
        "div": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "address"
        }
      },
      "FB_TEXT-ADDRESS-1_SR": {
        "dM": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": ""
        },
        "body": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": ""
        },
        "div": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": ""
        }
      },
      "FB_H1-H2.TEXT.H2-1_SM": {
        "dM": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "h2"
        },
        "body": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "h2"
        },
        "div": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "h2"
        }
      },
      "H_H1-1_SC": {
        "dM": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": "h1"
        },
        "body": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": "h1"
        },
        "div": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": "h1"
        }
      },
      "H_H3-1_SC": {
        "dM": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": "h3"
        },
        "body": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": "h3"
        },
        "div": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": "h3"
        }
      },
      "H_H1-H2-H3-H4-1_SC": {
        "dM": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": "h4"
        },
        "body": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": "h4"
        },
        "div": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": "h4"
        }
      },
      "H_P-1_SC": {
        "dM": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "p"
        },
        "body": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "p"
        },
        "div": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "p"
        }
      },
      "FN_FONTf:a-1_SI": {
        "dM": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": "arial"
        },
        "body": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": "arial"
        },
        "div": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": "arial"
        }
      },
      "FN_SPANs:ff:a-1_SI": {
        "dM": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": ""
        },
        "body": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": ""
        },
        "div": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": ""
        }
      },
      "FN_FONTf:a.s:ff:c-1_SI": {
        "dM": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "arial"
        },
        "body": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "arial"
        },
        "div": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "arial"
        }
      },
      "FN_FONTf:a-FONTf:c-1_SI": {
        "dM": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": "courier"
        },
        "body": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": "courier"
        },
        "div": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": "courier"
        }
      },
      "FN_SPANs:ff:c-FONTf:a-1_SI": {
        "dM": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": "arial"
        },
        "body": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": "arial"
        },
        "div": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": "arial"
        }
      },
      "FN_SPAN.fs18px-1_SI": {
        "dM": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": ""
        },
        "body": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": ""
        },
        "div": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": ""
        }
      },
      "FN_MYCOURIER-1-SI": {
        "dM": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": ""
        },
        "body": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": ""
        },
        "div": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": ""
        }
      },
      "FS_FONTsz:4-1_SI": {
        "dM": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": "4"
        },
        "body": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": "4"
        },
        "div": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": "4"
        }
      },
      "FS_FONTs:fs:l-1_SI": {
        "dM": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": ""
        },
        "body": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": ""
        },
        "div": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": ""
        }
      },
      "FS_FONT.ass.s:fs:l-1_SI": {
        "dM": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": ""
        },
        "body": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": ""
        },
        "div": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": ""
        }
      },
      "FS_FONTsz:1.s:fs:xl-1_SI": {
        "dM": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "1"
        },
        "body": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "1"
        },
        "div": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "1"
        }
      },
      "FS_SPAN.large-1_SI": {
        "dM": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": ""
        },
        "body": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": ""
        },
        "div": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": ""
        }
      },
      "FS_SPAN.fs18px-1_SI": {
        "dM": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": ""
        },
        "body": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": ""
        },
        "div": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": ""
        }
      },
      "FA_MYLARGE-1-SI": {
        "dM": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": ""
        },
        "body": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": ""
        },
        "div": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": ""
        }
      },
      "FA_MYFS18PX-1-SI": {
        "dM": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": ""
        },
        "body": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": ""
        },
        "div": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": ""
        }
      },
      "BC_FONTs:bc:fca-1_SI": {
        "dM": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": ""
        },
        "body": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": ""
        },
        "div": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": ""
        }
      },
      "BC_SPANs:bc:abc-1_SI": {
        "dM": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": ""
        },
        "body": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": ""
        },
        "div": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": ""
        }
      },
      "BC_FONTs:bc:084-SPAN-1_SI": {
        "dM": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": ""
        },
        "body": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": ""
        },
        "div": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": ""
        }
      },
      "BC_SPANs:bc:cde-SPAN-1_SI": {
        "dM": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": ""
        },
        "body": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": ""
        },
        "div": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": ""
        }
      },
      "BC_SPAN.ass.s:bc:rgb-1_SI": {
        "dM": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": ""
        },
        "body": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": ""
        },
        "div": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": ""
        }
      },
      "BC_SPAN.bcred-1_SI": {
        "dM": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": ""
        },
        "body": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": ""
        },
        "div": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": ""
        }
      },
      "BC_MYBCRED-1-SI": {
        "dM": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": ""
        },
        "body": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": ""
        },
        "div": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": ""
        }
      },
      "FC_FONTc:f00-1_SI": {
        "dM": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": "#ff0000"
        },
        "body": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": "#ff0000"
        },
        "div": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": "#ff0000"
        }
      },
      "FC_SPANs:c:0f0-1_SI": {
        "dM": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": ""
        },
        "body": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": ""
        },
        "div": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": ""
        }
      },
      "FC_FONTc:333.s:c:999-1_SI": {
        "dM": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "#333333"
        },
        "body": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "#333333"
        },
        "div": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "#333333"
        }
      },
      "FC_FONTc:641-SPAN-1_SI": {
        "dM": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": "#664411"
        },
        "body": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": "#664411"
        },
        "div": {
          "valscore": 1,
          "selscore": 0,
          "valresult": 8,
          "selresult": 3,
          "output": "#664411"
        }
      },
      "FC_SPANs:c:d95-SPAN-1_SI": {
        "dM": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": ""
        },
        "body": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": ""
        },
        "div": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": ""
        }
      },
      "FC_SPAN.red-1_SI": {
        "dM": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": ""
        },
        "body": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": ""
        },
        "div": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": ""
        }
      },
      "FC_MYRED-1-SI": {
        "dM": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": ""
        },
        "body": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": ""
        },
        "div": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": ""
        }
      },
      "HC_FONTs:bc:fc0-1_SI": {
        "dM": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "transparent"
        },
        "body": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "transparent"
        },
        "div": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "transparent"
        }
      },
      "HC_SPANs:bc:a0c-1_SI": {
        "dM": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "transparent"
        },
        "body": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "transparent"
        },
        "div": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "transparent"
        }
      },
      "HC_SPAN.ass.s:bc:rgb-1_SI": {
        "dM": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "transparent"
        },
        "body": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "transparent"
        },
        "div": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "transparent"
        }
      },
      "HC_FONTs:bc:83e-SPAN-1_SI": {
        "dM": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "transparent"
        },
        "body": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "transparent"
        },
        "div": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "transparent"
        }
      },
      "HC_SPANs:bc:b12-SPAN-1_SI": {
        "dM": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "transparent"
        },
        "body": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "transparent"
        },
        "div": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "transparent"
        }
      },
      "HC_SPAN.bcred-1_SI": {
        "dM": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "transparent"
        },
        "body": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "transparent"
        },
        "div": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "transparent"
        }
      },
      "HC_MYBCRED-1-SI": {
        "dM": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "transparent"
        },
        "body": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "transparent"
        },
        "div": {
          "valscore": 0,
          "selscore": 0,
          "valresult": 6,
          "selresult": 3,
          "output": "transparent"
        }
      }
    }
  }
}

